c ==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+=
      program helins
c ==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+=
c
c     General relativistic binary in equilibrium. 
c     Einstein field equation and equations for irrotational 
c     fluid flow are solved assuming the helical symmetry.  
c     Using self-consistent field method.
c
c     Parameters
c     chrot == i : Irrotational flow  |  chope == L : invert Laplacian
c           == c : Corotational flow  |        == H : invert Helmholtz
c
c     chgra == h : Helically symmetric source
c           == w : SUF Waveless source
c           == i : IWM formalism
c           == c : Waveless Helical cut off source for Laplacian
c           == C : Waveless Helical cut off source for Helmholtz
c           == H : Helical cut off source (Simple cutoff)
c           == W : Helical -> Waveless source for Helmholtz op.
c     iswl
c
c ==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+==+=
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metfl.f'
      include 'GR_IRDR_metgr.f'
c
      common / trmpg / sinmpg(0:nnlg,0:nnpg), cosmpg(0:nnlg,0:nnpg),
     &                simpsig(0:nnlg,0:nnpg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
      common / weigh / wgdr(0:nnr), wgdt(0:nnt), wgdp(0:nnp),
     &                wgrtp(0:nnr,0:nnt,0:nnp),
     &                 w4dr(0:nnr), w4dt(0:nnt), w4dp(0:nnp),
     &                w4rtp(0:nnr,0:nnt,0:nnp), wahop(0:nnr,0:nnt,0:nnp)
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
c
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / augfn / emdg(0:nnrg,0:nntg,0:nnpg),
     &                 ramg(0:nnrg,0:nntg,0:nnpg), 
     &               gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
c
      common / diffv / rsinv(0:nnt,0:nnp),
     &              dtrs(0:nnt,0:nnp),dprs(0:nnt,0:nnp)
c
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
c
      common / iomis / fffac, ffvep, eps, convf, itmx, iddd, numseq,
     &                 itype, iwrite
      common / hijsw / swlp(4), swls(4), iswl
      common / flusw / swflu
      common / cutsw / cutfac
      common / seqmas/ restmass, gravmass
c
      dimension sou(0:nnrg,0:nntg,0:nnpg), pot(0:nnrg,0:nntg,0:nnpg), 
     &          souvec(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension souten(0:nnrg,0:nntg,0:nnpg,1:6)
      dimension ssouten(0:nntg,0:nnpg,1:6), dssouten(0:nntg,0:nnpg,1:6)
      dimension spot(0:nnrg,0:nntg,0:nnpg)
      dimension poto1(0:nnrg,0:nntg,0:nnpg), poto2(0:nnrg,0:nntg,0:nnpg)
      dimension ssou(0:nntg,0:nnpg), dssou(0:nntg,0:nnpg)
      dimension grad(0:nnrg,0:nntg,0:nnpg,1:3),
     &         gradv(0:nnr,0:nnt,0:nnp,1:3)
      dimension back(0:nnrg,0:nntg,0:nnpg),
     &          gva(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension bk1(0:nnrg,0:nntg,0:nnpg), bk2(0:nnrg,0:nntg,0:nnpg),
     &          bk3(0:nnrg,0:nntg,0:nnpg), bk4(0:nnrg,0:nntg,0:nnpg),
     &          bk5(0:nnrg,0:nntg,0:nnpg), bk6(0:nnrg,0:nntg,0:nnpg)
c
      dimension soupsou(0:nntg,0:nnpg),dsoupsou(0:nntg,0:nnpg),
     &          souapou(0:nntg,0:nnpg),dsouapou(0:nntg,0:nnpg),
     &          souoxou(0:nntg,0:nnpg),dsouoxou(0:nntg,0:nnpg),
     &          souoyou(0:nntg,0:nnpg),dsouoyou(0:nntg,0:nnpg),
     &          souozou(0:nntg,0:nnpg),dsouozou(0:nntg,0:nnpg)
c
      dimension emdcc(100), sepaseq(100)
      integer ngdinc(100)
c
      dimension gmd(3,3),gmu(3,3),cris(3,3,3)
c
      dimension sgg(nnbou), gg(nnbou,nnbou)
      character*3 char
      character*1 chrot,chgra, chope
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      open(1,file='gnbpar.dat',status='old')
      open(24,file='gnbaux.dat',status='old')
      open(25,file='gnbseq.dat',status='old')
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c --- Parameters
c
      read(1,5000) nrf, ntf, npf
      read(1,5000) nl, nla, nbou, msym
      read(1,5005) nnn, nrout, rvout
      read(1,5000) ntg, npg, nlg, msymg
      read(1,5002) ngdin, pinx, cutfac
      read(1,5002) itmx, eps, convf
      read(1,5000) iddd, iswl
      read(1,5001) fffac,ffvep 
      read(1,5004) itype, iwrite, chrot, chgra, chope
 5000 format( 5i5)
 5001 format( 2f10.5)
 5002 format( 1i5, 2f10.5)
 5003 format( 1f10.5, 1i4)
 5004 format( 2i5, 3x, 3a1)
 5005 format( 2i5, 1f10.5)
c
c --- Physical constants and solar units.
c
      g = 6.6726d-8
      pi = 3.14159265358979d+0
c
      nr = nrf
      nt = ntf
      np = npf
      nrin = nnn*nr
      nrtot = nrin + nrout
c###  GR coordinate, phig = 0 to pi/2 
      npgxz = 0
      npgyz = npg
c###  Fluid coordinate, phib = 0 to pi 
      npfxz = 0
      npfyz = np/2
      npfxzm= np
c
c --- Switch for hij source term.
c
      swlp(1) = 1.0d0
      swlp(2) = 1.0d0
      swlp(3) = 0.0d0
      swlp(4) = 0.0d0
      swls(1) = 0.0d0
      swls(2) = 1.0d0
      swls(3) = 0.0d0
      swls(4) = 1.0d0
c
c --- Switch for fluid source term and the gravity.
c
      if (chrot.eq.'c') then 
      write(6,*) ' ### Co-rotating solutions. ###'
      else if (chrot.eq.'i') then 
      write(6,*) ' ### Irrotating solutions. ###'
      else
      write(6,*) ' ### INVARID PARAMETER --- chrot. ###'
      stop
      end if
      swflu = 1.0d0
      if (chrot.eq.'c') swflu = 0.0d0
c
      if (chgra.eq.'i') then 
      write(6,*) ' ### IWM formalism. ###'
      else if (chgra.eq.'w') then 
      write(6,*) ' ### SUF-Waveless formalism. ###'
      else if (chgra.eq.'c') then 
      write(6,*) ' ### Waveless-Helical cut off formalism. ###'
      else if (chgra.eq.'C') then 
      write(6,*) ' ### Waveless-Helical cut off formalism. ###'
      else if (chgra.eq.'h') then 
      write(6,*) ' ### Helical formalism. ###'
      else if (chgra.eq.'H') then 
      write(6,*) ' ### Helical cut off formalism (simple cutoff) ###'
      else if (chgra.eq.'W') then 
      write(6,*) ' ### Helical -> Waveless source ###'
      else 
      write(6,*) ' ### INVARID PARAMETER --- chgra. ###'
      stop
      end if
c
      if (chope.eq.'L') then 
      write(6,*) ' ### Invert Laplacian for hij. ###'
      else if (chope.eq.'H') then 
      write(6,*) ' ### Invert Helmholtz operator for hij. ###'
      else
      write(6,*) ' ### INVARID PARAMETER --- chope. ###'
      stop
      end if
c
      char = chrot//chgra//chope
c
c --- Rest mass constant sequence.
c
      read(25,3) numseq, restmass, gravmass
 3    format(1i5,1p,2e14.6)
      read(25,2) emdcc(1), ngdinc(1), incr
 2    format(1f10.5,2i5)
      read(25,1) emddiff, rmeps
 1    format(2f10.5)
      rmepsbak = rmeps
c
      sepaseq(1) = dble(ngdinc(1) + nrf)/dble(nrf)
      sepato = sepaseq(1)
      ndis = idint(sepato*dble(nrf)+1.0d-8)
      dis = sepato
c
      if (numseq.ge.2) then
      if (rmeps.lt.eps.and.incr.eq.0) then 
      open(26,file='gnbseqemd.dat',status='old')
      do 26 kk = 1, numseq
      read(26,1) emdcc(kk)
 26   continue
      close(26)
      end if
      do 4 kk = 2, numseq
      ngdinc(kk) = ngdinc(kk-1) + incr
      sepaseq(kk) = dble(ngdinc(kk) + nrf)/dble(nrf)
 4    continue
      end if
      emdc = emdcc(1)
c
      if (char.eq.'eco') then
      open(26,file='gnbcomp.dat',status='old')
      read(26,5) restmass
      do 27 kk = 1, numseq
      read(26,5) sepaseq(kk)
      sepaseq(kk) = sepaseq(kk)*0.5d0
      ngdinc(kk) = idint(sepaseq(kk)*dble(nrf)+1.0d-10) - nrf 
 27   continue
      close(26)
      end if
 5    format(1p,e14.6)
c
c ----------------------------------------------------------------------
c --- Initial.
c ----------------------------------------------------------------------
c
      iseq = 0
      call subio(0,iseq,char)
c
c --  modify constant of the first integral for co-rotating case.
c
      if (chrot.eq.'c') then
      nrtmp = ngdinc(1) + nrf
      emdgc = emd(0,0,0)
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
      psigc =  psi(nrtmp,0,0)
      alpgc = alph(nrtmp,0,0)
      ovygc = ovyu(nrtmp,0,0)
      gmyyd = 1.0d0 + hxxd(nrtmp,0,0)
      utgc  = 1.0d0/dsqrt(alpgc**2 - psigc**4*gmyyd*ovygc*ovygc)
      ber = hhgc/utgc
c
      do 810 ip = 0, np
      do 810 it = 0, nt
      do 810 ir = 0, nr
 810  vep(ir,it,ip) = 0.0d0
c
      end if
c
c ----------------------------------------------------------------------
c --- Calcuration of deformation sequence.
c ----------------------------------------------------------------------
c
      convfa = convf
      ngdinb = -1
c
      do 1400 iseq = 1, numseq
c
c --- Set nonvariables, s.t. mesh, trigonometric fn.,
c --- weight for integration, legendre polynomials.
c
      ngdin = ngdinc(iseq)
cke      sepato = dble(ngdin + nrf)/dble(nrf)
      sepato = sepaseq(iseq)
      dis = sepato
      ndis = idint(sepato*dble(nrf)+1.0d-10)
cke      ndis = ngdin + nrf
c
      if (iseq.eq.1.or.ngdinb.ne.ngdinc(iseq)) then
      write(6,*)' coordinates etc. '
      call nonvfl(iddd)
      call nonvgr
c
c --- Preparation for other index
c
      call invhij
      call bvu2d
      call bv2ov
c
c --- Preparation for the scalar part
c
      call ap2alps
c
      end if
c
      ngdinb = ngdinc(iseq)
c
      if (rmeps.lt.eps.and.incr.eq.0) emdc = emdcc(iseq)
      surr = 10.0d0**(idnint(dlog10(1.0d-04*emdc)))
c
      call nonvint(rs)
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c     Iteration started.  
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      convg = convfa
c
      iter = 0
      imascond = 1
      rmeps = rmepsbak
c
 1000 continue
c
      fmax0 = 0.0
      iter = iter + 1
      fcon = convg*float(iter)
      fmin = fffac
      fmivep = ffvep
      conv = dmin1( fmin, fcon)
      convep = dmin1( fmivep, fcon)
      convf = conv
ctesttest      gfmin = 0.7d0
      gfmin = fffac
      gconvf = dmin1( gfmin, fcon)
      cfvep = convep
c
c --- Print out the intermediate state
c
      if (iter.gt.itmx) then
      istat = 2
      char = chrot//chgra//chope
      call subiors(istat,iseq,char)
      call subio(istat,iseq,char)
      call physq(istat,iseq,chgra)
      if (iwrite.eq.1) call subioca
c
 4444  format(1p,25e12.4)
c
      write(6,*) ' **iter** '
cz      go to 1401
      if (iseq.eq.numseq) go to 1401
      go to 1400
      end if
c
c --- Start computation.  
c
      write(6,*) ' #### Iteration NO. = ', iter
c
c --- Preparation of quantities on GR coordinate.
c --  Improving parameters and alpha and psi.  
c
      if (chgra.eq.'i') call cleargeometry
      if (chgra.ne.'i') then 
      call cristoffel
      call riccitensor
      end if
      if (chgra.eq.'h'.or.chgra.eq.'c'.or.chgra.eq.'C'
     &.or.chgra.eq.'H'.or.chgra.eq.'W') then 
      call liegmab
      end if
      call excurve(chgra)
c
      call vgr2vflcap(rs)
      call flgrad4(vep,gradv,rs,1,0)
      call vfl2vgrcap(gradv,gradvg,rs,hrg,rg,1)
      call fl2grspl(emd,emdg,rs,hrg,rg,1)
c
c
      bvyfg = bvyu(nrgmid,ntg,0)
      do 77 ip = 0, np
      do 77 it = 0, nt
      ir = 0
      vphiy = vphif(ir,it,ip,2)
      ram(ir,it,ip) = ber + (bvyfg + ome*vphiy)*gradv(0,nt,npfyz,2)
      do 77 ir = 1, nr
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
      ram(ir,it,ip) = ber + (bvxfc + ome*vphix)*gradv(ir,it,ip,1)
     &                    + (bvyfc + ome*vphiy)*gradv(ir,it,ip,2)
     &                    + (bvzfc + ome*vphiz)*gradv(ir,it,ip,3)
 77   continue
c
      call fl2grspl(ram,ramg,rs,hrg,rg,1)
c
c
c --  For psi.  
c
      call psisource(sou,chgra)
c
cc      call halfsou(sou)
      call halfsousym(sou,1,1,1)
      call grav4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call surfsouscalar(psi,ssou,dssou)
      call grav4sfout(dssou,poto1,cosmpg,cosmpg,0,3,0,0)
      call grav4sfout( ssou,poto2,cosmpg,cosmpg,0,4,0,0)
c
      do 411 ipg = 0, npg
      do 411 itg = 0, ntg
      do 411 irg = 0, nrtot
      back(irg,itg,ipg) = psi(irg,itg,ipg)
      psi(irg,itg,ipg) = 1.0d0 + pot(irg,itg,ipg)
     &                 + poto1(irg,itg,ipg) + poto2(irg,itg,ipg)
 411  continue
      call grimpro(back,psi,convf,emxpsi,irerr,iterr,iperr)
ckk      write(6,4901) '  == psi   ==, error =', emxpsi, 
ckk     &              psi(irerr,iterr,iperr), irerr,iterr,iperr
ckk      fmax0 = dmax1(emxpsi,fmax0)
c
c
c --  Improving parameters and alpha and psi.  
c
      if (chrot.eq.'c') then 
      call paimproco(ome,ber,radi,convf,iter,fmax0,0)
      else
      call paimpro(ome,ber,radi,convf,iter,fmax0,0)
      end if
c
c      write(6,*) ' step 1 '
      write(6,*) ome, ber, radi
c
c --  For alpha.
c
ccc      call alpssource(sou,chgra)
       call alps2source(sou,chgra)
c
cc      call halfsou(sou)
      call halfsousym(sou,1,1,1)
      call grav4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
ccc      call surfsouscalar(alps,ssou,dssou)
ccc  not good for alph*psi**2   call surfsouscalar(alps2,ssou,dssou)
      call grav4sfout(dssou,poto1,cosmpg,cosmpg,0,3,0,0)
      call grav4sfout( ssou,poto2,cosmpg,cosmpg,0,4,0,0)
c
      do 415 ipg = 0, npg
      do 415 itg = 0, ntg
      do 415 irg = 0, nrtot
      back(irg,itg,ipg) = alph(irg,itg,ipg)
calps      alph(irg,itg,ipg) = (1.0d0 + pot(irg,itg,ipg)
calps     &                  + poto1(irg,itg,ipg) + poto2(irg,itg,ipg)
calps     &                                             )/psi(irg,itg,ipg)
      alph(irg,itg,ipg) = (1.0d0 + pot(irg,itg,ipg)
ccc     &                  + poto1(irg,itg,ipg) + poto2(irg,itg,ipg)
     &                                         )/psi(irg,itg,ipg)**2
ctesttest
      if (alph(irg,itg,ipg).ge.1.0d0) alph(irg,itg,ipg) = 1.0d0
ctesttest
 415  continue
c
      call grimpro(back,alph,convf,emxalp,irerr,iterr,iperr)
c
cckk      write(6,4901) '  == alph  ==, error =', emxalp, 
ckk     &            alph(irerr,iterr,iperr), irerr,iterr,iperr
ckk      fmax0 = dmax1(emxalp,fmax0)
c
c
c --  Improving parameters and alpha and psi.  
c
ctesttest      isaj = 1
      isaj = 0
      if (chope.eq.'L') isaj = 0
      call adjustasymptopia(isaj)
      call ap2alps
c
      if (chrot.eq.'c') then 
      call paimproco(ome,ber,radi,convf,iter,fmax0,0)
      else
      call paimpro(ome,ber,radi,convf,iter,fmax0,0)
      end if
c
c      write(6,*) ' step 2 '
      write(6,*) ome, ber, radi
c
c --  For shift.  
c
      call shiftsource(souvec,sou,chgra)
c
cc      call halfsou(sou)
      call halfsousym(sou,1,-1,-1)
      call grav4(sou,bbb,sinmpg,sinmpg,pnag,0,0,0,4)
c
      do 431 ii = 1, 3 
c
      do 432 ipg = 0, npg 
      do 432 itg = 0, ntg 
      do 432 irg = 0, nrtot 
      sou(irg,itg,ipg) = souvec(irg,itg,ipg,ii)   
 432  continue
c
      isy = 0
ccc      if (ii.eq.) isy = 0
ccc      if (ii.eq.) isy = 1
ccc      call halfsou(sou)
c
      if (ii.eq.1) call halfsousym(sou,1,1,-1)
      if (ii.eq.2) call halfsousym(sou,1,-1,1)
      if (ii.eq.3) call halfsousym(sou,-1,-1,-1)
c
      if (ii.eq.1) call grav4(sou,pot,sinmpg,sinmpg,pnag,0,0,1,4)
      if (ii.eq.2) call grav4(sou,pot,cosmpg,cosmpg,pnag,0,0,1,4)
      if (ii.eq.3) call grav4(sou,pot,sinmpg,sinmpg,pnag,1,1,0,4)
c
      do 434 ipg = 0, npg
      do 434 itg = 0, ntg
      do 434 irg = 0, nrtot
      gva(irg,itg,ipg,ii) = pot(irg,itg,ipg)
 434  continue
c                                                     
 431  continue
c
      do 435 ipg = 0, npg 
      do 435 itg = 0, ntg 
      do 435 irg = 0, nrtot 
      xxx = rg(irg)*sintheg(itg)*cosphig(ipg)
      yyy = rg(irg)*sintheg(itg)*sinphig(ipg)
      zzz = rg(irg)*costheg(itg)
      bbb(irg,itg,ipg) = bbb(irg,itg,ipg)
     &            - (xxx*gva(irg,itg,ipg,1)
     &             + yyy*gva(irg,itg,ipg,2)
     &             + zzz*gva(irg,itg,ipg,3))
 435  continue
c
c
      call grgrad4(bbb,grad,1,-1,-1)
      do 437 ii = 1, 3 
c
      do 438 ipg = 0, npg 
      do 438 itg = 0, ntg 
      do 438 irg = 0, nrtot 
      if (ii.eq.1) back(irg,itg,ipg) = bvxd(irg,itg,ipg)
      if (ii.eq.2) back(irg,itg,ipg) = bvyd(irg,itg,ipg)
      if (ii.eq.3) back(irg,itg,ipg) = bvzd(irg,itg,ipg)
      pot(irg,itg,ipg) =          gva(irg,itg,ipg,ii)
     &                 + 0.125d0*grad(irg,itg,ipg,ii)
 438  continue
c
      call grimpro(back,pot,convf,emxshi,irerr,iterr,iperr)
ckk      write(6,4901) '  == shift ==, error =', emxshi, 
ckk     &              pot(irerr,iterr,iperr), irerr,iterr,iperr
ckk      fmax0 = dmax1(emxshi,fmax0)
c
      do 439 ipg = 0, npg
      do 439 itg = 0, ntg
      do 439 irg = 0, nrtot
      if (ii.eq.1) bvxd(irg,itg,ipg) = pot(irg,itg,ipg)
      if (ii.eq.2) bvyd(irg,itg,ipg) = pot(irg,itg,ipg)
      if (ii.eq.3) bvzd(irg,itg,ipg) = pot(irg,itg,ipg)
 439  continue
c
 437  continue
c
      bvxu(0,0,0) = 0.d0
      bvyu(0,0,0) = 0.d0
      do 4250 ipg = 0, npg
      do 4250 irg = 0, nrtot
      bvyu(irg,0,ipg) = 0.d0
      bvzu(irg,0,ipg) = 0.d0
 4250 continue
      do 4260 ipg = 0, npg
      do 4260 itg = 0, ntg
      bvzu(0,itg,ipg) = 0.d0
 4260 continue
c
c --  Improving parameters and alpha and psi.  
c
      call bvd2u
      call bv2ov
c
      if (chrot.eq.'c') then 
      call paimproco(ome,ber,radi,convf,iter,fmax0,0)
      else
      call paimpro(ome,ber,radi,convf,iter,fmax0,0)
      end if
c
c      write(6,*) ' step 3 '
      write(6,*) ome, ber, radi
c
c --  For hij
c
      if (chgra.eq.'i') go to 9000
c
      call hijsource(souten,chgra,chope,iter)
      call surfhijsource(ssouten,dssouten,iter,chgra,chope)
c
      if (chope.eq.'H') then
      call hrhafn(ome)
      end if
c
      do 442 ipg = 0, npg
      do 442 itg = 0, ntg
      do 442 irg = 0, nrtot
      bk1(irg,itg,ipg) = hxxd(irg,itg,ipg)
      bk2(irg,itg,ipg) = hxyd(irg,itg,ipg)
      bk3(irg,itg,ipg) = hxzd(irg,itg,ipg)
      bk4(irg,itg,ipg) = hyyd(irg,itg,ipg)
      bk5(irg,itg,ipg) = hyzd(irg,itg,ipg)
      bk6(irg,itg,ipg) = hzzd(irg,itg,ipg)
      hxxd(irg,itg,ipg) = 0.0d0
      hxyd(irg,itg,ipg) = 0.0d0
      hxzd(irg,itg,ipg) = 0.0d0
      hyyd(irg,itg,ipg) = 0.0d0
      hyzd(irg,itg,ipg) = 0.0d0
      hzzd(irg,itg,ipg) = 0.0d0
 442  continue
c
      do 440 ii = 1, 6
c
      do 441 ipg = 0, npg 
      do 441 itg = 0, ntg 
      ssou(itg,ipg) = ssouten(itg,ipg,ii)
      dssou(itg,ipg) = dssouten(itg,ipg,ii)
      do 441 irg = 0, nrtot 
      sou(irg,itg,ipg) = souten(irg,itg,ipg,ii)
 441  continue
c
      if (ii.eq.1) call halfsousym(sou,1,1,1)
      if (ii.eq.2) call halfsousym(sou,1,-1,-1)
      if (ii.eq.3) call halfsousym(sou,-1,-1,1)
      if (ii.eq.4) call halfsousym(sou,1,1,1)
      if (ii.eq.5) call halfsousym(sou,-1,1,-1)
      if (ii.eq.6) call halfsousym(sou,1,1,1)
c
c --  Poisson solver.  
c
      if (chope.eq.'L') then
c
      if (ii.eq.1) then 
      call grav4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call grav4sfout(dssou,poto1,cosmpg,cosmpg,0,3,0,0)
      call grav4sfout( ssou,poto2,cosmpg,cosmpg,0,4,0,0)
      end if
      if (ii.eq.2) then
      call grav4(sou,pot,sinmpg,sinmpg,pnag,0,0,0,4)
      call grav4sfout(dssou,poto1,sinmpg,sinmpg,0,3,0,0)
      call grav4sfout( ssou,poto2,sinmpg,sinmpg,0,4,0,0)
      end if
      if (ii.eq.3) then
      call grav4(sou,pot,cosmpg,cosmpg,pnag,1,1,1,4)
      call grav4sfout(dssou,poto1,cosmpg,cosmpg,1,3,1,1)
      call grav4sfout( ssou,poto2,cosmpg,cosmpg,1,4,1,1)
      end if
      if (ii.eq.4) then
      call grav4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call grav4sfout(dssou,poto1,cosmpg,cosmpg,0,3,0,0)
      call grav4sfout( ssou,poto2,cosmpg,cosmpg,0,4,0,0)
      end if
      if (ii.eq.5) then
      call grav4(sou,pot,sinmpg,sinmpg,pnag,1,1,1,4)
      call grav4sfout(dssou,poto1,sinmpg,sinmpg,1,3,1,1)
      call grav4sfout( ssou,poto2,sinmpg,sinmpg,1,4,1,1)
      end if
      if (ii.eq.6) then
      call grav4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call grav4sfout(dssou,poto1,cosmpg,cosmpg,0,3,0,0)
      call grav4sfout( ssou,poto2,cosmpg,cosmpg,0,4,0,0)
      end if
c
      end if
c
c --  Helmholtz solver.  
c
      if (chope.eq.'H') then
c
      if (ii.eq.1) then
      call hegr4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call hegr4sfout(ome,ssou,dssou,spot,cosmpg,cosmpg,pnag,0,0,0,4)
      end if
      if (ii.eq.2) then
      call hegr4(sou,pot,sinmpg,sinmpg,pnag,0,0,0,4)
      call hegr4sfout(ome,ssou,dssou,spot,sinmpg,sinmpg,pnag,0,0,0,4)
      end if
      if (ii.eq.3) then
      call hegr4(sou,pot,cosmpg,cosmpg,pnag,1,1,1,4)
      call hegr4sfout(ome,ssou,dssou,spot,cosmpg,cosmpg,pnag,1,1,1,4)
      end if
      if (ii.eq.4) then
      call hegr4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call hegr4sfout(ome,ssou,dssou,spot,cosmpg,cosmpg,pnag,0,0,0,4)
      end if
      if (ii.eq.5) then
      call hegr4(sou,pot,sinmpg,sinmpg,pnag,1,1,1,4)
      call hegr4sfout(ome,ssou,dssou,spot,sinmpg,sinmpg,pnag,1,1,1,4)
      end if
      if (ii.eq.6) then
      call hegr4(sou,pot,cosmpg,cosmpg,pnag,0,0,0,4)
      call hegr4sfout(ome,ssou,dssou,spot,cosmpg,cosmpg,pnag,0,0,0,4)
      end if
c
      end if
c
      do 444 ipg = 0, npg
      do 444 itg = 0, ntg
      do 444 irg = 0, nrtot
      if (chope.eq.'L') potnew = pot(irg,itg,ipg)
ctesttest     &                         + poto1(irg,itg,ipg)+poto2(irg,itg,ipg)
      if (chope.eq.'H') potnew = pot(irg,itg,ipg)
     &                         +spot(irg,itg,ipg)
      if (ii.eq.1) hxxd(irg,itg,ipg) = potnew
      if (ii.eq.2) hxyd(irg,itg,ipg) = potnew
      if (ii.eq.3) hxzd(irg,itg,ipg) = potnew
      if (ii.eq.4) hyyd(irg,itg,ipg) = potnew
      if (ii.eq.5) hyzd(irg,itg,ipg) = potnew
      if (ii.eq.6) hzzd(irg,itg,ipg) = potnew
 444  continue
c
 440  continue
c
c --  Set det(gamma_{ab}) = psi^12 and Dirac gauge for new variable.
c
      call gauge(iter)
c
      call adjusthij(iter)
cccc      call hijdet1(iter)
c
c --  improve by iteration
c
ctesttest      call grimpro(bk1,hxxd,convf,emxhij,irerr,iterr,iperr)
ctesttest      call grimpro(bk2,hxyd,convf,emxhij,irerr,iterr,iperr)
ctesttest      call grimpro(bk3,hxzd,convf,emxhij,irerr,iterr,iperr)
ctesttest      call grimpro(bk4,hyyd,convf,emxhij,irerr,iterr,iperr)
ctesttest      call grimpro(bk5,hyzd,convf,emxhij,irerr,iterr,iperr)
ctesttest      call grimpro(bk6,hzzd,convf,emxhij,irerr,iterr,iperr)
      call grimpro(bk1,hxxd,gconvf,emxhij,irerr,iterr,iperr)
      call grimpro(bk2,hxyd,gconvf,emxhij,irerr,iterr,iperr)
      call grimpro(bk3,hxzd,gconvf,emxhij,irerr,iterr,iperr)
      call grimpro(bk4,hyyd,gconvf,emxhij,irerr,iterr,iperr)
      call grimpro(bk5,hyzd,gconvf,emxhij,irerr,iterr,iperr)
      call grimpro(bk6,hzzd,gconvf,emxhij,irerr,iterr,iperr)
c
ckk      write(6,4901) '  == hij   ==, error =', emxhij, 
ckk     &              pot(irerr,iterr,iperr), irerr,iterr,iperr
ckk      fmax0 = dmax1(emxhij,fmax0)
c
      call invhij
c
c --  Improving parameters and alpha and psi.  
c
c      write(6,*) ' step 4a '
      write(6,*) ome, ber, radi
c
      if (chrot.eq.'c') then 
      call paimproco(ome,ber,radi,convf,iter,fmax0,0)
      else
      call paimpro(ome,ber,radi,convf,iter,fmax0,0)
      end if
      write(6,4000) ome, ber, radi, psi(0,0,0)
c
c      write(6,*) ' step 4 '
      write(6,*) ome, ber, radi
c
c --  IWM formalism
c
 9000 continue
c
c --  For imposition of symmetry to field variables on xy,yz,zx-planes. 
c
      call symmetry
c
c --  For Corotational fluid, First integral of Euler eq.
c --  For Irrotational fluid, First integral of Euler eq. and eq. of conti.  
c
      call gr2flspl(psi,psif,rs,0,0)
      call gr2flspl(alph,alphf,rs,0,0)
      call vgr2vflcap(rs)
c
      if (chrot.eq.'c') then 
      call fluidco(iter,itmx,convf,cfvep,fmax0,ahores,emxemd,char)
      else
      call fluid(iter,itmx,convf,cfvep,fmax0,ahores,emxemd,char)
      end if
c
ctesttest         fmax0 = 1.0d0
c
c --- Formats
c
 4901 format(a22,1p,e12.4,',  value =',e12.4,2x,3i4)
 4000 format(1p, 6e12.4)
 4400 format(1p,17e12.4)
c
c     ########  ATTENSION ON THE FACTOR OF GREEN FUNCTION ########
c
c --- untill convergence is made, go to 1000
c
      write(6,4902)'  -- fmax0 --, error =', fmax0
 4902 format(a22,1p,e12.4)
c
c --- constant rest mass sequence. ---
c
      call mascon(imascond,emxemd,ahores,emdc,restmass,emddiff,
     &            rmeps,eps,fmax0)
c
      if (fmax0.gt.eps) go to 1000
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- Print out the converged state.
c
      istat = 1
      char = chrot//chgra//chope
      call subiors(istat,iseq,char)
cz      if (iseq.eq.numseq) call subio(istat,iseq,char)
      call subio(istat,iseq,char)
      call physq(istat,iseq,chgra)
c
c---  NOTE: helical_check.f is included.
      call helical_check(chgra,iseq)
cc      stop '** Helical check **'
c
c --- for initial value
c
      if (iwrite.eq.1) call subioca
c
c --- Calcuration of deformation sequence.
c
      write(6,*)' Sequence No.= ',iseq
czz      if (iseq.lt.numseq) go to 1400
 1400 continue
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
 1401 continue
c
c --- end of the program
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      include 'helical_check.f'
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine hegr4(sou,pot,scmp,sicomp,pnagth,iesy,ilini,imini,iord)
c
*     In the following subroutine, grav4, when m is nonzero 
*      bsjy = -(2l+1)m*omega j_l(m*omega r_<) y_l(m*omega r_>) 
*     replaces 
*      hfsn = r_<^l/r_>^(l+1)  
*     to change the poisson solver to a helmholtz solver.
*     For m=0, bsjy is still r_<^l/r_>^(l+1) 
*
*     A final do loop, ending at label 100 in the old grav4, normalized
*     the potential.  It is now incorporated into the do loop that 
*     ends at label 1000.
*   
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
c     the common block grbs replaces grfsn 
      common / grbs / bsjy(0:nnrg,0:nnlg,0:nnlg,0:nnrg),
     &         sbsjy(0:nnlg,0:nnlg,0:nnrg),sbsjyp(0:nnlg,0:nnlg,0:nnrg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
c
      dimension  sou(0:nnrg,0:nntg,0:nnpg), pot(0:nnrg,0:nntg,0:nnpg)
      dimension  scmp(0:nnlg,0:nnpg), sicomp(0:nnlg,0:nnpg)
      dimension  pnagth(0:nnlg,0:nnlg,0:nntg)
      dimension work1(0:nntg,0:nnrg,0:nnlg),
     &          work2(0:nnrg,0:nnlg,0:nnlg),
     &          work3(0:nnlg,0:nnlg,0:nnrg),
     &          work4(0:nnlg,0:nnrg,0:nntg)
c
c --- Gravitational and Velocity potential is calculated. ---
c
c     L[p] = S --> p = 1/4pi Int[ S/r dV]
c     sin(phi) L[p] = S --> p = 1/4pi Int[ S/r dV]
c     sin(th) sin(phi) L[p] = S --> p = 1/4pi Int[ S/r dV]
c
c     no-rotational symmetry 
c
c     scmp --> cos(m phi) for x-z plane symmetric source. 
c              sin(m phi) for x-z plane anti-symmetric source. 
c     sicomp --> cos(m phi) for x-z plane symmetric source. 
c                sin(m phi) for x-z plane anti-symmetric source. 
c                sin(m phi)/sin(phi) 
c             for x-z plane anti-symmetrized source by sin(phi).
c     pnagth --> P_nm for nomal.
c     pnagth --> P_nm/sin(th) for a variable regularized 
c                by sin(th). (non-zero on theta = 0 axis.)
c     iesy --> 0 for equatorially symmetric source.
c              1 for equatorially anti-symmetric source.
c     ilini --> start of summation for index l. 
c     imini --> start of summation for index m. 
c              
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c   work1(itt,irr,im) = sum_ipp (scmp(im,ipp)*sou(irr,itt,ipp))
c   work2(irr,il,im) = sum_itt (pn(il,im,itt)*work1(itt,irr,im))
c   work3(il,im,ir) = sum_irr (hfn(irr,il,ir)*work2(irr,il,im))
c   work4(im,ir,it) = sum_il (pn(il,im,it)*work3(il,im,ir))
c   pot(ir,it,ip) = sum_im (scmp(im,ip)*work4(im,ir,it))
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c      write(6,*)' grav4  '
c
c    hfsn(irr,nn,ir) -->  for r'< r
c                         for r < r'
c
c --- for 4th order
c
chelitest
      nlgbak = nlg
cc      nlg = 2
chelitest
c
      san1 = 0.5d0
      if (iord.eq.4) san1 = 1.0d0/3.0d0
c
      do 1001 im = imini, nlg, msymg
      do 1001 irr = 1, nrtot
      do 1001 itt = 0, ntg
      work1(itt,irr,im) = 0.0d0
      do 1001 ipp = 0, npg
      work1(itt,irr,im) = work1(itt,irr,im) + 
     &                    wgrtpg(irr,itt,ipp)*
     &                    sou(irr,itt,ipp)*scmp(im,ipp)  
 1001 continue
c
      do 1002 il = 0, nlg
      do 1002 im = imini, nlg, msymg
      pari = 1.0d0 + (-1.0d0)**(il+im+iesy)
      pef = pari*epsig(im)*facnmg(il,im)
      do 1002 irr = 1, nrtot
      work2(irr,il,im) = 0.0d0
      do 1002 itt = 0, ntg
      work2(irr,il,im) = work2(irr,il,im) + 
     &                   pef*work1(itt,irr,im)*pnag(il,im,itt)
 1002 continue
c
      do 1003 ir = 0, nrtot
      do 1003 il = 0, nlg
      do 1003 im = imini, nlg, msymg
      work3(il,im,ir) = 0.0d0
chelitest
ckk      nrbound = nrtot
ckk      if (im.gt.8) nrbound = nrin 
ckk      do 1003 irr = 1, nrbound
      do 1003 irr = 1, nrtot
      work3(il,im,ir) = work3(il,im,ir) + 
     &                  work2(irr,il,im)*bsjy(irr,il,im,ir)
*  This is the place where bsjy has replaced hfsn in computing the potential
 1003 continue
c
      do 1004 it = 0, ntg
      do 1004 ir = 0, nrtot
      do 1004 im = imini, nlg, msymg
      work4(im,ir,it) = 0.0d0
      do 1004 il = ilini, nlg
      work4(im,ir,it) = work4(im,ir,it) + 
     &                  work3(il,im,ir)*pnagth(il,im,it)
 1004 continue
c
      pi = 3.14159265358979d+0
      pi4inv = 1.0d0/4.0d0/pi
      pi4aho = pi4inv*2.0d0*dble(msymg)
      do 1000 ip = 0, npg
      do 1000 it = 0, ntg
      do 1000 ir = 0, nrtot
       pot(ir,it,ip) = 0.0d0
chelitest
       nlgmax = nlg
cheli       if (ir.ge.nrin) nlgmax = 8
       do im = imini, nlgmax, msymg
        pot(ir,it,ip) = pot(ir,it,ip) +
     &                work4(im,ir,it)*sicomp(im,ip)
       enddo
      pot(ir,it,ip) = - pi4aho*pot(ir,it,ip)
 1000 continue
c
chelitest
      nlg = nlgbak
chelitest
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine hegr4sfout(omega,sou,dsou,spot,scmp,sicomp,pnagth,
     &                      iesy,ilini,imini,iord)
*
*     This subroutine computes the contribution spot(ir,it,ip)
*     to the potential pot from a surface term at the surface ir = nrtot 
*     The integrand is proportional to a function 
*      psis = partial_r pot(R,theta,phi)n_l(R) - pot \partial_r n_l(omega R)
*     The routine is adapted from grav4, omitting the r integral and 
*     r weighting, but retaining the theta and phi integrals and the 
*     corresponding sums
*
* P_lm components of the potential at the surface:
* swork1 is the mth component of pot, weighted by wgdtg
* spwork1 is the mth component of partial_r pot weighted by wgdtg
* swork2 is the lm component of pot
* spwork2 is the lm component of partial_r pot
*
*
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
c     the common block grbs replaces grfsn 
c      common omega
      common / grbs / bsjy(0:nnrg,0:nnlg,0:nnlg,0:nnrg),
     &         sbsjy(0:nnlg,0:nnlg,0:nnrg),sbsjyp(0:nnlg,0:nnlg,0:nnrg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
cccc     &               pnagco(0:nnlg,0:nnlg,0:nntg),
cccc     &               pnagsi(0:nnlg,0:nnlg,0:nntg)
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
c
      dimension  sou(0:nntg,0:nnpg), dsou(0:nntg,0:nnpg)
      dimension  spot(0:nnrg,0:nntg,0:nnpg)
      dimension  scmp(0:nnlg,0:nnpg), sicomp(0:nnlg,0:nnpg)
      dimension  pnagth(0:nnlg,0:nnlg,0:nntg)
      dimension  swork1(0:nntg,0:nnpg),spwork1(0:nntg,0:nnpg),
     &           swork2(0:nntg,0:nnpg),spwork2(0:nntg,0:nnpg),
     &           swork3(0:nnlg,0:nnlg,0:nnrg),
     &           swork4(0:nnlg,0:nnrg,0:nntg)
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
chelitest
      nlgbak = nlg
cc      nlg = 2
chelitest
      do 1001 im = imini, nlg, msymg
      do 1001 itt = 0, ntg
      swork1(itt,im) = 0.0d0
      spwork1(itt,im) = 0.0d0
      do 1001 ipp = 0, npg
      swork1(itt,im) = swork1(itt,im) + 
     &                    wgdtg(itt)*wgdpg(ipp)*
     &                    sou(itt,ipp)*scmp(im,ipp)
cc     &                    pot(nrtot,itt,ipp)*scmp(im,ipp)
      spwork1(itt,im) = spwork1(itt,im) + 
     &                    wgdtg(itt)*wgdpg(ipp)*
     &                    dsou(itt,ipp)*scmp(im,ipp)
 1001 continue
c
      do 1002 il = 0, nlg
      do 1002 im = imini, nlg, msymg
      pari = 1.0d0 + (-1.0d0)**(il+im+iesy)
      pef = pari*epsig(im)*facnmg(il,im)
      swork2(il,im) = 0.0d0
      spwork2(il,im) = 0.d0
      do 1002 itt = 0, ntg
       swork2(il,im) = swork2(il,im) + 
     &                     pef*swork1(itt,im)*pnag(il,im,itt)
       spwork2(il,im) = spwork2(il,im) + 
     &                     pef*spwork1(itt,im)*pnag(il,im,itt)
 1002 continue
c
*
*   Construct the surface integral for each l,m,r 
*    psi =  partial_r pot_lm *y_l(m omega r) - pot_lm* partial_r y_l(m omega r)
*   swork3 = psi * (-m omega)(2l+1)
*  
*   sbsjy :=  j_l(m omega r) y_l(m omega R) (m omega)(2l+1)
*   sbsjyp =  j_l(m omega r) y_l'(m omega R)(m omega)^2(2l+1)
*
      do 1003 il = 0, nlg
      do 1003 im = imini, nlg, msymg
      do 1003 ir = 0, nrtot     
      swork3(il,im,ir) = spwork2(il,im)*sbsjy(il,im,ir) 
     &                 -  swork2(il,im)*sbsjyp(il,im,ir)
 1003 continue
c
      do 1004 it = 0, ntg
      do 1004 ir = 0, nrtot
      do 1004 im = imini, nlg, msymg
       swork4(im,ir,it) = 0.0d0
      do 1004 il = ilini, nlg
       swork4(im,ir,it) = swork4(im,ir,it) + 
     &                    swork3(il,im,ir)*pnagth(il,im,it)
 1004 continue
c
      pi = 3.14159265358979d+0
      pi4inv = 1.0d0/4.0d0/pi
      rsqpi4aho =rg(nrtot)*rg(nrtot)*pi4inv*2.0d0*dble(msymg)
      do 1000 ip = 0, npg
      do 1000 it = 0, ntg
      do 1000 ir = 0, nrtot
      spot(ir,it,ip) = 0.0d0
       do im = imini, nlg, msymg
        spot(ir,it,ip) = spot(ir,it,ip) +
     &                   swork4(im,ir,it)*sicomp(im,ip)
       enddo
      spot(ir,it,ip) = - rsqpi4aho*spot(ir,it,ip)
 1000 continue
c
chelitest
      nlg = nlgbak
chelitest
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grav4(sou,pot,scmp,sicomp,pnagth,iesy,ilini,imini,iord)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
      common / grfsn / hfsn(0:nnrg,0:nnlg,0:nnrg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
c
      dimension  sou(0:nnrg,0:nntg,0:nnpg), pot(0:nnrg,0:nntg,0:nnpg)
      dimension  scmp(0:nnlg,0:nnpg), sicomp(0:nnlg,0:nnpg)
      dimension  pnagth(0:nnlg,0:nnlg,0:nntg)
      dimension work1(0:nntg,0:nnrg,0:nnlg),
     &          work2(0:nnrg,0:nnlg,0:nnlg),
     &          work3(0:nnlg,0:nnlg,0:nnrg),
     &          work4(0:nnlg,0:nnrg,0:nntg)
c
c --- Gravitational and Velocity potential is caluculated. ---
c
c     L[p] = S --> p = 1/4pi Int[ S/r dV]
c     sin(phi) L[p] = S --> p = 1/4pi Int[ S/r dV]
c     sin(th) sin(phi) L[p] = S --> p = 1/4pi Int[ S/r dV]
c
c     no-rotational symmetry 
c
c     scmp --> cos(m phi) for x-z plane symmetric source. 
c              sin(m phi) for x-z plane anti-symmetric source. 
c     sicomp --> cos(m phi) for x-z plane symmetric source. 
c                sin(m phi) for x-z plane anti-symmetric source. 
c                sin(m phi)/sin(phi) 
c             for x-z plane anti-symmetrized source by sin(phi).
c     pnagth --> P_nm for nomal.
c     pnagth --> P_nm/sin(th) for a variable regularized 
c                by sin(th). (non-zero on theta = 0 axis.)
c     iesy --> 0 for equatorially symmetric source.
c              1 for equatorially anti-symmetric source.
c     ilini --> start of summation for index l. 
c     imini --> start of summation for index m. 
c              
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c   work1(itt,irr,im) = sum_ipp (scmp(im,ipp)*sou(irr,itt,ipp))
c   work2(irr,il,im) = sum_itt (pn(il,im,itt)*work1(itt,irr,im))
c   work3(il,im,ir) = sum_irr (hfn(irr,il,ir)*work2(irr,il,im))
c   work4(im,ir,it) = sum_il (pn(il,im,it)*work3(il,im,ir))
c   pot(ir,it,ip) = sum_im (scmp(im,ip)*work4(im,ir,it))
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c      write(6,*)' grav4  '
c
c    hfsn(irr,nn,ir) -->  for r'< r
c                         for r < r'
c
c --- for 4th order
c
      san1 = 0.5d0
      if (iord.eq.4) san1 = 1.0d0/3.0d0
c
      do 1001 im = imini, nlg, msymg
      do 1001 irr = 1, nrtot
      do 1001 itt = 0, ntg
      work1(itt,irr,im) = 0.0d0
      do 1001 ipp = 0, npg
      work1(itt,irr,im) = work1(itt,irr,im) + 
     &                    wgrtpg(irr,itt,ipp)*
     &                    sou(irr,itt,ipp)*scmp(im,ipp)  
 1001 continue
c
      do 1002 il = ilini, nlg
      do 1002 im = imini, nlg, msymg
      pari = 1.0d0 + (-1.0d0)**(il+im+iesy)
      pef = pari*epsig(im)*facnmg(il,im)
      do 1002 irr = 1, nrtot
      work2(irr,il,im) = 0.0d0
      do 1002 itt = 0, ntg
      work2(irr,il,im) = work2(irr,il,im) + 
     &                   pef*work1(itt,irr,im)*pnag(il,im,itt)
 1002 continue
c
      do 1003 ir = 0, nrtot
      do 1003 il = ilini, nlg
      do 1003 im = imini, nlg, msymg
      work3(il,im,ir) = 0.0d0
      do 1003 irr = 1, nrtot
      work3(il,im,ir) = work3(il,im,ir) + 
     &                  work2(irr,il,im)*hfsn(irr,il,ir)
 1003 continue
c
      do 1004 it = 0, ntg
      do 1004 ir = 0, nrtot
      do 1004 im = imini, nlg, msymg
      work4(im,ir,it) = 0.0d0
      do 1004 il = ilini, nlg
      work4(im,ir,it) = work4(im,ir,it) + 
     &                  work3(il,im,ir)*pnagth(il,im,it)
 1004 continue
c
      do 1000 ip = 0, npg
      do 1000 it = 0, ntg
      do 1000 ir = 0, nrtot
      pot(ir,it,ip) = 0.0d0
      do 1000 im = imini, nlg, msymg
      pot(ir,it,ip) = pot(ir,it,ip) +
     &                work4(im,ir,it)*sicomp(im,ip)
 1000 continue
c
      pi = 3.14159265358979d+0
      pi4inv = 1.0d0/4.0d0/pi
      pi4aho = pi4inv*2.0d0*dble(msymg)
      do 100 ip = 0, npg
      do 100 it = 0, ntg
      do 100 ir = 0, nrtot
 100  pot(ir,it,ip) = - pi4aho*pot(ir,it,ip)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grav4sfout(sousf,pot,scmp,sicomp,iesy,iaho,ilini,imini)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
c
      dimension  pot(0:nnrg,0:nntg,0:nnpg)
      dimension  sousf(0:nntg,0:nnpg)
      dimension  scmp(0:nnlg,0:nnpg), sicomp(0:nnlg,0:nnpg)
      dimension work1(0:nntg,0:nnlg), 
     &          work2(0:nnlg,0:nnlg), 
     &          work3(0:nnlg,0:nnrg),
     &          work4(0:nnlg,0:nnrg,0:nntg)
c
c --- Gravitational and Velocity potential is caluculated. ---
c
c     pi-rotation (anti-)symmetry.
c
c     iesy --> 0 for equatorially symmetric source.
c              1 for equatorially anti-symmetric source.
c     iaho --> 3 for d phi/dr condition (outward normal). 
c              4 for phi(r) condition (outward normal).
c     imini --> start of summation for index m. 
c              
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c   work1(itt,im) = sum_ipp (scmp(im,ipp)*sou(itt,ipp))
c   work2(il,im) = sum_itt (pn(il,im,itt)*work1(itt,im))
c   work3(il,ir) = n or rvout * (rvout/rg(ir))**il
c   work4(im,ir,it) = sum_il (pn(il,im,it)*work3(il,ir)*
c                             work2(il,im))
c   pot(ir,it,ip) = sum_im (scmp(im,ip)*work4(im,ir,it))
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      do 1001 im = imini, nlg, msymg
      do 1001 itt = 0, ntg
      work1(itt,im) = 0.0d0
      do 1001 ipp = 0, npg
      wok = w4dtg(itt)*w4dpg(ipp)*sousf(itt,ipp)
      work1(itt,im) = work1(itt,im) + wok*scmp(im,ipp)
 1001 continue
c
      do 1002 il = 0, nlg
      do 1002 im = imini, nlg, msymg
      pari = 1.0d0 + (-1.0d0)**(il+im+iesy)
      pef  = 2.0d0*pari*epsig(im)*facnmg(il,im)
      work2(il,im) = 0.0d0
      do 1002 itt = 0, ntg
      wok = pef*pnag(il,im,itt)
      work2(il,im) = work2(il,im) + wok*work1(itt,im)
 1002 continue
c
      rvoutinv = 1.0d0/rvout
      do 1003 ir = 0, nrtot
      il = 0
      if (iaho.eq.3) enn = rvout
      if (iaho.eq.4) enn = - dble(il+1)
      work3(il,ir) = enn
      do 1003 il = 1, nlg
      if (iaho.eq.3) enn = rvout*(rg(ir)*rvoutinv)**il
      if (iaho.eq.4) enn = - dble(il+1)*(rg(ir)*rvoutinv)**il
      work3(il,ir) = enn
 1003 continue
c
      do 1004 it = 0, ntg
      do 1004 ir = 0, nrtot
      do 1004 im = imini, nlg, msymg
      work4(im,ir,it) = 0.0d0
      do 1004 il = ilini, nlg
      wok = work3(il,ir)*pnag(il,im,it)
      work4(im,ir,it) = work4(im,ir,it) + wok*work2(il,im)
 1004 continue
c
      do 1000 ip = 0, npg
      do 1000 it = 0, ntg
      do 1000 ir = 0, nrtot
      pot(ir,it,ip) = 0.0d0
      do 1000 im = imini, nlg, msymg
      pot(ir,it,ip) = pot(ir,it,ip)
     &              + work4(im,ir,it)*sicomp(im,ip)
 1000 continue
c
      pi = 3.14159265358979d+0
      pi4inv = 1.0d0/4.0d0/pi
      if (iaho.eq.1.or.iaho.eq.3) pi4aho = pi4inv*2.0d0*dble(msymg)
      if (iaho.eq.2.or.iaho.eq.4) pi4aho = - pi4inv*2.0d0*dble(msymg)
c
      do 100 ip = 0, npg
      do 100 it = 0, ntg
      do 100 ir = 0, nrtot
 100  pot(ir,it,ip) = pi4aho*pot(ir,it,ip)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine halfsou(sou)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
      dimension sou(0:nnrg,0:nntg,0:nnpg), soub(0:nnrg,0:nntg,0:nnpg)
      dimension x4(4), f4(4)
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
      do 100 irg = 0, nrtot
      soub(irg,itg,ipg) = sou(irg,itg,ipg)
  100 continue
c
      do 101 irg = 1, nrtot
      hhrr = hrg(irg)
      irg0 = min0(max0(irg-2,0),nrtot-3) - 1
      do 102 ii = 1, 4
      x4(ii) = rg(irg0+ii)
  102 continue
      do 101 ipg = 0, npg
      do 101 itg = 0, ntg
      do 104 ii = 1, 4
      f4(ii) = soub(irg0+ii,itg,ipg)
  104 continue
      sou(irg,itg,ipg) = fn_lagint(x4,f4,hhrr)
  101 continue
c
      do 105 ipg = 0, npg
      do 105 itg = 0, ntg
      sou(0,itg,ipg) = 0.0d0
 105  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine halfsousym(sou,ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
      dimension sou(0:nnrg,0:nntg,0:nnpg), soub(0:nnrg,0:nntg,0:nnpg)
      dimension x4(4), f4(4)
c
      ir0sym = ixysym*iyzsym*izxsym
      r0sym = dble(ir0sym)
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
      do 100 irg = 0, nrtot
      soub(irg,itg,ipg) = sou(irg,itg,ipg)
  100 continue
c
      do 1 irg = 1, nrtot
      ir0 = min0(irg-2,nrtot-3)
c
      do 8 ii = 1, 4
      irg0 = ir0 + ii - 1
      x4(ii) = rgex(irg0)
 8    continue
      hhrr = hrg(irg)
c
      do 2 ipg = 0, npg
      do 2 itg = 0, ntg
      do 9 ii = 1, 4
      irg0 = ir0 + ii - 1
      irlsw = (irg0-1)/nrtot
      irssw = (1-isign(1,irg0))/2
      irmsw = 1 - irlsw - irssw
      iairg0 = (irssw + irmsw)*iabs(irg0) + irlsw*(2*nrtot-irg0)
      rlsw = dble(irlsw)
      rssw = dble(irssw)
      rmsw = dble(irmsw)
      facr = rmsw + r0sym*rssw
      f4(ii) = facr*soub(iairg0,itg,ipg)
 9    continue
      sou(irg,itg,ipg) = fn_lagint(x4,f4,hhrr)
 2    continue
 1    continue
c
      do 105 ipg = 0, npg
      do 105 itg = 0, ntg
      sou(0,itg,ipg) = 0.0d0
 105  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine halfsou2(sou,isy)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
      dimension sou(0:nnrg,0:nntg,0:nnpg), soub(0:nnrg,0:nntg,0:nnpg)
      dimension x4(4), f4(4)
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
      soub(0,itg,ipg) = sou(0,itg,ipg)
      if (isy.eq.1) soub(0,itg,ipg) = 0.0d0
      do 100 irg = 1, nrtot
      soub(irg,itg,ipg) = sou(irg,itg,ipg)
  100 continue
c
      if (isy.eq.0) irg1 = 1
      if (isy.eq.1) then
      irg1 = 2
      irg = 1
      hhrr = hrg(irg)
      do 1001 ipg = 0, npg
      do 1001 itg = 0, ntg
      sou(irg,itg,ipg) = 0.5d0*sou(2,itg,ipg)
 1001 continue
      end if
c
      do 101 irg = irg1, nrtot
      hhrr = hrg(irg)
      irg0 = min0(max0(irg-2,0),nrtot-3) - 1
      do 102 ii = 1, 4
      x4(ii) = rg(irg0+ii)
  102 continue
      do 101 ipg = 0, npg
      do 101 itg = 0, ntg
      do 104 ii = 1, 4
      f4(ii) = soub(irg0+ii,itg,ipg)
  104 continue
      sou(irg,itg,ipg) = fn_lagint(x4,f4,hhrr)
  101 continue
c
      do 105 ipg = 0, npg
      do 105 itg = 0, ntg
      sou(0,itg,ipg) = 0.0d0
 105  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine nonvfl(iddd)
c
c --- cal.non-variables on grids. (s.t. radius sine cosine etc.)
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      common / extpt / cospmp(0:nnp,0:nnp), cosppp(0:nnp,0:nnp) 
      common / weigh / wgdr(0:nnr), wgdt(0:nnt), wgdp(0:nnp),
     &                wgrtp(0:nnr,0:nnt,0:nnp),
     &                 w4dr(0:nnr), w4dt(0:nnt), w4dp(0:nnp),
     &                w4rtp(0:nnr,0:nnt,0:nnp), wahop(0:nnr,0:nnt,0:nnp)
      common / legen / spn(0:nnt,0:nnp,0:nnl), 
     &                 fsn(0:nnr,0:nnl,0:nnr)
      common / asleg / pna(0:nnla,0:nnla,0:nnt),
     &               dtpna(0:nnla,0:nnla,0:nnt), 
     &               facnm(0:nnla,0:nnla), epsi(0:nnla)
      common / trimp / sinmp(0:nnla,0:nnp),  cosmp(0:nnla,0:nnp)
      common / asylm / ypna(0:nnla,0:nnla,0:nnt),
     &               dtypna(0:nnla,0:nnla,0:nnt)
c
      dimension fac(0:nnla)
      dimension qp1(0:nnl), qp2(0:nnl), qp3(0:nnl), qp4(0:nnl)
c
c- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- Set up of meshes  ---  ( r(1) = dr ( not the center ) )
c --- The constatnt msym means the symmetry of the configuration.
c
      pi = 3.14159265358979d+0
      dr   = 1.0d0/dble(nr)
      dth  = pi/2.d0/dble(nt)
      dphi = pi/dble(msym)/dble(np)
      drf   = dr
      dthf  = dth
      dphif = dphi
c
      drinv = 1.0d0/dr
      dthinv = 1.0d0/dth
      dphiinv = 1.0d0/dphi
      drfinv = drinv
      dthfinv = dthinv
      dphifinv = dphiinv
c
      do 100 ir = 0, nr
      r(ir) = dble(ir)*dr
      rf(ir) = r(ir)
  100 continue
      rinv( 0) = 0.d0
      rfinv(0) = rinv(0)
      do 104 ir = 1, nr
      rinv(ir) = 1.0d0/r(ir)
      rfinv(ir) = rinv(ir)
  104 continue      
c
      do 101 it = 0, nt
      th(it) = dble(it)*dth
      thf(it) = th(it)
  101 continue
      do 102 ip = 0, np
      phi(ip) = dble(ip)*dphi
      phif(ip) = phi(ip)
  102 continue
c
c --- cal. sine ,cosine and tange on grids of polar angle. ---
c --- notice ; tange diverge to infinity when agr=pi/2, j1=m
c
      do 121 it  = 0, nt
      sinthe(it) = dsin(th(it))
      costhe(it) = dcos(th(it))
      sinthef(it) = sinthe(it)
      costhef(it) = costhe(it)
  121 continue
      cosec( 0) = 0.0d0
      cosecf(0) = cosec(0)
      do 122 it = 1, nt
      cosec(it) = 1.0d0/dsin(th(it))
      cosecf(it)= cosec(it)
  122 continue
c
      do 124 ip  = 0, np
      sinphi(ip) = dsin(phi(ip))
      cosphi(ip) = dcos(phi(ip))
      sinphif(ip) = sinphi(ip)
      cosphif(ip) = cosphi(ip)
      do 124 nn  = 0, nla
      fnn = dble(nn)
      sinmp(nn,ip) = dsin(fnn*phi(ip))
      cosmp(nn,ip) = dcos(fnn*phi(ip))
  124 continue
c
      do 125 ip  = 0, np
      do 125 ipp = 0, np
      cospmp(ipp,ip) = dcos(phi(ip) - phi(ipp))
      cosppp(ipp,ip) = dcos(phi(ip) + phi(ipp))
  125 continue
c
c --- weight for integration.
c
      san1 = 1.0d0/3.0d0
      san4 = 4.0d0/3.0d0
      san2 = 2.0d0/3.0d0
      do 191 ip = 0, np
      if(ip.eq.0.or .ip.eq.np) wgdp(ip) = 0.5d0*dphi
      if(ip.ne.0.and.ip.ne.np) wgdp(ip) = 1.0d0*dphi
      if(ip.eq.0.or .ip.eq.np                   ) w4dp(ip) = san1*dphi
      if(ip.ne.0.and.ip.ne.np.and.mod(ip,2).eq.1) w4dp(ip) = san4*dphi
      if(ip.ne.0.and.ip.ne.np.and.mod(ip,2).eq.0) w4dp(ip) = san2*dphi
  191 continue
      do 192 it = 0, nt
      if(it.eq.0.or .it.eq.nt) wgdt(it) = 0.5d0*sinthe(it)*dth
      if(it.ne.0.and.it.ne.nt) wgdt(it) = 1.0d0*sinthe(it)*dth
      if(it.eq.0.or .it.eq.nt                   ) 
     &   w4dt(it) = san1*sinthe(it)*dth
      if(it.ne.0.and.it.ne.nt.and.mod(it,2).eq.1) 
     &   w4dt(it) = san4*sinthe(it)*dth
      if(it.ne.0.and.it.ne.nt.and.mod(it,2).eq.0) 
     &   w4dt(it) = san2*sinthe(it)*dth
  192 continue
      do 194 ir = 0, nr
      if(ir.eq.0.or .ir.eq.nr) wgdr(ir) = 0.5d0*r(ir)**2*dr
      if(ir.ne.0.and.ir.ne.nr) wgdr(ir) = 1.0d0*r(ir)**2*dr
      if(ir.eq.0.or .ir.eq.nr                   ) 
     &   w4dr(ir) = san1*r(ir)**2*dr
      if(ir.ne.0.and.ir.ne.nr.and.mod(ir,2).eq.1) 
     &   w4dr(ir) = san4*r(ir)**2*dr
      if(ir.ne.0.and.ir.ne.nr.and.mod(ir,2).eq.0) 
     &   w4dr(ir) = san2*r(ir)**2*dr
  194 continue
c
      do 195 ip = 0, np
      do 195 it = 0, nt
      do 195 ir = 0, nr
      wgrtp(ir,it,ip)=wgdr(ir)*wgdt(it)*wgdp(ip)
      w4rtp(ir,it,ip)=w4dr(ir)*w4dt(it)*w4dp(ip)
      if (iddd.ne.4) wahop(ir,it,ip) = wgrtp(ir,it,ip)
      if (iddd.eq.4) wahop(ir,it,ip) = w4rtp(ir,it,ip)
  195 continue
c
c --- computation of the legendre polynomials
c
      do 2001 ipp = 0, np
      do 2001 itt = 0, nt
c
      do 2002 il = 0, nl
      spn(itt,ipp,il) = 0.0d0
 2002 continue
c
      it = nt
      ip = np
      ssit  = dsin(th(it))
      ccit  = dcos(th(it))
      ssitt = dsin(th(itt))
      ccitt = dcos(th(itt))
      spitt = dsin(pi-th(itt))
      cpitt = dcos(pi-th(itt))
      corot = dcos(phi(ip)-phi(ipp))
      coref = dcos(phi(ip)+phi(ipp))
c
      cosg1 = ccit*ccitt+ssit*ssitt*corot
      cosg2 = ccit*cpitt+ssit*spitt*corot
      cosg3 = ccit*ccitt+ssit*ssitt*coref
      cosg4 = ccit*cpitt+ssit*spitt*coref
c
      qp1(0) = 1.0d+0
      qp1(1) = cosg1
      qp2(0) = 1.0d+0
      qp2(1) = cosg2
      qp3(0) = 1.0d+0
      qp3(1) = cosg3
      qp4(0) = 1.0d+0
      qp4(1) = cosg4
c
      do 2010 il = 2, nl
      b1 = 1.0d0-1.0d0/dble(il)
      b2 = 2.0d0-1.0d0/dble(il)
      qp1(il) = b2*cosg1*qp1(il-1)-b1*qp1(il-2)
      qp2(il) = b2*cosg2*qp2(il-1)-b1*qp2(il-2)
      qp3(il) = b2*cosg3*qp3(il-1)-b1*qp3(il-2)
      qp4(il) = b2*cosg4*qp4(il-1)-b1*qp4(il-2)
 2010 continue
c
      do 2014 il = 0, nl
       spn(itt,ipp,il) = spn(itt,ipp,il) 
     &     +   qp1(il)  +   qp2(il) +   qp3(il) +   qp4(il)
 2014 continue
c
 2001 continue
c
c ----------------------------------------------------------------------
c        The associated Legendre polynomials are computed.  
c 
c        nla : maximum value of n
c ----------------------------------------------------------------------
c
c --- computation of associated Legendre polynomials.
c
      do 2110 it = 0, nt
c
      cc = dcos(dth*dble(it))
      ss = dsin(dth*dble(it))
c
      do 2120 nn = 0, nla
      do 2120 mm = 0, nla
      pna(nn,mm,it)  = 0.0d0
      dtpna(nn,mm,it)  = 0.0d0
 2120 continue
c
      fac(0) = 1.0d0
      do 2121 mm = 1, nla
      fmm = dble(mm)
      fac(mm) = (2.0d0*fmm-1.0d0) * fac(mm-1)
 2121 continue
c
      pna(0,0,it) = 1.d0
      dtpna(0,0,it) = 0.d0
      do 2122 mm = 1, nla
        pna(mm,mm,it) = fac(mm) * (-ss)**mm 
 2122 continue
      mm = 1
      dtpna(mm,mm,it) = fac(mm) * dble(mm)*(-cc)
      do 2220 mm = 2, nla
      dtpna(mm,mm,it) = fac(mm) * dble(mm)*(-ss)**(mm-1)*(-cc)
 2220 continue
c
      do 2123 mm = 0, nla-1
      fmm = dble(mm)
        pna(mm+1,mm,it) = (2.0d0*fmm + 1.0d0)* cc*  pna(mm,mm,it)
      dtpna(mm+1,mm,it) = (2.0d0*fmm + 1.0d0)*(cc*dtpna(mm,mm,it)
     &                                  -ss*  pna(mm,mm,it))
 2123 continue
c
      do 2124 mm = 0, nla-2
      fmm = dble(mm)
      do 2124 kk = 2, nla-mm
      fkk = dble(kk)
      q1 = ( 2.0d0 * fmm + 2.0d0 * fkk - 1.0d0 ) / fkk
      q2 = ( 2.0d0 * fmm + fkk - 1.0d0 ) / fkk
      pna(mm+kk,mm,it) = q1 * cc * pna(mm+kk-1,mm,it)
     &                 - q2      * pna(mm+kk-2,mm,it)
      dtpna(mm+kk,mm,it) = q1 *(cc * dtpna(mm+kk-1,mm,it)
     &                        - ss *   pna(mm+kk-1,mm,it)) 
     &                   - q2      * dtpna(mm+kk-2,mm,it)
 2124 continue
c
 2110 continue
c
c -------------------------------
c --- Computation of factors. ---
c -------------------------------
c
      do 2139 nn = 0, nla
      do 2139 mm = 0, nla
      facnm(nn,mm) = 0.0d+0
 2139 continue
c
      facnm(0,0) = 1.0d0
      do 2140 nn = 1, nla
      fnn  = dble(nn)
      facnm(nn,0) = 1.0d0
      do 2140 mm = 1, nn
      fmm  = dble(mm)
      fnmfm= fnn-fmm + 1.0d0 
      facnm(nn,mm) = facnm(nn,mm-1)/(fnn+fmm)/fnmfm
 2140 continue
c
      do 2141 mm = 0, nla 
      epsi(mm) = 2.0d+0 
      if (mm.eq.0) epsi(mm) = 1.0d+0 
 2141 continue
c
      do 2142 it = 0, nt
      do 2142 nn = 0, nla
      do 2142 mm = 0, nn
        ypna(nn,mm,it) = (epsi(mm)*(2.0d0*dble(nn)+1.0d0)/(4.0d0*pi)*
     &                   facnm(nn,mm))**0.5d0*pna(nn,mm,it)
      dtypna(nn,mm,it) = (epsi(mm)*(2.0d0*dble(nn)+1.0d0)/(4.0d0*pi)*
     &                   facnm(nn,mm))**0.5d0*dtpna(nn,mm,it)
 2142 continue
c
c ------------------------------------
c --- Computation of functoin fsn. ---
c ------------------------------------
c
c    fsn(irr,nn,id,ir) --> id =  0 for rs'*r' < rs*r
c                          id = +1 for rs*r < rs'*r'
c
      do 418 nn  = 0, nl
      do 418 ir  = 0, nr
      do 418 irr = 0, nr
        fsn(irr,nn,ir) = 0.d0
  418 continue
c
      do 419 ir  = 1, nr
      do 419 irr = 1, nr
      if (r(irr).lt.r(ir)) then
      do 4190 nn  = 0, nl
        fsn(irr,nn,ir) = r(irr)**nn/r(ir)**(nn+1)
 4190 continue
      end if
      if (r(irr).ge.r(ir)) then
      do 4191 nn  = 0, nl
        fsn(irr,nn,ir) = r(ir)**nn/r(irr)**(nn+1)
 4191 continue
      end if
 419  continue
c
      ir  = 0
      nn  = 0
      do 420 irr = 1, nr
        fsn(irr,nn,ir) = 1.0d0/r(irr)
 420  continue
      irr = 0
      nn  = 0
      do 421 ir = 1, nr
        fsn(irr,nn,ir) = 1.0d0/r(ir)
 421  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine nonvgr
c
c --- cal.non-variables on grids. (s.t. radius sine cosine etc.)
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / trmpg / sinmpg(0:nnlg,0:nnpg), cosmpg(0:nnlg,0:nnpg),
     &                simpsig(0:nnlg,0:nnpg)
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
      common / grfsn / hfsn(0:nnrg,0:nnlg,0:nnrg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
      common / dvphi / dphiu(3,3)
c
      dimension fac(0:nnlg)
c
c- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- Set up of meshes  ---  ( r(1) = dr ( not the center ) )
c --- The constatnt msym means the symmetry of the configuration.
c
      pi = 3.14159265358979d+0
c
      dthg  = pi/2.d0/dble(ntg)
      dphig = pi/2.d0/dble(npg)
c
      dthginv=1.0d0/dthg
      dphiginv=1.0d0/dphig
      dthginv2=1.0d0/dthg/2.0d0
      dphiginv2=1.0d0/dphig/2.0d0
      dthginv12=1.0d0/dthg/12.0d0
      dphiginv12=1.0d0/dphig/12.0d0
c
      nrin = nnn*nr
      nrtot = nrin + nrout
      rvdom = rvout - dble(nnn)
c
      nrg0 = 4
      ntg0 = 4
      npg0 = 4
c
      drdr = 1.0d0/dble(nr)
      drdrinv = dble(nr)
      do 100 ir = 0, nrin
      drg(ir)   = drdr
      drginv(ir) = drdrinv
      drginv2(ir) = 0.5d0*drdrinv
 100  continue
c
c --- For variable mesh.
c
      ratrr = 2.0d0
c
 1400 continue
c
      ratrrb = ratrr
      alge = -(ratrr**(nrout+1)-ratrr-rvdom*drdrinv*(ratrr-1.0d0))
      dalge = dble(nrout+1)*ratrr**nrout - 1.0d0 - rvdom*drdrinv
      ratrr = ratrr + alge/dalge
      error = 2.d0*(ratrr - ratrrb)/(ratrr + ratrrb)
c
      if (dabs(error).gt.1.d-14) go to 1400
c
      do 101 ir = nrin+1, nrtot
      drg(ir) = ratrr*drg(ir-1)
      drginv(ir) = 1.0d0/drg(ir)
 101  continue
      do 102 ir = nrin+1, nrtot - 1
      drginv2(ir) = 1.0d0/(drg(ir)+drg(ir+1))
 102  continue
      drginv2(nrtot) = 1.0d0/(drg(nrtot)+drg(nrtot-1))
c
      rg(0) = 0.0d0
      rginv(0) = 0.0d0
      rgex(0) = rg(0)
      do 110 ir = 1, nrtot
      rg(ir) = rg(ir-1) + drg(ir)
      hrg(ir) = (rg(ir) + rg(ir-1))*0.5d0
      rginv(ir) = 1.0d0/rg(ir)
      hrginv(ir) = 1.0d0/hrg(ir)
      rgex(ir) = rg(ir)
  110 continue
      do 111 it = 0, ntg
      thg(it) = dble(it)*dthg
      thgex(it) = thg(it)
  111 continue
      do 112 ip = 0, npg
      phig(ip) = dble(ip)*dphig
      phigex(ip) = phig(ip)
  112 continue
c
c --  Added for grgrad
      do 114 ir = -nrg0, -1
      rgex(ir) = - rg(-ir)
  114 continue
      do 115 it = 1, ntg0
      thgex(-it) = - thg(it)
      thgex(ntg+it) = dble(ntg+it)*dthg
  115 continue
      do 116 ip = 1, npg0
      phigex(-ip) = - phig(ip)
      phigex(npg+ip) = dble(npg+ip)*dphig
  116 continue
c
      write(6,*)error, ratrr, rvout, rg(nrtot)
      rdet = rg(nrtot) - rvout
      if(rdet.gt.1.d-10)then
      write(6,*) ' bad coordinate '
      stop
      end if
c
c --  dphiu(a,b) = D_b\phi^a
c
      dphiu(1,1) = 0.0d0
      dphiu(1,2) =-1.0d0
      dphiu(1,3) = 0.0d0
      dphiu(2,1) = 1.0d0
      dphiu(2,2) = 0.0d0
      dphiu(2,3) = 0.0d0
      dphiu(3,1) = 0.0d0
      dphiu(3,2) = 0.0d0
      dphiu(3,3) = 0.0d0
c
c --- cal. sine ,cosine and tange on grids of polar angle. ---
c --- notice ; tange diverge to infinity when agr=pi/2, j1=m
c
      do 121 it  = 0, ntg
      sintheg(it) = dsin(thg(it))
      costheg(it) = dcos(thg(it))
  121 continue
      cosecg( 0) = 0.0d0
      cotang( 0) = 0.0d0
      do 122 it = 1, ntg - 1
      cosecg(it) = 1.0d0/dsin(thg(it))
      cotang(it) = 1.0d0/dtan(thg(it))
  122 continue
      cosecg(ntg) = 1.0d0
      cotang(ntg) = 0.0d0
c
      do 124 ip  = 0, npg
      sinphig(ip) = dsin(phig(ip))
      cosphig(ip) = dcos(phig(ip))
      if (ip.ne.0.and.ip.ne.npg) cotphig(ip) = 1.0d0/dtan(phig(ip))
      if (ip.eq.0  ) cotphig(ip) = 0.0d0
      if (ip.eq.npg) cotphig(ip) = 0.0d0
      do 124 nn  = 0, nlg
      fnn = dble(nn)
      sinmpg(nn,ip) = dsin(fnn*phig(ip))
      cosmpg(nn,ip) = dcos(fnn*phig(ip))
  124 continue
c
      do 1240 ip  = 0, npg
      simpsig( 0,ip) = 0.0d0
      simpsig( 1,ip) = 1.0d0
 1240 continue
      do 1140 nn  = 2, nlg
      fnn = dble(nn)
      simpsig(nn,0) = fnn
      do 1140 ip  = 1, npg
      simpsig(nn,ip) = sinmpg(nn,ip)/sinmpg(1,ip)
 1140 continue
c
c --- weight for integration.
c
      san1 = 1.0d0/3.0d0
      san4 = 4.0d0/3.0d0
      san2 = 2.0d0/3.0d0
c
      do 191 ip = 0, npg
czzz      if(ip.eq.0.or .ip.eq.npg) wgdpg(ip) = 0.5d0*dphig
czzz      if(ip.ne.0.and.ip.ne.npg) wgdpg(ip) = 1.0d0*dphig
      if(ip.eq.0.or .ip.eq.npg                   ) w4dpg(ip)=san1*dphig
      if(ip.ne.0.and.ip.ne.npg.and.mod(ip,2).eq.1) w4dpg(ip)=san4*dphig
      if(ip.ne.0.and.ip.ne.npg.and.mod(ip,2).eq.0) w4dpg(ip)=san2*dphig
c
      wgdpg(ip) = w4dpg(ip)
c
  191 continue
c
      do 192 it = 0, ntg
czzz      if(it.eq.0.or .it.eq.ntg) wgdtg(it) = 0.5d0*sintheg(it)*dthg
czzz      if(it.ne.0.and.it.ne.ntg) wgdtg(it) = 1.0d0*sintheg(it)*dthg
      if(it.eq.0.or .it.eq.ntg)
     &   w4dtg(it) = san1*sintheg(it)*dthg
      if(it.ne.0.and.it.ne.ntg.and.mod(it,2).eq.1)
     &   w4dtg(it) = san4*sintheg(it)*dthg
      if(it.ne.0.and.it.ne.ntg.and.mod(it,2).eq.0)
     &   w4dtg(it) = san2*sintheg(it)*dthg
c
      wgdtg(it) = w4dtg(it)
c
  192 continue
c
      do 194 ir = 1, nrtot
      wgdrg(ir) = hrg(ir)**2*drg(ir)
  194 continue
c
      do 195 ip = 0, npg
      do 195 it = 0, ntg
      do 195 ir = 1, nrtot
      wgrtpg(ir,it,ip)=wgdrg(ir)*wgdtg(it)*wgdpg(ip)
  195 continue
c
c ----------------------------------------------------------------------
c        The associated Legendre polynomials are computed.  
c 
c        nla : maximum value of n
c ----------------------------------------------------------------------
c
c --- computation of associated Legendre polynomials.
c
      do 2110 it = 0, ntg
c
      cc = dcos(dthg*dble(it))
      ss = dsin(dthg*dble(it))
c
      do 2120 nn = 0, nlg
      do 2120 mm = 0, nlg
      pnag(nn,mm,it)  = 0.0d0
 2120 continue
c
      fac(0) = 1.0d0
      do 2121 mm = 1, nlg
      fmm = dble(mm)
      fac(mm) = (2.0d0*fmm-1.0d0) * fac(mm-1)
 2121 continue
c
      pnag(0,0,it) = 1.d0
      do 2122 mm = 1, nlg
        pnag(mm,mm,it) = fac(mm) * (-ss)**mm 
 2122 continue
c
      do 2123 mm = 0, nlg-1
      fmm = dble(mm)
        pnag(mm+1,mm,it) = (2.0d0*fmm + 1.0d0)* cc*  pnag(mm,mm,it)
 2123 continue
c
      do 2124 mm = 0, nlg-2
      fmm = dble(mm)
      do 2124 kk = 2, nlg-mm
      fkk = dble(kk)
      q1 = ( 2.0d0 * fmm + 2.0d0 * fkk - 1.0d0 ) / fkk
      q2 = ( 2.0d0 * fmm + fkk - 1.0d0 ) / fkk
      pnag(mm+kk,mm,it) = q1 * cc * pnag(mm+kk-1,mm,it)
     &                  - q2      * pnag(mm+kk-2,mm,it)
 2124 continue
c
 2110 continue
c
c -------------------------------
c --- Computation of factors. ---
c -------------------------------
c
      do 2139 nn = 0, nlg
      do 2139 mm = 0, nlg
      facnmg(nn,mm) = 0.0d+0
 2139 continue
c
      facnmg(0,0) = 1.0d0
      do 2140 nn = 1, nlg
      fnn  = dble(nn)
      facnmg(nn,0) = 1.0d0
      do 2140 mm = 1, nn
      fmm  = dble(mm)
      fnmfm= fnn-fmm + 1.0d0 
      facnmg(nn,mm) = facnmg(nn,mm-1)/(fnn+fmm)/fnmfm
 2140 continue
c
      do 2141 mm = 0, nlg 
      epsig(mm) = 2.0d+0 
      if (mm.eq.0) epsig(mm) = 1.0d+0 
 2141 continue
c
c -------------------------------------
c --- Computation of functoin hfsn. ---
c -------------------------------------
c
c    hfsn(irr,nn,id,ir) --> for r' < r
c                           for r < r'
c
      do 418 nn  = 0, nlg
      do 418 ir  = 0, nrtot
      do 418 irr = 0, nrtot
        hfsn(irr,nn,ir) = 0.d0
  418 continue
c
      do 419 ir  = 1, nrtot
      do 4190 irr = 1, nrtot
      if (hrg(irr).lt.rg(ir)) then
      do 4191 nn  = 0, nlg
        hfsn(irr,nn,ir) = hrg(irr)**nn/rg(ir)**(nn+1)
 4191 continue
      end if
      if (hrg(irr).ge.rg(ir)) then
      do 4192 nn  = 0, nlg
        hfsn(irr,nn,ir) = rg(ir)**nn/hrg(irr)**(nn+1)
 4192 continue
      end if
 4190 continue
 419  continue
c
      ir  = 0
      nn  = 0
      do 4200 irr = 1, nrtot
        hfsn(irr,nn,ir) = 1.0d0/hrg(irr)
 4200 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine nonvint(rs)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / cfong / rgf(0:nnr,0:nnt,0:nnp), 
     &                thgf(0:nnr,0:nnt,0:nnp), 
     &               phigf(0:nnr,0:nnt,0:nnp)
      common / cgonf / rfg(0:nnrg,0:nntg,0:nnpg), 
     &                thfg(0:nnrg,0:nntg,0:nnpg), 
     &               phifg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      dimension rs(0:nnt,0:nnp)
c
c --- Determine region of interpolation on gravity coordinate.  
c
cdi      dis = dble(ndis)/dble(nr)
      dis = sepato
cdi      nrgmin = ndis - nr
cdi      nrgmax = ndis + nr
cdi      nrgmid =(nrgmax + nrgmin)/2
      nrgmin = ndis - nr
      nrgmax = ndis + nr + 1
      nrgmid =(nrgmax-1 + nrgmin)/2
c ### CAUTION current setting
      nrgdmx = nrgmid
      thmin  = pi/2.0d0 - dasin(1.0d0/dis)
      ntgmin = idint( thmin/dthg )
      phimax = dasin(1.0d0/dis)
      npgmax = idint(phimax/dphig) + 1
      if (ngdin.eq.0) npgmax = npg
      write (6,*) 'nr   = ', nr, ',  nt = ', nt,',  np = ', np
      write (6,*) 'ndis   = ', ndis, ',  nrgmid = ', nrgmid
      write (6,*) 'nrgmin = ', nrgmin, ',  nrgmax = ', nrgmax      
      write (6,*) 'ntgmin = ', ntgmin, ',  npgmax = ', npgmax      
c
c --- Find fluid coodinate values on gravity coordinate, cgf. 
c
      do 100 ip = 0, np
      do 100 it = 0, nt
      do 100 ir = 0, nr
      rr = rf(ir)*rs(it,ip)
      st = sinthef(it)
      ct = costhef(it)
      sp = sinphif(ip)
      cp = cosphif(ip)
      rstcp = rr*st*cp
      rstsp = rr*st*sp
      xxyy = (dis**2 + (rr*st)**2 + 2.d0*dis*rstcp)**0.5
      rgf(ir,it,ip) = (dis**2 + rr**2 + 2.d0*dis*rstcp)**0.5
      thgf(ir,it,ip) = datan2(xxyy,rr*ct)
      phigf(ir,it,ip) = datan2(rstsp,dis+rstcp)
 100  continue
c
c --- Find gravity coodinate values on fluid coordinate, cfg. 
c
      do 101 ip = 0, npgmax
      do 101 it = ntgmin, ntg
      do 101 ir = nrgmin, nrgmax
      rr = rg(ir)
      st = sintheg(it)
      ct = costheg(it)
      sp = sinphig(ip)
      cp = cosphig(ip)
      rstcp = rr*st*cp
      rstsp = rr*st*sp
c
      tiny = 1.0d-14
c
      xxyy = (dis**2 + (rr*st)**2 - 2.d0*dis*rstcp + tiny)**0.5
      thfg(ir,it,ip) = datan2(xxyy,rr*ct)
      if (-dis+rstcp.ne.0.0d0)
     &     phifg(ir,it,ip) = datan2(rstsp,-dis+rstcp)
      if (rstsp.eq.0.0d0.and.-dis+rstcp.eq.0.0d0)
     &     phifg(ir,it,ip) = 0.0d0
      if (rstsp.ne.0.0d0.and.-dis+rstcp.eq.0.0d0)
     &     phifg(ir,it,ip) = pi/2.0d0
c
      itf = idint(thfg(ir,it,ip)*dthfinv)
      ipf = idint(phifg(ir,it,ip)*dphifinv)
      fcth0 = (thfg(ir,it,ip) - thf(itf))*dthfinv
      fcth1 = 1.0d0 - fcth0
      fcphi0 = (phifg(ir,it,ip) - phif(ipf))*dphifinv
      fcphi1 = 1.0d0 - fcphi0
      rsave = 1.0d0
      if (ip.eq.0.and.it.ne.0.and.it.ne.ntg)
     & rsave = fcth1*rs(itf,ipf) + fcth0*rs(itf+1,ipf)
      if (ip.ne.0.and.ip.ne.npg.and.it.eq.ntg)
     & rsave = fcphi1*rs(ntf,ipf) + fcphi0*rs(ntf,ipf+1)
      if (ip.ne.0.and.ip.ne.npg.and.it.ne.0.and.it.ne.ntg) then
      f0p = fcphi1*rs(itf,ipf) + fcphi0*rs(itf,ipf+1)
      f1p = fcphi1*rs(itf+1,ipf) + fcphi0*rs(itf+1,ipf+1)
      rsave = fcth1*f0p + fcth0*f1p
      end if
      rfg(ir,it,ip)=(dis**2 + rr**2 - 2.d0*dis*rstcp + tiny)**0.5/rsave
c
 101  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine fl2grspl(flv,grv,rs,hhrg,rrrg,isw)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / cfong / rgf(0:nnr,0:nnt,0:nnp), 
     &                thgf(0:nnr,0:nnt,0:nnp), 
     &               phigf(0:nnr,0:nnt,0:nnp)
      common / cgonf / rfg(0:nnrg,0:nntg,0:nnpg), 
     &                thfg(0:nnrg,0:nntg,0:nnpg), 
     &               phifg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      dimension grv(0:nnrg,0:nntg,0:nnpg), flv(0:nnr,0:nnt,0:nnp)
      dimension rs(0:nnt,0:nnp),hhrg(nnrg),rrrg(0:nnrg),rrgg(0:nnrg)
      dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),
     &          f(1),f2(2),f4(4),f44(4,4)
      dimension xx(2*nnr+1),yy(2*nnr+1),cc(2*nnr,3),
     &          xf(2*nnr),ff(2*nnr)
c
c ---
c
      small = 1.0d-10
c
      if (isw.eq.0) then
      rrgg(0)   = 0.0d0
      do 9000 irg = 1, nrtot
      rrgg(irg) = hhrg(irg)
 9000 continue
      end if
c
      if (isw.ne.0) then
      do 9001 irg = 0, nrtot
      rrgg(irg) = rrrg(irg)
 9001 continue
      end if
c
c --- Find gravity coodinate values on fluid coordinate, cfg. 
c
      nc = nnr
      n = 4
      iopt(1)=3
      iopt(2)=3
caho      iopt(1)=1
caho      iopt(2)=1
      df(1) = 0.0d0
      df(2) = 0.0d0
c
      dis = sepato
c
      do 101 ip = 0, npgmax
      do 101 it = ntgmin, ntg
      do 101 ir = nrgmin, nrgmax
      rr = rrgg(ir)
      st = sintheg(it)
      ct = costheg(it)
      sp = sinphig(ip)
      cp = cosphig(ip)
      rstcp = rr*st*cp
      rstsp = rr*st*sp
c
      tiny = 1.0d-14
c
      xxyy = (dis**2 + (rr*st)**2 - 2.d0*dis*rstcp + tiny)**0.5
      thfg(ir,it,ip) = datan2(xxyy,rr*ct)
      if (-dis+rstcp.ne.0.0d0) 
     &     phifg(ir,it,ip) = datan2(rstsp,-dis+rstcp)
      if (rstsp.eq.0.0d0.and.-dis+rstcp.eq.0.0d0)
     &     phifg(ir,it,ip) = 0.0d0
      if (rstsp.ne.0.0d0.and.-dis+rstcp.eq.0.0d0)
     &     phifg(ir,it,ip) = pi/2.0d0
c
      itf = idint(thfg(ir,it,ip)*dthfinv)
      ipf = idint(phifg(ir,it,ip)*dphifinv)
c
      itfi = itf - 2
      ipfi = ipf - 2
      if (itf.eq.    0) itfi = itf - 1
      if (itf.eq.ntf-1) itfi = itf - 3
      if (ipf.eq.    0) ipfi = ipf - 1
      if (ipf.eq.npf-1) ipfi = ipf - 3
c
      rsave = 1.0d0
      if (ir.eq.0) go to 8
      if (ip.eq.0.and.it.ne.0.and.it.ne.ntg) then
      do 1 ii = 1, n
      itf0 = itfi + ii
       x(ii)=thf(itf0)
       y(ii)=rs(itf0,ipf)
 1    continue
      v = thfg(ir,it,ip)
      call lagint(x,n,y,v,f)
      rsave = f(1)
      end if
      if (ip.ne.0.and.ip.ne.npg.and.it.eq.ntg) then
      do 2 ii = 1, n
      ipf0 = ipfi + ii
       x(ii)=phif(ipf0)
 2     y(ii)=rs(itf,ipf0)
      v = phifg(ir,it,ip)
      call lagint(x,n,y,v,f)
      rsave = f(1)
      end if
      if (ip.ne.0.and.ip.ne.npg.and.it.ne.0.and.it.ne.ntg) then
      do 3 jj = 1, n
      itf0 = itfi + jj
      do 4 ii = 1, n
      ipf0 = ipfi + ii
       x(ii)=phif(ipf0)
 4     y(ii)=rs(itf0,ipf0)
      v = phifg(ir,it,ip)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
 3    continue
      do 5 ii = 1, n
      itf0 = itfi + ii
       x(ii)=thf(itf0)
 5     y(ii)=f4(ii)
      v = thfg(ir,it,ip)
      call lagint(x,n,y,v,f)
      rsave = f(1)
      end if
c
 8    continue
      rfg(ir,it,ip)=(dis**2 + rr**2 - 2.d0*dis*rstcp + tiny)**0.5/rsave
c
 101  continue
c
c --- Interporation of quantity on fluid to gravity coordinate. 
c
      do 89 ipg = 0, npg
      do 89 itg = 0, ntg
      do 89 irg = 0, nrtot
 89   grv(irg,itg,ipg) = 0.0d0
c
c --  for x-axis
c
      do 900 irf = 0, nrf
      xx(irf+1) = dis - rf(nrf-irf)*rs(ntf,npf)
 900  yy(irf+1) = flv(nrf-irf,ntf,npf)
      do 901 irf = nrf+1, 2*nrf
      xx(irf+1) = dis + rf(irf-nrf)*rs(ntf,0)
 901  yy(irf+1) = flv(irf-nrf,ntf,0)
c
      i0 = min0(nrgmin-2,0)
      do 902 irg = i0, nrgmax + 2
      grv(irg,ntg,0) = 0.0d0
      do 904 ix = 1, 2*nrf
      if (rrgg(irg).ge.xx(ix  )-small.and.
     &    rrgg(irg).le.xx(ix+1)+small) then
      ix0 = min0(max0(ix-1,1),2*nrf-2) - 1
c
      do 90 ii = 1, n
      ixf0 = ix0 + ii
       x(ii)=xx(ixf0)
 90    y(ii)=yy(ixf0)
      v = rrgg(irg)
      call lagint(x,n,y,v,f)
      grv(irg,ntg,0) = f(1)
c
      go to 902
      end if
 904  continue
 902  continue
c
c --
c
      ipg = 0
      do 92 itg = ntgmin, ntg - 1
      do 92 irg = nrgmin, nrgmax
c
      irf = idint(rfg(irg,itg,ipg)*drfinv)
      itf = idint(thfg(irg,itg,ipg)*dthfinv)
      ipf = idint(phifg(irg,itg,ipg)*dphifinv)
c
      if (rfg(irg,itg,ipg).gt.1.0d0) go to 92
c
      irfi = min0(max0(irf-2,0),nrf-4)
      itfi = max0(min0(itf-2,ntf-4),-1)
c
      do 10 jj = 1, n
      irf0 = irfi + jj
      do 11 ii = 1, n
      itf0 = itfi + ii
       x(ii)=thf(itf0)
 11    y(ii)=flv(irf0,itf0,ipf)
      v = thfg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
 10   continue
      do 15 ii = 1, n
      irf0 = irfi + ii
       x(ii)=rf(irf0)
 15    y(ii)=f4(ii)
      v = rfg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      grv(irg,itg,ipg) = f(1)
c
 92   continue
c
      itg = ntg
      do 94 ipg = 1, npgmax
      do 94 irg = nrgmin, nrgmax
c
      irf = idint(rfg(irg,itg,ipg)*drfinv)
      itf = ntf
      ipf = idint(phifg(irg,itg,ipg)*dphifinv)
c
      if (rfg(irg,itg,ipg).gt.1.0d0) go to 94
c
      irfi = irf - 2
      ipfi = ipf - 2
      if (irf.eq.    0) irfi = irf - 1
      if (irf.eq.nrf-1) irfi = irf - 3
      if (ipf.eq.    0) ipfi = ipf - 1
      if (ipf.eq.npf-1) ipfi = ipf - 3
c
      do 20 jj = 1, n
      irf0 = irfi + jj
      do 21 ii = 1, n
      ipf0 = ipfi + ii
       x(ii)=phif(ipf0)
 21    y(ii)=flv(irf0,itf,ipf0)
      v = phifg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
 20   continue
      do 25 ii = 1, n
      irf0 = irfi + ii
       x(ii)=rf(irf0)
 25    y(ii)=f4(ii)
      v = rfg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      grv(irg,itg,ipg) = f(1)
c
 94   continue
c
      do 100 ipg = 1, npgmax
      do 100 itg = ntgmin, ntg - 1
      do 100 irg = nrgmin, nrgmax
c
      irf = idint(rfg(irg,itg,ipg)*drfinv)
      itf = idint(thfg(irg,itg,ipg)*dthfinv)
      ipf = idint(phifg(irg,itg,ipg)*dphifinv)
c
      if (rfg(irg,itg,ipg).gt.1.0d0) go to 100
c
      irfi = min0(max0(irf-2,0),nrf-4)
      itfi = min0(max0(itf-2,0),ntf-4)
      ipfi = min0(max0(ipf-2,0),npf-4)
c
      do 40 jj = 1, n
      irf0 = irfi + jj
      do 41 kk = 1, n
      itf0 = itfi + kk
      do 42 ii = 1, n
      ipf0 = ipfi + ii
       x(ii)=phif(ipf0)
 42    y(ii)=flv(irf0,itf0,ipf0)
      v = phifg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      f44(kk,jj) = f(1)
 41   continue
 40   continue
c
      do 43 jj = 1, n
      irf0 = irfi + jj
      do 44 ii = 1, n
      itf0 = itfi + ii
       x(ii)=thf(itf0)
 44    y(ii)=f44(ii,jj)
      v = thfg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
 43   continue
c
      do 45 ii = 1, n
      irf0 = irfi + ii
       x(ii)=rf(irf0)
 45    y(ii)=f4(ii)
      v = rfg(irg,itg,ipg)
      call lagint(x,n,y,v,f)
      grv(irg,itg,ipg) = f(1)
c
 100  continue
c
      if (ntgmin.eq.0) then
      itg = 0
      do 93 ipg = 0, npg
      do 93 irg = 1, nrgmax
      irf = idint(rfg(irg,itg,ipg)*drfinv)
      itf = idint(thfg(irg,itg,ipg)*dthfinv)
      ipf = idint(phifg(irg,itg,ipg)*dphifinv)
      if (rfg(irg,itg,ipg).gt.1.0d0) go to 93
cz      grv(irg,itg,ipg) = grv(irg,itg,0)
      grv(irg,itg,ipg) = 0.0d0
 93   continue
      end if
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine gr2flspl(grvo,flv,rs,isw,isweq)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / cfong / rgf(0:nnr,0:nnt,0:nnp), 
     &                thgf(0:nnr,0:nnt,0:nnp), 
     &               phigf(0:nnr,0:nnt,0:nnp)
      common / cgonf / rfg(0:nnrg,0:nntg,0:nnpg), 
     &                thfg(0:nnrg,0:nntg,0:nnpg), 
     &               phifg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      dimension grvo(0:nnrg,0:nntg,0:nnpg), flv(0:nnr,0:nnt,0:nnp)
      dimension grv(0:nnrg,0:nntg+1,-1:nnpg)
      dimension rs(0:nnt,0:nnp)
      dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),
     &          f(1),f2(2),f4(4),f44(4,4)
      dimension xx(nnrg),yy(nnrg),cc(nnrg,3),
     &          xf(2*nnr+1),ff(2*nnr+1)
c
c --- Find fluid coodinate values on gravity coordinate, cgf. 
c
      nc = nnr
      n = 4
      iopt(1)=3
      iopt(2)=3
caho      iopt(1)=1
caho      iopt(2)=1
      df(1) = 0.0d0
      df(2) = 0.0d0
c
cdis      dis = dble(ndis)/dble(nr)
      dis = sepato
      do 10 ip = 0, np
      do 10 it = 0, nt
      do 10 ir = 0, nr
      rr = rf(ir)*rs(it,ip)
      st = sinthef(it)
      ct = costhef(it)
      sp = sinphif(ip)
      cp = cosphif(ip)
      rstcp = rr*st*cp
      rstsp = rr*st*sp
      xxyy = (dis**2 + (rr*st)**2 + 2.d0*dis*rstcp)**0.5
      rgf(ir,it,ip) = (dis**2 + rr**2 + 2.d0*dis*rstcp)**0.5
      thgf(ir,it,ip) = datan2(xxyy,rr*ct)
      phigf(ir,it,ip) = datan2(rstsp,dis+rstcp)
 10   continue
c
      do 200 itg = 0, ntg
      do 200 irg = 0, nrtot
      grv(irg,itg,-1) = (-1.0d0)**isw*grvo(irg,itg,1)
      do 200 ipg = 0, npg
      grv(irg,itg,ipg) = grvo(irg,itg,ipg)
 200  continue
      do 210 irg =  0, nrtot
      grv(irg,ntg+1,-1) = (-1.0d0)**isw*
     &                    (-1.0d0)**isweq*grvo(irg,ntg-1,1)
      do 210 ipg =  0, npg
c???      do 210 ipg = -1, npg
      grv(irg,ntg+1,ipg) = (-1.0d0)**isweq*grvo(irg,ntg-1,ipg)
 210  continue
      thg(ntg+1) = thg(ntg) + dthg
      phig(-1) = phig(0) - dphig
c
c --- Interporation of quantity on gravity to fluid coordinate. 
c
      do 89 ipf = 0, npf
      do 89 itf = 0, ntf
      do 89 irf = 0, nrf
 89   flv(irf,itf,ipf) = 0.0d0
c
c --  for x-axis
c
      do 900 irg = 0, nrin
      xx(irg+1) = rg(irg)
 900  yy(irg+1) = grv(irg,ntg,0)
c
      do 901 irf = 0, nrf
 901  xf(irf+1) = dis - rf(nrf-irf)*rs(ntf,npf)
      do 902 irf = nrf+1, 2*nrf
 902  xf(irf+1) = dis + rf(irf-nrf)*rs(ntf,0)
c
      if (xf(1).le.0.0d0) xf(1) = 1.0d-14
c
      kn = nrin + 1
      km = 2*nrf + 1
      knc = nnrg
      call splc(xx,kn,yy,df,iopt,cc,knc,ier)
      call splf(xx,kn,yy,cc,knc,xf,km,ff,ier)
c
      do 90 irf = 1, nrf
      flv(irf,ntf,0) = ff(nrf+1 + irf)
      flv(irf,ntf,npf) = ff(nrf+1 - irf)
 90   continue
      do 94 ipf = 0, npf
      do 94 itf = 0, ntf
      flv(0,itf,ipf) = ff(nrf+1)
 94   continue
c
c --
c
      do 91 ipf = 0, npf, npf
      do 91 itf = 0, ntf - 1
c
      do 91 irf = 1, nrf
c
      irg = idint(rgf(irf,itf,ipf)*drginv(10))
      itg = idint(thgf(irf,itf,ipf)*dthginv)
      ipg = 0
c
      irgi = max0(irg-2,0)
      itgi = max0(min0(itg-2,ntg-4),-1)
c
      do 4 jj = 1, n
      irg0 = irgi + jj
      do 11 ii = 1, n
      itg0 = itgi + ii
       x(ii)=thg(itg0)
   11  y(ii)=grv(irg0,itg0,ipg)
      v = thgf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
    4 continue
c
      do 20 ii = 1, n
      irg0 = irgi + ii
       x(ii)=rg(irg0)
 20    y(ii)=f4(ii)
      v = rgf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      flv(irf,itf,ipf) = f(1)
c      
 91   continue
c
      itf = 0
      do 92 ipf = 1, npf
      do 92 irf = 1, nrf
      flv(irf,itf,ipf) = flv(irf,itf,0)
 92   continue
c
      itf = ntf
      do 93 ipf = 1, npf - 1
      do 93 irf = 1, nrf
c
      irg = idint(rgf(irf,itf,ipf)*drginv(10))
      itg = ntg
      ipg = idint(phigf(irf,itf,ipf)*dphiginv)
c
      irgi = irg - 2
      ipgi = ipg - 2
      iopt(1)=3
      iopt(2)=3
      df(1) = 0.0d0
      df(2) = 0.0d0
      if (irg.eq.0) then
      irgi = irg - 1
      end if
      if (ipg.eq.0) then
      ipgi = ipg - 1
ccc      iopt(1) = 2 - isw
      iopt(2) = 3
      end if
      do 5 jj = 1, n
      irg0 = irgi + jj
      do 12 ii = 1, n
      ipg0 = ipgi + ii
       x(ii)=phig(ipg0)
   12  y(ii)=grv(irg0,itg,ipg0)
      v = phigf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
    5 continue
c
      do 21 ii = 1, n
      irg0 = irgi + ii
       x(ii)=rg(irg0)
 21    y(ii)=f4(ii)
      v = rgf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      flv(irf,itf,ipf) = f(1)
c      
 93   continue
c
      do 100 ipf = 1, npf - 1
      do 100 itf = 1, ntf - 1
      do 100 irf = 1, nrf
c
      irg = idint(rgf(irf,itf,ipf)*drginv(10))
      itg = idint(thgf(irf,itf,ipf)*dthginv)
      ipg = idint(phigf(irf,itf,ipf)*dphiginv)
c
      irgi = irg - 2
      itgi = itg - 2
      ipgi = ipg - 2
      iopt(1)=3
      iopt(2)=3
      df(1) = 0.0d0
      df(2) = 0.0d0
      if (irg.eq.0) then
      irgi = irg - 1
      end if
      if (itg.eq.ntg-1) then
      itgi = itg - 3
      end if
      if (ipg.eq.0) then
      ipgi = ipg - 1
ccc      iopt(1) = 2 - isw
      iopt(2) = 3
      end if
c
      do 6 jj = 1, n
      irg0 = irgi + jj
      do 7 kk = 1, n
      itg0 = itgi + kk
      do 13 ii = 1, n
      ipg0 = ipgi + ii
       x(ii)=phig(ipg0)
   13  y(ii)=grv(irg0,itg0,ipg0)
      v = phigf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      f44(kk,jj) = f(1)
    7 continue
    6 continue
c
      if (itg.eq.ntg-1) then
      itgi = itg - 3
      iopt(1) = 3
ccc      iopt(2) = 2 - isweq
      end if
c
      do 15 jj = 1, n
      irg0 = irgi + jj
      do 14 ii = 1, n
      itg0 = itgi + ii
       x(ii)=thg(itg0)
   14  y(ii)=f44(ii,jj)
      v = thgf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      f4(jj) = f(1)
   15 continue
c
      do 16 ii = 1, n
      irg0 = irgi + ii
       x(ii)=rg(irg0)
   16  y(ii)=f4(ii)
      v = rgf(irf,itf,ipf)
      call lagint(x,n,y,v,f)
      flv(irf,itf,ipf) = f(1)
c
 100  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine subio(istat,iseq,char)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / iomis / fffac, ffvep, eps, convf, itmx, iddd, numseq,
     &                 itype, iwrite
      common / hijsw / swlp(4), swls(4), iswl
      common / trmpg / sinmpg(0:nnlg,0:nnpg), cosmpg(0:nnlg,0:nnpg),
     &                simpsig(0:nnlg,0:nnpg)
      common / cutsw / cutfac
c
      character*3 char
      character*3 moji
c
c ------------------------------------------------------------
c     istat = 0 and iseq 0 -> open ini file and close it 
c                             and open las file
c     istat = 2            -> close las file and open nxt file
c ------------------------------------------------------------
c
      if (istat.eq.0.and.iseq.eq.0) then
      moji = 'ini'
      open(2,file='gnbflu.'//moji,status='old')
      open(3,file='gnbgra.'//moji,status='old')
      end if
cz      if (istat.eq.1.and.iseq.eq.1) then
cz      moji = 'las'
cz      open(2,file='gnbflu.'//moji,status='old')
cz      open(3,file='gnbgra.'//moji,status='old')
cz      end if
cz      if (istat.eq.3) then
      if (istat.eq.1) then
      moji = 'las'
      open(2,file='gnbflu.'//moji,status='old')
      open(3,file='gnbgra.'//moji,status='old')
      end if
      if (istat.eq.2) then
cz      if (iseq.ne.1) then
cz      close(2)
cz      close(3)
cz      end if
      moji = 'nxt'
      open(2,file='gnbflu.'//moji,status='old')
      open(3,file='gnbgra.'//moji,status='old')
      end if
c
c -------------
c --- Read. ---
c -------------
c
      if (istat.eq.0) then
c
c --- Fluid variables
c
      do 498 ii = 1, 7
 498  read(2,5000) idum
      read(2,5001)  dum
      read(2,5000) idum
c
      read(2,4000) ome, ber, radi
      do 100 ip = 0, np
      do 100 it = 0, nt
      read(2,4000) (emd(ir,it,ip), ir = 0, nr)
      read(2,4000) (vep(ir,it,ip), ir = 0, nr)
 100  continue
      do 110 ip = 0, np
      read(2,4000) (rs(it,ip), it = 0, nt)
 110  continue
c
c --- Metric potentials.  
c
c      do 499 ii = 1, 9
c 499  read(3,4999) 
      do 499 ii = 1, 7
 499  read(3,5000) idum
      read(3,5001)  dum
      read(3,5000) idum
c
      read(3,4000) ome, ber, radi
      do 200 ipg = 0, npg
      do 200 itg = 0, ntg
c
      read(3,4000) (psi(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (alph(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (bvxu(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (bvyu(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (bvzu(irg,itg,ipg), irg = 0, nrtot)
c
      read(3,4000) (hxxd(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (hyyd(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (hzzd(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (hxyd(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (hxzd(irg,itg,ipg), irg = 0, nrtot)
      read(3,4000) (hyzd(irg,itg,ipg), irg = 0, nrtot)
c
 200  continue
c      
      if(itype.eq.1) then
      write(6,*) 'reading and bbb'
      do 201 ipg = 0, npg
      do 201 itg = 0, ntg
      read(3,4000) (bbb(irg,itg,ipg), irg = 0, nrtot)
 201  continue
      end if
c
      close(2)
      close(3)
c
c --- add 1 to conformal factor.
c
      if (psi(nr+ngdin,ntg,0).le.1.0d0) then
      do 204 ipg = 0, npg
      do 204 itg = 0, ntg
      do 204 irg = 0, nrtot
      psi(irg,itg,ipg) = 1.0d0 + psi(irg,itg,ipg)
 204  continue
      end if
c
c --- invert sigunature of the shift.
c
      do 205 ipg = 0, npg
      do 205 itg = 0, ntg
      do 205 irg = 0, nrtot
      bvxu(irg,itg,ipg) = - bvxu(irg,itg,ipg)
      bvyu(irg,itg,ipg) = - bvyu(irg,itg,ipg)
      bvzu(irg,itg,ipg) = - bvzu(irg,itg,ipg)
 205  continue
c
c
      end if
c
c --------------
c --- Write. ---
c --------------
c
      if (istat.ne.0) then
c
c --- Fluid variables
c
      write(2,5000) nrf, ntf, npf
      write(2,5000) nl, nla, nbou, msym
      write(2,5005) nnn, nrout, rvout
      write(2,5000) ntg, npg, nlg, msymg
      write(2,5002) ngdin, pinx, cutfac
      write(2,5002) itmx, eps, convf
      write(2,5000) iddd, iswl
      write(2,5001) fffac,ffvep 
      write(2,5004) itype, iwrite, char
c
      write(2,4000) ome, ber, radi
      do 400 ip = 0, np
      do 400 it = 0, nt
      write(2,4000) (emd(ir,it,ip), ir = 0, nr)
      write(2,4000) (vep(ir,it,ip), ir = 0, nr)
 400  continue
      do 410 ip = 0, np
      write(2,4000) (rs(it,ip), it = 0, nt)
 410  continue
c
c --- Metric potentials.  
c
      write(3,5000) nrf, ntf, npf
      write(3,5000) nl, nla, nbou, msym
      write(3,5005) nnn, nrout, rvout
      write(3,5000) ntg, npg, nlg, msymg
      write(3,5002) ngdin, pinx, cutfac
      write(3,5002) itmx, eps, convf
      write(3,5000) iddd, iswl
      write(3,5001) fffac,ffvep 
      write(3,5004) itype, iwrite, char
c
      write(3,4000) ome, ber, radi
      do 500 ipg = 0, npg
      do 500 itg = 0, ntg
c
      write(3,4000) (psi(irg,itg,ipg)-1.0d0, irg = 0, nrtot)
      write(3,4000) (alph(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (-bvxu(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (-bvyu(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (-bvzu(irg,itg,ipg), irg = 0, nrtot)
c
      write(3,4000) (hxxd(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (hyyd(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (hzzd(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (hxyd(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (hxzd(irg,itg,ipg), irg = 0, nrtot)
      write(3,4000) (hyzd(irg,itg,ipg), irg = 0, nrtot)
c
 500  continue
c
      if(itype.eq.1.or.itype.eq.2) then
      write(6,*) 'writing bbb'
      do 501 ipg = 0, npg
      do 501 itg = 0, ntg
      write(3,4000) (bbb(irg,itg,ipg), irg = 0, nrtot)
 501  continue
      end if
c
      close(2)
      close(3)
c
      end if
c
 4000 format(1p,6e12.4)
 4999 format(' ')
c
 5000 format( 5i5)
 5001 format( 1p,2e10.3)
 5002 format( 1i5, 1p,2e10.3)
 5003 format( 1p,1e10.3, 1i4)
 5004 format( 2i5, 3x, a3)
 5005 format( 2i5, 1p,1e10.3)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine subiors(istat,iseq,char)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / metpo / psi(0:nnrg,0:nntg,0:nnpg),
     &                alph(0:nnrg,0:nntg,0:nnpg),
     &                alps(0:nnrg,0:nntg,0:nnpg),
     &               alps2(0:nnrg,0:nntg,0:nnpg)
c
      character*3 char
      character*3 moji
c
      pi = 3.14159265358979d+0
c
      if (iseq.eq.1) then
      open(14,file='gnbrs.dat',status='old')
      open(15,file='gnbemd.dat',status='old')
      end if
c
c --------------
c --- Write. ---
c --------------
c
c --- Fluid variables
c
      write(14,4000) (rs(ntf,ipf), ipf = 0, npf) 
      do 414 ip = 0, np, np
      write(14,4000) (rs(itf,ip), itf = 0, ntf) 
      write(15,4000) (emd(ir,nt,ip), ir = 0, nr)
 414  continue
      write(15,4000) (psi(irg,ntg,0), irg = 0, nrtot)
c
 4000 format(1p,6e12.4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine psisource(sou,chgra)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
      common / augfn / emdg(0:nnrg,0:nntg,0:nnpg),
     &                 ramg(0:nnrg,0:nntg,0:nnpg), 
     &               gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / flusw / swflu
c
      dimension sou(0:nnrg,0:nntg,0:nnpg) 
      dimension grad(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension dabfnc(3,3)
c
      character*1 chgra
c
c --- Source for computing the conformal factor psi.
c
      call grgrad4(psi,grad,1,1,1)
c
      do 410 ipg = 0, npg
      do 410 itg = 0, ntg
      do 410 irg = 0, nrtot
c
      emdgc = emdg(irg,itg,ipg)
      ramgc = ramg(irg,itg,ipg)
      psigc =  psi(irg,itg,ipg)
      alpgc = alph(irg,itg,ipg)
      rhogc = emdgc**pinx
      pregc = rhogc*emdgc
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
c
      utgc  =       swflu *ramg(irg,itg,ipg)/(alpgc**2*hhgc)
     &      +(1.0d0-swflu)*hhgc/ber
c
      zfac = 1.0d0
      if (emdgc.le.0.0d0) zfac = 0.0d0
      rhoHc = hhgc*rhogc*(alpgc*utgc)**2 - pregc
c
c
      gmxxu = hxxu(irg,itg,ipg) + 1.0d0
      gmxyu = hxyu(irg,itg,ipg)
      gmxzu = hxzu(irg,itg,ipg)
      gmyyu = hyyu(irg,itg,ipg) + 1.0d0
      gmyzu = hyzu(irg,itg,ipg)
      gmzzu = hzzu(irg,itg,ipg) + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      rxx = rab(irg,itg,ipg,1)
      rxy = rab(irg,itg,ipg,2)
      rxz = rab(irg,itg,ipg,3)
      ryy = rab(irg,itg,ipg,4)
      ryz = rab(irg,itg,ipg,5)
      rzz = rab(irg,itg,ipg,6)
      ryx = rxy 
      rzx = rxz
      rzy = ryz
c
c --  Skip for IWM.
      rics = 0.0d0
      gcdp = 0.0d0
      hd2p = 0.0d0
      if (chgra.eq.'i') go to 1410
      rics = gmxxu*rxx + gmxyu*rxy + gmxzu*rxz 
     &     + gmyxu*ryx + gmyyu*ryy + gmyzu*ryz 
     &     + gmzxu*rzx + gmzyu*rzy + gmzzu*rzz 
c
      gcdp = gmcrix(irg,itg,ipg)*grad(irg,itg,ipg,1)
     &     + gmcriy(irg,itg,ipg)*grad(irg,itg,ipg,2)
     &     + gmcriz(irg,itg,ipg)*grad(irg,itg,ipg,3)
c
      call dadbscalargsym(psi,dabfnc,irg,itg,ipg,1,1,1)
      hd2p = hxxu(irg,itg,ipg)* dabfnc(1,1)
     &     + hxyu(irg,itg,ipg)*(dabfnc(1,2) + dabfnc(2,1))
     &     + hxzu(irg,itg,ipg)*(dabfnc(1,3) + dabfnc(3,1))
     &     + hyyu(irg,itg,ipg)* dabfnc(2,2)
     &     + hyzu(irg,itg,ipg)*(dabfnc(2,3) + dabfnc(3,2))
     &     + hzzu(irg,itg,ipg)* dabfnc(3,3)
 1410 continue
c
ctest      plap(irg,itg,ipg) = 
      plap = 
     &      0.125d0*psigc*rics
     &    - 0.125d0*psigc**5*rkijkij(irg,itg,ipg)
     &    - radi**2*2.0d0*pi*psigc**5*rhoHc*zfac
c
ctest      sou(irg,itg,ipg) = - hd2p + gcdp + plap(irg,itg,ipg)
      sou(irg,itg,ipg) = - hd2p + gcdp + plap
c
 410  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine alpssource(sou,chgra)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
      common / augfn / emdg(0:nnrg,0:nntg,0:nnpg),
     &                 ramg(0:nnrg,0:nntg,0:nnpg), 
     &               gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / flusw / swflu
c
      dimension sou(0:nnrg,0:nntg,0:nnpg) 
      dimension grad(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension dabfnc(3,3)
c
      character*1 chgra
c
c --- Source for computing the alpha*psi.
c
ctest      do 412 ipg = 0, npg
ctest      do 412 itg = 0, ntg
ctest      do 412 irg = 0, nrtot
ctest      alps(irg,itg,ipg) = alph(irg,itg,ipg)*psi(irg,itg,ipg)
ctest  412 continue
c
      call grgrad4(alps,grad,1,1,1)
c
      do 414 ipg = 0, npg
      do 414 itg = 0, ntg
      do 414 irg = 0, nrtot
c
      emdgc = emdg(irg,itg,ipg)
      ramgc = ramg(irg,itg,ipg)
      psigc =  psi(irg,itg,ipg)
      alpgc = alph(irg,itg,ipg)
      alpsigc = alps(irg,itg,ipg)
      rhogc = emdgc**pinx
      pregc = rhogc*emdgc
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
c
      utgc  =       swflu *ramg(irg,itg,ipg)/(alpgc**2*hhgc)
     &      +(1.0d0-swflu)*hhgc/ber
c
      zfac = 1.0d0
      if (emdgc.le.0.0d0) zfac = 0.0d0
      rp2s = 3.0d0*hhgc*rhogc*(alpgc*utgc)**2 
     &     - 2.0d0*hhgc*rhogc + 5.0d0*pregc
c
      gmxxu = hxxu(irg,itg,ipg) + 1.0d0
      gmxyu = hxyu(irg,itg,ipg)
      gmxzu = hxzu(irg,itg,ipg)
      gmyyu = hyyu(irg,itg,ipg) + 1.0d0
      gmyzu = hyzu(irg,itg,ipg)
      gmzzu = hzzu(irg,itg,ipg) + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      rxx = rab(irg,itg,ipg,1)
      rxy = rab(irg,itg,ipg,2)
      rxz = rab(irg,itg,ipg,3)
      ryy = rab(irg,itg,ipg,4)
      ryz = rab(irg,itg,ipg,5)
      rzz = rab(irg,itg,ipg,6)
      ryx = rxy 
      rzx = rxz
      rzy = ryz
c
c --  Skip for IWM.
      rics = 0.0d0
      gcdp = 0.0d0
      hd2p = 0.0d0
      if (chgra.eq.'i') go to 1414
      rics = gmxxu*rxx + gmxyu*rxy + gmxzu*rxz 
     &     + gmyxu*ryx + gmyyu*ryy + gmyzu*ryz 
     &     + gmzxu*rzx + gmzyu*rzy + gmzzu*rzz 
c
      gcdp = gmcrix(irg,itg,ipg)*grad(irg,itg,ipg,1)
     &     + gmcriy(irg,itg,ipg)*grad(irg,itg,ipg,2)
     &     + gmcriz(irg,itg,ipg)*grad(irg,itg,ipg,3)
c
      call dadbscalargsym(alps,dabfnc,irg,itg,ipg,1,1,1)
      hd2p = hxxu(irg,itg,ipg)* dabfnc(1,1)
     &     + hxyu(irg,itg,ipg)*(dabfnc(1,2) + dabfnc(2,1))
     &     + hxzu(irg,itg,ipg)*(dabfnc(1,3) + dabfnc(3,1))
     &     + hyyu(irg,itg,ipg)* dabfnc(2,2)
     &     + hyzu(irg,itg,ipg)*(dabfnc(2,3) + dabfnc(3,2))
     &     + hzzu(irg,itg,ipg)* dabfnc(3,3)
 1414 continue
c
      sou(irg,itg,ipg) = 
     &    - hd2p + gcdp + 0.125d0*alpsigc*rics
     &    + 0.875d0*alpgc*psigc**5*rkijkij(irg,itg,ipg)
     &    + radi**2*2.0d0*pi*alpgc*psigc**5*rp2s
c
 414  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine alps2source(sou,chgra)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
      common / augfn / emdg(0:nnrg,0:nntg,0:nnpg),
     &                 ramg(0:nnrg,0:nntg,0:nnpg), 
     &               gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / flusw / swflu
c
      dimension sou(0:nnrg,0:nntg,0:nnpg) 
      dimension dabfnc(3,3)
c
      character*1 chgra
c
c --- Source for computing the alpha*psi**2.
c
      do 414 ipg = 0, npg
      do 414 itg = 0, ntg
      do 414 irg = 0, nrtot
c
      emdgc = emdg(irg,itg,ipg)
      ramgc = ramg(irg,itg,ipg)
      psigc =  psi(irg,itg,ipg)
      alpgc = alph(irg,itg,ipg)
      alps2gc = alps2(irg,itg,ipg)
      rhogc = emdgc**pinx
      pregc = rhogc*emdgc
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
c
      utgc  =       swflu *ramg(irg,itg,ipg)/(alpgc**2*hhgc)
     &      +(1.0d0-swflu)*hhgc/ber
c
      zfac = 1.0d0
      if (emdgc.le.0.0d0) zfac = 0.0d0
      trS = hhgc*rhogc*((alpgc*utgc)**2 - 1.0d0) 
     &    + 3.0d0*pregc
c
      gmxxu = hxxu(irg,itg,ipg) + 1.0d0
      gmxyu = hxyu(irg,itg,ipg)
      gmxzu = hxzu(irg,itg,ipg)
      gmyyu = hyyu(irg,itg,ipg) + 1.0d0
      gmyzu = hyzu(irg,itg,ipg)
      gmzzu = hzzu(irg,itg,ipg) + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      rxx = rab(irg,itg,ipg,1)
      rxy = rab(irg,itg,ipg,2)
      rxz = rab(irg,itg,ipg,3)
      ryy = rab(irg,itg,ipg,4)
      ryz = rab(irg,itg,ipg,5)
      rzz = rab(irg,itg,ipg,6)
      ryx = rxy 
      rzx = rxz
      rzy = ryz
c
      call grgrad(psi,dpsidx,dpsidy,dpsidz,irg,itg,ipg,1,1,1)
      call grgrad(alps,dapdx,dapdy,dapdz,irg,itg,ipg,1,1,1)
      dapdp = gmxxu*dapdx*dpsidx+gmxyu*dapdx*dpsidy+gmxzu*dapdx*dpsidz
     &      + gmyxu*dapdy*dpsidx+gmyyu*dapdy*dpsidy+gmyzu*dapdy*dpsidz
     &      + gmzxu*dapdz*dpsidx+gmzyu*dapdz*dpsidy+gmzzu*dapdz*dpsidz
c
c --  Skip for IWM.
      rics = 0.0d0
      gcdap2 = 0.0d0
      hd2ap2 = 0.0d0
      if (chgra.eq.'i') go to 1414
c
      call grgrad(alps2,dap2dx,dap2dy,dap2dz,irg,itg,ipg,1,1,1)
c
      rics = gmxxu*rxx + gmxyu*rxy + gmxzu*rxz 
     &     + gmyxu*ryx + gmyyu*ryy + gmyzu*ryz 
     &     + gmzxu*rzx + gmzyu*rzy + gmzzu*rzz 
c
      gcdap2 = gmcrix(irg,itg,ipg)*dap2dx
     &       + gmcriy(irg,itg,ipg)*dap2dy
     &       + gmcriz(irg,itg,ipg)*dap2dz
c
cc      call dadbscalarg(alps2,dabfnc,irg,itg,ipg,1,1,1)
      call dadbscalargsym(alps2,dabfnc,irg,itg,ipg,1,1,1)
      hd2ap2 = hxxu(irg,itg,ipg)* dabfnc(1,1)
     &       + hxyu(irg,itg,ipg)*(dabfnc(1,2) + dabfnc(2,1))
     &       + hxzu(irg,itg,ipg)*(dabfnc(1,3) + dabfnc(3,1))
     &       + hyyu(irg,itg,ipg)* dabfnc(2,2)
     &       + hyzu(irg,itg,ipg)*(dabfnc(2,3) + dabfnc(3,2))
     &       + hzzu(irg,itg,ipg)* dabfnc(3,3)
 1414 continue
c
      sou(irg,itg,ipg) = 
     &    - hd2ap2 + gcdap2 + 2.0d0*dapdp + 0.25d0*alps2gc*rics
     &    + 0.75d0*alpgc*psigc**6*rkijkij(irg,itg,ipg)
     &    + radi**2*4.0d0*pi*alpgc*psigc**6*trS
c
 414  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine shiftsource(souvec,sou,chgra)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
      common / cdbvd / cdbvxd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 cdbvyd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 cdbvzd(0:nnrg,0:nntg,0:nnpg,1:3)
      common / pdbvd / pdbvxd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 pdbvyd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 pdbvzd(0:nnrg,0:nntg,0:nnpg,1:3)
      common / augfn / emdg(0:nnrg,0:nntg,0:nnpg),
     &                 ramg(0:nnrg,0:nntg,0:nnpg), 
     &               gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
      common / cliep / elpxx(0:nnrg,0:nntg,0:nnpg),
     &                 elpxy(0:nnrg,0:nntg,0:nnpg),
     &                 elpxz(0:nnrg,0:nntg,0:nnpg),
     &                 elpyy(0:nnrg,0:nntg,0:nnpg),
     &                 elpyz(0:nnrg,0:nntg,0:nnpg),
     &                 elpzz(0:nnrg,0:nntg,0:nnpg)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / flusw / swflu
      common / cutsw / cutfac
c
      dimension sou(0:nnrg,0:nntg,0:nnpg) 
      dimension souvec(0:nnrg,0:nntg,0:nnpg,1:3)
c      dimension fnc0(0:nnrg,0:nntg,0:nnpg), 
c     &         grad0(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension fnc2(0:nnrg,0:nntg,0:nnpg), 
     &         grad2(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension fnc4(0:nnrg,0:nntg,0:nnpg), 
     &         grad4(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension r5(5),  th5(5), phi5(5),
     &         fr5(5),  ft5(5),  fp5(5), vphig(3),
     &       grad1(3), dxcb(6), dycb(6), dzcb(6), dabfnc(1:3,1:3)
      dimension ic0(1:3)
c
      dimension cri1be(0:nnrg,0:nntg,0:nnpg),
     &          cri2be(0:nnrg,0:nntg,0:nnpg),
     &          cri3be(0:nnrg,0:nntg,0:nnpg),
     &          cri4be(0:nnrg,0:nntg,0:nnpg),
     &          cri5be(0:nnrg,0:nntg,0:nnpg),
     &          cri6be(0:nnrg,0:nntg,0:nnpg)
c
      character*1 chgra
c
c --- compute source terms for shift, which is evaluated on grids.
c
      do 420 ipg = 0, npg
      do 420 itg = 0, ntg
      do 420 irg = 0, nrtot
      hhxxu = hxxu(irg,itg,ipg)
      hhxyu = hxyu(irg,itg,ipg)
      hhxzu = hxzu(irg,itg,ipg)
      hhyyu = hyyu(irg,itg,ipg)
      hhyzu = hyzu(irg,itg,ipg)
      hhzzu = hzzu(irg,itg,ipg)
      hhyxu = hhxyu
      hhzxu = hhxzu
      hhzyu = hhyzu
c
      pdbvxdx = pdbvxd(irg,itg,ipg,1)
      pdbvxdy = pdbvxd(irg,itg,ipg,2)
      pdbvxdz = pdbvxd(irg,itg,ipg,3)
      pdbvydx = pdbvyd(irg,itg,ipg,1)
      pdbvydy = pdbvyd(irg,itg,ipg,2)
      pdbvydz = pdbvyd(irg,itg,ipg,3)
      pdbvzdx = pdbvzd(irg,itg,ipg,1)
      pdbvzdy = pdbvzd(irg,itg,ipg,2)
      pdbvzdz = pdbvzd(irg,itg,ipg,3)
c
      fnc2(irg,itg,ipg) = psi(irg,itg,ipg)**6/alph(irg,itg,ipg)
      fnc4(irg,itg,ipg) = hhxxu*pdbvxdx+hhxyu*pdbvxdy+hhxzu*pdbvxdz
     &                    hhyxu*pdbvydx+hhyyu*pdbvydy+hhyzu*pdbvydz
     &                    hhzxu*pdbvzdx+hhzyu*pdbvzdy+hhzzu*pdbvzdz
c
      bvxdc = bvxd(irg,itg,ipg)
      bvydc = bvyd(irg,itg,ipg)
      bvzdc = bvzd(irg,itg,ipg)
      c11 = cri(irg,itg,ipg,1,1)
      c12 = cri(irg,itg,ipg,1,2)
      c13 = cri(irg,itg,ipg,1,3)
      c14 = cri(irg,itg,ipg,1,4)
      c15 = cri(irg,itg,ipg,1,5)
      c16 = cri(irg,itg,ipg,1,6)
      c21 = cri(irg,itg,ipg,2,1)
      c22 = cri(irg,itg,ipg,2,2)
      c23 = cri(irg,itg,ipg,2,3)
      c24 = cri(irg,itg,ipg,2,4)
      c25 = cri(irg,itg,ipg,2,5)
      c26 = cri(irg,itg,ipg,2,6)
      c31 = cri(irg,itg,ipg,3,1)
      c32 = cri(irg,itg,ipg,3,2)
      c33 = cri(irg,itg,ipg,3,3)
      c34 = cri(irg,itg,ipg,3,4)
      c35 = cri(irg,itg,ipg,3,5)
      c36 = cri(irg,itg,ipg,3,6)
      cri1be(irg,itg,ipg) = c11*bvxdc + c21*bvydc + c31*bvzdc
      cri2be(irg,itg,ipg) = c12*bvxdc + c22*bvydc + c32*bvzdc
      cri3be(irg,itg,ipg) = c13*bvxdc + c23*bvydc + c33*bvzdc
      cri4be(irg,itg,ipg) = c14*bvxdc + c24*bvydc + c34*bvzdc
      cri5be(irg,itg,ipg) = c15*bvxdc + c25*bvydc + c35*bvzdc
      cri6be(irg,itg,ipg) = c16*bvxdc + c26*bvydc + c36*bvzdc
c
 420  continue
c
      call grgrad4(fnc2,grad2,1,1,1)
      call grgrad4(fnc4,grad4,1,-1,-1)
c
      san = 1.0d0/3.0d0
      san2= 2.0d0/3.0d0
c
      do 430 ii = 1, 3
c
      do 424 ipg = 0, npg
      do 424 itg = 0, ntg
      do 424 irg = 0, nrtot
c
      cutoff = 1.0d0
      if (chgra.eq.'c'.or.chgra.eq.'C'.or.chgra.eq.'W') then
      if (rg(irg).gt.cutfac*pi/ome) cutoff = 0.0d0
      end if
c
      emdgc = emdg(irg,itg,ipg)
      ramgc = ramg(irg,itg,ipg)
      psigc =  psi(irg,itg,ipg)
      alpgc = alph(irg,itg,ipg)
      afnc2inv = alph(irg,itg,ipg)/fnc2(irg,itg,ipg)
      rhogc = emdgc**pinx
      pregc = rhogc*emdgc
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
c
      utgc  =       swflu *ramg(irg,itg,ipg)/(alpgc**2*hhgc)
     &      +(1.0d0-swflu)*hhgc/ber
c
      bvxgc = bvxu(irg,itg,ipg)
      bvygc = bvyu(irg,itg,ipg)
      bvzgc = bvzu(irg,itg,ipg)
c
      vphig(1) = - rg(irg)*sintheg(itg)*sinphig(ipg)
      vphig(2) =   rg(irg)*sintheg(itg)*cosphig(ipg)
      vphig(3) = 0.0d0
c
      if (ii.eq.1) oterm = swflu *gradvg(irg,itg,ipg,1)
     &             +(1.0d0-swflu)*  ovxd(irg,itg,ipg)
      if (ii.eq.2) oterm = swflu *gradvg(irg,itg,ipg,2)
     &             +(1.0d0-swflu)*  ovyd(irg,itg,ipg)
      if (ii.eq.3) oterm = swflu *gradvg(irg,itg,ipg,3)
     &             +(1.0d0-swflu)*  ovzd(irg,itg,ipg)
c
      zfac = 1.0d0
      if (emdgc.le.0.0d0) zfac = 0.0d0
      rjj =       swflu *rhogc*alpgc*utgc*oterm 
     &    +(1.0d0-swflu)*hhgc*rhogc*alpgc*utgc**2*psigc**4*oterm
c
      hhxxu = hxxu(irg,itg,ipg)
      hhxyu = hxyu(irg,itg,ipg)
      hhxzu = hxzu(irg,itg,ipg)
      hhyyu = hyyu(irg,itg,ipg)
      hhyzu = hyzu(irg,itg,ipg)
      hhzzu = hzzu(irg,itg,ipg)
      hhyxu = hhxyu
      hhzxu = hhxzu
      hhzyu = hhyzu
      gmxxu = hhxxu + 1.0d0
      gmxyu = hhxyu
      gmxzu = hhxzu
      gmyyu = hhyyu + 1.0d0
      gmyzu = hhyzu
      gmzzu = hhzzu + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      bvxgc = bvxu(irg,itg,ipg)
      bvygc = bvyu(irg,itg,ipg)
      bvzgc = bvzu(irg,itg,ipg)
c
      dxafn = grad2(irg,itg,ipg,1)
      dyafn = grad2(irg,itg,ipg,2)
      dzafn = grad2(irg,itg,ipg,3)
      rkax  = rkij(irg,itg,ipg,ii,1)
      rkay  = rkij(irg,itg,ipg,ii,2)
      rkaz  = rkij(irg,itg,ipg,ii,3)
c
      dbvxdx = cdbvxd(irg,itg,ipg,1)
      dbvydx = cdbvyd(irg,itg,ipg,1)
      dbvzdx = cdbvzd(irg,itg,ipg,1)
      dbvxdy = cdbvxd(irg,itg,ipg,2)
      dbvydy = cdbvyd(irg,itg,ipg,2)
      dbvzdy = cdbvzd(irg,itg,ipg,2)
      dbvxdz = cdbvxd(irg,itg,ipg,3)
      dbvydz = cdbvyd(irg,itg,ipg,3)
      dbvzdz = cdbvzd(irg,itg,ipg,3)
c
c --  Skip for IWM.
      hddb = 0.0d0
      gdcb = 0.0d0
      gcrdb1 = 0.0d0
      gcrdb2 = 0.0d0
      gradfnc4 = 0.0d0
      rax = 0.0d0
      ray = 0.0d0
      raz = 0.0d0
      divlp = 0.0d0
c
      if (chgra.eq.'i') go to 1424
c
      gradfnc4 = grad4(irg,itg,ipg,ii)
c
      c11 = cri(irg,itg,ipg,1,1)
      c12 = cri(irg,itg,ipg,1,2)
      c13 = cri(irg,itg,ipg,1,3)
      c14 = cri(irg,itg,ipg,1,4)
      c15 = cri(irg,itg,ipg,1,5)
      c16 = cri(irg,itg,ipg,1,6)
      c21 = cri(irg,itg,ipg,2,1)
      c22 = cri(irg,itg,ipg,2,2)
      c23 = cri(irg,itg,ipg,2,3)
      c24 = cri(irg,itg,ipg,2,4)
      c25 = cri(irg,itg,ipg,2,5)
      c26 = cri(irg,itg,ipg,2,6)
      c31 = cri(irg,itg,ipg,3,1)
      c32 = cri(irg,itg,ipg,3,2)
      c33 = cri(irg,itg,ipg,3,3)
      c34 = cri(irg,itg,ipg,3,4)
      c35 = cri(irg,itg,ipg,3,5)
      c36 = cri(irg,itg,ipg,3,6)
c
      gc1 = gmcrix(irg,itg,ipg)
      gc2 = gmcriy(irg,itg,ipg)
      gc3 = gmcriz(irg,itg,ipg)
c
      ic1 = 1*(ii-2)*(ii-3)/2 - 2*(ii-1)*(ii-3) + 3*(ii-1)*(ii-2)/2
      ic2 = 2*(ii-2)*(ii-3)/2 - 4*(ii-1)*(ii-3) + 5*(ii-1)*(ii-2)/2
      ic3 = 3*(ii-2)*(ii-3)/2 - 5*(ii-1)*(ii-3) + 6*(ii-1)*(ii-2)/2
c
      rax = rab(irg,itg,ipg,ic1)
      ray = rab(irg,itg,ipg,ic2)
      raz = rab(irg,itg,ipg,ic3)
c
      ic0(1) = ic1
      ic0(2) = ic2
      ic0(3) = ic3
c
c --- hbcdadbwa
c
cc      if (ii.eq.1) call dadbscalarg(bvxd,dabfnc,irg,itg,ipg,1,1,-1)
cc      if (ii.eq.2) call dadbscalarg(bvyd,dabfnc,irg,itg,ipg,1,-1,1)
cc      if (ii.eq.3) call dadbscalarg(bvzd,dabfnc,irg,itg,ipg,-1,-1,-1)
      if(ii.eq.1)call dadbscalargsym(bvxd,dabfnc,irg,itg,ipg,1,1,-1)
      if(ii.eq.2)call dadbscalargsym(bvyd,dabfnc,irg,itg,ipg,1,-1,1)
      if(ii.eq.3)call dadbscalargsym(bvzd,dabfnc,irg,itg,ipg,-1,-1,-1)
      hddb = hhxxu*dabfnc(1,1) + hhxyu*dabfnc(1,2) + hhxzu*dabfnc(1,3)
     &     + hhyxu*dabfnc(2,1) + hhyyu*dabfnc(2,2) + hhyzu*dabfnc(2,3)
     &     + hhzxu*dabfnc(3,1) + hhzyu*dabfnc(3,2) + hhzzu*dabfnc(3,3)
c
c --- divergence of cristoffel*shift.
c
      if (ii.eq.1) then
      call grgrad(cri1be,dxc1b,dyc1b,dzc1b,irg,itg,ipg,1,-1,-1)
      call grgrad(cri2be,dxc2b,dyc2b,dzc2b,irg,itg,ipg,1,1,1)
      call grgrad(cri3be,dxc3b,dyc3b,dzc3b,irg,itg,ipg,-1,1,-1)
      gdcb = gmxxu*dxc1b + gmxyu*dxc2b + gmxzu*dxc3b
     &     + gmyxu*dyc1b + gmyyu*dyc2b + gmyzu*dyc3b
     &     + gmzxu*dzc1b + gmzyu*dzc2b + gmzzu*dzc3b
      end if
      if (ii.eq.2) then
      call grgrad(cri2be,dxc2b,dyc2b,dzc2b,irg,itg,ipg,1,1,1)
      call grgrad(cri4be,dxc4b,dyc4b,dzc4b,irg,itg,ipg,1,-1,-1)
      call grgrad(cri5be,dxc5b,dyc5b,dzc5b,irg,itg,ipg,-1,-1,1)
      gdcb = gmxxu*dxc2b + gmxyu*dxc4b + gmxzu*dxc5b
     &     + gmyxu*dyc2b + gmyyu*dyc4b + gmyzu*dyc5b
     &     + gmzxu*dzc2b + gmzyu*dzc4b + gmzzu*dzc5b
      end if
      if (ii.eq.3) then
      call grgrad(cri3be,dxc3b,dyc3b,dzc3b,irg,itg,ipg,-1,1,-1)
      call grgrad(cri5be,dxc5b,dyc5b,dzc5b,irg,itg,ipg,-1,-1,1)
      call grgrad(cri6be,dxc6b,dyc6b,dzc6b,irg,itg,ipg,1,-1,-1)
      gdcb = gmxxu*dxc3b + gmxyu*dxc5b + gmxzu*dxc6b
     &     + gmyxu*dyc3b + gmyyu*dyc5b + gmyzu*dyc6b
     &     + gmzxu*dzc3b + gmzyu*dzc5b + gmzzu*dzc6b
      end if
c
c --- other two terms from tilded laplacian.
c
      if (ii.eq.1) gcrdb1 = gc1*dbvxdx + gc2*dbvxdy + gc3*dbvxdz
      if (ii.eq.2) gcrdb1 = gc1*dbvydx + gc2*dbvydy + gc3*dbvydz
      if (ii.eq.3) gcrdb1 = gc1*dbvzdx + gc2*dbvzdy + gc3*dbvzdz
c
      gmxbvx = gmxxu*dbvxdx + gmxyu*dbvxdy + gmxzu*dbvxdz
      gmxbvy = gmxxu*dbvydx + gmxyu*dbvydy + gmxzu*dbvydz
      gmxbvz = gmxxu*dbvzdx + gmxyu*dbvzdy + gmxzu*dbvzdz
      gmybvx = gmyxu*dbvxdx + gmyyu*dbvxdy + gmyzu*dbvxdz
      gmybvy = gmyxu*dbvydx + gmyyu*dbvydy + gmyzu*dbvydz
      gmybvz = gmyxu*dbvzdx + gmyyu*dbvzdy + gmyzu*dbvzdz
      gmzbvx = gmzxu*dbvxdx + gmzyu*dbvxdy + gmzzu*dbvxdz
      gmzbvy = gmzxu*dbvydx + gmzyu*dbvydy + gmzzu*dbvydz
      gmzbvz = gmzxu*dbvzdx + gmzyu*dbvzdy + gmzzu*dbvzdz
c
      if (ii.eq.1)
     & gcrdb2 = c11*gmxbvx + c21*gmxbvy + c31*gmxbvz
     &        + c12*gmybvx + c22*gmybvy + c32*gmybvz 
     &        + c13*gmzbvx + c23*gmzbvy + c33*gmzbvz
c
      if (ii.eq.2)
     & gcrdb2 = c12*gmxbvx + c22*gmxbvy + c32*gmxbvz
     &        + c14*gmybvx + c24*gmybvy + c34*gmybvz 
     &        + c15*gmzbvx + c25*gmzbvy + c35*gmzbvz
c
      if (ii.eq.3)
     & gcrdb2 = c13*gmxbvx + c23*gmxbvy + c33*gmxbvz
     &        + c15*gmybvx + c25*gmybvy + c35*gmybvz 
     &        + c16*gmzbvx + c26*gmzbvy + c36*gmzbvz
c
c --  Helical term, \tD_b (L\phi)_a^b.
c
      if (chgra.eq.'h'.or.chgra.eq.'c'.or.chgra.eq.'C'
     &.or.chgra.eq.'H'.or.chgra.eq.'W') then
c
      elpxxd = elpxx(irg,itg,ipg)
      elpxyd = elpxy(irg,itg,ipg)
      elpxzd = elpxz(irg,itg,ipg)
      elpyyd = elpyy(irg,itg,ipg)
      elpyzd = elpyz(irg,itg,ipg)
      elpzzd = elpzz(irg,itg,ipg)
      elpyxd = elpxyd
      elpzxd = elpxzd
      elpzyd = elpyzd
c
      elpxxm = gmxxu*elpxxd + gmxyu*elpxyd + gmxzu*elpxzd
      elpxym = gmyxu*elpxxd + gmyyu*elpxyd + gmyzu*elpxzd
      elpxzm = gmzxu*elpxxd + gmzyu*elpxyd + gmzzu*elpxzd
      elpyxm = gmxxu*elpyxd + gmxyu*elpyyd + gmxzu*elpyzd
      elpyym = gmyxu*elpyxd + gmyyu*elpyyd + gmyzu*elpyzd
      elpyzm = gmzxu*elpyxd + gmzyu*elpyyd + gmzzu*elpyzd
      elpzxm = gmxxu*elpzxd + gmxyu*elpzyd + gmxzu*elpzzd
      elpzym = gmyxu*elpzxd + gmyyu*elpzyd + gmyzu*elpzzd
      elpzzm = gmzxu*elpzxd + gmzyu*elpzyd + gmzzu*elpzzd
c
      if (ii.eq.1) then
      call grgrad(elpxx,dexxdx,dexxdy,dexxdz,irg,itg,ipg,1,-1,-1)
      call grgrad(elpxy,dexydx,dexydy,dexydz,irg,itg,ipg,1,1,1)
      call grgrad(elpxz,dexzdx,dexzdy,dexzdz,irg,itg,ipg,-1,1,-1)
      pdivlp = gmxxu*dexxdx + gmxyu*dexxdy + gmxzu*dexxdz
     &       + gmyxu*dexydx + gmyyu*dexydy + gmyzu*dexydz
     &       + gmzxu*dexzdx + gmzyu*dexzdy + gmzzu*dexzdz
      gclp = c11*elpxxm + c12*elpxym + c13*elpxzm
     &     + c21*elpyxm + c22*elpyym + c23*elpyzm
     &     + c31*elpzxm + c32*elpzym + c33*elpzzm
      divlp = pdivlp - gclp
      end if
      if (ii.eq.2) then
      call grgrad(elpxy,dexydx,dexydy,dexydz,irg,itg,ipg,1,1,1)
      call grgrad(elpyy,deyydx,deyydy,deyydz,irg,itg,ipg,1,-1,-1)
      call grgrad(elpyz,deyzdx,deyzdy,deyzdz,irg,itg,ipg,-1,-1,1)
      pdivlp = gmxxu*dexydx + gmxyu*dexydy + gmxzu*dexydz
     &       + gmyxu*deyydx + gmyyu*deyydy + gmyzu*deyydz
     &       + gmzxu*deyzdx + gmzyu*deyzdy + gmzzu*deyzdz
      gclp = c12*elpxxm + c14*elpxym + c15*elpxzm
     &     + c22*elpyxm + c24*elpyym + c25*elpyzm
     &     + c32*elpzxm + c34*elpzym + c35*elpzzm
      divlp = pdivlp - gclp
      end if
      if (ii.eq.3) then
      call grgrad(elpxz,dexzdx,dexzdy,dexzdz,irg,itg,ipg,-1,1,-1)
      call grgrad(elpyz,deyzdx,deyzdy,deyzdz,irg,itg,ipg,-1,-1,1)
      call grgrad(elpzz,dezzdx,dezzdy,dezzdz,irg,itg,ipg,1,-1,-1)
      pdivlp = gmxxu*dexzdx + gmxyu*dexzdy + gmxzu*dexzdz
     &       + gmyxu*deyzdx + gmyyu*deyzdy + gmyzu*deyzdz
     &       + gmzxu*dezzdx + gmzyu*dezzdy + gmzzu*dezzdz
      gclp = c13*elpxxm + c15*elpxym + c16*elpxzm
     &     + c23*elpyxm + c25*elpyym + c26*elpyzm
     &     + c33*elpzxm + c35*elpzym + c36*elpzzm
      divlp = pdivlp - gclp
      end if
c
      end if
c
 1424 continue
c
      souvec(irg,itg,ipg,ii) = 
     &    - hddb + gdcb + gcrdb1 + gcrdb2 - san*gradfnc4
     &    -(rax*bvxgc + ray*bvygc + raz*bvzgc) - ome*divlp*cutoff
     &    - 2.0d0*afnc2inv*(
     &    + gmxxu*rkax*dxafn + gmxyu*rkax*dyafn + gmxzu*rkax*dzafn
     &    + gmyxu*rkay*dxafn + gmyyu*rkay*dyafn + gmyzu*rkay*dzafn
     &    + gmzxu*rkaz*dxafn + gmzyu*rkaz*dyafn + gmzzu*rkaz*dzafn)
     &    + radi**2*16.0d0*pi*alpgc*rjj*zfac
c     
 424  continue
 430  continue
c
c --- For bbb.
c
      do 444 ipg = 0, npg
      do 444 itg = 0, ntg
      do 444 irg = 0, nrtot
      xxx = rg(irg)*sintheg(itg)*cosphig(ipg)
      yyy = rg(irg)*sintheg(itg)*sinphig(ipg)
      zzz = rg(irg)*costheg(itg)
      sou(irg,itg,ipg) = xxx*souvec(irg,itg,ipg,1)
     &                 + yyy*souvec(irg,itg,ipg,2)
     &                 + zzz*souvec(irg,itg,ipg,3)
  444 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine hijsource(souten,chgra,chope,iter)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
      common / cdbvd / cdbvxd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 cdbvyd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 cdbvzd(0:nnrg,0:nntg,0:nnpg,1:3)
      common / cdivb / cdivbv(0:nnrg,0:nntg,0:nnpg)
      common / liebe / rlbxx(0:nnrg,0:nntg,0:nnpg),
     &                 rlbxy(0:nnrg,0:nntg,0:nnpg),
     &                 rlbxz(0:nnrg,0:nntg,0:nnpg),
     &                 rlbyy(0:nnrg,0:nntg,0:nnpg),
     &                 rlbyz(0:nnrg,0:nntg,0:nnpg),
     &                 rlbzz(0:nnrg,0:nntg,0:nnpg)
      common / lieph / rlpxx(0:nnrg,0:nntg,0:nnpg),
     &                 rlpxy(0:nnrg,0:nntg,0:nnpg),
     &                 rlpxz(0:nnrg,0:nntg,0:nnpg),
     &                 rlpyy(0:nnrg,0:nntg,0:nnpg),
     &                 rlpyz(0:nnrg,0:nntg,0:nnpg),
     &                 rlpzz(0:nnrg,0:nntg,0:nnpg)
      common / augfn / emdg(0:nnrg,0:nntg,0:nnpg),
     &                 ramg(0:nnrg,0:nntg,0:nnpg), 
     &               gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / hijsw / swlp(4), swls(4), iswl
      common / flusw / swflu
      common / cutsw / cutfac
      common / dvphi / dphiu(3,3)
c
      dimension souten(0:nnrg,0:nntg,0:nnpg,1:6)
      dimension gradp(0:nnrg,0:nntg,0:nnpg,1:3), 
     &          grada(0:nnrg,0:nntg,0:nnpg,1:3), 
     &          gradap(0:nnrg,0:nntg,0:nnpg,1:3), dabalps2(1:3,1:3), 
     &          gradap2(0:nnrg,0:nntg,0:nnpg,1:3), daalps2(3), 
     &          dapsi(3), daalph(3), daalps(3), cdbv(3,3), vphig(3)
      dimension fnc0(0:nnrg,0:nntg,0:nnpg)
      dimension gradb(0:nnrg,0:nntg,0:nnpg,1:3,1:3), 
     &          dbv(1:3,1:3), dov(1:3,1:3)
      dimension gradk(0:nnrg,0:nntg,0:nnpg,1:6,1:3), daij(1:6,1:3)
      dimension r5(5), th5(5), phi5(5), gamu(1:3,1:3), gamd(1:3,1:3),
     &         fr5(5),  ft5(5),  fp5(5), fr5x(5), ft5x(5), fp5x(5),
     &        fr5y(5), ft5y(5), fp5y(5), fr5z(5), ft5z(5), fp5z(5),
     &          xi(4),  yi1(4),  yi2(4),  yi3(4),  yi4(4),
     &         yi5(4),  yi6(4),  yi7(4),  yi8(4),  yi9(4),
     &       grad1(3), grad1x(3), grad1y(3),  grad1z(3), 
     &       dckkx(3),  dckky(3),  dckkz(3), divhgmc(6), aij(1:3,1:3)
      dimension rlieaij(3,3), rnlab(3,3), rpsiab(3,3), 
     &           aacabc(3,3),   sab(3,3), ovd(3), ovu(3), rpddal(3,3)
      dimension heli(3,3), dphabd(3,3), dphabu(3,3), d2phab(3,3), 
     &        rlbgab(3,3), rlpgab(3,3), dliepg(6,3), dliebg(6,3), 
     &        rlplbg(3,3), rlblpg(3,3), rlblbg(3,3), palidp(3,3)
      dimension ica(6), icb(6)
      dimension tm1a(3,3),tm2a(3,3),tm3a(3,3),tm4a(3,3),tm5a(3,3)
c
      character*1 chgra, chope
c
c --- source for hij is evaluated on grid points.
c
      do 1 ii = 1, 3
c ### bvx, bvy, bvz are non-rotating shift!!
      if (ii.eq.1) call grgrad4(bvxu,gradp,1,1,-1)
      if (ii.eq.2) call grgrad4(bvyu,gradp,1,-1,1)
      if (ii.eq.3) call grgrad4(bvzu,gradp,-1,-1,-1)
      do 3 ipg = 0, npg
      do 3 itg = 0, ntg
      do 3 irg = 0, nrtot
      gradb(irg,itg,ipg,ii,1) = gradp(irg,itg,ipg,1)
      gradb(irg,itg,ipg,ii,2) = gradp(irg,itg,ipg,2)
      gradb(irg,itg,ipg,ii,3) = gradp(irg,itg,ipg,3)
    3 continue
    1 continue
c
      do 4 ic = 1, 6
      ia = 1 + ic/4 + ic/6
      ib = ic - (ic/4)*2 - ic/6
      do 5 ipg = 0, npg
      do 5 itg = 0, ntg
      do 5 irg = 0, nrtot
      fnc0(irg,itg,ipg) = rkij(irg,itg,ipg,ia,ib)
    5 continue
      if (ic.eq.1) call grgrad4(fnc0,gradp,1,-1,-1)
      if (ic.eq.2) call grgrad4(fnc0,gradp,1,1,1)
      if (ic.eq.3) call grgrad4(fnc0,gradp,-1,1,-1)
      if (ic.eq.4) call grgrad4(fnc0,gradp,1,-1,-1)
      if (ic.eq.5) call grgrad4(fnc0,gradp,-1,-1,1)
      if (ic.eq.6) call grgrad4(fnc0,gradp,1,-1,-1)
      do 6 ipg = 0, npg
      do 6 itg = 0, ntg
      do 6 irg = 0, nrtot
      gradk(irg,itg,ipg,ic,1) = gradp(irg,itg,ipg,1)
      gradk(irg,itg,ipg,ic,2) = gradp(irg,itg,ipg,2)
      gradk(irg,itg,ipg,ic,3) = gradp(irg,itg,ipg,3)
    6 continue
    4 continue
c
      do 7 ipg = 0, npg
      do 7 itg = 0, ntg
      do 7 irg = 0, nrtot
      alps2(irg,itg,ipg) = alph(irg,itg,ipg)*psi(irg,itg,ipg)**2
    7 continue
c
      call grgrad4(psi,gradp,1,1,1)
      call grgrad4(alph,grada,1,1,1)
      call grgrad4(alps,gradap,1,1,1)
      call grgrad4(alps2,gradap2,1,1,1)
c
c
      san = 1.0d0/3.0d0
      san2= 2.0d0/3.0d0
      roku= 1.0d0/6.0d0
c
      do 10 ipg = 0, npg
      do 10 itg = 0, ntg
      do 10 irg = 0, nrtot
c
      cutoff = 1.0d0
      if (chgra.eq.'C'.or.chgra.eq.'H'.or.chgra.eq.'W') then
      if (rg(irg).gt.cutfac*pi/ome) cutoff = 0.0d0
      end if
c
      psigc =  psi(irg,itg,ipg)
      alpgc = alph(irg,itg,ipg)
      ap2gc = alps2(irg,itg,ipg)
      psigc4 = psigc**4
      psiinv = 1.0d0/psi(irg,itg,ipg)
      psiinv2 = psiinv**2
      alpgcinv = 1.0d0/alph(irg,itg,ipg)
      ap2gcinv = 1.0d0/alps2(irg,itg,ipg)
      ps43oal = 4.0d0*psigc**3*alpgcinv
      ps4oal = psigc4*alpgcinv
      ps4oal2= psigc4*alpgcinv**2
      emdgc = emdg(irg,itg,ipg)
      ramgc = ramg(irg,itg,ipg)
      rhogc = emdgc**pinx
      pregc = rhogc*emdgc
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
c
      utgc  =       swflu *ramg(irg,itg,ipg)/(alpgc**2*hhgc)
     &      +(1.0d0-swflu)*hhgc/ber
c
      zfac = 1.0d0
      if (emdgc.le.0.0d0) zfac = 0.0d0
c
      hhxxu = hxxu(irg,itg,ipg)
      hhxyu = hxyu(irg,itg,ipg)
      hhxzu = hxzu(irg,itg,ipg)
      hhyyu = hyyu(irg,itg,ipg)
      hhyzu = hyzu(irg,itg,ipg)
      hhzzu = hzzu(irg,itg,ipg)
      hhyxu = hhxyu
      hhzxu = hhxzu
      hhzyu = hhyzu
      gamu(1,1) = hhxxu + 1.0d0
      gamu(1,2) = hhxyu
      gamu(1,3) = hhxzu
      gamu(2,2) = hhyyu + 1.0d0
      gamu(2,3) = hhyzu
      gamu(3,3) = hhzzu + 1.0d0
      gamu(2,1) = gamu(1,2)
      gamu(3,1) = gamu(1,3)
      gamu(3,2) = gamu(2,3)
c
      hhxxd = hxxd(irg,itg,ipg)
      hhxyd = hxyd(irg,itg,ipg)
      hhxzd = hxzd(irg,itg,ipg)
      hhyyd = hyyd(irg,itg,ipg)
      hhyzd = hyzd(irg,itg,ipg)
      hhzzd = hzzd(irg,itg,ipg)
      hhyxd = hhxyd
      hhzxd = hhxzd
      hhzyd = hhyzd
      gamd(1,1) = hhxxd + 1.0d0
      gamd(1,2) = hhxyd
      gamd(1,3) = hhxzd
      gamd(2,2) = hhyyd + 1.0d0
      gamd(2,3) = hhyzd
      gamd(3,3) = hhzzd + 1.0d0
      gamd(2,1) = gamd(1,2)
      gamd(3,1) = gamd(1,3)
      gamd(3,2) = gamd(2,3)
c
      ovd(1) = ovxd(irg,itg,ipg)
      ovd(2) = ovyd(irg,itg,ipg)
      ovd(3) = ovzd(irg,itg,ipg)
      ovu(1) = ovxu(irg,itg,ipg)
      ovu(2) = ovyu(irg,itg,ipg)
      ovu(3) = ovzu(irg,itg,ipg)
c
c ### bvx, bvy, bvz are non-rotating shift!!
      bvxgc = bvxu(irg,itg,ipg)
      bvygc = bvyu(irg,itg,ipg)
      bvzgc = bvzu(irg,itg,ipg)
c
      vphig(1) = - rg(irg)*sintheg(itg)*sinphig(ipg)
      vphig(2) =   rg(irg)*sintheg(itg)*cosphig(ipg)
      vphig(3) = 0.0d0
c
      do 14 ia = 1, 3
      dapsi(ia) = gradp(irg,itg,ipg,ia)
      daalph(ia) = grada(irg,itg,ipg,ia)
      daalps(ia) = gradap(irg,itg,ipg,ia)
      daalps2(ia) = gradap2(irg,itg,ipg,ia)
      cdbv(1,ia) = cdbvxd(irg,itg,ipg,ia)
      cdbv(2,ia) = cdbvyd(irg,itg,ipg,ia)
      cdbv(3,ia) = cdbvzd(irg,itg,ipg,ia)
      do 15 ib = 1, 3
      aij(ia,ib) = rkij(irg,itg,ipg,ia,ib)
      dbv(ia,ib) = gradb(irg,itg,ipg,ia,ib)
 15   continue
      do 16 ic = 1, 6
      daij(ic,ia) = gradk(irg,itg,ipg,ic,ia)
 16   continue
 14   continue
c
      cdivbc = cdivbv(irg,itg,ipg)
c
c --- DaDb(alpha psi^2)
c
cc      call dadbscalarg(alps2,dabalps2,irg,itg,ipg,1,1,1)
      call dadbscalargsym(alps2,dabalps2,irg,itg,ipg,1,1,1)
ctesttest      call dadbscalargsym_2(alps2,dabalps2,irg,itg,ipg,1,1,1)
c
      gadadp=gamu(1,1)*daalph(1)*dapsi(1)+gamu(1,2)*daalph(1)*dapsi(2)
     &      +gamu(1,3)*daalph(1)*dapsi(3)+gamu(2,1)*daalph(2)*dapsi(1)
     &      +gamu(2,2)*daalph(2)*dapsi(2)+gamu(2,3)*daalph(2)*dapsi(3)
     &      +gamu(3,1)*daalph(3)*dapsi(1)+gamu(3,2)*daalph(3)*dapsi(2)
     &      +gamu(3,3)*daalph(3)*dapsi(3)
c
c --- Lie(psi^4 A_ab)
c
      sw1 = swlp(iswl)
      sw2 = 1.0d0 - sw1
      sw3 = swls(iswl)
c
c ### rotating shift
      ovxgc = bvxgc + ome*vphig(1)
      ovygc = bvygc + ome*vphig(2)
      ovzgc = bvzgc + ome*vphig(3)
c
      ovpadpsi=ps43oal*(ovxgc*dapsi(1)+ovygc*dapsi(2)+ovzgc*dapsi(3))
      dov(1,2) = dbv(1,2) + ome*dphiu(1,2)
      dov(2,1) = dbv(2,1) + ome*dphiu(2,1)
c
ctest      rbvxgc = bvxgc + sw3*ome*vphig(1)
ctest      rbvygc = bvygc + sw3*ome*vphig(2)
ctest      rbvzgc = bvzgc + sw3*ome*vphig(3)
c
ctest      bvpadpsi = 
ctest     & - sw1*san2*ps4oal*cdivbc
ctest     & + sw2*ps43oal*(rbvxgc*dapsi(1)+rbvygc*dapsi(2)+rbvzgc*dapsi(3))
c
ctest      dbv(1,2) = dbv(1,2) + sw3*ome*dphiu(1,2)
ctest      dbv(2,1) = dbv(2,1) + sw3*ome*dphiu(2,1)
c
c --- For helical terms
c
      if (chgra.eq.'h'.or.chgra.eq.'c'.or.chgra.eq.'C'
     &.or.chgra.eq.'H'.or.chgra.eq.'W') then
c
      rlbgab(1,1) = rlbxx(irg,itg,ipg)
      rlbgab(1,2) = rlbxy(irg,itg,ipg)
      rlbgab(1,3) = rlbxz(irg,itg,ipg)
      rlbgab(2,1) = rlbxy(irg,itg,ipg)
      rlbgab(2,2) = rlbyy(irg,itg,ipg)
      rlbgab(2,3) = rlbyz(irg,itg,ipg)
      rlbgab(3,1) = rlbxz(irg,itg,ipg)
      rlbgab(3,2) = rlbyz(irg,itg,ipg)
      rlbgab(3,3) = rlbzz(irg,itg,ipg)
      rlpgab(1,1) = rlpxx(irg,itg,ipg)
      rlpgab(1,2) = rlpxy(irg,itg,ipg)
      rlpgab(1,3) = rlpxz(irg,itg,ipg)
      rlpgab(2,1) = rlpxy(irg,itg,ipg)
      rlpgab(2,2) = rlpyy(irg,itg,ipg)
      rlpgab(2,3) = rlpyz(irg,itg,ipg)
      rlpgab(3,1) = rlpxz(irg,itg,ipg)
      rlpgab(3,2) = rlpyz(irg,itg,ipg)
      rlpgab(3,3) = rlpzz(irg,itg,ipg)
c
      call grderiv1phi(hxxd,dphxxd,irg,itg,ipg,1,1,1)
      call grderiv1phi(hxyd,dphxyd,irg,itg,ipg,1,-1,-1)
      call grderiv1phi(hxzd,dphxzd,irg,itg,ipg,-1,-1,1)
      call grderiv1phi(hyyd,dphyyd,irg,itg,ipg,1,1,1)
      call grderiv1phi(hyzd,dphyzd,irg,itg,ipg,-1,1,-1)
      call grderiv1phi(hzzd,dphzzd,irg,itg,ipg,1,1,1)
      dphyxd = dphxyd
      dphzxd = dphxzd
      dphzyd = dphyzd
      dphabd(1,1) = dphxxd
      dphabd(1,2) = dphxyd
      dphabd(1,3) = dphxzd
      dphabd(2,1) = dphyxd
      dphabd(2,2) = dphyyd
      dphabd(2,3) = dphyzd
      dphabd(3,1) = dphzxd
      dphabd(3,2) = dphzyd
      dphabd(3,3) = dphzzd
      call grderiv1phi(hxxu,dphxxu,irg,itg,ipg,1,1,1)
      call grderiv1phi(hxyu,dphxyu,irg,itg,ipg,1,-1,-1)
      call grderiv1phi(hxzu,dphxzu,irg,itg,ipg,-1,-1,1)
      call grderiv1phi(hyyu,dphyyu,irg,itg,ipg,1,1,1)
      call grderiv1phi(hyzu,dphyzu,irg,itg,ipg,-1,1,-1)
      call grderiv1phi(hzzu,dphzzu,irg,itg,ipg,1,1,1)
      dphyxu = dphxyu
      dphzxu = dphxzu
      dphzyu = dphyzu
      dphabu(1,1) = dphxxu
      dphabu(1,2) = dphxyu
      dphabu(1,3) = dphxzu
      dphabu(2,1) = dphyxu
      dphabu(2,2) = dphyyu
      dphabu(2,3) = dphyzu
      dphabu(3,1) = dphzxu
      dphabu(3,2) = dphzyu
      dphabu(3,3) = dphzzu
      call grderiv2phi(hxxd,d2phxx,irg,itg,ipg,1,1,1)
      call grderiv2phi(hxyd,d2phxy,irg,itg,ipg,1,-1,-1)
      call grderiv2phi(hxzd,d2phxz,irg,itg,ipg,-1,-1,1)
      call grderiv2phi(hyyd,d2phyy,irg,itg,ipg,1,1,1)
      call grderiv2phi(hyzd,d2phyz,irg,itg,ipg,-1,1,-1)
      call grderiv2phi(hzzd,d2phzz,irg,itg,ipg,1,1,1)
      d2phyx = d2phxy
      d2phzx = d2phxz
      d2phzy = d2phyz
      d2phab(1,1) = d2phxx
      d2phab(1,2) = d2phxy
      d2phab(1,3) = d2phxz
      d2phab(2,1) = d2phyx
      d2phab(2,2) = d2phyy
      d2phab(2,3) = d2phyz
      d2phab(3,1) = d2phzx
      d2phab(3,2) = d2phzy
      d2phab(3,3) = d2phzz
c
c --  \Lie_\phi T_{ab} 
c --   = \pa_\phi T_{ab} + T_{ac} \zD_b\phi^c + T_{cb} \zD_a\phi^c
c
      call grderiv1phi(rlbxx,dpdbgxx,irg,itg,ipg,1,-1,-1)
      call grderiv1phi(rlbxy,dpdbgxy,irg,itg,ipg,1,1,1)
      call grderiv1phi(rlbxz,dpdbgxz,irg,itg,ipg,-1,1,-1)
      call grderiv1phi(rlbyy,dpdbgyy,irg,itg,ipg,1,-1,-1)
      call grderiv1phi(rlbyz,dpdbgyz,irg,itg,ipg,-1,-1,1)
      call grderiv1phi(rlbzz,dpdbgzz,irg,itg,ipg,1,-1,-1)
      dpdbgyx = dpdbgxy
      dpdbgzx = dpdbgxz
      dpdbgzy = dpdbgyz
      rlplbg(1,1)=dpdbgxx+rlbgab(1,2)*dphiu(2,1)+rlbgab(2,1)*dphiu(2,1)
      rlplbg(1,2)=dpdbgxy+rlbgab(1,1)*dphiu(1,2)+rlbgab(2,2)*dphiu(2,1)
      rlplbg(1,3)=dpdbgxz
      rlplbg(2,1)=dpdbgyx+rlbgab(2,2)*dphiu(2,1)+rlbgab(1,1)*dphiu(1,2)
      rlplbg(2,2)=dpdbgyy+rlbgab(2,1)*dphiu(1,2)+rlbgab(1,2)*dphiu(1,2)
      rlplbg(2,3) = dpdbgyz
      rlplbg(3,1) = dpdbgzx
      rlplbg(3,2) = dpdbgzy
      rlplbg(3,3) = dpdbgzz
c
      rlielnp = 8.0d0*psiinv
     &  *(ovu(1)* dapsi(1) + ovu(2)* dapsi(2) + ovu(3)* dapsi(3))
      rlielna = alpgcinv
     &  *(ovu(1)*daalph(1) + ovu(2)*daalph(2) + ovu(3)*daalph(3))
c
      call grgrad(rlbxx,dlbgxxdx,dlbgxxdy,dlbgxxdz,irg,itg,ipg,1,-1,-1)
      call grgrad(rlbxy,dlbgxydx,dlbgxydy,dlbgxydz,irg,itg,ipg,1,1,1)
      call grgrad(rlbxz,dlbgxzdx,dlbgxzdy,dlbgxzdz,irg,itg,ipg,-1,1,-1)
      call grgrad(rlbyy,dlbgyydx,dlbgyydy,dlbgyydz,irg,itg,ipg,1,-1,-1)
      call grgrad(rlbyz,dlbgyzdx,dlbgyzdy,dlbgyzdz,irg,itg,ipg,-1,-1,1)
      call grgrad(rlbzz,dlbgzzdx,dlbgzzdy,dlbgzzdz,irg,itg,ipg,1,-1,-1)
      dliebg(1,1) = dlbgxxdx
      dliebg(1,2) = dlbgxxdy
      dliebg(1,3) = dlbgxxdz
      dliebg(2,1) = dlbgxydx
      dliebg(2,2) = dlbgxydy
      dliebg(2,3) = dlbgxydz
      dliebg(3,1) = dlbgxzdx
      dliebg(3,2) = dlbgxzdy
      dliebg(3,3) = dlbgxzdz
      dliebg(4,1) = dlbgyydx
      dliebg(4,2) = dlbgyydy
      dliebg(4,3) = dlbgyydz
      dliebg(5,1) = dlbgyzdx
      dliebg(5,2) = dlbgyzdy
      dliebg(5,3) = dlbgyzdz
      dliebg(6,1) = dlbgzzdx
      dliebg(6,2) = dlbgzzdy
      dliebg(6,3) = dlbgzzdz
      call grgrad(rlpxx,dlpgxxdx,dlpgxxdy,dlpgxxdz,irg,itg,ipg,1,-1,-1)
      call grgrad(rlpxy,dlpgxydx,dlpgxydy,dlpgxydz,irg,itg,ipg,1,1,1)
      call grgrad(rlpxz,dlpgxzdx,dlpgxzdy,dlpgxzdz,irg,itg,ipg,-1,1,-1)
      call grgrad(rlpyy,dlpgyydx,dlpgyydy,dlpgyydz,irg,itg,ipg,1,-1,-1)
      call grgrad(rlpyz,dlpgyzdx,dlpgyzdy,dlpgyzdz,irg,itg,ipg,-1,-1,1)
      call grgrad(rlpzz,dlpgzzdx,dlpgzzdy,dlpgzzdz,irg,itg,ipg,1,-1,-1)
      dliepg(1,1) = dlpgxxdx
      dliepg(1,2) = dlpgxxdy
      dliepg(1,3) = dlpgxxdz
      dliepg(2,1) = dlpgxydx
      dliepg(2,2) = dlpgxydy
      dliepg(2,3) = dlpgxydz
      dliepg(3,1) = dlpgxzdx
      dliepg(3,2) = dlpgxzdy
      dliepg(3,3) = dlpgxzdz
      dliepg(4,1) = dlpgyydx
      dliepg(4,2) = dlpgyydy
      dliepg(4,3) = dlpgyydz
      dliepg(5,1) = dlpgyzdx
      dliepg(5,2) = dlpgyzdy
      dliepg(5,3) = dlpgyzdz
      dliepg(6,1) = dlpgzzdx
      dliepg(6,2) = dlpgzzdy
      dliepg(6,3) = dlpgzzdz
c
      end if
c
      do 18 ic = 1, 6
c
      ia = 1 + ic/4 + ic/6
      ib = ic - (ic/4)*2 - ic/6
c
c --- Lie_w A_{ab} 
c       = w^c \pa_c A_{ab} + A_{ac}\pa_b w^c + A_{cb}\pa_a w^c. 
c
      rlieaij(ia,ib) = 
     &     ovxgc*daij(ic,1) + ovygc*daij(ic,2) + ovzgc*daij(ic,3)
     &   + aij(ia,1)*dov(1,ib)+aij(ia,2)*dov(2,ib)+aij(ia,3)*dov(3,ib)
     &   + aij(1,ib)*dov(1,ia)+aij(2,ib)*dov(2,ia)+aij(3,ib)*dov(3,ia)
c
ctest      rlieaij(ia,ib) = 
ctest     &     rbvxgc*daij(ic,1) + rbvygc*daij(ic,2) + rbvzgc*daij(ic,3)
ctest     &   + aij(ia,1)*dbv(1,ib)+aij(ia,2)*dbv(2,ib)+aij(ia,3)*dbv(3,ib)
ctest     &   + aij(1,ib)*dbv(1,ia)+aij(2,ib)*dbv(2,ia)+aij(3,ib)*dbv(3,ia)
c
c --- R_ab(nonlinear) 
c
      rnlab(ia,ib) = rabnl(irg,itg,ipg,ic)
c
c --- R^psi_ab - 1/alpha DaDb alpha
c
      c1ab = cri(irg,itg,ipg,1,ic)
      c2ab = cri(irg,itg,ipg,2,ic)
      c3ab = cri(irg,itg,ipg,3,ic)
c
      cdalps2 = c1ab*daalps2(1) + c2ab*daalps2(2) + c3ab*daalps2(3)
      dapda = 4.0d0*(daalps(ia)*dapsi(ib)+daalps(ib)*dapsi(ia))
      rpddal(ia,ib) = ap2gcinv*(- dabalps2(ia,ib) + cdalps2 + dapda)
c
c --- AacAbc
c
      aacabc(ia,ib) = gamu(1,1)*aij(ia,1)*aij(ib,1)
     &              + gamu(1,2)*aij(ia,1)*aij(ib,2)
     &              + gamu(1,3)*aij(ia,1)*aij(ib,3)
     &              + gamu(2,1)*aij(ia,2)*aij(ib,1)
     &              + gamu(2,2)*aij(ia,2)*aij(ib,2)
     &              + gamu(2,3)*aij(ia,2)*aij(ib,3)
     &              + gamu(3,1)*aij(ia,3)*aij(ib,1)
     &              + gamu(3,2)*aij(ia,3)*aij(ib,2)
     &              + gamu(3,3)*aij(ia,3)*aij(ib,3)
c
c --- Helical terms
c
      heli(ia,ib) = 0.0d0
      if (chgra.eq.'h'.or.chgra.eq.'H'.or.chgra.eq.'W') then
c
      rlblpg(ia,ib) = 
     &     bvxgc*dliepg(ic,1)+bvygc*dliepg(ic,2)+bvzgc*dliepg(ic,3)
     &   + rlpgab(ia,1)*dov(1,ib) + rlpgab(ia,2)*dov(2,ib)
     &   + rlpgab(ia,3)*dov(3,ib) + rlpgab(1,ib)*dov(1,ia)
     &   + rlpgab(2,ib)*dov(2,ia) + rlpgab(3,ib)*dov(3,ia)
      rlblbg(ia,ib) = 
     &     bvxgc*dliebg(ic,1)+bvygc*dliebg(ic,2)+bvzgc*dliebg(ic,3)
     &   + rlbgab(ia,1)*dov(1,ib) + rlbgab(ia,2)*dov(2,ib)
     &   + rlbgab(ia,3)*dov(3,ib) + rlbgab(1,ib)*dov(1,ia)
     &   + rlbgab(2,ib)*dov(2,ia) + rlbgab(3,ib)*dov(3,ia)
c
      palidp(ia,ib) = (dphabd(ia,1) + rlpgab(ia,1))*dphiu(1,ib)
     &              + (dphabd(ia,2) + rlpgab(ia,2))*dphiu(2,ib)
     &              + (dphabd(ia,3) + rlpgab(ia,3))*dphiu(3,ib)
     &              + (dphabd(1,ib) + rlpgab(1,ib))*dphiu(1,ia)
     &              + (dphabd(2,ib) + rlpgab(2,ib))*dphiu(2,ia)
     &              + (dphabd(3,ib) + rlpgab(3,ib))*dphiu(3,ia)
c
      term1 = 0.5d0*(ps4oal2 - 1.0d0)*ome**2*d2phab(ia,ib)
      term2 = 0.5d0*ps4oal2*ome**2*palidp(ia,ib)
      term3 = 0.5d0*ps4oal2*ome*(rlplbg(ia,ib) + rlblpg(ia,ib))
      term4 = 0.5d0*ps4oal2*rlblbg(ia,ib)
      term5 = ps4oal*aij(ia,ib)*(rlielnp - rlielna)
c
c --  for print out
      if (irg.eq.2.and.itg.eq.1.and.ipg.eq.0) then
      write(6,88)term1,term2,term3,term4,term5
 88   format(1p,6e14.6)
      end if
c
      tm1a(ia,ib) = term1
      tm2a(ia,ib) = term2
      tm3a(ia,ib) = term3
      tm4a(ia,ib) = term4
      tm5a(ia,ib) = term5
c --  
c
      if (chgra.eq.'H') then
      term2 = term2*cutoff
      term3 = term3*cutoff
      end if
c
      heli(ia,ib) = term1 + term2 + term3 + term4 + term5
c
      end if
c
c --- Fluid source
c
      sab(ia,ib) = swflu*rhogc/hhgc
     &            *gradvg(irg,itg,ipg,ia)*gradvg(irg,itg,ipg,ib)
     &     +(1.0d0-swflu)*hhgc*rhogc*utgc**2*psigc4**2*ovd(ia)*ovd(ib)
c
   18 continue
c
c --- derivative for h_ab and h^ab.
c
      call grgrad(hxxd,dhxxddx,dhxxddy,dhxxddz,irg,itg,ipg,1,1,1)
      call grgrad(hxyd,dhxyddx,dhxyddy,dhxyddz,irg,itg,ipg,1,-1,-1)
      call grgrad(hxzd,dhxzddx,dhxzddy,dhxzddz,irg,itg,ipg,-1,-1,1)
      call grgrad(hyyd,dhyyddx,dhyyddy,dhyyddz,irg,itg,ipg,1,1,1)
      call grgrad(hyzd,dhyzddx,dhyzddy,dhyzddz,irg,itg,ipg,-1,1,-1)
      call grgrad(hzzd,dhzzddx,dhzzddy,dhzzddz,irg,itg,ipg,1,1,1)
c
      dhyxddx = dhxyddx
      dhyxddy = dhxyddy
      dhyxddz = dhxyddz
      dhzxddx = dhxzddx
      dhzxddy = dhxzddy
      dhzxddz = dhxzddz
      dhzyddx = dhyzddx
      dhzyddy = dhyzddy
      dhzyddz = dhyzddz
c
      call grgrad(hxxu,dhxxudx,dhxxudy,dhxxudz,irg,itg,ipg,1,1,1)
      call grgrad(hxyu,dhxyudx,dhxyudy,dhxyudz,irg,itg,ipg,1,-1,-1)
      call grgrad(hxzu,dhxzudx,dhxzudy,dhxzudz,irg,itg,ipg,-1,-1,1)
      call grgrad(hyyu,dhyyudx,dhyyudy,dhyyudz,irg,itg,ipg,1,1,1)
      call grgrad(hyzu,dhyzudx,dhyzudy,dhyzudz,irg,itg,ipg,-1,1,-1)
      call grgrad(hzzu,dhzzudx,dhzzudy,dhzzudz,irg,itg,ipg,1,1,1)
c
      dhyxudx = dhxyudx
      dhyxudy = dhxyudy
      dhyxudz = dhxyudz
      dhzxudx = dhxzudx
      dhzxudy = dhxzudy
      dhzxudz = dhxzudz
      dhzyudx = dhyzudx
      dhzyudy = dhyzudy
      dhzyudz = dhyzudz
c
c --- end
c
      dhdh = dhxxudx*dhxxddx +  dhxxudy*dhxxddy +  dhxxudz*dhxxddz
     &     + dhxyudx*dhxyddx +  dhxyudy*dhxyddy +  dhxyudz*dhxyddz
     &     + dhxzudx*dhxzddx +  dhxzudy*dhxzddy +  dhxzudz*dhxzddz
     &     + dhyxudx*dhyxddx +  dhyxudy*dhyxddy +  dhyxudz*dhyxddz
     &     + dhyyudx*dhyyddx +  dhyyudy*dhyyddy +  dhyyudz*dhyyddz
     &     + dhyzudx*dhyzddx +  dhyzudy*dhyzddy +  dhyzudz*dhyzddz
     &     + dhzxudx*dhzxddx +  dhzxudy*dhzxddy +  dhzxudz*dhzxddz
     &     + dhzyudx*dhzyddx +  dhzyudy*dhzyddy +  dhzyudz*dhzyddz
     &     + dhzzudx*dhzzddx +  dhzzudy*dhzzddy +  dhzzudz*dhzzddz
c
      dphdph = dphxxu*dphxxd + dphxyu*dphxyd + dphxzu*dphxzd
     &       + dphyxu*dphyxd + dphyyu*dphyyd + dphyzu*dphyzd
     &       + dphzxu*dphzxd + dphzyu*dphzyd + dphzzu*dphzzd
c
      heli(2,1) = heli(1,2)
      heli(3,1) = heli(1,3)
      heli(3,2) = heli(2,3)
      rlieaij(2,1) = rlieaij(1,2)
      rlieaij(3,1) = rlieaij(1,3)
      rlieaij(3,2) = rlieaij(2,3)
        rnlab(2,1) =   rnlab(1,2)
        rnlab(3,1) =   rnlab(1,3)
        rnlab(3,2) =   rnlab(2,3)
       rpddal(2,1) =  rpddal(1,2)
       rpddal(3,1) =  rpddal(1,3)
       rpddal(3,2) =  rpddal(2,3)
       aacabc(2,1) =  aacabc(1,2)
       aacabc(3,1) =  aacabc(1,3)
       aacabc(3,2) =  aacabc(2,3)
          sab(2,1) =     sab(1,2)
          sab(3,1) =     sab(1,3)
          sab(3,2) =     sab(2,3)
c
      trheli = 0.0d0
      traij = 0.0d0
      trlieaij = 0.0d0
      trrnlab = 0.0d0
      trrpddal = 0.0d0
      traa = 0.0d0
      trsab = 0.0d0
      trd2ph = 0.0d0
      do 20 ib = 1, 3
      do 20 ia = 1, 3
      trheli   = trheli   + gamu(ia,ib)*   heli(ia,ib)
      traij    = traij    + gamu(ia,ib)*    aij(ia,ib)
      trlieaij = trlieaij + gamu(ia,ib)*rlieaij(ia,ib)
      trrnlab  = trrnlab  + gamu(ia,ib)*  rnlab(ia,ib)
      trrpddal = trrpddal + gamu(ia,ib)* rpddal(ia,ib)
      traa     = traa     + gamu(ia,ib)* aacabc(ia,ib)
      trsab    = trsab    + gamu(ia,ib)*    sab(ia,ib)
      trd2ph   = trd2ph   + gamu(ia,ib)* d2phab(ia,ib)
   20 continue
c
      do 10 ic = 1, 6
c
      ia = 1 + ic/4 + ic/6
      ib = ic - (ic/4)*2 - ic/6
c
      sgam = san*gamd(ia,ib)
      tfaij    =     aij(ia,ib) - sgam*traij
      tflieaij = rlieaij(ia,ib) - sgam*trlieaij
      tfrnlab  =   rnlab(ia,ib) - sgam*trrnlab 
      tfrpddal =  rpddal(ia,ib) - sgam*trrpddal
      tfaa     =  aacabc(ia,ib) - sgam*traa
      tfsab    =     sab(ia,ib) - sgam*trsab
c
      tfd2ph   =  d2phab(ia,ib) - sgam*trd2ph   
c
      gamdhdh  = gamd(ia,ib)*dhdh
      ogdphdph = 0.0d0
      if (chope.eq.'H') ogdphdph = gamd(ia,ib)*ome**2*dphdph
c
      tfliep4aij = 0.0d0
      tfheli     = 0.0d0
      if (chgra.eq.'w') tfliep4aij = tfaij*ovpadpsi + ps4oal*tflieaij
      if (chgra.eq.'c') tfliep4aij = tfaij*ovpadpsi + ps4oal*tflieaij
      if (chgra.eq.'C') tfliep4aij = tfaij*ovpadpsi + ps4oal*tflieaij
     &                             - 0.5d0*ome**2*tfd2ph*cutoff
      if (chgra.eq.'h') tfheli = heli(ia,ib) - sgam*trheli
      if (chgra.eq.'H') tfheli = heli(ia,ib) - sgam*trheli
      if (chgra.eq.'W') then 
                        tfheli = heli(ia,ib) - sgam*trheli
                        tfheli = tfheli*cutoff
                        tfliep4aij = tfaij*ovpadpsi + ps4oal*tflieaij
                        tfliep4aij = tfliep4aij*(1.0d0 - cutoff)
      end if
c
c
      souten(irg,itg,ipg,ic) = 
     &      2.0d0*( tfheli + tfliep4aij
     &            + tfrnlab + tfrpddal - 2.0d0*psigc4*tfaa
     &            - roku*gamdhdh + roku*ogdphdph
     &            - radi**2*8.0d0*pi*tfsab*zfac)
c
ctesttest
c      include 'GR_IRDR_souten_output_rpal.f'
ctesttest
c
   10 continue
c
 990  format(1p,18e14.6)
 999  format(1p,18e12.4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine surfsouscalar(fnc,ssou,dssou)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg)
      dimension ssou(0:nntg,0:nnpg), dssou(0:nntg,0:nnpg)
      dimension r5(5), f5(5)
c
c --- source for surface terms evaluated on grid points.
c
      irg = nrtot
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
c ### For scalar, subtracting 1.
      ssou(itg,ipg) = fnc(irg,itg,ipg) - 1.0d0
 100  continue
c
      irgi = nrtot - 5
      do 1 ii = 1, 5
 1    r5(ii) = rg(irgi+ii)
      rv = rg(nrout)
c
      do 110 ipg = 0, npg
      do 110 itg = 0, ntg
      do 2 ii = 1, 5
 2    f5(ii) = fnc(irgi+ii,itg,ipg)
cc      dssou(itg,ipg) = dfncdx(r5,f5,rv)
c ### For scalar, subtracting 1.
      dssou(itg,ipg) = - (fnc(irg,itg,ipg) - 1.0d0)/rg(irg)
 110  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine surfhijsource(ssouten,dssouten,iter,chgra,chope)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      dimension ssouten(0:nntg,0:nnpg,1:6), dssouten(0:nntg,0:nnpg,1:6)
      dimension ssoufix(0:nntg,0:nnpg,1:6), dssoufix(0:nntg,0:nnpg,1:6)
      dimension ssouvar(0:nntg,0:nnpg,1:6), dssouvar(0:nntg,0:nnpg,1:6)
      dimension r5(5), f5(5)
c
      character*1 chgra, chope
c
c --- source for hij surface terms evaluated on grid points.
c
      irg = nrtot
c
      irgi = nrtot - 5
      do 1 ii = 1, 5
 1    r5(ii) = rg(irgi+ii)
c
ctesttest      rv = rg(nrout)
      rv = rg(nrtot)
c
      do 110 ipg = 0, npg
      do 110 itg = 0, ntg
c
c --  For the funcitons.
c
      ssouvar(itg,ipg,1) = hxxd(irg,itg,ipg)
      ssouvar(itg,ipg,2) = hxyd(irg,itg,ipg)
      ssouvar(itg,ipg,3) = hxzd(irg,itg,ipg)
      ssouvar(itg,ipg,4) = hyyd(irg,itg,ipg)
      ssouvar(itg,ipg,5) = hyzd(irg,itg,ipg)
      ssouvar(itg,ipg,6) = hzzd(irg,itg,ipg)
c
c --  For the derivatives.
c
      do 2 ii = 1, 5
 2    f5(ii) = hxxd(irgi+ii,itg,ipg)
      dssouvar(itg,ipg,1) = dfncdx(r5,f5,rv)
      do 3 ii = 1, 5
 3    f5(ii) = hxyd(irgi+ii,itg,ipg)
      dssouvar(itg,ipg,2) = dfncdx(r5,f5,rv)
      do 4 ii = 1, 5
 4    f5(ii) = hxzd(irgi+ii,itg,ipg)
      dssouvar(itg,ipg,3) = dfncdx(r5,f5,rv)
      do 5 ii = 1, 5
 5    f5(ii) = hyyd(irgi+ii,itg,ipg)
      dssouvar(itg,ipg,4) = dfncdx(r5,f5,rv)
      do 6 ii = 1, 5
 6    f5(ii) = hyzd(irgi+ii,itg,ipg)
      dssouvar(itg,ipg,5) = dfncdx(r5,f5,rv)
      do 7 ii = 1, 5
 7    f5(ii) = hzzd(irgi+ii,itg,ipg)
      dssouvar(itg,ipg,6) = dfncdx(r5,f5,rv)
ctesttest
      if (iter.eq.15) then
ctesttest
      ssoufix(itg,ipg,1) = ssouvar(itg,ipg,1)
      ssoufix(itg,ipg,2) = ssouvar(itg,ipg,2)
      ssoufix(itg,ipg,3) = ssouvar(itg,ipg,3)
      ssoufix(itg,ipg,4) = ssouvar(itg,ipg,4)
      ssoufix(itg,ipg,5) = ssouvar(itg,ipg,5)
      ssoufix(itg,ipg,6) = ssouvar(itg,ipg,6)
      dssoufix(itg,ipg,1) = dssouvar(itg,ipg,1)
      dssoufix(itg,ipg,2) = dssouvar(itg,ipg,2)
      dssoufix(itg,ipg,3) = dssouvar(itg,ipg,3)
      dssoufix(itg,ipg,4) = dssouvar(itg,ipg,4)
      dssoufix(itg,ipg,5) = dssouvar(itg,ipg,5)
      dssoufix(itg,ipg,6) = dssouvar(itg,ipg,6)
ctesttest
      end if
ctesttest
 110  continue
c
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
c
      if (chope.eq.'L') then
c --  Robin boundary
      ssouten(itg,ipg,1) = ssouvar(itg,ipg,1)
      ssouten(itg,ipg,2) = ssouvar(itg,ipg,2)
      ssouten(itg,ipg,3) = ssouvar(itg,ipg,3)
      ssouten(itg,ipg,4) = ssouvar(itg,ipg,4)
      ssouten(itg,ipg,5) = ssouvar(itg,ipg,5)
      ssouten(itg,ipg,6) = ssouvar(itg,ipg,6)
ctesttest      dssouten(itg,ipg,1) = -hxxd(irg,itg,ipg)/rg(irg)
      dssouten(itg,ipg,1) = 0.0d0
      dssouten(itg,ipg,2) = 0.0d0
      dssouten(itg,ipg,3) = 0.0d0
ctesttest      dssouten(itg,ipg,4) = -hyyd(irg,itg,ipg)/rg(irg)
      dssouten(itg,ipg,4) = 0.0d0
      dssouten(itg,ipg,5) = 0.0d0
      dssouten(itg,ipg,6) = 0.0d0
      end if
c
c --  For the funcitons.
c
      if (chope.eq.'H') then
      ssouten(itg,ipg,1) = ssouvar(itg,ipg,1)
      ssouten(itg,ipg,2) = ssouvar(itg,ipg,2)
      ssouten(itg,ipg,3) = ssouvar(itg,ipg,3)
      ssouten(itg,ipg,4) = ssouvar(itg,ipg,4)
      ssouten(itg,ipg,5) = ssouvar(itg,ipg,5)
      ssouten(itg,ipg,6) = ssouvar(itg,ipg,6)
cfix      ssouten(itg,ipg,1) = ssoufix(itg,ipg,1)
cfix      ssouten(itg,ipg,2) = ssoufix(itg,ipg,2)
cfix      ssouten(itg,ipg,3) = ssoufix(itg,ipg,3)
cfix      ssouten(itg,ipg,4) = ssoufix(itg,ipg,4)
cfix      ssouten(itg,ipg,5) = ssoufix(itg,ipg,5)
cfix      ssouten(itg,ipg,6) = ssoufix(itg,ipg,6)
ccc      ssouten(itg,ipg,1) = 0.0d0
ccc      ssouten(itg,ipg,2) = 0.0d0
ccc      ssouten(itg,ipg,3) = 0.0d0
ccc      ssouten(itg,ipg,4) = 0.0d0
ccc      ssouten(itg,ipg,5) = 0.0d0
ccc      ssouten(itg,ipg,6) = 0.0d0
crob2      ssouten(itg,ipg,1) = - rg(irg)*dssouten(itg,ipg,1)
crob2      ssouten(itg,ipg,2) = - rg(irg)*dssouten(itg,ipg,2)
crob2      ssouten(itg,ipg,3) = - rg(irg)*dssouten(itg,ipg,3)
crob2      ssouten(itg,ipg,4) = - rg(irg)*dssouten(itg,ipg,4)
crob2      ssouten(itg,ipg,5) = - rg(irg)*dssouten(itg,ipg,5)
crob2      ssouten(itg,ipg,6) = - rg(irg)*dssouten(itg,ipg,6)
c
c --  For the derivatives.
c
cdir      dssouten(itg,ipg,1) = dssouvar(itg,ipg,1)
cdir      dssouten(itg,ipg,2) = dssouvar(itg,ipg,2)
cdir      dssouten(itg,ipg,3) = dssouvar(itg,ipg,3)
cdir      dssouten(itg,ipg,4) = dssouvar(itg,ipg,4)
cdir      dssouten(itg,ipg,5) = dssouvar(itg,ipg,5)
cdir      dssouten(itg,ipg,6) = dssouvar(itg,ipg,6)
cfix      dssouten(itg,ipg,1) = dssoufix(itg,ipg,1)
cfix      dssouten(itg,ipg,2) = dssoufix(itg,ipg,2)
cfix      dssouten(itg,ipg,3) = dssoufix(itg,ipg,3)
cfix      dssouten(itg,ipg,4) = dssoufix(itg,ipg,4)
cfix      dssouten(itg,ipg,5) = dssoufix(itg,ipg,5)
cfix      dssouten(itg,ipg,6) = dssoufix(itg,ipg,6)
      dssouten(itg,ipg,1) = 0.0d0
      dssouten(itg,ipg,2) = 0.0d0
      dssouten(itg,ipg,3) = 0.0d0
      dssouten(itg,ipg,4) = 0.0d0
      dssouten(itg,ipg,5) = 0.0d0
      dssouten(itg,ipg,6) = 0.0d0
crob      dssouten(itg,ipg,1) = -hxxd(irg,itg,ipg)/rg(irg)
crob      dssouten(itg,ipg,2) = -hxyd(irg,itg,ipg)/rg(irg)
crob      dssouten(itg,ipg,3) = -hxzd(irg,itg,ipg)/rg(irg)
crob      dssouten(itg,ipg,4) = -hyyd(irg,itg,ipg)/rg(irg)
crob      dssouten(itg,ipg,5) = -hyzd(irg,itg,ipg)/rg(irg)
crob      dssouten(itg,ipg,6) = -hzzd(irg,itg,ipg)/rg(irg)
c
      end if
c
 100  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine ap2alps
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / metpo /  psi(0:nnrg,0:nntg,0:nnpg),
     &                 alph(0:nnrg,0:nntg,0:nnpg),
     &                 alps(0:nnrg,0:nntg,0:nnpg),
     &                alps2(0:nnrg,0:nntg,0:nnpg)
c
c --- Prepareing alps and alps2 from alpha and psi.  
c
      do 40 ipg = 0, npg
      do 40 itg = 0, ntg
      do 40 irg = 0, nrtot
      alps(irg,itg,ipg) = alph(irg,itg,ipg)*psi(irg,itg,ipg)
      alps2(irg,itg,ipg) = alph(irg,itg,ipg)*psi(irg,itg,ipg)**2
   40 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine alps2ap
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / metpo /  psi(0:nnrg,0:nntg,0:nnpg),
     &                 alph(0:nnrg,0:nntg,0:nnpg),
     &                 alps(0:nnrg,0:nntg,0:nnpg),
     &                alps2(0:nnrg,0:nntg,0:nnpg)
c
c --- Recovering alpha and psi from alps and alps2.  
c
      do 40 ipg = 0, npg
      do 40 itg = 0, ntg
      do 40 irg = 0, nrtot
      psi(irg,itg,ipg) = alps2(irg,itg,ipg)/alps(irg,itg,ipg)
      alph(irg,itg,ipg) = alps(irg,itg,ipg)**2/alps2(irg,itg,ipg)
   40 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine bvu2d
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / metbu / bvxu(0:nnrg,0:nntg,0:nnpg), 
     &                 bvyu(0:nnrg,0:nntg,0:nnpg), 
     &                 bvzu(0:nnrg,0:nntg,0:nnpg)
      common / metbd / bvxd(0:nnrg,0:nntg,0:nnpg), 
     &                 bvyd(0:nnrg,0:nntg,0:nnpg), 
     &                 bvzd(0:nnrg,0:nntg,0:nnpg)
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
c
c --- Lowering index of shift.  
c
      do 40 ipg = 0, npg
      do 40 itg = 0, ntg
      do 40 irg = 0, nrtot
      gmxxd = 1.0d0 + hxxd(irg,itg,ipg)
      gmxyd =         hxyd(irg,itg,ipg)
      gmxzd =         hxzd(irg,itg,ipg)
      bvxd(irg,itg,ipg) = gmxxd*bvxu(irg,itg,ipg)
     &                  + gmxyd*bvyu(irg,itg,ipg)
     &                  + gmxzd*bvzu(irg,itg,ipg)
   40 continue
c
      do 41 ipg = 0, npg
      do 41 itg = 0, ntg
      do 41 irg = 0, nrtot
      gmyxd =         hxyd(irg,itg,ipg)
      gmyyd = 1.0d0 + hyyd(irg,itg,ipg)
      gmyzd =         hyzd(irg,itg,ipg)
      bvyd(irg,itg,ipg) = gmyxd*bvxu(irg,itg,ipg)
     &                  + gmyyd*bvyu(irg,itg,ipg)
     &                  + gmyzd*bvzu(irg,itg,ipg)
   41 continue
c
      do 42 ipg = 0, npg
      do 42 itg = 0, ntg
      do 42 irg = 0, nrtot
      gmzxd =         hxzd(irg,itg,ipg)
      gmzyd =         hyzd(irg,itg,ipg)
      gmzzd = 1.0d0 + hzzd(irg,itg,ipg)
      bvzd(irg,itg,ipg) = gmzxd*bvxu(irg,itg,ipg)
     &                  + gmzyd*bvyu(irg,itg,ipg)
     &                  + gmzzd*bvzu(irg,itg,ipg)
   42 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine bvd2u
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / metbu / bvxu(0:nnrg,0:nntg,0:nnpg), 
     &                 bvyu(0:nnrg,0:nntg,0:nnpg), 
     &                 bvzu(0:nnrg,0:nntg,0:nnpg)
      common / metbd / bvxd(0:nnrg,0:nntg,0:nnpg), 
     &                 bvyd(0:nnrg,0:nntg,0:nnpg), 
     &                 bvzd(0:nnrg,0:nntg,0:nnpg)
      common / met3u / hxxu(0:nnrg,0:nntg,0:nnpg),
     &                 hxyu(0:nnrg,0:nntg,0:nnpg),
     &                 hxzu(0:nnrg,0:nntg,0:nnpg),
     &                 hyyu(0:nnrg,0:nntg,0:nnpg),
     &                 hyzu(0:nnrg,0:nntg,0:nnpg),
     &                 hzzu(0:nnrg,0:nntg,0:nnpg)
c
c --- Lowering index of shift.  
c
      do 40 ipg = 0, npg
      do 40 itg = 0, ntg
      do 40 irg = 0, nrtot
      gmxxu = 1.0d0 + hxxu(irg,itg,ipg)
      gmxyu =         hxyu(irg,itg,ipg)
      gmxzu =         hxzu(irg,itg,ipg)
      bvxu(irg,itg,ipg) = gmxxu*bvxd(irg,itg,ipg)
     &                  + gmxyu*bvyd(irg,itg,ipg)
     &                  + gmxzu*bvzd(irg,itg,ipg)
   40 continue
c
      do 41 ipg = 0, npg
      do 41 itg = 0, ntg
      do 41 irg = 0, nrtot
      gmyxu =         hxyu(irg,itg,ipg)
      gmyyu = 1.0d0 + hyyu(irg,itg,ipg)
      gmyzu =         hyzu(irg,itg,ipg)
      bvyu(irg,itg,ipg) = gmyxu*bvxd(irg,itg,ipg)
     &                  + gmyyu*bvyd(irg,itg,ipg)
     &                  + gmyzu*bvzd(irg,itg,ipg)
   41 continue
c
      do 42 ipg = 0, npg
      do 42 itg = 0, ntg
      do 42 irg = 0, nrtot
      gmzxu =         hxzu(irg,itg,ipg)
      gmzyu =         hyzu(irg,itg,ipg)
      gmzzu = 1.0d0 + hzzu(irg,itg,ipg)
      bvzu(irg,itg,ipg) = gmzxu*bvxd(irg,itg,ipg)
     &                  + gmzyu*bvyd(irg,itg,ipg)
     &                  + gmzzu*bvzd(irg,itg,ipg)
   42 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine bv2ov
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
      common / calcp /  ome, ber, radi, dis
c
c --- shift to rotating shift.  
c
      do 39 ipg = 0, npg
      do 39 itg = 0, ntg
      do 39 irg = 0, nrtot
      vphixg = - rg(irg)*sintheg(itg)*sinphig(ipg)
      vphiyg =   rg(irg)*sintheg(itg)*cosphig(ipg)
      vphizg = 0.0d0
      bvxgc = bvxu(irg,itg,ipg)
      bvygc = bvyu(irg,itg,ipg)
      bvzgc = bvzu(irg,itg,ipg)
      ovxu(irg,itg,ipg) = bvxgc + ome*vphixg
      ovyu(irg,itg,ipg) = bvygc + ome*vphiyg
      ovzu(irg,itg,ipg) = bvzgc + ome*vphizg
   39 continue
c
c --- Lowering index of rotating shift.  
c
      do 40 ipg = 0, npg
      do 40 itg = 0, ntg
      do 40 irg = 0, nrtot
      gmxxd = 1.0d0 + hxxd(irg,itg,ipg)
      gmxyd =         hxyd(irg,itg,ipg)
      gmxzd =         hxzd(irg,itg,ipg)
      ovxd(irg,itg,ipg) = gmxxd*ovxu(irg,itg,ipg)
     &                  + gmxyd*ovyu(irg,itg,ipg)
     &                  + gmxzd*ovzu(irg,itg,ipg)
   40 continue
c
      do 41 ipg = 0, npg
      do 41 itg = 0, ntg
      do 41 irg = 0, nrtot
      gmyxd =         hxyd(irg,itg,ipg)
      gmyyd = 1.0d0 + hyyd(irg,itg,ipg)
      gmyzd =         hyzd(irg,itg,ipg)
      ovyd(irg,itg,ipg) = gmyxd*ovxu(irg,itg,ipg)
     &                  + gmyyd*ovyu(irg,itg,ipg)
     &                  + gmyzd*ovzu(irg,itg,ipg)
   41 continue
c
      do 42 ipg = 0, npg
      do 42 itg = 0, ntg
      do 42 irg = 0, nrtot
      gmzxd =         hxzd(irg,itg,ipg)
      gmzyd =         hyzd(irg,itg,ipg)
      gmzzd = 1.0d0 + hzzd(irg,itg,ipg)
      ovzd(irg,itg,ipg) = gmzxd*ovxu(irg,itg,ipg)
     &                  + gmzyd*ovyu(irg,itg,ipg)
     &                  + gmzzd*ovzu(irg,itg,ipg)
   42 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine invhij
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
      common / met3u / hxxu(0:nnrg,0:nntg,0:nnpg),
     &                 hxyu(0:nnrg,0:nntg,0:nnpg),
     &                 hxzu(0:nnrg,0:nntg,0:nnpg),
     &                 hyyu(0:nnrg,0:nntg,0:nnpg),
     &                 hyzu(0:nnrg,0:nntg,0:nnpg),
     &                 hzzu(0:nnrg,0:nntg,0:nnpg)
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
      do 100 irg = 0, nrtot
c
      hxx = hxxd(irg,itg,ipg)
      hxy = hxyd(irg,itg,ipg)
      hxz = hxzd(irg,itg,ipg)
      hyx = hxy
      hyy = hyyd(irg,itg,ipg)
      hyz = hyzd(irg,itg,ipg)
      hzx = hxz
      hzy = hyz
      hzz = hzzd(irg,itg,ipg)
c
      hod1 = hxx + hyy + hzz
      hod2 = hxx*hyy + hxx*hzz + hyy*hzz
     &     - hxy*hyx - hxz*hzx - hyz*hzy
      hod3 = hxx*hyy*hzz + hxy*hyz*hzx + hxz*hyx*hzy
     &     - hxx*hyz*hzy - hxy*hyx*hzz - hxz*hyy*hzx
      detgm  = 1.0d0 + hod1 + hod2 + hod3
      detgmi = 1.0d0/detgm
c
      hod1  = + hyy + hzz
      hod2  = + hyy*hzz - hyz*hzy
      gmxxu = (1.0d0 + hod1 + hod2)*detgmi
      hod1  = - hxy
      hod2  = + hxz*hzy - hxy*hzz
      gmxyu = (hod1 + hod2)*detgmi
      hod1  = - hxz
      hod2  = + hxy*hyz - hxz*hyy
      gmxzu = (hod1 + hod2)*detgmi
      hod1  = + hxx + hzz
      hod2  = + hxx*hzz - hxz*hzx
      gmyyu = (1.0d0 + hod1 + hod2)*detgmi
      hod1  = - hyz
      hod2  = + hxz*hyx - hxx*hyz
      gmyzu = (hod1 + hod2)*detgmi
      hod1  = + hxx + hyy
      hod2  = + hxx*hyy - hxy*hyx
      gmzzu = (1.0d0 + hod1 + hod2)*detgmi
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      hxxu(irg,itg,ipg) = gmxxu - 1.0d0
      hxyu(irg,itg,ipg) = gmxyu
      hxzu(irg,itg,ipg) = gmxzu
      hyyu(irg,itg,ipg) = gmyyu - 1.0d0
      hyzu(irg,itg,ipg) = gmyzu
      hzzu(irg,itg,ipg) = gmzzu - 1.0d0
c
  100 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine symmetry
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
c
c --  For xy-plane.
      itg = ntg
      do 100 ipg = 0, npg
      do 100 irg = 0, nrtot
      ovzu(irg,itg,ipg) = 0.0d0
      ovzd(irg,itg,ipg) = 0.0d0
      bvzu(irg,itg,ipg) = 0.0d0
      bvzd(irg,itg,ipg) = 0.0d0
      hxzd(irg,itg,ipg) = 0.0d0
      hxzu(irg,itg,ipg) = 0.0d0
      hyzd(irg,itg,ipg) = 0.0d0
      hyzu(irg,itg,ipg) = 0.0d0
  100 continue
c
c --  For xz-plane.
c
      ipg = npgxz
      do 101 itg = 0, ntg
      do 101 irg = 0, nrtot
      ovxu(irg,itg,ipg) = 0.0d0
      ovxd(irg,itg,ipg) = 0.0d0
      ovzu(irg,itg,ipg) = 0.0d0
      ovzd(irg,itg,ipg) = 0.0d0
      bvxu(irg,itg,ipg) = 0.0d0
      bvxd(irg,itg,ipg) = 0.0d0
      bvzu(irg,itg,ipg) = 0.0d0
      bvzd(irg,itg,ipg) = 0.0d0
      hxyd(irg,itg,ipg) = 0.0d0
      hxyu(irg,itg,ipg) = 0.0d0
      hyzd(irg,itg,ipg) = 0.0d0
      hyzu(irg,itg,ipg) = 0.0d0
  101 continue
c
c --  For yz-plane.
c
      ipg = npgyz
      do 102 itg = 0, ntg
      do 102 irg = 0, nrtot
      ovyu(irg,itg,ipg) = 0.0d0
      ovyd(irg,itg,ipg) = 0.0d0
      ovzu(irg,itg,ipg) = 0.0d0
      ovzd(irg,itg,ipg) = 0.0d0
      bvyu(irg,itg,ipg) = 0.0d0
      bvyd(irg,itg,ipg) = 0.0d0
      bvzu(irg,itg,ipg) = 0.0d0
      bvzd(irg,itg,ipg) = 0.0d0
      hxyd(irg,itg,ipg) = 0.0d0
      hxyu(irg,itg,ipg) = 0.0d0
      hxzd(irg,itg,ipg) = 0.0d0
      hxzu(irg,itg,ipg) = 0.0d0
  102 continue
c
c --  For z-axis.
c
      itg = 0
      do 103 ipg = 0, npg
      do 103 irg = 0, nrtot
      ovxu(irg,itg,ipg) = 0.0d0
      ovxd(irg,itg,ipg) = 0.0d0
      ovyu(irg,itg,ipg) = 0.0d0
      ovyd(irg,itg,ipg) = 0.0d0
      ovzu(irg,itg,ipg) = 0.0d0
      ovzd(irg,itg,ipg) = 0.0d0
      bvxu(irg,itg,ipg) = 0.0d0
      bvxd(irg,itg,ipg) = 0.0d0
      bvyu(irg,itg,ipg) = 0.0d0
      bvyd(irg,itg,ipg) = 0.0d0
      bvzu(irg,itg,ipg) = 0.0d0
      bvzd(irg,itg,ipg) = 0.0d0
      hxyd(irg,itg,ipg) = 0.0d0
      hxyu(irg,itg,ipg) = 0.0d0
      hxzd(irg,itg,ipg) = 0.0d0
      hxzu(irg,itg,ipg) = 0.0d0
      hyzd(irg,itg,ipg) = 0.0d0
      hyzu(irg,itg,ipg) = 0.0d0
  103 continue
c
c --  For the origin.
c
      irg = 0
      do 104 ipg = 0, npg
      do 104 itg = 0, ntg
      ovxu(irg,itg,ipg) = 0.0d0
      ovxd(irg,itg,ipg) = 0.0d0
      ovyu(irg,itg,ipg) = 0.0d0
      ovyd(irg,itg,ipg) = 0.0d0
      ovzu(irg,itg,ipg) = 0.0d0
      ovzd(irg,itg,ipg) = 0.0d0
      bvxu(irg,itg,ipg) = 0.0d0
      bvxd(irg,itg,ipg) = 0.0d0
      bvyu(irg,itg,ipg) = 0.0d0
      bvyd(irg,itg,ipg) = 0.0d0
      bvzu(irg,itg,ipg) = 0.0d0
      bvzd(irg,itg,ipg) = 0.0d0
      hxyd(irg,itg,ipg) = 0.0d0
      hxyu(irg,itg,ipg) = 0.0d0
      hxzd(irg,itg,ipg) = 0.0d0
      hxzu(irg,itg,ipg) = 0.0d0
      hyzd(irg,itg,ipg) = 0.0d0
      hyzu(irg,itg,ipg) = 0.0d0
  104 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine cleargeometry
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
c
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
      do 100 irg = 0, nrtot
      hxxd(irg,itg,ipg) = 0.0d0
      hxyd(irg,itg,ipg) = 0.0d0
      hxzd(irg,itg,ipg) = 0.0d0
      hyyd(irg,itg,ipg) = 0.0d0
      hyzd(irg,itg,ipg) = 0.0d0
      hzzd(irg,itg,ipg) = 0.0d0
      hxxu(irg,itg,ipg) = 0.0d0
      hxyu(irg,itg,ipg) = 0.0d0
      hxzu(irg,itg,ipg) = 0.0d0
      hyyu(irg,itg,ipg) = 0.0d0
      hyzu(irg,itg,ipg) = 0.0d0
      hzzu(irg,itg,ipg) = 0.0d0
      cri(irg,itg,ipg,1,1) = 0.0d0
      cri(irg,itg,ipg,2,1) = 0.0d0
      cri(irg,itg,ipg,3,1) = 0.0d0
      cri(irg,itg,ipg,1,2) = 0.0d0
      cri(irg,itg,ipg,2,2) = 0.0d0
      cri(irg,itg,ipg,3,2) = 0.0d0
      cri(irg,itg,ipg,1,3) = 0.0d0
      cri(irg,itg,ipg,2,3) = 0.0d0
      cri(irg,itg,ipg,3,3) = 0.0d0
      cri(irg,itg,ipg,1,4) = 0.0d0
      cri(irg,itg,ipg,2,4) = 0.0d0
      cri(irg,itg,ipg,3,4) = 0.0d0
      cri(irg,itg,ipg,1,5) = 0.0d0
      cri(irg,itg,ipg,2,5) = 0.0d0
      cri(irg,itg,ipg,3,5) = 0.0d0
      cri(irg,itg,ipg,1,6) = 0.0d0
      cri(irg,itg,ipg,2,6) = 0.0d0
      cri(irg,itg,ipg,3,6) = 0.0d0
      gmcrix(irg,itg,ipg) = 0.0d0
      gmcriy(irg,itg,ipg) = 0.0d0
      gmcriz(irg,itg,ipg) = 0.0d0
      rab(irg,itg,ipg,1) = 0.0d0
      rab(irg,itg,ipg,2) = 0.0d0
      rab(irg,itg,ipg,3) = 0.0d0
      rab(irg,itg,ipg,4) = 0.0d0
      rab(irg,itg,ipg,5) = 0.0d0
      rab(irg,itg,ipg,6) = 0.0d0
      rabnl(irg,itg,ipg,1) = 0.0d0
      rabnl(irg,itg,ipg,2) = 0.0d0
      rabnl(irg,itg,ipg,3) = 0.0d0
      rabnl(irg,itg,ipg,4) = 0.0d0
      rabnl(irg,itg,ipg,5) = 0.0d0
      rabnl(irg,itg,ipg,6) = 0.0d0
  100 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine hijdet1(iter)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
c
      ii = mod(iter,3)
ctesttest
      ii = 2
ctesttest
c
      do 445 ipg = 0, npg
      do 445 itg = 0, ntg
      do 445 irg = 0, nrtot
c
      hxx = hxxd(irg,itg,ipg)
      hxy = hxyd(irg,itg,ipg)
      hxz = hxzd(irg,itg,ipg)
      hyx = hxy
      hyy = hyyd(irg,itg,ipg)
      hyz = hyzd(irg,itg,ipg)
      hzx = hxz
      hzy = hyz
      hzz = hzzd(irg,itg,ipg)
c
      if (ii.eq.0) then
      ho1 = hyy + hzz
      ho2 = - hyz*hzy + hyy*hzz - hyx*hxy - hzx*hxz
      ho3 = - hyx*hzz*hxy + hyz*hzx*hxy + hyx*hzy*hxz - hyy*hzx*hxz
      ho2d = - hyz*hzy + hyy*hzz
      hxxd(irg,itg,ipg) = -(ho1 + ho2 + ho3)/(1.0d0 + ho1 + ho2d)
      end if
      if (ii.eq.1) then
      ho1 = hzz + hxx
      ho2 = - hzx*hxz + hzz*hxx - hzy*hyz - hxy*hyx
      ho3 = - hzy*hxx*hyz + hzx*hxy*hyz + hzy*hxz*hyx - hzz*hxy*hyx
      ho2d = - hzx*hxz + hzz*hxx
      hyyd(irg,itg,ipg) = -(ho1 + ho2 + ho3)/(1.0d0 + ho1 + ho2d)
      end if
      if (ii.eq.2) then
      ho1 = hxx + hyy
      ho2 = - hxy*hyx + hxx*hyy - hxz*hzx - hyz*hzy
      ho3 = - hxz*hyy*hzx + hxy*hyz*hzx + hxz*hyx*hzy - hxx*hyz*hzy
      ho2d = - hxy*hyx + hxx*hyy
      hzzd(irg,itg,ipg) = -(ho1 + ho2 + ho3)/(1.0d0 + ho1 + ho2d)
      end if
c
 445  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine adjusthij(iter)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / metpo /  psi(0:nnrg,0:nntg,0:nnpg),
     &                 alph(0:nnrg,0:nntg,0:nnpg),
     &                 alps(0:nnrg,0:nntg,0:nnpg),
     &                alps2(0:nnrg,0:nntg,0:nnpg)
      common / met3u / hxxu(0:nnrg,0:nntg,0:nnpg),
     &                 hxyu(0:nnrg,0:nntg,0:nnpg),
     &                 hxzu(0:nnrg,0:nntg,0:nnpg),
     &                 hyyu(0:nnrg,0:nntg,0:nnpg),
     &                 hyzu(0:nnrg,0:nntg,0:nnpg),
     &                 hzzu(0:nnrg,0:nntg,0:nnpg)
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
c
      twelve = 1.0d0/12.0d0
      do 445 ipg = 0, npg
      do 445 itg = 0, ntg
      do 445 irg = 0, nrtot
c
      hxx = hxxd(irg,itg,ipg)
      hxy = hxyd(irg,itg,ipg)
      hxz = hxzd(irg,itg,ipg)
      hyx = hxy
      hyy = hyyd(irg,itg,ipg)
      hyz = hyzd(irg,itg,ipg)
      hzx = hxz
      hzy = hyz
      hzz = hzzd(irg,itg,ipg)
c
      gmxx = 1.0d0 + hxx
      gmxy = hxy
      gmxz = hxz
      gmyx = hxy
      gmyy = 1.0d0 + hyy
      gmyz = hyz
      gmzx = hxz
      gmzy = hyz
      gmzz = 1.0d0 + hzz
c
      hod1 = hxx + hyy + hzz
      hod2 = hxx*hyy + hxx*hzz + hyy*hzz
     &     - hxy*hyx - hxz*hzx - hyz*hzy
      hod3 = hxx*hyy*hzz + hxy*hyz*hzx + hxz*hyx*hzy
     &     - hxx*hyz*hzy - hxy*hyx*hzz - hxz*hyy*hzx
      detgm  = 1.0d0 + hod1 + hod2 + hod3
c
      psiold = psi(irg,itg,ipg)
      psinew = psiold*detgm**twelve
      psi4 = (psiold/psinew)**4
c      
      psi(irg,itg,ipg) = psinew
      hxxd(irg,itg,ipg) = gmxx*psi4 - 1.0d0
      hxyd(irg,itg,ipg) = gmxy*psi4
      hxzd(irg,itg,ipg) = gmxz*psi4
      hyyd(irg,itg,ipg) = gmyy*psi4 - 1.0d0
      hyzd(irg,itg,ipg) = gmyz*psi4
      hzzd(irg,itg,ipg) = gmzz*psi4 - 1.0d0
c
 445  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine gauge(iter)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / trmpg / sinmpg(0:nnlg,0:nnpg), cosmpg(0:nnlg,0:nnpg),
     &                simpsig(0:nnlg,0:nnpg)
      common / grleg / pnag(0:nnlg,0:nnlg,0:nntg),
     &               facnmg(0:nnlg,0:nnlg), epsig(0:nnlg)
c
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
      common / met3u / hxxu(0:nnrg,0:nntg,0:nnpg),
     &                 hxyu(0:nnrg,0:nntg,0:nnpg),
     &                 hxzu(0:nnrg,0:nntg,0:nnpg),
     &                 hyyu(0:nnrg,0:nntg,0:nnpg),
     &                 hyzu(0:nnrg,0:nntg,0:nnpg),
     &                 hzzu(0:nnrg,0:nntg,0:nnpg)
      dimension gx(0:nnrg,0:nntg,0:nnpg),
     &          gy(0:nnrg,0:nntg,0:nnpg),
     &          gz(0:nnrg,0:nntg,0:nnpg)
      dimension  divg(0:nnrg,0:nntg,0:nnpg),
     &          sougx(0:nnrg,0:nntg,0:nnpg),
     &          sougy(0:nnrg,0:nntg,0:nnpg),
     &          sougz(0:nnrg,0:nntg,0:nnpg),
     &            bfn(0:nnrg,0:nntg,0:nnpg),
     &           grad(0:nnrg,0:nntg,0:nnpg,1:3)
c
c --- Impose extended Dirac gauge condition.
c
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
      do 100 irg = 0, nrtot
c
      call grgrad(hxxd,dhxxdx,dhxxdy,dhxxdz,irg,itg,ipg,1,1,1)
      call grgrad(hxyd,dhxydx,dhxydy,dhxydz,irg,itg,ipg,1,-1,-1)
      call grgrad(hxzd,dhxzdx,dhxzdy,dhxzdz,irg,itg,ipg,-1,-1,1)
      call grgrad(hyyd,dhyydx,dhyydy,dhyydz,irg,itg,ipg,1,1,1)
      call grgrad(hyzd,dhyzdx,dhyzdy,dhyzdz,irg,itg,ipg,-1,1,-1)
      call grgrad(hzzd,dhzzdx,dhzzdy,dhzzdz,irg,itg,ipg,1,1,1)
      hxidiv = dhxxdx + dhxydy + dhxzdz
      hyidiv = dhxydx + dhyydy + dhyzdz
      hzidiv = dhxzdx + dhyzdy + dhzzdz
c
c --  higher order
c --  NOT USED
      hxxuc = hxxu(irg,itg,ipg)
      hxyuc = hxyu(irg,itg,ipg)
      hxzuc = hxzu(irg,itg,ipg)
      hyxuc = hxyu(irg,itg,ipg)
      hyyuc = hyyu(irg,itg,ipg)
      hyzuc = hyzu(irg,itg,ipg)
      hzxuc = hxzu(irg,itg,ipg)
      hzyuc = hyzu(irg,itg,ipg)
      hzzuc = hzzu(irg,itg,ipg)
      hdhx = hxxuc*dhxxdx + hxyuc*dhxxdy + hxzuc*dhxxdz
     &     + hyxuc*dhxydx + hyyuc*dhxydy + hyzuc*dhxydz
     &     + hzxuc*dhxzdx + hzyuc*dhxzdy + hzzuc*dhxzdz
      hdhy = hxxuc*dhyxdx + hxyuc*dhyxdy + hxzuc*dhyxdz
     &     + hyxuc*dhyydx + hyyuc*dhyydy + hyzuc*dhyydz
     &     + hzxuc*dhyzdx + hzyuc*dhyzdy + hzzuc*dhyzdz
      hdhz = hxxuc*dhzxdx + hxyuc*dhzxdy + hxzuc*dhzxdz
     &     + hyxuc*dhzydx + hyyuc*dhzydy + hyzuc*dhzydz
     &     + hzxuc*dhzzdx + hzyuc*dhzzdy + hzzuc*dhzzdz
c --
ck      if (iter.ge.10) then
ck      sougx(irg,itg,ipg) = hxidiv + hdhx
ck      sougy(irg,itg,ipg) = hyidiv + hdhy
ck      sougz(irg,itg,ipg) = hzidiv + hdhz
ck      else 
c -- original
      sougx(irg,itg,ipg) = hxidiv
      sougy(irg,itg,ipg) = hyidiv
      sougz(irg,itg,ipg) = hzidiv
ck      end if
c
 100  continue
c
ccc      call halfsou2(sougx,1)
ccc      call halfsou2(sougy,1)
ccc      call halfsou2(sougz,1)
      call halfsousym(sougx,1,-1,1)
      call halfsousym(sougy,1,1,-1)
      call halfsousym(sougz,-1,1,1)
c
      call grav4(sougx,gx,cosmpg,cosmpg,pnag,0,1,1,4)
      call grav4(sougy,gy,sinmpg,sinmpg,pnag,0,1,1,4)
      call grav4(sougz,gz,cosmpg,cosmpg,pnag,1,0,0,4)
c
      do 10 ipg = 0, npg
      do 10 itg = 0, ntg
      do 10 irg = 0, nrtot
      call grgrad(gx,dgxdx,dgxdy,dgxdz,irg,itg,ipg,1,-1,1)
      call grgrad(gy,dgydx,dgydy,dgydz,irg,itg,ipg,1,1,-1)
      call grgrad(gz,dgzdx,dgzdy,dgzdz,irg,itg,ipg,-1,1,1)
      divg(irg,itg,ipg) = dgxdx + dgydy + dgzdz
cshi      xxx = rg(irg)*sintheg(itg)*cosphig(ipg)
cshi      yyy = rg(irg)*sintheg(itg)*sinphig(ipg)
cshi      zzz = rg(irg)*costheg(itg)
cshi      divg(irg,itg,ipg) = xxx*gx(irg,itg,ipg)
cshi     &                  + yyy*gy(irg,itg,ipg)
cshi     &                  + zzz*gz(irg,itg,ipg)
   10 continue
c
ccc      call halfsou(divg)
      call halfsousym(divg,1,1,1)
      call grav4(divg,bfn,cosmpg,cosmpg,pnag,0,0,0,4)
c
cshi      do 50 ipg = 0, npg
cshi      do 50 itg = 0, ntg
cshi      do 50 irg = 0, nrtot
cshi      xxx = rg(irg)*sintheg(itg)*cosphig(ipg)
cshi      yyy = rg(irg)*sintheg(itg)*sinphig(ipg)
cshi      zzz = rg(irg)*costheg(itg)
cshi      bfn(irg,itg,ipg) = bfn(irg,itg,ipg) 
cshi     &                 - (xxx*gx(irg,itg,ipg)
cshi     &                  + yyy*gy(irg,itg,ipg)
cshi     &                  + zzz*gz(irg,itg,ipg))
cshi   50 continue
c
      call grgrad4(bfn,grad,1,1,1)
c
      do 110 ipg = 0, npg
      do 110 itg = 0, ntg
      do 110 irg = 0, nrtot
      gx(irg,itg,ipg) = gx(irg,itg,ipg) -0.25d0*grad(irg,itg,ipg,1)
      gy(irg,itg,ipg) = gy(irg,itg,ipg) -0.25d0*grad(irg,itg,ipg,2)
      gz(irg,itg,ipg) = gz(irg,itg,ipg) -0.25d0*grad(irg,itg,ipg,3)
cshi      gx(irg,itg,ipg) = gx(irg,itg,ipg) + 0.125d0*grad(irg,itg,ipg,1)
cshi      gy(irg,itg,ipg) = gy(irg,itg,ipg) + 0.125d0*grad(irg,itg,ipg,2)
cshi      gz(irg,itg,ipg) = gz(irg,itg,ipg) + 0.125d0*grad(irg,itg,ipg,3)
 110  continue
c
      fac23 = 2.0d0/3.0d0
      do 200 ipg = 0, npg
      do 200 itg = 0, ntg
      do 200 irg = 0, nrtot
c
      call grgrad(gx,dgxdx,dgxdy,dgxdz,irg,itg,ipg,1,-1,1)
      call grgrad(gy,dgydx,dgydy,dgydz,irg,itg,ipg,1,1,-1)
      call grgrad(gz,dgzdx,dgzdy,dgzdz,irg,itg,ipg,-1,1,1)
c
      divgg  = dgxdx + dgydy + dgzdz
      dlgxdx = dgxdx + dgxdx - fac23*divgg
      dlgxdy = dgxdy + dgydx
      dlgxdz = dgxdz + dgzdx
      dlgydy = dgydy + dgydy - fac23*divgg
      dlgydz = dgydz + dgzdy
      dlgzdz = dgzdz + dgzdz - fac23*divgg
c
      hxxd(irg,itg,ipg) = hxxd(irg,itg,ipg) - dlgxdx
      hxyd(irg,itg,ipg) = hxyd(irg,itg,ipg) - dlgxdy
      hxzd(irg,itg,ipg) = hxzd(irg,itg,ipg) - dlgxdz
      hyyd(irg,itg,ipg) = hyyd(irg,itg,ipg) - dlgydy
      hyzd(irg,itg,ipg) = hyzd(irg,itg,ipg) - dlgydz
      hzzd(irg,itg,ipg) = hzzd(irg,itg,ipg) - dlgzdz
c
 200  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine adjustasymptopia(isaj)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / metpo /  psi(0:nnrg,0:nntg,0:nnpg),
     &                 alph(0:nnrg,0:nntg,0:nnpg),
     &                 alps(0:nnrg,0:nntg,0:nnpg),
     &                alps2(0:nnrg,0:nntg,0:nnpg)
      common / fitms / fitadm, fitkom
      common / calcp / ome, ber, radi, dis
c
      dimension psidat(0:nnrg), alphdat(0:nnrg)
c
c --  Fit psi    = 1 + MADM/2r, and alpha   = 1 - MK/r
c         psidat = 0.5/(psi - 1),   alphdat = 1/(1 - alpha)
c
c     isaj = 0 -> adjust psi and alpha in the asymptotics.
c     isaj = 1 -> no adjust
c
      pi = 3.14159265358979d+0
c
      ave = dble(ntg+1)*dble(npg+1)
      irg10 = nrtot
      do 4 irg = nrtot, 0, -1
      if (rg(irg).ge.10.0d0*pi/ome) irg10 = irg
    4 continue
      irgini = min0(nrtot-15,irg10)
      nrgend = nrtot - 5
      npoi = nrgend - irgini + 1
c
      do 10 irg = irgini, nrgend
      psiv  = 0.0d0
      alphv = 0.0d0
      do 20 itg = 0, ntg
      do 20 ipg = 0, npg
      psiv  = psiv  + psi(irg,itg,ipg)
      alphv = alphv + alph(irg,itg,ipg)
   20 continue
      psidat(irg)  = 0.5d0/(psiv/ave - 1.0d0)
      alphdat(irg) = 1.0d0/(1.0d0 - alphv/ave)
   10 continue
c
      s1 = 0.0d0
      sp2 = 0.0d0
      sa2 = 0.0d0
      do 30 irg = irgini, nrgend
      s1  = s1  + rg(irg)**2
      sp2 = sp2 + psidat(irg)*rg(irg)
      sa2 = sa2 + alphdat(irg)*rg(irg)
   30 continue
c
      coadm = s1/sp2
      cokom = s1/sa2
      fitadm = 0.5d0*radi*coadm
      fitkom = 0.5d0*radi*cokom
c
      if (isaj.eq.0) then 
      do 40 ipg = 0, npg
      do 40 itg = 0, ntg
      do 40 irg = irgini, nrtot
      psi(irg,itg,ipg)  = 1.0d0 + coadm/(2.0d0*rg(irg))
      alph(irg,itg,ipg) = 1.0d0 - cokom/rg(irg)
   40 continue
      end if
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine cristoffel
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
      common / met3u / hxxu(0:nnrg,0:nntg,0:nnpg),
     &                 hxyu(0:nnrg,0:nntg,0:nnpg),
     &                 hxzu(0:nnrg,0:nntg,0:nnpg),
     &                 hyyu(0:nnrg,0:nntg,0:nnpg),
     &                 hyzu(0:nnrg,0:nntg,0:nnpg),
     &                 hzzu(0:nnrg,0:nntg,0:nnpg)
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
c
c --- Compute Cristoffel symbols,   
c     whose value is assigned on the grid points. 
c     C^a_bc=1/2 gm^ad(pa_b h_dc+...)
c --- for interporation.
c
      do 4 ipg = 0, npg
      do 4 itg = 0, ntg
      do 4 irg = 0, nrtot
c
      gmxxu = hxxu(irg,itg,ipg) + 1.0d0
      gmxyu = hxyu(irg,itg,ipg)
      gmxzu = hxzu(irg,itg,ipg)
      gmyyu = hyyu(irg,itg,ipg) + 1.0d0
      gmyzu = hyzu(irg,itg,ipg)
      gmzzu = hzzu(irg,itg,ipg) + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      call grgrad(hxxd,dhxxdx,dhxxdy,dhxxdz,irg,itg,ipg,1,1,1)
      call grgrad(hxyd,dhxydx,dhxydy,dhxydz,irg,itg,ipg,1,-1,-1)
      call grgrad(hxzd,dhxzdx,dhxzdy,dhxzdz,irg,itg,ipg,-1,-1,1)
      call grgrad(hyyd,dhyydx,dhyydy,dhyydz,irg,itg,ipg,1,1,1)
      call grgrad(hyzd,dhyzdx,dhyzdy,dhyzdz,irg,itg,ipg,-1,1,-1)
      call grgrad(hzzd,dhzzdx,dhzzdy,dhzzdz,irg,itg,ipg,1,1,1)
c
      dhyxdx = dhxydx
      dhyxdy = dhxydy
      dhyxdz = dhxydz
c
      dhzxdx = dhxzdx
      dhzxdy = dhxzdy
      dhzxdz = dhxzdz
c
      dhzydx = dhyzdx
      dhzydy = dhyzdy
      dhzydz = dhyzdz
c
c --- Impose Dirac gauge.
c
cdirac      dhx = gmxxu*dhxxdx + gmxyu*dhxxdy + gmxzu*dhxxdz
cdirac     &    + gmyxu*dhyxdx + gmyyu*dhyxdy + gmyzu*dhyxdz
cdirac     &    + gmzxu*dhzxdx + gmzyu*dhzxdy + gmzzu*dhzxdz
cdirac      dhy = gmxxu*dhxydx + gmxyu*dhxydy + gmxzu*dhxydz
cdirac     &    + gmyxu*dhyydx + gmyyu*dhyydy + gmyzu*dhyydz
cdirac     &    + gmzxu*dhzydx + gmzyu*dhzydy + gmzzu*dhzydz
cdirac      dhz = gmxxu*dhxzdx + gmxyu*dhxzdy + gmxzu*dhxzdz
cdirac     &    + gmyxu*dhyzdx + gmyyu*dhyzdy + gmyzu*dhyzdz
cdirac     &    + gmzxu*dhzzdx + gmzyu*dhzzdy + gmzzu*dhzzdz
cdirac      gzzinv = 1.0d0/gmzzu
cdirac      dhxzdz = - gzzinv*dhx + dhxzdz
cdirac      dhyzdz = - gzzinv*dhy + dhyzdz
cdirac      dhzzdz = - gzzinv*dhz + dhzzdz
cdirac      dhzxdz = dhxzdz
cdirac      dhzydz = dhyzdz
c
c --- end
c
      crid11 = 0.5d0*(dhxxdx + dhxxdx - dhxxdx)
      crid12 = 0.5d0*(dhxxdy + dhxydx - dhxydx)
      crid13 = 0.5d0*(dhxxdz + dhxzdx - dhxzdx)
      crid14 = 0.5d0*(dhxydy + dhxydy - dhyydx)
      crid15 = 0.5d0*(dhxydz + dhxzdy - dhyzdx)
      crid16 = 0.5d0*(dhxzdz + dhxzdz - dhzzdx)
      crid21 = 0.5d0*(dhxydx + dhxydx - dhxxdy)
      crid22 = 0.5d0*(dhxydy + dhyydx - dhxydy)
      crid23 = 0.5d0*(dhxydz + dhyzdx - dhxzdy)
      crid24 = 0.5d0*(dhyydy + dhyydy - dhyydy)
      crid25 = 0.5d0*(dhyydz + dhyzdy - dhyzdy)
      crid26 = 0.5d0*(dhyzdz + dhyzdz - dhzzdy)
      crid31 = 0.5d0*(dhxzdx + dhxzdx - dhxxdz)
      crid32 = 0.5d0*(dhxzdy + dhyzdx - dhxydz)
      crid33 = 0.5d0*(dhxzdz + dhzzdx - dhxzdz)
      crid34 = 0.5d0*(dhyzdy + dhyzdy - dhyydz)
      crid35 = 0.5d0*(dhyzdz + dhzzdy - dhyzdz)
      crid36 = 0.5d0*(dhzzdz + dhzzdz - dhzzdz)
c
      cri(irg,itg,ipg,1,1) =
     &      (-gmxzu*dhxxdz - gmxyu*dhxxdy + gmxxu*dhxxdx + 
     &  2.0d0*gmxyu*dhxydx + 2.0d0*gmxzu*dhxzdx)*0.5d0
      cri(irg,itg,ipg,1,2) =
     &      (-gmxzu*dhxydz + gmxxu*dhxxdy + gmxzu*dhxzdy + 
     &        gmxyu*dhyydx + gmxzu*dhyzdx)*0.5d0
      cri(irg,itg,ipg,1,3) =
     &       (gmxxu*dhxxdz + gmxyu*dhxydz - gmxyu*dhxzdy + 
     &        gmxyu*dhyzdx + gmxzu*dhzzdx)*0.5d0
      cri(irg,itg,ipg,1,4) =
     &      (-gmxzu*dhyydz + 2.0d0*gmxxu*dhxydy + gmxyu*dhyydy + 
     &  2.0d0*gmxzu*dhyzdy - gmxxu*dhyydx)*0.5d0
      cri(irg,itg,ipg,1,5) =
     &       (gmxxu*dhxydz + gmxyu*dhyydz + gmxxu*dhxzdy + 
     &        gmxzu*dhzzdy - gmxxu*dhyzdx)*0.5d0
      cri(irg,itg,ipg,1,6) =
     & (2.0d0*gmxxu*dhxzdz + 2.0d0*gmxyu*dhyzdz + 
     &        gmxzu*dhzzdz - gmxyu*dhzzdy - gmxxu*dhzzdx)*0.5d0
c
      cri(irg,itg,ipg,2,1) =
     &      (-gmyzu*dhxxdz - gmyyu*dhxxdy + gmxyu*dhxxdx + 
     &  2.0d0*gmyyu*dhxydx + 2.0d0*gmyzu*dhxzdx)*0.5d0
      cri(irg,itg,ipg,2,2) =
     &      (-gmyzu*dhxydz + gmxyu*dhxxdy + gmyzu*dhxzdy + 
     &        gmyyu*dhyydx + gmyzu*dhyzdx)*0.5d0
      cri(irg,itg,ipg,2,3) =
     &       (gmxyu*dhxxdz + gmyyu*dhxydz - gmyyu*dhxzdy + 
     &        gmyyu*dhyzdx + gmyzu*dhzzdx)*0.5d0
      cri(irg,itg,ipg,2,4) =
     &      (-gmyzu*dhyydz + 2.0d0*gmxyu*dhxydy + gmyyu*dhyydy + 
     &  2.0d0*gmyzu*dhyzdy - gmxyu*dhyydx)*0.5d0
      cri(irg,itg,ipg,2,5) =
     &       (gmxyu*dhxydz + gmyyu*dhyydz + gmxyu*dhxzdy + 
     &        gmyzu*dhzzdy - gmxyu*dhyzdx)*0.5d0
      cri(irg,itg,ipg,2,6) =
     & (2.0d0*gmxyu*dhxzdz + 2.0d0*gmyyu*dhyzdz + 
     &        gmyzu*dhzzdz - gmyyu*dhzzdy - gmxyu*dhzzdx)*0.5d0
c
      cri(irg,itg,ipg,3,1) =
     &      (-gmzzu*dhxxdz - gmyzu*dhxxdy + gmxzu*dhxxdx + 
     &  2.0d0*gmyzu*dhxydx + 2.0d0*gmzzu*dhxzdx)*0.5d0
      cri(irg,itg,ipg,3,2) =
     &      (-gmzzu*dhxydz + gmxzu*dhxxdy + gmzzu*dhxzdy + 
     &        gmyzu*dhyydx + gmzzu*dhyzdx)*0.5d0
      cri(irg,itg,ipg,3,3) =
     &       (gmxzu*dhxxdz + gmyzu*dhxydz - gmyzu*dhxzdy + 
     &        gmyzu*dhyzdx + gmzzu*dhzzdx)*0.5d0
      cri(irg,itg,ipg,3,4) =
     &      (-gmzzu*dhyydz + 2.0d0*gmxzu*dhxydy + gmyzu*dhyydy + 
     &  2.0d0*gmzzu*dhyzdy - gmxzu*dhyydx)*0.5d0
      cri(irg,itg,ipg,3,5) =
     &       (gmxzu*dhxydz + gmyzu*dhyydz + gmxzu*dhxzdy + 
     &        gmzzu*dhzzdy - gmxzu*dhyzdx)*0.5d0
      cri(irg,itg,ipg,3,6) =
     & (2.0d0*gmxzu*dhxzdz + 2.0d0*gmyzu*dhyzdz + 
     &        gmzzu*dhzzdz - gmyzu*dhzzdy - gmxzu*dhzzdx)*0.5d0
c
c --  gamma^ab C^c_ab
c
cgauge      gmcrix(irg,itg,ipg) = gmxxu*cri(irg,itg,ipg,1,1)
cgauge     &                    + gmxyu*cri(irg,itg,ipg,1,2)*2.0d0
cgauge     &                    + gmxzu*cri(irg,itg,ipg,1,3)*2.0d0
cgauge     &                    + gmyyu*cri(irg,itg,ipg,1,4)
cgauge     &                    + gmyzu*cri(irg,itg,ipg,1,5)*2.0d0
cgauge     &                    + gmzzu*cri(irg,itg,ipg,1,6)
cgauge      gmcriy(irg,itg,ipg) = gmxxu*cri(irg,itg,ipg,2,1)
cgauge     &                    + gmxyu*cri(irg,itg,ipg,2,2)*2.0d0
cgauge     &                    + gmxzu*cri(irg,itg,ipg,2,3)*2.0d0
cgauge     &                    + gmyyu*cri(irg,itg,ipg,2,4)
cgauge     &                    + gmyzu*cri(irg,itg,ipg,2,5)*2.0d0
cgauge     &                    + gmzzu*cri(irg,itg,ipg,2,6)
cgauge      gmcriz(irg,itg,ipg) = gmxxu*cri(irg,itg,ipg,3,1)
cgauge     &                    + gmxyu*cri(irg,itg,ipg,3,2)*2.0d0
cgauge     &                    + gmxzu*cri(irg,itg,ipg,3,3)*2.0d0
cgauge     &                    + gmyyu*cri(irg,itg,ipg,3,4)
cgauge     &                    + gmyzu*cri(irg,itg,ipg,3,5)*2.0d0
cgauge     &                    + gmzzu*cri(irg,itg,ipg,3,6)
c
      gmcrix(irg,itg,ipg) = 0.0d0
      gmcriy(irg,itg,ipg) = 0.0d0
      gmcriz(irg,itg,ipg) = 0.0d0
 4    continue
c
cgauge      write(6,*) 'gmcri',gmcrix(8,7,12), gmcriy(8,7,12), gmcriz(8,7,12)
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine riccitensor
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
      common / met3u / hxxu(0:nnrg,0:nntg,0:nnpg),
     &                 hxyu(0:nnrg,0:nntg,0:nnpg),
     &                 hxzu(0:nnrg,0:nntg,0:nnpg),
     &                 hyyu(0:nnrg,0:nntg,0:nnpg),
     &                 hyzu(0:nnrg,0:nntg,0:nnpg),
     &                 hzzu(0:nnrg,0:nntg,0:nnpg)
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
c
      dimension  delhab(6),
     &          r5(5),  th5(5), phi5(5),
     &         fr5(5),  ft5(5),  fp5(5), fr5x(5), ft5x(5), fp5x(5),
     &        fr5y(5), ft5y(5), fp5y(5), fr5z(5), ft5z(5), fp5z(5),
     &          xi(4),  yi1(4),  yi2(4),  yi3(4),  yi4(4),
     &         yi5(4),  yi6(4),  yi7(4),  yi8(4),  yi9(4),
     &       grad1(3), grad1x(3), grad1y(3),  grad1z(3),
     &       dckkx(3),  dckky(3),  dckkz(3), dhudhd(3,3), dhdh(6),
     &       r6(6), th6(6), phi6(6), 
     &       fr6xx(6), ft6xx(6), fp6xx(6), fr5xx(5), ft5xx(5), 
     &       fr6xy(6), ft6xy(6), fp6xy(6), fr5xy(5), ft5xy(5),
     &       fr6xz(6), ft6xz(6), fp6xz(6), fr5xz(5), ft5xz(5),
     &       fr6yy(6), ft6yy(6), fp6yy(6), fr5yy(5), ft5yy(5),
     &       fr6yz(6), ft6yz(6), fp6yz(6), fr5yz(5), ft5yz(5),
     &       fr6zz(6), ft6zz(6), fp6zz(6), fr5zz(5), ft5zz(5)
      dimension dhd(3,3,3), dhu(3,3,3),  gamu(3,3)
      dimension d2hxx(3,3), d2hxy(3,3), d2hxz(3,3),
     &          d2hyy(3,3), d2hyz(3,3), d2hzz(3,3)
      dimension hd2h(6)
c
c --- Compute Ricci tensor & R_ab(nonlinar)   
c     whose value is assigned on the grid points. 
c     Gauge condition D_b h^ab =0 and \tgamma = 0 has been imposed,  
c --- hence, R_ab = -1/2 Lap h_ab + R_ab(nonlinear).
c
      do 10 ipg = 0, npg
      do 10 itg = 0, ntg
      do 10 irg = 0, nrtot
c
c --- R_nonlinear
c
      hhxxu = hxxu(irg,itg,ipg)
      hhxyu = hxyu(irg,itg,ipg)
      hhxzu = hxzu(irg,itg,ipg)
      hhyyu = hyyu(irg,itg,ipg)
      hhyzu = hyzu(irg,itg,ipg)
      hhzzu = hzzu(irg,itg,ipg)
      hhyxu = hhxyu
      hhzxu = hhxzu
      hhzyu = hhyzu
      gamu(1,1) = hhxxu + 1.0d0
      gamu(1,2) = hhxyu
      gamu(1,3) = hhxzu
      gamu(2,2) = hhyyu + 1.0d0
      gamu(2,3) = hhyzu
      gamu(3,3) = hhzzu + 1.0d0
      gamu(2,1) = gamu(1,2)
      gamu(3,1) = gamu(1,3)
      gamu(3,2) = gamu(2,3)
c
      c11 = cri(irg,itg,ipg,1,1)
      c12 = cri(irg,itg,ipg,1,2)
      c13 = cri(irg,itg,ipg,1,3)
      c14 = cri(irg,itg,ipg,1,4)
      c15 = cri(irg,itg,ipg,1,5)
      c16 = cri(irg,itg,ipg,1,6)
      c21 = cri(irg,itg,ipg,2,1)
      c22 = cri(irg,itg,ipg,2,2)
      c23 = cri(irg,itg,ipg,2,3)
      c24 = cri(irg,itg,ipg,2,4)
      c25 = cri(irg,itg,ipg,2,5)
      c26 = cri(irg,itg,ipg,2,6)
      c31 = cri(irg,itg,ipg,3,1)
      c32 = cri(irg,itg,ipg,3,2)
      c33 = cri(irg,itg,ipg,3,3)
      c34 = cri(irg,itg,ipg,3,4)
      c35 = cri(irg,itg,ipg,3,5)
      c36 = cri(irg,itg,ipg,3,6)
c
cgauge      ckkx = c11 + c22 + c33      
cgauge      ckky = c12 + c24 + c35      
cgauge      ckkz = c13 + c25 + c36
      ckkx = 0.0d0
      ckky = 0.0d0
      ckkz = 0.0d0
c
      ckxlclxk = c11**2 + 2.0d0*c12*c21 + c22**2 + 
     &    2.0d0*c13*c31 + 2.0d0*c23*c32 + c33**2
      ckxlclyk = c11*c12 + c14*c21 + c12*c22 + c22*c24 + 
     & c15*c31 + c13*c32 + c25*c32 + c23*c34 + c33*c35
      ckxlclzk = c11*c13 + c15*c21 + c12*c23 + c22*c25 + 
     & c16*c31 + c26*c32 + c13*c33 + c23*c35 + c33*c36
      ckylclyk = c12**2 + 2.0d0*c14*c22 + c24**2 + 
     &    2.0d0*c15*c32 + 2.0d0*c25*c34 + c35**2
      ckylclzk = c12*c13 + c15*c22 + c14*c23 + c24*c25 + 
     & c16*c32 + c15*c33 + c26*c34 + c25*c35 + c35*c36
      ckzlclzk = c13**2 + 2.0d0*c15*c23 + c25**2 + 
     &    2.0d0*c16*c33 + 2.0d0*c26*c35 + c36**2
c
cgauge      clxxckkl = c11*ckkx + c21*ckky + c31*ckkz
cgauge      clxyckkl = c12*ckkx + c22*ckky + c32*ckkz
cgauge      clxzckkl = c13*ckkx + c23*ckky + c33*ckkz
cgauge      clyyckkl = c14*ckkx + c24*ckky + c34*ckkz
cgauge      clyzckkl = c15*ckkx + c25*ckky + c35*ckkz
cgauge      clzzckkl = c16*ckkx + c26*ckky + c36*ckkz
      clxxckkl = 0.0d0
      clxyckkl = 0.0d0
      clxzckkl = 0.0d0
      clyyckkl = 0.0d0
      clyzckkl = 0.0d0
      clzzckkl = 0.0d0
c
c --- gradient of cristoffel = 0 for gauge condition.
c
cgauge      ir0 = min0(max0(irg-2,0),nrtot-4)
cgauge      it0 = min0(max0(itg-2,0),ntg-4)
cgauge      ip0 = min0(max0(ipg-2,0),npg-4)
c
cgauge      do 7 ic = 1, 3
c
cgauge      ic1 = 1*(ic-2)*(ic-3)/2 - 2*(ic-1)*(ic-3) + 3*(ic-1)*(ic-2)/2
cgauge      ic2 = 2*(ic-2)*(ic-3)/2 - 4*(ic-1)*(ic-3) + 5*(ic-1)*(ic-2)/2
cgauge      ic3 = 3*(ic-2)*(ic-3)/2 - 5*(ic-1)*(ic-3) + 6*(ic-1)*(ic-2)/2
c
cgauge      do 8 ii = 1, 5
cgauge      irg0 = ir0 + ii - 1
cgauge      itg0 = it0 + ii - 1
cgauge      ipg0 = ip0 + ii - 1
cgauge      r5(ii) = rg(irg0)
cgauge      th5(ii) = thg(itg0)
cgauge      phi5(ii) = phig(ipg0)
c
cgauge      if (irg.eq.0) then
cgauge      fr5(ii) = cri(irg0,ntg,npgxz,1,ic1) + cri(irg0,ntg,npgxz,2,ic2)
cgauge     &        + cri(irg0,ntg,npgxz,3,ic3)
cgauge      ft5(ii) = cri(irg0,ntg,npgyz,1,ic1) + cri(irg0,ntg,npgyz,2,ic2)
cgauge     &        + cri(irg0,ntg,npgyz,3,ic3)
cgauge      fp5(ii) = cri(irg0,0,0,1,ic1) + cri(irg0,0,0,2,ic2)
cgauge     &        + cri(irg0,0,0,3,ic3)
cgauge      else if (irg.ne.0.and.itg.eq.0) then
cgauge      fr5(ii) = cri(irg,itg0,npgxz,1,ic1) + cri(irg,itg0,npgxz,2,ic2)
cgauge     &        + cri(irg,itg0,npgxz,3,ic3)
cgauge      ft5(ii) = cri(irg,itg0,npgyz,1,ic1) + cri(irg,itg0,npgyz,2,ic2)
cgauge     &        + cri(irg,itg0,npgyz,3,ic3)
cgauge      fp5(ii) = cri(irg0,0,0,1,ic1) + cri(irg0,0,0,2,ic2)
cgauge     &        + cri(irg0,0,0,3,ic3)
cgauge      else
cgauge      fr5(ii) = cri(irg0,itg,ipg,1,ic1) + cri(irg0,itg,ipg,2,ic2)
cgauge     &        + cri(irg0,itg,ipg,3,ic3)
cgauge      ft5(ii) = cri(irg,itg0,ipg,1,ic1) + cri(irg,itg0,ipg,2,ic2)
cgauge     &        + cri(irg,itg0,ipg,3,ic3)
cgauge      fp5(ii) = cri(irg,itg,ipg0,1,ic1) + cri(irg,itg,ipg0,2,ic2)
cgauge     &        + cri(irg,itg,ipg0,3,ic3)
cgauge      end if
cgauge    8 continue
c
c --- To cartesian component.  
c
cgauge      rv = rg(irg)
cgauge      tv = thg(itg)
cgauge      pv = phig(ipg)
cgauge      rrgginv = rginv(irg)
c
cgauge      if (irg.eq.0) then
cgauge      grad1(1) = dfncdx(r5,fr5,rv)
cgauge      grad1(2) = dfncdx(r5,ft5,rv) 
cgauge      grad1(3) = dfncdx(r5,fp5,rv)
cgauge      else if (irg.ne.0.and.itg.eq.0) then
cgauge      grad1(1) = dfncdx(th5,fr5,tv)*rrgginv
cgauge      grad1(2) = dfncdx(th5,ft5,tv)*rrgginv
cgauge      grad1(3) = dfncdx(r5,fp5,rv)
cgauge      else
cgauge      gr1 = dfncdx(r5,fr5,rv)
cgauge      gr2 = dfncdx(th5,ft5,tv)*rrgginv
cgauge      gr3 = dfncdx(phi5,fp5,pv)*rrgginv*cosecg(itg)
cgauge      grad1(1) = gr1*sintheg(itg)*cosphig(ipg)
cgauge     &         + gr2*costheg(itg)*cosphig(ipg)  
cgauge     &         - gr3*sinphig(ipg) 
cgauge      grad1(2) = gr1*sintheg(itg)*sinphig(ipg)
cgauge     &         + gr2*costheg(itg)*sinphig(ipg)
cgauge     &         + gr3*cosphig(ipg) 
cgauge      grad1(3) = gr1*costheg(itg)
cgauge     &         - gr2*sintheg(itg)
c
cgauge      end if
c
cgauge      if (ic.eq.1) then 
cgauge      dckkx(1) = grad1(1)
cgauge      dckkx(2) = grad1(2)
cgauge      dckkx(3) = grad1(3)
cgauge      end if
cgauge      if (ic.eq.2) then 
cgauge      dckky(1) = grad1(1)
cgauge      dckky(2) = grad1(2)
cgauge      dckky(3) = grad1(3)
cgauge      end if
cgauge      if (ic.eq.3) then 
cgauge      dckkz(1) = grad1(1)
cgauge      dckkz(2) = grad1(2)
cgauge      dckkz(3) = grad1(3)
cgauge      end if
c
cgauge    7 continue
c
      dckkx(1) = 0.0D0
      dckkx(2) = 0.0D0
      dckkx(3) = 0.0D0
      dckky(1) = 0.0D0
      dckky(2) = 0.0D0
      dckky(3) = 0.0D0
      dckkz(1) = 0.0D0
      dckkz(2) = 0.0D0
      dckkz(3) = 0.0D0
c
c --- Derivatives of h_ab.
c
      call grgrad1g(hxxd,grad1,irg,itg,ipg,1,1,1)
      dhd(1,1,1) = grad1(1)
      dhd(1,1,2) = grad1(2)
      dhd(1,1,3) = grad1(3)
      call grgrad1g(hxyd,grad1,irg,itg,ipg,1,-1,-1)
      dhd(1,2,1) = grad1(1)
      dhd(1,2,2) = grad1(2)
      dhd(1,2,3) = grad1(3)
      dhd(2,1,1) = grad1(1)
      dhd(2,1,2) = grad1(2)
      dhd(2,1,3) = grad1(3)
      call grgrad1g(hxzd,grad1,irg,itg,ipg,-1,-1,1)
      dhd(1,3,1) = grad1(1)
      dhd(1,3,2) = grad1(2)
      dhd(1,3,3) = grad1(3)
      dhd(3,1,1) = grad1(1)
      dhd(3,1,2) = grad1(2)
      dhd(3,1,3) = grad1(3)
      call grgrad1g(hyyd,grad1,irg,itg,ipg,1,1,1)
      dhd(2,2,1) = grad1(1)
      dhd(2,2,2) = grad1(2)
      dhd(2,2,3) = grad1(3)
      call grgrad1g(hyzd,grad1,irg,itg,ipg,-1,1,-1)
      dhd(2,3,1) = grad1(1)
      dhd(2,3,2) = grad1(2)
      dhd(2,3,3) = grad1(3)
      dhd(3,2,1) = grad1(1)
      dhd(3,2,2) = grad1(2)
      dhd(3,2,3) = grad1(3)
      call grgrad1g(hzzd,grad1,irg,itg,ipg,1,1,1)
      dhd(3,3,1) = grad1(1)
      dhd(3,3,2) = grad1(2)
      dhd(3,3,3) = grad1(3)
c
      call grgrad1g(hxxu,grad1,irg,itg,ipg,1,1,1)
      dhu(1,1,1) = grad1(1)
      dhu(1,1,2) = grad1(2)
      dhu(1,1,3) = grad1(3)
      call grgrad1g(hxyu,grad1,irg,itg,ipg,1,-1,-1)
      dhu(1,2,1) = grad1(1)
      dhu(1,2,2) = grad1(2)
      dhu(1,2,3) = grad1(3)
      dhu(2,1,1) = grad1(1)
      dhu(2,1,2) = grad1(2)
      dhu(2,1,3) = grad1(3)
      call grgrad1g(hxzu,grad1,irg,itg,ipg,-1,-1,1)
      dhu(1,3,1) = grad1(1)
      dhu(1,3,2) = grad1(2)
      dhu(1,3,3) = grad1(3)
      dhu(3,1,1) = grad1(1)
      dhu(3,1,2) = grad1(2)
      dhu(3,1,3) = grad1(3)
      call grgrad1g(hyyu,grad1,irg,itg,ipg,1,1,1)
      dhu(2,2,1) = grad1(1)
      dhu(2,2,2) = grad1(2)
      dhu(2,2,3) = grad1(3)
      call grgrad1g(hyzu,grad1,irg,itg,ipg,-1,1,-1)
      dhu(2,3,1) = grad1(1)
      dhu(2,3,2) = grad1(2)
      dhu(2,3,3) = grad1(3)
      dhu(3,2,1) = grad1(1)
      dhu(3,2,2) = grad1(2)
      dhu(3,2,3) = grad1(3)
      call grgrad1g(hzzu,grad1,irg,itg,ipg,1,1,1)
      dhu(3,3,1) = grad1(1)
      dhu(3,3,2) = grad1(2)
      dhu(3,3,3) = grad1(3)
c
c --- Impose Dirac gauge.
c
ctest      dhu(1,1,1) = - dhu(1,2,2) - dhu(1,3,3)
ctest      dhu(2,2,2) = - dhu(2,1,1) - dhu(2,3,3)
ctest      dhu(3,3,3) = - dhu(3,1,1) - dhu(3,2,2)
cdirac      dhu(1,3,3) = - dhu(1,1,1) - dhu(1,2,2)
cdirac      dhu(2,3,3) = - dhu(2,1,1) - dhu(2,2,2)
cdirac      dhu(3,3,3) = - dhu(3,1,1) - dhu(3,2,2)
cdirac      dhu(3,1,3) = dhu(1,3,3)
cdirac      dhu(3,2,3) = dhu(2,3,3)
ctest3      dhu(1,1,1) = - dhu(1,2,2) - dhu(1,3,3)
ctest3      dhu(2,1,1) = - dhu(2,2,2) - dhu(2,3,3)
ctest3      dhu(3,1,1) = - dhu(3,2,2) - dhu(3,3,3)
ctest3      dhu(1,2,1) = dhu(2,1,1)
ctest3      dhu(1,3,1) = dhu(3,1,1)
ctest4      dhu(1,2,2) = - dhu(1,1,1) - dhu(1,3,3)
ctest4      dhu(2,2,2) = - dhu(2,1,1) - dhu(2,3,3)
ctest4      dhu(3,2,2) = - dhu(3,1,1) - dhu(3,3,3)
ctest4      dhu(2,1,2) = dhu(1,2,2)
ctest4      dhu(2,3,2) = dhu(3,2,2)
c
cdirac      dhx=gamu(1,1)*dhd(1,1,1)+gamu(1,2)*dhd(1,1,2)+gamu(1,3)*dhd(1,1,3)
cdirac     &   +gamu(2,1)*dhd(2,1,1)+gamu(2,2)*dhd(2,1,2)+gamu(2,3)*dhd(2,1,3)
cdirac     &   +gamu(3,1)*dhd(3,1,1)+gamu(3,2)*dhd(3,1,2)+gamu(3,3)*dhd(3,1,3)
cdirac      dhy=gamu(1,1)*dhd(1,2,1)+gamu(1,2)*dhd(1,2,2)+gamu(1,3)*dhd(1,2,3)
cdirac     &   +gamu(2,1)*dhd(2,2,1)+gamu(2,2)*dhd(2,2,2)+gamu(2,3)*dhd(2,2,3)
cdirac     &   +gamu(3,1)*dhd(3,2,1)+gamu(3,2)*dhd(3,2,2)+gamu(3,3)*dhd(3,2,3)
cdirac      dhz=gamu(1,1)*dhd(1,3,1)+gamu(1,2)*dhd(1,3,2)+gamu(1,3)*dhd(1,3,3)
cdirac     &   +gamu(2,1)*dhd(2,3,1)+gamu(2,2)*dhd(2,3,2)+gamu(2,3)*dhd(2,3,3)
cdirac     &   +gamu(3,1)*dhd(3,3,1)+gamu(3,2)*dhd(3,3,2)+gamu(3,3)*dhd(3,3,3)
cdirac      gzzinv = 1.0d0/gamu(3,3)
cdirac      dhd(1,3,3) = - gzzinv*dhx + dhd(1,3,3)
cdirac      dhd(2,3,3) = - gzzinv*dhy + dhd(2,3,3)
cdirac      dhd(3,3,3) = - gzzinv*dhz + dhd(3,3,3)
cdirac      dhd(3,1,3) = dhd(1,3,3)
cdirac      dhd(3,2,3) = dhd(2,3,3)
c
c --- end
c
      do 14 ia = 1, 3
      do 14 ib = 1, 3
      dhudhd(ia,ib) = 0.0d0
      do 14 ic = 1, 3
      do 14 id = 1, 3
      dhudhd(ia,ib) = dhudhd(ia,ib) + dhu(ic,id,ia)*dhd(ib,id,ic)
 14   continue
      dhdh(1) = dhudhd(1,1) + dhudhd(1,1)
      dhdh(2) = dhudhd(1,2) + dhudhd(2,1)
      dhdh(3) = dhudhd(1,3) + dhudhd(3,1)
      dhdh(4) = dhudhd(2,2) + dhudhd(2,2)
      dhdh(5) = dhudhd(2,3) + dhudhd(3,2)
      dhdh(6) = dhudhd(3,3) + dhudhd(3,3)
c
      call dadbscalargsym(hxxd,d2hxx,irg,itg,ipg,1,1,1)
      call dadbscalargsym(hxyd,d2hxy,irg,itg,ipg,1,-1,-1)
      call dadbscalargsym(hxzd,d2hxz,irg,itg,ipg,-1,-1,1)
      call dadbscalargsym(hyyd,d2hyy,irg,itg,ipg,1,1,1)
      call dadbscalargsym(hyzd,d2hyz,irg,itg,ipg,-1,1,-1)
      call dadbscalargsym(hzzd,d2hzz,irg,itg,ipg,1,1,1)
c
      hd2h(1) = hhxxu*d2hxx(1,1) + hhxyu*d2hxx(1,2) + hhxzu*d2hxx(1,3)
     &        + hhyxu*d2hxx(2,1) + hhyyu*d2hxx(2,2) + hhyzu*d2hxx(2,3)
     &        + hhzxu*d2hxx(3,1) + hhzyu*d2hxx(3,2) + hhzzu*d2hxx(3,3)
      hd2h(2) = hhxxu*d2hxy(1,1) + hhxyu*d2hxy(1,2) + hhxzu*d2hxy(1,3)
     &        + hhyxu*d2hxy(2,1) + hhyyu*d2hxy(2,2) + hhyzu*d2hxy(2,3)
     &        + hhzxu*d2hxy(3,1) + hhzyu*d2hxy(3,2) + hhzzu*d2hxy(3,3)
      hd2h(3) = hhxxu*d2hxz(1,1) + hhxyu*d2hxz(1,2) + hhxzu*d2hxz(1,3)
     &        + hhyxu*d2hxz(2,1) + hhyyu*d2hxz(2,2) + hhyzu*d2hxz(2,3)
     &        + hhzxu*d2hxz(3,1) + hhzyu*d2hxz(3,2) + hhzzu*d2hxz(3,3)
      hd2h(4) = hhxxu*d2hyy(1,1) + hhxyu*d2hyy(1,2) + hhxzu*d2hyy(1,3)
     &        + hhyxu*d2hyy(2,1) + hhyyu*d2hyy(2,2) + hhyzu*d2hyy(2,3)
     &        + hhzxu*d2hyy(3,1) + hhzyu*d2hyy(3,2) + hhzzu*d2hyy(3,3)
      hd2h(5) = hhxxu*d2hyz(1,1) + hhxyu*d2hyz(1,2) + hhxzu*d2hyz(1,3)
     &        + hhyxu*d2hyz(2,1) + hhyyu*d2hyz(2,2) + hhyzu*d2hyz(2,3)
     &        + hhzxu*d2hyz(3,1) + hhzyu*d2hyz(3,2) + hhzzu*d2hyz(3,3)
      hd2h(6) = hhxxu*d2hzz(1,1) + hhxyu*d2hzz(1,2) + hhxzu*d2hzz(1,3)
     &        + hhyxu*d2hzz(2,1) + hhyyu*d2hzz(2,2) + hhyzu*d2hzz(2,3)
     &        + hhzxu*d2hzz(3,1) + hhzyu*d2hzz(3,2) + hhzzu*d2hzz(3,3)
c
c --- -1/2 Laplacian(h_ab)
c
ctesttest      call laphab(delhab,irg,itg,ipg)
      delhab(1) = d2hxx(1,1) + d2hxx(2,2) + d2hxx(3,3)
      delhab(2) = d2hxy(1,1) + d2hxy(2,2) + d2hxy(3,3)
      delhab(3) = d2hxz(1,1) + d2hxz(2,2) + d2hxz(3,3)
      delhab(4) = d2hyy(1,1) + d2hyy(2,2) + d2hyy(3,3)
      delhab(5) = d2hyz(1,1) + d2hyz(2,2) + d2hyz(3,3)
      delhab(6) = d2hzz(1,1) + d2hzz(2,2) + d2hzz(3,3)
c
c --- Ricci tensor R_ab and RNL_ab.
c
      rabnl(irg,itg,ipg,1) = -0.5d0*(dhdh(1) + hd2h(1))
     &                     - dckkx(1) + clxxckkl - ckxlclxk
      rabnl(irg,itg,ipg,2) = -0.5d0*(dhdh(2) + hd2h(2))
     &                     - dckky(1) + clxyckkl - ckxlclyk
      rabnl(irg,itg,ipg,3) = -0.5d0*(dhdh(3) + hd2h(3))
     &                     - dckkz(1) + clxzckkl - ckxlclzk
      rabnl(irg,itg,ipg,4) = -0.5d0*(dhdh(4) + hd2h(4))
     &                     - dckky(2) + clyyckkl - ckylclyk
      rabnl(irg,itg,ipg,5) = -0.5d0*(dhdh(5) + hd2h(5))
     &                     - dckkz(2) + clyzckkl - ckylclzk
      rabnl(irg,itg,ipg,6) = -0.5d0*(dhdh(6) + hd2h(6))
     &                     - dckkz(3) + clzzckkl - ckzlclzk
      rab(irg,itg,ipg,1) = -0.5d0*delhab(1) + rabnl(irg,itg,ipg,1)
      rab(irg,itg,ipg,2) = -0.5d0*delhab(2) + rabnl(irg,itg,ipg,2)
      rab(irg,itg,ipg,3) = -0.5d0*delhab(3) + rabnl(irg,itg,ipg,3)
      rab(irg,itg,ipg,4) = -0.5d0*delhab(4) + rabnl(irg,itg,ipg,4)
      rab(irg,itg,ipg,5) = -0.5d0*delhab(5) + rabnl(irg,itg,ipg,5)
      rab(irg,itg,ipg,6) = -0.5d0*delhab(6) + rabnl(irg,itg,ipg,6)
c
   10 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function d2fncdx2(xg,fnc,rv)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension xg(6),fnc(6)
c
      ir0 = 1
      ir1 = 2
      ir2 = 3
      ir3 = 4
      ir4 = 5
      ir5 = 6
      dr01 = xg(ir0) - xg(ir1)
      dr02 = xg(ir0) - xg(ir2)
      dr03 = xg(ir0) - xg(ir3)
      dr04 = xg(ir0) - xg(ir4)
      dr05 = xg(ir0) - xg(ir5)
      dr12 = xg(ir1) - xg(ir2)
      dr13 = xg(ir1) - xg(ir3)
      dr14 = xg(ir1) - xg(ir4)
      dr15 = xg(ir1) - xg(ir5)
      dr23 = xg(ir2) - xg(ir3)
      dr24 = xg(ir2) - xg(ir4)
      dr25 = xg(ir2) - xg(ir5)
      dr34 = xg(ir3) - xg(ir4)
      dr35 = xg(ir3) - xg(ir5)
      dr45 = xg(ir4) - xg(ir5)
      dr10 = - dr01
      dr20 = - dr02
      dr21 = - dr12
      dr30 = - dr03
      dr31 = - dr13
      dr32 = - dr23
      dr40 = - dr04
      dr41 = - dr14
      dr42 = - dr24
      dr43 = - dr34
      dr50 = - dr05
      dr51 = - dr15
      dr52 = - dr25
      dr53 = - dr35
      dr54 = - dr45
      rrv0 = rv - xg(ir0)
      rrv1 = rv - xg(ir1)
      rrv2 = rv - xg(ir2)
      rrv3 = rv - xg(ir3)
      rrv4 = rv - xg(ir4)
      rrv5 = rv - xg(ir5)
      wer0 = 2.0d0*(rrv3*rrv4*rrv5 + rrv2*rrv4*rrv5 + rrv2*rrv3*rrv5
     &            + rrv2*rrv3*rrv4 + rrv1*rrv4*rrv5 + rrv1*rrv3*rrv5 
     &            + rrv1*rrv3*rrv4 + rrv1*rrv2*rrv5 + rrv1*rrv2*rrv4
     &            + rrv1*rrv2*rrv3)/(dr01*dr02*dr03*dr04*dr05) 
      wer1 = 2.0d0*(rrv3*rrv4*rrv5 + rrv2*rrv4*rrv5 + rrv2*rrv3*rrv5
     &            + rrv2*rrv3*rrv4 + rrv0*rrv4*rrv5 + rrv0*rrv3*rrv5 
     &            + rrv0*rrv3*rrv4 + rrv0*rrv2*rrv5 + rrv0*rrv2*rrv4
     &            + rrv0*rrv2*rrv3)/(dr10*dr12*dr13*dr14*dr15) 
      wer2 = 2.0d0*(rrv3*rrv4*rrv5 + rrv1*rrv4*rrv5 + rrv1*rrv3*rrv5
     &            + rrv1*rrv3*rrv4 + rrv0*rrv4*rrv5 + rrv0*rrv3*rrv5 
     &            + rrv0*rrv3*rrv4 + rrv0*rrv1*rrv5 + rrv0*rrv1*rrv4
     &            + rrv0*rrv1*rrv3)/(dr20*dr21*dr23*dr24*dr25) 
      wer3 = 2.0d0*(rrv2*rrv4*rrv5 + rrv1*rrv4*rrv5 + rrv1*rrv2*rrv5
     &            + rrv1*rrv2*rrv4 + rrv0*rrv4*rrv5 + rrv0*rrv2*rrv5 
     &            + rrv0*rrv2*rrv4 + rrv0*rrv1*rrv5 + rrv0*rrv1*rrv4
     &            + rrv0*rrv1*rrv2)/(dr30*dr31*dr32*dr34*dr35) 
      wer4 = 2.0d0*(rrv2*rrv3*rrv5 + rrv1*rrv3*rrv5 + rrv1*rrv2*rrv5
     &            + rrv1*rrv2*rrv3 + rrv0*rrv3*rrv5 + rrv0*rrv2*rrv5 
     &            + rrv0*rrv2*rrv3 + rrv0*rrv1*rrv5 + rrv0*rrv1*rrv3
     &            + rrv0*rrv1*rrv2)/(dr40*dr41*dr42*dr43*dr45) 
      wer5 = 2.0d0*(rrv2*rrv3*rrv4 + rrv1*rrv3*rrv4 + rrv1*rrv2*rrv4
     &            + rrv1*rrv2*rrv3 + rrv0*rrv3*rrv4 + rrv0*rrv2*rrv4 
     &            + rrv0*rrv2*rrv3 + rrv0*rrv1*rrv4 + rrv0*rrv1*rrv3
     &            + rrv0*rrv1*rrv2)/(dr50*dr51*dr52*dr53*dr54) 
c
      d2fncdx2 = wer0*fnc(ir0) + wer1*fnc(ir1) +
     &           wer2*fnc(ir2) + wer3*fnc(ir3) +
     &           wer4*fnc(ir4) + wer5*fnc(ir5)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine laphab(delhab,irg,itg,ipg)
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      common / met3d / hxxd(0:nnrg,0:nntg,0:nnpg),
     &                 hxyd(0:nnrg,0:nntg,0:nnpg),
     &                 hxzd(0:nnrg,0:nntg,0:nnpg),
     &                 hyyd(0:nnrg,0:nntg,0:nnpg),
     &                 hyzd(0:nnrg,0:nntg,0:nnpg),
     &                 hzzd(0:nnrg,0:nntg,0:nnpg)
c
      dimension  delhab(6),
     &       r5(5), th5(5), phi5(5), r6(6), th6(6), phi6(6), 
     &       fr6xx(6), ft6xx(6), fp6xx(6), fr5xx(5), ft5xx(5), 
     &       fr6xy(6), ft6xy(6), fp6xy(6), fr5xy(5), ft5xy(5),
     &       fr6xz(6), ft6xz(6), fp6xz(6), fr5xz(5), ft5xz(5),
     &       fr6yy(6), ft6yy(6), fp6yy(6), fr5yy(5), ft5yy(5),
     &       fr6yz(6), ft6yz(6), fp6yz(6), fr5yz(5), ft5yz(5),
     &       fr6zz(6), ft6zz(6), fp6zz(6), fr5zz(5), ft5zz(5)
c
c --- Compute Laplacian h_ab,   
c     whose value is assigned on the grid points. 
c     Laplacian is computed by derivatives of Catesian coordinate for 
c --- r=0 or theta=0, and by that of spherical coordinate for elsewhere.
c
      ir0 = min0(max0(irg-2,0),nrtot-4)
      it0 = min0(max0(itg-2,0),ntg-4)
      ip0 = min0(max0(ipg-2,0),npg-4)
c
      ir2 = min0(max0(irg-2,0),nrtot-5)
      it2 = min0(max0(itg-2,0),ntg-5)
      ip2 = min0(max0(ipg-2,0),npg-5)
c
      rv = rg(irg)
      tv = thg(itg)
      pv = phig(ipg)
      rrgginv = rginv(irg)
c
      do 27 ii = 1, 5
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      r5(ii) = rg(irg0)
      th5(ii) = thg(itg0)
      phi5(ii) = phig(ipg0)
   27 continue
      do 28 ii = 1, 6
      irg0 = ir2 + ii - 1
      itg0 = it2 + ii - 1
      ipg0 = ip2 + ii - 1
      r6(ii) = rg(irg0)
      th6(ii) = thg(itg0)
      phi6(ii) = phig(ipg0)
   28 continue
c
      if (irg.eq.0) then
c
      do 38 ii = 1, 6
      irg0 = ir2 + ii - 1
c
      fr6xx(ii) = hxxd(irg0,ntg,0)
      ft6xx(ii) = hxxd(irg0,ntg,npgyz)
      fp6xx(ii) = hxxd(irg0,0,0)
      fr6xy(ii) = hxyd(irg0,ntg,0)
      ft6xy(ii) = hxyd(irg0,ntg,npgyz)
      fp6xy(ii) = hxyd(irg0,0,0)
      fr6xz(ii) = hxzd(irg0,ntg,0)
      ft6xz(ii) = hxzd(irg0,ntg,npgyz)
      fp6xz(ii) = hxzd(irg0,0,0)
      fr6yy(ii) = hyyd(irg0,ntg,0)
      ft6yy(ii) = hyyd(irg0,ntg,npgyz)
      fp6yy(ii) = hyyd(irg0,0,0)
      fr6yz(ii) = hyzd(irg0,ntg,0)
      ft6yz(ii) = hyzd(irg0,ntg,npgyz)
      fp6yz(ii) = hyzd(irg0,0,0)
      fr6zz(ii) = hzzd(irg0,ntg,0)
      ft6zz(ii) = hzzd(irg0,ntg,npgyz)
      fp6zz(ii) = hzzd(irg0,0,0)
c
   38 continue
c
      d2hxxdr2 = d2fncdx2(r6,fr6xx,rv)
      d2hxxdt2 = d2fncdx2(r6,ft6xx,rv)
      d2hxxdp2 = d2fncdx2(r6,fp6xx,rv)
      d2hxydr2 = d2fncdx2(r6,fr6xy,rv)
      d2hxydt2 = d2fncdx2(r6,ft6xy,rv)
      d2hxydp2 = d2fncdx2(r6,fp6xy,rv)
      d2hxzdr2 = d2fncdx2(r6,fr6xz,rv)
      d2hxzdt2 = d2fncdx2(r6,ft6xz,rv)
      d2hxzdp2 = d2fncdx2(r6,fp6xz,rv)
      d2hyydr2 = d2fncdx2(r6,fr6yy,rv)
      d2hyydt2 = d2fncdx2(r6,ft6yy,rv)
      d2hyydp2 = d2fncdx2(r6,fp6yy,rv)
      d2hyzdr2 = d2fncdx2(r6,fr6yz,rv)
      d2hyzdt2 = d2fncdx2(r6,ft6yz,rv)
      d2hyzdp2 = d2fncdx2(r6,fp6yz,rv)
      d2hzzdr2 = d2fncdx2(r6,fr6zz,rv)
      d2hzzdt2 = d2fncdx2(r6,ft6zz,rv)
      d2hzzdp2 = d2fncdx2(r6,fp6zz,rv)
c
      delhxx = d2hxxdr2 + d2hxxdt2 + d2hxxdp2
      delhxy = d2hxydr2 + d2hxydt2 + d2hxydp2
      delhxz = d2hxzdr2 + d2hxzdt2 + d2hxzdp2
      delhyy = d2hyydr2 + d2hyydt2 + d2hyydp2
      delhyz = d2hyzdr2 + d2hyzdt2 + d2hyzdp2
      delhzz = d2hzzdr2 + d2hzzdt2 + d2hzzdp2
c
      else if (irg.ne.0.and.itg.eq.0) then
c
      do 47 ii = 1, 5
      irg0 = ir0 + ii - 1
c
      fr5xx(ii) = hxxd(irg0,0,0)
      fr5xy(ii) = hxyd(irg0,0,0)
      fr5xz(ii) = hxzd(irg0,0,0)
      fr5yy(ii) = hyyd(irg0,0,0)
      fr5yz(ii) = hyzd(irg0,0,0)
      fr5zz(ii) = hzzd(irg0,0,0)
c
   47 continue
c
      do 48 ii = 1, 6
      irg0 = ir2 + ii - 1
      itg0 = it2 + ii - 1
c
      fr6xx(ii) = hxxd(irg,itg0,0)
      ft6xx(ii) = hxxd(irg,itg0,npgyz)
      fp6xx(ii) = hxxd(irg0,0,0)
      fr6xy(ii) = hxyd(irg,itg0,0)
      ft6xy(ii) = hxyd(irg,itg0,npgyz)
      fp6xy(ii) = hxyd(irg0,0,0)
      fr6xz(ii) = hxzd(irg,itg0,0)
      ft6xz(ii) = hxzd(irg,itg0,npgyz)
      fp6xz(ii) = hxzd(irg0,0,0)
      fr6yy(ii) = hyyd(irg,itg0,0)
      ft6yy(ii) = hyyd(irg,itg0,npgyz)
      fp6yy(ii) = hyyd(irg0,0,0)
      fr6yz(ii) = hyzd(irg,itg0,0)
      ft6yz(ii) = hyzd(irg,itg0,npgyz)
      fp6yz(ii) = hyzd(irg0,0,0)
      fr6zz(ii) = hzzd(irg,itg0,0)
      ft6zz(ii) = hzzd(irg,itg0,npgyz)
      fp6zz(ii) = hzzd(irg0,0,0)
c
   48 continue
c
      dhxxdr = dfncdx(r5,fr5xx,rv)
      dhxydr = dfncdx(r5,fr5xy,rv)
      dhxzdr = dfncdx(r5,fr5xz,rv)
      dhyydr = dfncdx(r5,fr5yy,rv)
      dhyzdr = dfncdx(r5,fr5yz,rv)
      dhzzdr = dfncdx(r5,fr5zz,rv)
c
      d2hxxdr2 = d2fncdx2(th6,fr6xx,tv)
      d2hxxdt2 = d2fncdx2(th6,ft6xx,tv)
      d2hxxdp2 = d2fncdx2(r6,fp6xx,rv)
      d2hxydr2 = d2fncdx2(th6,fr6xy,tv)
      d2hxydt2 = d2fncdx2(th6,ft6xy,tv)
      d2hxydp2 = d2fncdx2(r6,fp6xy,rv)
      d2hxzdr2 = d2fncdx2(th6,fr6xz,tv)
      d2hxzdt2 = d2fncdx2(th6,ft6xz,tv)
      d2hxzdp2 = d2fncdx2(r6,fp6xz,rv)
      d2hyydr2 = d2fncdx2(th6,fr6yy,tv)
      d2hyydt2 = d2fncdx2(th6,ft6yy,tv)
      d2hyydp2 = d2fncdx2(r6,fp6yy,rv)
      d2hyzdr2 = d2fncdx2(th6,fr6yz,tv)
      d2hyzdt2 = d2fncdx2(th6,ft6yz,tv)
      d2hyzdp2 = d2fncdx2(r6,fp6yz,rv)
      d2hzzdr2 = d2fncdx2(th6,fr6zz,tv)
      d2hzzdt2 = d2fncdx2(th6,ft6zz,tv)
      d2hzzdp2 = d2fncdx2(r6,fp6zz,rv)
c
      rrgginv2 = rrgginv**2
c
      delhxx = d2hxxdr2*rrgginv2 + d2hxxdt2*rrgginv2 + d2hxxdp2
     &       + dhxxdr*rrgginv*2.0d0
      delhxy = d2hxydr2*rrgginv2 + d2hxydt2*rrgginv2 + d2hxydp2
     &       + dhxydr*rrgginv*2.0d0
      delhxz = d2hxzdr2*rrgginv2 + d2hxzdt2*rrgginv2 + d2hxzdp2
     &       + dhxzdr*rrgginv*2.0d0
      delhyy = d2hyydr2*rrgginv2 + d2hyydt2*rrgginv2 + d2hyydp2
     &       + dhyydr*rrgginv*2.0d0
      delhyz = d2hyzdr2*rrgginv2 + d2hyzdt2*rrgginv2 + d2hyzdp2
     &       + dhyzdr*rrgginv*2.0d0
      delhzz = d2hzzdr2*rrgginv2 + d2hzzdt2*rrgginv2 + d2hzzdp2
     &       + dhzzdr*rrgginv*2.0d0
c
      else
c
      do 57 ii = 1, 5
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
c
      ft5xx(ii) = hxxd(irg,itg0,ipg)
      ft5xy(ii) = hxyd(irg,itg0,ipg)
      ft5xz(ii) = hxzd(irg,itg0,ipg)
      ft5yy(ii) = hyyd(irg,itg0,ipg)
      ft5yz(ii) = hyzd(irg,itg0,ipg)
      ft5zz(ii) = hzzd(irg,itg0,ipg)
c
   57 continue
c
      do 58 ii = 1, 6
      irg0 = ir2 + ii - 1
      itg0 = it2 + ii - 1
      ipg0 = ip2 + ii - 1
c
      fr6xx(ii) = hxxd(irg0,itg,ipg)*rg(irg0)
      ft6xx(ii) = hxxd(irg,itg0,ipg)
      fp6xx(ii) = hxxd(irg,itg,ipg0)
      fr6xy(ii) = hxyd(irg0,itg,ipg)*rg(irg0)
      ft6xy(ii) = hxyd(irg,itg0,ipg)
      fp6xy(ii) = hxyd(irg,itg,ipg0)
      fr6xz(ii) = hxzd(irg0,itg,ipg)*rg(irg0)
      ft6xz(ii) = hxzd(irg,itg0,ipg)
      fp6xz(ii) = hxzd(irg,itg,ipg0)
      fr6yy(ii) = hyyd(irg0,itg,ipg)*rg(irg0)
      ft6yy(ii) = hyyd(irg,itg0,ipg)
      fp6yy(ii) = hyyd(irg,itg,ipg0)
      fr6yz(ii) = hyzd(irg0,itg,ipg)*rg(irg0)
      ft6yz(ii) = hyzd(irg,itg0,ipg)
      fp6yz(ii) = hyzd(irg,itg,ipg0)
      fr6zz(ii) = hzzd(irg0,itg,ipg)*rg(irg0)
      ft6zz(ii) = hzzd(irg,itg0,ipg)
      fp6zz(ii) = hzzd(irg,itg,ipg0)
c
   58 continue
c
      dhxxdt = dfncdx(th5,ft5xx,tv)
      dhxydt = dfncdx(th5,ft5xy,tv)
      dhxzdt = dfncdx(th5,ft5xz,tv)
      dhyydt = dfncdx(th5,ft5yy,tv)
      dhyzdt = dfncdx(th5,ft5yz,tv)
      dhzzdt = dfncdx(th5,ft5zz,tv)
c
      d2hxxdr2 = d2fncdx2(r6,fr6xx,rv)
      d2hxxdt2 = d2fncdx2(th6,ft6xx,tv)
      d2hxxdp2 = d2fncdx2(phi6,fp6xx,pv)
      d2hxydr2 = d2fncdx2(r6,fr6xy,rv)
      d2hxydt2 = d2fncdx2(th6,ft6xy,tv)
      d2hxydp2 = d2fncdx2(phi6,fp6xy,pv)
      d2hxzdr2 = d2fncdx2(r6,fr6xz,rv)
      d2hxzdt2 = d2fncdx2(th6,ft6xz,tv)
      d2hxzdp2 = d2fncdx2(phi6,fp6xz,pv)
      d2hyydr2 = d2fncdx2(r6,fr6yy,rv)
      d2hyydt2 = d2fncdx2(th6,ft6yy,tv)
      d2hyydp2 = d2fncdx2(phi6,fp6yy,pv)
      d2hyzdr2 = d2fncdx2(r6,fr6yz,rv)
      d2hyzdt2 = d2fncdx2(th6,ft6yz,tv)
      d2hyzdp2 = d2fncdx2(phi6,fp6yz,pv)
      d2hzzdr2 = d2fncdx2(r6,fr6zz,rv)
      d2hzzdt2 = d2fncdx2(th6,ft6zz,tv)
      d2hzzdp2 = d2fncdx2(phi6,fp6zz,pv)
c
      rrgginv2 = rrgginv**2
      cosecg2  = cosecg(itg)**2
c
      delhxx = d2hxxdr2*rrgginv
     &       + d2hxxdt2*rrgginv2 + dhxxdt*rrgginv2*cotang(itg) 
     &       + d2hxxdp2*rrgginv2*cosecg2
      delhxy = d2hxydr2*rrgginv
     &       + d2hxydt2*rrgginv2 + dhxydt*rrgginv2*cotang(itg) 
     &       + d2hxydp2*rrgginv2*cosecg2
      delhxz = d2hxzdr2*rrgginv
     &       + d2hxzdt2*rrgginv2 + dhxzdt*rrgginv2*cotang(itg) 
     &       + d2hxzdp2*rrgginv2*cosecg2
      delhyy = d2hyydr2*rrgginv
     &       + d2hyydt2*rrgginv2 + dhyydt*rrgginv2*cotang(itg) 
     &       + d2hyydp2*rrgginv2*cosecg2
      delhyz = d2hyzdr2*rrgginv
     &       + d2hyzdt2*rrgginv2 + dhyzdt*rrgginv2*cotang(itg) 
     &       + d2hyzdp2*rrgginv2*cosecg2
      delhzz = d2hzzdr2*rrgginv
     &       + d2hzzdt2*rrgginv2 + dhzzdt*rrgginv2*cotang(itg) 
     &       + d2hzzdp2*rrgginv2*cosecg2
c
      end if
c
      delhab(1) = delhxx
      delhab(2) = delhxy
      delhab(3) = delhxz
      delhab(4) = delhyy
      delhab(5) = delhyz
      delhab(6) = delhzz
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine dadbscalargsym(fnc,dabfnc,irg,itg,ipg,
     &                          ixysym,iyzsym,izxsym)
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension  fnc(0:nnrg,0:nntg,0:nnpg), dabfnc(1:3,1:3),
     &           r5(5), th5(5), phi5(5), grad1(3), 
     &           dfdx_r(5), dfdx_th(5), dfdx_phi(5),
     &           dfdy_r(5), dfdy_th(5), dfdy_phi(5),
     &           dfdz_r(5), dfdz_th(5), dfdz_phi(5)
c
c --- Compute second derivative of a scalar D_b D_a f,   
c     whose value is assigned on the grid points. 
c     Derivative is computed by that of Catesian coordinate for 
c --- r=0 or theta=0, and by that of spherical coordinate for elsewhere.
c
      ir0 = min0(irg-2,nrtot-4)
      it0 = itg-2
      ip0 = ipg-2
ctesttest      ir0 = min0(max0(irg-2,0),nrtot-4)
ctesttest      it0 = min0(max0(itg-2,0),ntg-4)
ctesttest      ip0 = min0(max0(ipg-2,0),npg-4)
c
c --  For x deriv.  iyzsym -> -iyzsym
c     For y deriv.  izxsym -> -izxsym
c     For z deriv.  ixysym -> -ixysym
c
      ir0symdx = -ixysym*iyzsym*izxsym
      it0symdx = -iyzsym*izxsym
      itnsymdx =  ixysym
      ip0symdx =  izxsym
      ipnsymdx = -iyzsym
      r0symdx = dble(ir0symdx)
      t0symdx = dble(it0symdx)
      tnsymdx = dble(itnsymdx)
      p0symdx = dble(ip0symdx)
      pnsymdx = dble(ipnsymdx)
c
      ir0symdy = -ixysym*iyzsym*izxsym
      it0symdy = -iyzsym*izxsym
      itnsymdy =  ixysym
      ip0symdy = -izxsym
      ipnsymdy =  iyzsym
      r0symdy = dble(ir0symdy)
      t0symdy = dble(it0symdy)
      tnsymdy = dble(itnsymdy)
      p0symdy = dble(ip0symdy)
      pnsymdy = dble(ipnsymdy)
c
      ir0symdz = -ixysym*iyzsym*izxsym
      it0symdz =  iyzsym*izxsym
      itnsymdz = -ixysym
      ip0symdz =  izxsym
      ipnsymdz =  iyzsym
      r0symdz = dble(ir0symdz)
      t0symdz = dble(it0symdz)
      tnsymdz = dble(itnsymdz)
      p0symdz = dble(ip0symdz)
      pnsymdz = dble(ipnsymdz)
c
      rv = rg(irg)
      tv = thg(itg)
      pv = phig(ipg)
      rrgginv = rginv(irg)
      cosecgb = cosecg(itg)
c ##  phig = 0 to pi/2 
c
      do 27 ii = 1, 5
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      r5(ii) = rgex(irg0)
      th5(ii) = thgex(itg0)
      phi5(ii) = phigex(ipg0)
   27 continue
c
      if (irg.eq.0) then
c
      do 28 ii = 1, 5
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      rlsw = dble((irg0-1)/nrtot)
      tlsw = dble((itg0-1)/ntg)
      plsw = dble((ipg0-1)/npg)
      rssw = dble((1-isign(1,irg0))/2)
      tssw = dble((1-isign(1,itg0))/2)
      pssw = dble((1-isign(1,ipg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      tmsw = 1.0d0 - tlsw - tssw
      pmsw = 1.0d0 - plsw - pssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      iaitg0 = idnint(tssw+tmsw)*iabs(itg0)+idnint(tlsw)*(2*ntg  -itg0)
      iaipg0 = idnint(pssw+pmsw)*iabs(ipg0)+idnint(plsw)*(2*npg  -ipg0)
c
      facrdx = rmsw + pnsymdx*rssw
      factdx = rmsw + p0symdx*rssw
      facpdx = rmsw + tnsymdx*rssw
      facrdy = rmsw + pnsymdy*rssw
      factdy = rmsw + p0symdy*rssw
      facpdy = rmsw + tnsymdy*rssw
      facrdz = rmsw + pnsymdz*rssw
      factdz = rmsw + p0symdz*rssw
      facpdz = rmsw + tnsymdz*rssw
c
      call grgrad1g(fnc,grad1,iairg0,ntg,npgxz,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = facrdx*grad1(1)
      dfdy_r(ii) = facrdy*grad1(2)
      dfdz_r(ii) = facrdz*grad1(3)
c
      call grgrad1g(fnc,grad1,iairg0,ntg,npgyz,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = factdx*grad1(1)
      dfdy_th(ii) = factdy*grad1(2)
      dfdz_th(ii) = factdz*grad1(3)
c
      call grgrad1g(fnc,grad1,iairg0,0,0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = facpdx*grad1(1)
      dfdy_phi(ii) = facpdy*grad1(2)
      dfdz_phi(ii) = facpdz*grad1(3)
c
   28 continue
c
      dabfnc(1,1) = dfncdx(r5,dfdx_r,rv)
      dabfnc(1,2) = dfncdx(r5,dfdx_th,rv)
      dabfnc(1,3) = dfncdx(r5,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx(r5,dfdy_r,rv)
      dabfnc(2,2) = dfncdx(r5,dfdy_th,rv)
      dabfnc(2,3) = dfncdx(r5,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx(r5,dfdz_r,rv)
      dabfnc(3,2) = dfncdx(r5,dfdz_th,rv)
      dabfnc(3,3) = dfncdx(r5,dfdz_phi,rv)
c
      else if (irg.ne.0.and.itg.eq.0) then
c
      do 38 ii = 1, 5
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      rlsw = dble((irg0-1)/nrtot)
      tlsw = dble((itg0-1)/ntg)
      plsw = dble((ipg0-1)/npg)
      rssw = dble((1-isign(1,irg0))/2)
      tssw = dble((1-isign(1,itg0))/2)
      pssw = dble((1-isign(1,ipg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      tmsw = 1.0d0 - tlsw - tssw
      pmsw = 1.0d0 - plsw - pssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      iaitg0 = idnint(tssw+tmsw)*iabs(itg0)+idnint(tlsw)*(2*ntg  -itg0)
      iaipg0 = idnint(pssw+pmsw)*iabs(ipg0)+idnint(plsw)*(2*npg  -ipg0)
c
      facrdx = tmsw + pnsymdx*tssw
      factdx = tmsw + p0symdx*tssw
      facpdx = rmsw + tnsymdx*rssw
      facrdy = tmsw + pnsymdy*tssw
      factdy = tmsw + p0symdy*tssw
      facpdy = rmsw + tnsymdy*rssw
      facrdz = tmsw + pnsymdz*tssw
      factdz = tmsw + p0symdz*tssw
      facpdz = rmsw + tnsymdz*rssw
c
      call grgrad1g(fnc,grad1,irg,iaitg0,npgxz,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = facrdx*grad1(1)
      dfdy_r(ii) = facrdy*grad1(2)
      dfdz_r(ii) = facrdz*grad1(3)
c
      call grgrad1g(fnc,grad1,irg,iaitg0,npgyz,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = factdx*grad1(1)
      dfdy_th(ii) = factdy*grad1(2)
      dfdz_th(ii) = factdz*grad1(3)
c
      call grgrad1g(fnc,grad1,iairg0,0,0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = facpdx*grad1(1)
      dfdy_phi(ii) = facpdy*grad1(2)
      dfdz_phi(ii) = facpdz*grad1(3)
c
   38 continue
c
      dabfnc(1,1) = dfncdx(th5,dfdx_r,tv)*rrgginv
      dabfnc(1,2) = dfncdx(th5,dfdx_th,tv)*rrgginv
      dabfnc(1,3) = dfncdx(r5,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx(th5,dfdy_r,tv)*rrgginv
      dabfnc(2,2) = dfncdx(th5,dfdy_th,tv)*rrgginv
      dabfnc(2,3) = dfncdx(r5,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx(th5,dfdz_r,tv)*rrgginv
      dabfnc(3,2) = dfncdx(th5,dfdz_th,tv)*rrgginv
      dabfnc(3,3) = dfncdx(r5,dfdz_phi,rv)
c
      else
c
      do 48 ii = 1, 5
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      rlsw = dble((irg0-1)/nrtot)
      tlsw = dble((itg0-1)/ntg)
      plsw = dble((ipg0-1)/npg)
      rssw = dble((1-isign(1,irg0))/2)
      tssw = dble((1-isign(1,itg0))/2)
      pssw = dble((1-isign(1,ipg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      tmsw = 1.0d0 - tlsw - tssw
      pmsw = 1.0d0 - plsw - pssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      iaitg0 = idnint(tssw+tmsw)*iabs(itg0)+idnint(tlsw)*(2*ntg  -itg0)
      iaipg0 = idnint(pssw+pmsw)*iabs(ipg0)+idnint(plsw)*(2*npg  -ipg0)
c
      facrdx = rmsw + r0symdx*rssw
      factdx = tmsw + t0symdx*tssw + tnsymdx*tlsw
      facpdx = pmsw + p0symdx*pssw + pnsymdx*plsw
      facrdy = rmsw + r0symdy*rssw
      factdy = tmsw + t0symdy*tssw + tnsymdy*tlsw
      facpdy = pmsw + p0symdy*pssw + pnsymdy*plsw
      facrdz = rmsw + r0symdz*rssw
      factdz = tmsw + t0symdz*tssw + tnsymdz*tlsw
      facpdz = pmsw + p0symdz*pssw + pnsymdz*plsw
c
      call grgrad1g(fnc,grad1,iairg0,itg,ipg,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = facrdx*grad1(1)
      dfdy_r(ii) = facrdy*grad1(2)
      dfdz_r(ii) = facrdz*grad1(3)
c
      call grgrad1g(fnc,grad1,irg,iaitg0,ipg,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = factdx*grad1(1)
      dfdy_th(ii) = factdy*grad1(2)
      dfdz_th(ii) = factdz*grad1(3)
c
      call grgrad1g(fnc,grad1,irg,itg,iaipg0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = facpdx*grad1(1)
      dfdy_phi(ii) = facpdy*grad1(2)
      dfdz_phi(ii) = facpdz*grad1(3)
c
   48 continue
c
      ddfdxdr = dfncdx(r5,dfdx_r,rv)
      ddfdxdt = dfncdx(th5,dfdx_th,tv)*rrgginv
      ddfdxdp = dfncdx(phi5,dfdx_phi,pv)*rrgginv*cosecgb
      ddfdydr = dfncdx(r5,dfdy_r,rv)
      ddfdydt = dfncdx(th5,dfdy_th,tv)*rrgginv
      ddfdydp = dfncdx(phi5,dfdy_phi,pv)*rrgginv*cosecgb
      ddfdzdr = dfncdx(r5,dfdz_r,rv)
      ddfdzdt = dfncdx(th5,dfdz_th,tv)*rrgginv
      ddfdzdp = dfncdx(phi5,dfdz_phi,pv)*rrgginv*cosecgb
c
      dabfnc(1,1) = ddfdxdr*sintheg(itg)*cosphig(ipg)
     &            + ddfdxdt*costheg(itg)*cosphig(ipg)  
     &            - ddfdxdp*sinphig(ipg)
      dabfnc(1,2) = ddfdxdr*sintheg(itg)*sinphig(ipg)
     &            + ddfdxdt*costheg(itg)*sinphig(ipg)
     &            + ddfdxdp*cosphig(ipg)
      dabfnc(1,3) = ddfdxdr*costheg(itg)
     &            - ddfdxdt*sintheg(itg)
      dabfnc(2,1) = ddfdydr*sintheg(itg)*cosphig(ipg)
     &            + ddfdydt*costheg(itg)*cosphig(ipg)  
     &            - ddfdydp*sinphig(ipg)
      dabfnc(2,2) = ddfdydr*sintheg(itg)*sinphig(ipg)
     &            + ddfdydt*costheg(itg)*sinphig(ipg)
     &            + ddfdydp*cosphig(ipg)
      dabfnc(2,3) = ddfdydr*costheg(itg)
     &            - ddfdydt*sintheg(itg)
      dabfnc(3,1) = ddfdzdr*sintheg(itg)*cosphig(ipg)
     &            + ddfdzdt*costheg(itg)*cosphig(ipg)  
     &            - ddfdzdp*sinphig(ipg)
      dabfnc(3,2) = ddfdzdr*sintheg(itg)*sinphig(ipg)
     &            + ddfdzdt*costheg(itg)*sinphig(ipg)
     &            + ddfdzdp*cosphig(ipg)
      dabfnc(3,3) = ddfdzdr*costheg(itg)
     &            - ddfdzdt*sintheg(itg)
c
      end if
c
ctesttest 
c      dabfnc(2,1) = dabfnc(1,2)
c      dabfnc(3,1) = dabfnc(1,3)
c      dabfnc(3,2) = dabfnc(2,3)
      dabfnc(1,3) = dabfnc(3,1)
      dabfnc(2,3) = dabfnc(3,2)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine dadbscalargsym_2(fnc,dabfnc,irg,itg,ipg,
     &                              ixysym,iyzsym,izxsym)
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension  fnc(0:nnrg,0:nntg,0:nnpg), dabfnc(1:3,1:3),
     &           r3(3), th3(3), phi3(3), grad1(3), 
     &           dfdx_r(3), dfdx_th(3), dfdx_phi(3),
     &           dfdy_r(3), dfdy_th(3), dfdy_phi(3),
     &           dfdz_r(3), dfdz_th(3), dfdz_phi(3)
c
c --- Compute second derivative of a scalar D_b D_a f,   
c     whose value is assigned on the grid points. 
c     Derivative is computed by that of Catesian coordinate for 
c --- r=0 or theta=0, and by that of spherical coordinate for elsewhere.
c
      ir0 = min0(irg-1,nrtot-2)
      it0 = itg-1
      ip0 = ipg-1
c
c --  For x deriv.  iyzsym -> -iyzsym
c     For y deriv.  izxsym -> -izxsym
c     For z deriv.  ixysym -> -ixysym
c
      ir0symdx = -ixysym*iyzsym*izxsym
      it0symdx = -iyzsym*izxsym
      itnsymdx =  ixysym
      ip0symdx =  izxsym
      ipnsymdx = -iyzsym
      r0symdx = dble(ir0symdx)
      t0symdx = dble(it0symdx)
      tnsymdx = dble(itnsymdx)
      p0symdx = dble(ip0symdx)
      pnsymdx = dble(ipnsymdx)
c
      ir0symdy = -ixysym*iyzsym*izxsym
      it0symdy = -iyzsym*izxsym
      itnsymdy =  ixysym
      ip0symdy = -izxsym
      ipnsymdy =  iyzsym
      r0symdy = dble(ir0symdy)
      t0symdy = dble(it0symdy)
      tnsymdy = dble(itnsymdy)
      p0symdy = dble(ip0symdy)
      pnsymdy = dble(ipnsymdy)
c
      ir0symdz = -ixysym*iyzsym*izxsym
      it0symdz =  iyzsym*izxsym
      itnsymdz = -ixysym
      ip0symdz =  izxsym
      ipnsymdz =  iyzsym
      r0symdz = dble(ir0symdz)
      t0symdz = dble(it0symdz)
      tnsymdz = dble(itnsymdz)
      p0symdz = dble(ip0symdz)
      pnsymdz = dble(ipnsymdz)
c
      rv = rg(irg)
      tv = thg(itg)
      pv = phig(ipg)
      rrgginv = rginv(irg)
      cosecgb = cosecg(itg)
c ##  phig = 0 to pi/2 
c
      do 27 ii = 1, 3
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      r3(ii) = rgex(irg0)
      th3(ii) = thgex(itg0)
      phi3(ii) = phigex(ipg0)
   27 continue
c
      if (irg.eq.0) then
c
      do 28 ii = 1, 3
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      rlsw = dble((irg0-1)/nrtot)
      tlsw = dble((itg0-1)/ntg)
      plsw = dble((ipg0-1)/npg)
      rssw = dble((1-isign(1,irg0))/2)
      tssw = dble((1-isign(1,itg0))/2)
      pssw = dble((1-isign(1,ipg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      tmsw = 1.0d0 - tlsw - tssw
      pmsw = 1.0d0 - plsw - pssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      iaitg0 = idnint(tssw+tmsw)*iabs(itg0)+idnint(tlsw)*(2*ntg  -itg0)
      iaipg0 = idnint(pssw+pmsw)*iabs(ipg0)+idnint(plsw)*(2*npg  -ipg0)
c
      facrdx = rmsw + pnsymdx*rssw
      factdx = rmsw + p0symdx*rssw
      facpdx = rmsw + tnsymdx*rssw
      facrdy = rmsw + pnsymdy*rssw
      factdy = rmsw + p0symdy*rssw
      facpdy = rmsw + tnsymdy*rssw
      facrdz = rmsw + pnsymdz*rssw
      factdz = rmsw + p0symdz*rssw
      facpdz = rmsw + tnsymdz*rssw
c
      call grgrad1g_2(fnc,grad1,iairg0,ntg,npgxz,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = facrdx*grad1(1)
      dfdy_r(ii) = facrdy*grad1(2)
      dfdz_r(ii) = facrdz*grad1(3)
c
      call grgrad1g_2(fnc,grad1,iairg0,ntg,npgyz,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = factdx*grad1(1)
      dfdy_th(ii) = factdy*grad1(2)
      dfdz_th(ii) = factdz*grad1(3)
c
      call grgrad1g_2(fnc,grad1,iairg0,0,0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = facpdx*grad1(1)
      dfdy_phi(ii) = facpdy*grad1(2)
      dfdz_phi(ii) = facpdz*grad1(3)
c
   28 continue
c
      dabfnc(1,1) = dfncdx2nd(r3,dfdx_r,rv)
      dabfnc(1,2) = dfncdx2nd(r3,dfdx_th,rv)
      dabfnc(1,3) = dfncdx2nd(r3,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx2nd(r3,dfdy_r,rv)
      dabfnc(2,2) = dfncdx2nd(r3,dfdy_th,rv)
      dabfnc(2,3) = dfncdx2nd(r3,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx2nd(r3,dfdz_r,rv)
      dabfnc(3,2) = dfncdx2nd(r3,dfdz_th,rv)
      dabfnc(3,3) = dfncdx2nd(r3,dfdz_phi,rv)
c
      else if (irg.ne.0.and.itg.eq.0) then
c
      do 38 ii = 1, 3
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      rlsw = dble((irg0-1)/nrtot)
      tlsw = dble((itg0-1)/ntg)
      plsw = dble((ipg0-1)/npg)
      rssw = dble((1-isign(1,irg0))/2)
      tssw = dble((1-isign(1,itg0))/2)
      pssw = dble((1-isign(1,ipg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      tmsw = 1.0d0 - tlsw - tssw
      pmsw = 1.0d0 - plsw - pssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      iaitg0 = idnint(tssw+tmsw)*iabs(itg0)+idnint(tlsw)*(2*ntg  -itg0)
      iaipg0 = idnint(pssw+pmsw)*iabs(ipg0)+idnint(plsw)*(2*npg  -ipg0)
c
      facrdx = tmsw + pnsymdx*tssw
      factdx = tmsw + p0symdx*tssw
      facpdx = rmsw + tnsymdx*rssw
      facrdy = tmsw + pnsymdy*tssw
      factdy = tmsw + p0symdy*tssw
      facpdy = rmsw + tnsymdy*rssw
      facrdz = tmsw + pnsymdz*tssw
      factdz = tmsw + p0symdz*tssw
      facpdz = rmsw + tnsymdz*rssw
c
      call grgrad1g_2(fnc,grad1,irg,iaitg0,npgxz,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = facrdx*grad1(1)
      dfdy_r(ii) = facrdy*grad1(2)
      dfdz_r(ii) = facrdz*grad1(3)
c
      call grgrad1g_2(fnc,grad1,irg,iaitg0,npgyz,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = factdx*grad1(1)
      dfdy_th(ii) = factdy*grad1(2)
      dfdz_th(ii) = factdz*grad1(3)
c
      call grgrad1g_2(fnc,grad1,iairg0,0,0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = facpdx*grad1(1)
      dfdy_phi(ii) = facpdy*grad1(2)
      dfdz_phi(ii) = facpdz*grad1(3)
c
   38 continue
c
      dabfnc(1,1) = dfncdx2nd(th3,dfdx_r,tv)*rrgginv
      dabfnc(1,2) = dfncdx2nd(th3,dfdx_th,tv)*rrgginv
      dabfnc(1,3) = dfncdx2nd(r3,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx2nd(th3,dfdy_r,tv)*rrgginv
      dabfnc(2,2) = dfncdx2nd(th3,dfdy_th,tv)*rrgginv
      dabfnc(2,3) = dfncdx2nd(r3,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx2nd(th3,dfdz_r,tv)*rrgginv
      dabfnc(3,2) = dfncdx2nd(th3,dfdz_th,tv)*rrgginv
      dabfnc(3,3) = dfncdx2nd(r3,dfdz_phi,rv)
c
      else
c
      do 48 ii = 1, 3
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      rlsw = dble((irg0-1)/nrtot)
      tlsw = dble((itg0-1)/ntg)
      plsw = dble((ipg0-1)/npg)
      rssw = dble((1-isign(1,irg0))/2)
      tssw = dble((1-isign(1,itg0))/2)
      pssw = dble((1-isign(1,ipg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      tmsw = 1.0d0 - tlsw - tssw
      pmsw = 1.0d0 - plsw - pssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      iaitg0 = idnint(tssw+tmsw)*iabs(itg0)+idnint(tlsw)*(2*ntg  -itg0)
      iaipg0 = idnint(pssw+pmsw)*iabs(ipg0)+idnint(plsw)*(2*npg  -ipg0)
c
      facrdx = rmsw + r0symdx*rssw
      factdx = tmsw + t0symdx*tssw + tnsymdx*tlsw
      facpdx = pmsw + p0symdx*pssw + pnsymdx*plsw
      facrdy = rmsw + r0symdy*rssw
      factdy = tmsw + t0symdy*tssw + tnsymdy*tlsw
      facpdy = pmsw + p0symdy*pssw + pnsymdy*plsw
      facrdz = rmsw + r0symdz*rssw
      factdz = tmsw + t0symdz*tssw + tnsymdz*tlsw
      facpdz = pmsw + p0symdz*pssw + pnsymdz*plsw
c
      call grgrad1g_2(fnc,grad1,iairg0,itg,ipg,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = facrdx*grad1(1)
      dfdy_r(ii) = facrdy*grad1(2)
      dfdz_r(ii) = facrdz*grad1(3)
c
      call grgrad1g_2(fnc,grad1,irg,iaitg0,ipg,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = factdx*grad1(1)
      dfdy_th(ii) = factdy*grad1(2)
      dfdz_th(ii) = factdz*grad1(3)
c
      call grgrad1g_2(fnc,grad1,irg,itg,iaipg0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = facpdx*grad1(1)
      dfdy_phi(ii) = facpdy*grad1(2)
      dfdz_phi(ii) = facpdz*grad1(3)
c
   48 continue
c
      ddfdxdr = dfncdx2nd(r3,dfdx_r,rv)
      ddfdxdt = dfncdx2nd(th3,dfdx_th,tv)*rrgginv
      ddfdxdp = dfncdx2nd(phi3,dfdx_phi,pv)*rrgginv*cosecgb
      ddfdydr = dfncdx2nd(r3,dfdy_r,rv)
      ddfdydt = dfncdx2nd(th3,dfdy_th,tv)*rrgginv
      ddfdydp = dfncdx2nd(phi3,dfdy_phi,pv)*rrgginv*cosecgb
      ddfdzdr = dfncdx2nd(r3,dfdz_r,rv)
      ddfdzdt = dfncdx2nd(th3,dfdz_th,tv)*rrgginv
      ddfdzdp = dfncdx2nd(phi3,dfdz_phi,pv)*rrgginv*cosecgb
c
      dabfnc(1,1) = ddfdxdr*sintheg(itg)*cosphig(ipg)
     &            + ddfdxdt*costheg(itg)*cosphig(ipg)  
     &            - ddfdxdp*sinphig(ipg)
      dabfnc(1,2) = ddfdxdr*sintheg(itg)*sinphig(ipg)
     &            + ddfdxdt*costheg(itg)*sinphig(ipg)
     &            + ddfdxdp*cosphig(ipg)
      dabfnc(1,3) = ddfdxdr*costheg(itg)
     &            - ddfdxdt*sintheg(itg)
      dabfnc(2,1) = ddfdydr*sintheg(itg)*cosphig(ipg)
     &            + ddfdydt*costheg(itg)*cosphig(ipg)  
     &            - ddfdydp*sinphig(ipg)
      dabfnc(2,2) = ddfdydr*sintheg(itg)*sinphig(ipg)
     &            + ddfdydt*costheg(itg)*sinphig(ipg)
     &            + ddfdydp*cosphig(ipg)
      dabfnc(2,3) = ddfdydr*costheg(itg)
     &            - ddfdydt*sintheg(itg)
      dabfnc(3,1) = ddfdzdr*sintheg(itg)*cosphig(ipg)
     &            + ddfdzdt*costheg(itg)*cosphig(ipg)  
     &            - ddfdzdp*sinphig(ipg)
      dabfnc(3,2) = ddfdzdr*sintheg(itg)*sinphig(ipg)
     &            + ddfdzdt*costheg(itg)*sinphig(ipg)
     &            + ddfdzdp*cosphig(ipg)
      dabfnc(3,3) = ddfdzdr*costheg(itg)
     &            - ddfdzdt*sintheg(itg)
c
      end if
c
ctesttest 
c      dabfnc(2,1) = dabfnc(1,2)
c      dabfnc(3,1) = dabfnc(1,3)
c      dabfnc(3,2) = dabfnc(2,3)
      dabfnc(1,3) = dabfnc(3,1)
      dabfnc(2,3) = dabfnc(3,2)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine dadbscalarg(fnc,dabfnc,irg,itg,ipg,
     &                       ixysym,iyzsym,izxsym)
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      dimension  fnc(0:nnrg,0:nntg,0:nnpg), dabfnc(1:3,1:3),
     &           r5(5), th5(5), phi5(5), grad1(3), 
     &           dfdx_r(5), dfdx_th(5), dfdx_phi(5),
     &           dfdy_r(5), dfdy_th(5), dfdy_phi(5),
     &           dfdz_r(5), dfdz_th(5), dfdz_phi(5)
c
c --- Compute second derivative of a scalar D_b D_a f,   
c     whose value is assigned on the grid points. 
c     Derivative is computed by that of Catesian coordinate for 
c --- r=0 or theta=0, and by that of spherical coordinate for elsewhere.
c
      ir0 = min0(max0(irg-2,0),nrtot-4)
      it0 = min0(max0(itg-2,0),ntg-4)
      ip0 = min0(max0(ipg-2,0),npg-4)
c
      rv = rg(irg)
      tv = thg(itg)
      pv = phig(ipg)
      rrgginv = rginv(irg)
      cosecgb = cosecg(itg)
c ##  phig = 0 to pi/2 
c
      do 27 ii = 1, 5
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      r5(ii) = rg(irg0)
      th5(ii) = thg(itg0)
      phi5(ii) = phig(ipg0)
   27 continue
c
      if (irg.eq.0) then
c
      do 28 ii = 1, 5
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
c
      call grgrad1g(fnc,grad1,irg0,ntg,npgxz,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = grad1(1)
      dfdy_r(ii) = grad1(2)
      dfdz_r(ii) = grad1(3)
c
      call grgrad1g(fnc,grad1,irg0,ntg,npgyz,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = grad1(1)
      dfdy_th(ii) = grad1(2)
      dfdz_th(ii) = grad1(3)
c
      call grgrad1g(fnc,grad1,irg0,0,0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = grad1(1)
      dfdy_phi(ii) = grad1(2)
      dfdz_phi(ii) = grad1(3)
c
   28 continue
c
      dabfnc(1,1) = dfncdx(r5,dfdx_r,rv)
      dabfnc(1,2) = dfncdx(r5,dfdx_th,rv)
      dabfnc(1,3) = dfncdx(r5,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx(r5,dfdy_r,rv)
      dabfnc(2,2) = dfncdx(r5,dfdy_th,rv)
      dabfnc(2,3) = dfncdx(r5,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx(r5,dfdz_r,rv)
      dabfnc(3,2) = dfncdx(r5,dfdz_th,rv)
      dabfnc(3,3) = dfncdx(r5,dfdz_phi,rv)
c
      else if (irg.ne.0.and.itg.eq.0) then
c
      do 38 ii = 1, 5
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
c
      call grgrad1g(fnc,grad1,irg,itg0,npgxz,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = grad1(1)
      dfdy_r(ii) = grad1(2)
      dfdz_r(ii) = grad1(3)
c
      call grgrad1g(fnc,grad1,irg,itg0,npgyz,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = grad1(1)
      dfdy_th(ii) = grad1(2)
      dfdz_th(ii) = grad1(3)
c
      call grgrad1g(fnc,grad1,irg0,0,0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = grad1(1)
      dfdy_phi(ii) = grad1(2)
      dfdz_phi(ii) = grad1(3)
c
   38 continue
c
      dabfnc(1,1) = dfncdx(th5,dfdx_r,tv)*rrgginv
      dabfnc(1,2) = dfncdx(th5,dfdx_th,tv)*rrgginv
      dabfnc(1,3) = dfncdx(r5,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx(th5,dfdy_r,tv)*rrgginv
      dabfnc(2,2) = dfncdx(th5,dfdy_th,tv)*rrgginv
      dabfnc(2,3) = dfncdx(r5,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx(th5,dfdz_r,tv)*rrgginv
      dabfnc(3,2) = dfncdx(th5,dfdz_th,tv)*rrgginv
      dabfnc(3,3) = dfncdx(r5,dfdz_phi,rv)
c
      else
c
      do 48 ii = 1, 5
c
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
c
      call grgrad1g(fnc,grad1,irg0,itg,ipg,ixysym,iyzsym,izxsym)
      dfdx_r(ii) = grad1(1)
      dfdy_r(ii) = grad1(2)
      dfdz_r(ii) = grad1(3)
c
      call grgrad1g(fnc,grad1,irg,itg0,ipg,ixysym,iyzsym,izxsym)
      dfdx_th(ii) = grad1(1)
      dfdy_th(ii) = grad1(2)
      dfdz_th(ii) = grad1(3)
c
      call grgrad1g(fnc,grad1,irg,itg,ipg0,ixysym,iyzsym,izxsym)
      dfdx_phi(ii) = grad1(1)
      dfdy_phi(ii) = grad1(2)
      dfdz_phi(ii) = grad1(3)
c
   48 continue
c
      ddfdxdr = dfncdx(r5,dfdx_r,rv)
      ddfdxdt = dfncdx(th5,dfdx_th,tv)*rrgginv
      ddfdxdp = dfncdx(phi5,dfdx_phi,pv)*rrgginv*cosecgb
      ddfdydr = dfncdx(r5,dfdy_r,rv)
      ddfdydt = dfncdx(th5,dfdy_th,tv)*rrgginv
      ddfdydp = dfncdx(phi5,dfdy_phi,pv)*rrgginv*cosecgb
      ddfdzdr = dfncdx(r5,dfdz_r,rv)
      ddfdzdt = dfncdx(th5,dfdz_th,tv)*rrgginv
      ddfdzdp = dfncdx(phi5,dfdz_phi,pv)*rrgginv*cosecgb
c
      dabfnc(1,1) = ddfdxdr*sintheg(itg)*cosphig(ipg)
     &            + ddfdxdt*costheg(itg)*cosphig(ipg)  
     &            - ddfdxdp*sinphig(ipg)
      dabfnc(1,2) = ddfdxdr*sintheg(itg)*sinphig(ipg)
     &            + ddfdxdt*costheg(itg)*sinphig(ipg)
     &            + ddfdxdp*cosphig(ipg)
      dabfnc(1,3) = ddfdxdr*costheg(itg)
     &            - ddfdxdt*sintheg(itg)
      dabfnc(2,1) = ddfdydr*sintheg(itg)*cosphig(ipg)
     &            + ddfdydt*costheg(itg)*cosphig(ipg)  
     &            - ddfdydp*sinphig(ipg)
      dabfnc(2,2) = ddfdydr*sintheg(itg)*sinphig(ipg)
     &            + ddfdydt*costheg(itg)*sinphig(ipg)
     &            + ddfdydp*cosphig(ipg)
      dabfnc(2,3) = ddfdydr*costheg(itg)
     &            - ddfdydt*sintheg(itg)
      dabfnc(3,1) = ddfdzdr*sintheg(itg)*cosphig(ipg)
     &            + ddfdzdt*costheg(itg)*cosphig(ipg)  
     &            - ddfdzdp*sinphig(ipg)
      dabfnc(3,2) = ddfdzdr*sintheg(itg)*sinphig(ipg)
     &            + ddfdzdt*costheg(itg)*sinphig(ipg)
     &            + ddfdzdp*cosphig(ipg)
      dabfnc(3,3) = ddfdzdr*costheg(itg)
     &            - ddfdzdt*sintheg(itg)
c
      end if
c
ctesttest 
c      dabfnc(2,1) = dabfnc(1,2)
c      dabfnc(3,1) = dabfnc(1,3)
c      dabfnc(3,2) = dabfnc(2,3)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grderiv1r(fnc,deriv,irg,itg,ipg,ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg), fr5(5), r5(5)
c
c --- Compute r-derivative of a function.  
c --- The derivative is evaluated on grid points. 
c
      ir0 = min0(irg-2,nrtot-4)
      ir0sym = ixysym*iyzsym*izxsym
      r0sym = dble(ir0sym)
c
      rv = rg(irg)
c
      do 8 ii = 1, 5
      irg0 = ir0 + ii - 1
      r5(ii) = rgex(irg0)
      rlsw = dble((irg0-1)/nrtot)
      rssw = dble((1-isign(1,irg0))/2)
      rmsw = 1.0d0 - rlsw - rssw
      iairg0 = idnint(rssw+rmsw)*iabs(irg0)+idnint(rlsw)*(2*nrtot-irg0)
      facr = rmsw + r0sym*rssw
      fr5(ii) = facr*fnc(iairg0,itg,ipg)
    8 continue
c
      deriv = dfncdx(r5,fr5,rv)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grderiv1phi(fnc,deriv,irg,itg,ipg,ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg), fp5(5), p5(5)
c
c --- Compute phi-derivative of a function.  
c --- The derivative is evaluated on grid points. 
c
      ip0 = ipg-2
      ip0sym = izxsym
      ipnsym = iyzsym
      p0sym = dble(ip0sym)
      pnsym = dble(ipnsym)
      pv = phig(ipg)
c
      do 8 ii = 1, 5
      ipg0 = ip0 + ii - 1
      p5(ii) = phigex(ipg0)
      iplsw = (ipg0-1)/npg
      ipssw = (1-isign(1,ipg0))/2
      ipmsw = 1 - iplsw - ipssw
      iaipg0 = (ipssw + ipmsw)*iabs(ipg0) + iplsw*(2*npg  -ipg0)
      plsw = dble(iplsw)
      pssw = dble(ipssw)
      pmsw = dble(ipmsw)
      facp = pmsw + p0sym*pssw + pnsym*plsw
      fp5(ii) = facp*fnc(irg,itg,iaipg0)
    8 continue
c
      deriv = dfncdx(p5,fp5,pv)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grderiv2phi(fnc,deriv,irg,itg,ipg,ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg), fp5(5), p5(5)
c
c --- Compute phi-derivative of a function.  
c --- The derivative is evaluated on grid points. 
c
      ip0 = ipg-2
      ip0sym = izxsym
      ipnsym = iyzsym
      p0sym = dble(ip0sym)
      pnsym = dble(ipnsym)
      pv = phig(ipg)
c
      do 8 ii = 1, 5
      ipg0 = ip0 + ii - 1
      p5(ii) = phigex(ipg0)
      iplsw = (ipg0-1)/npg
      ipssw = (1-isign(1,ipg0))/2
      ipmsw = 1 - iplsw - ipssw
      iaipg0 = (ipssw + ipmsw)*iabs(ipg0) + iplsw*(2*npg  -ipg0)
      plsw = dble(iplsw)
      pssw = dble(ipssw)
      pmsw = dble(ipmsw)
      facp = pmsw + p0sym*pssw + pnsym*plsw
      fp5(ii) = facp*fnc(irg,itg,iaipg0)
    8 continue
c
      deriv = d2fdx2_3rd(p5,fp5,pv)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine excurve(chgra)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / cdbvd / cdbvxd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 cdbvyd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 cdbvzd(0:nnrg,0:nntg,0:nnpg,1:3)
      common / cdivb / cdivbv(0:nnrg,0:nntg,0:nnpg)
      common / pdbvd / pdbvxd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 pdbvyd(0:nnrg,0:nntg,0:nnpg,1:3), 
     &                 pdbvzd(0:nnrg,0:nntg,0:nnpg,1:3)
      common / cliep / elpxx(0:nnrg,0:nntg,0:nnpg),
     &                 elpxy(0:nnrg,0:nntg,0:nnpg),
     &                 elpxz(0:nnrg,0:nntg,0:nnpg),
     &                 elpyy(0:nnrg,0:nntg,0:nnpg),
     &                 elpyz(0:nnrg,0:nntg,0:nnpg),
     &                 elpzz(0:nnrg,0:nntg,0:nnpg)
      common / liebe / rlbxx(0:nnrg,0:nntg,0:nnpg),
     &                 rlbxy(0:nnrg,0:nntg,0:nnpg),
     &                 rlbxz(0:nnrg,0:nntg,0:nnpg),
     &                 rlbyy(0:nnrg,0:nntg,0:nnpg),
     &                 rlbyz(0:nnrg,0:nntg,0:nnpg),
     &                 rlbzz(0:nnrg,0:nntg,0:nnpg)
      common / calcp /  ome, ber, radi, dis
      common / cutsw / cutfac
c
      dimension dbvxu(0:nnrg,0:nntg,0:nnpg,1:3), 
     &          dbvyu(0:nnrg,0:nntg,0:nnpg,1:3), 
     &          dbvzu(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension gamu(3,3)
c
      character*1 chgra
c
c --- Compute extringic curvature.  
c --- Whose value is assigned on the grid points. 
c
ctesttesttest
      info = 0
ctesttesttest
c
      fa23 = 2.0d0/3.0d0
c
      call grgrad4(bvxd,pdbvxd,1,1,-1)
      call grgrad4(bvyd,pdbvyd,1,-1,1)
      call grgrad4(bvzd,pdbvzd,-1,-1,-1)
c
      call grgrad4(bvxu,dbvxu,1,1,-1)
      call grgrad4(bvyu,dbvyu,1,-1,1)
      call grgrad4(bvzu,dbvzu,-1,-1,-1)
c
      do 4 ipg = 0, npg
      do 4 itg = 0, ntg
      do 4 irg = 0, nrtot
c
      cutoff = 1.0d0
      if (chgra.eq.'c'.or.chgra.eq.'C'.or.chgra.eq.'W') then
      if (rg(irg).gt.cutfac*pi/ome) cutoff = 0.0d0
      end if
c
      bvxha = bvxd(irg,itg,ipg)
      bvyha = bvyd(irg,itg,ipg)
      bvzha = bvzd(irg,itg,ipg)
      ainvh = 0.5d0/alph(irg,itg,ipg)
c 
      pdbvxdx = dbvxu(irg,itg,ipg,1)
      pdbvxdy = dbvxu(irg,itg,ipg,2)
      pdbvxdz = dbvxu(irg,itg,ipg,3)
      pdbvydx = dbvyu(irg,itg,ipg,1)
      pdbvydy = dbvyu(irg,itg,ipg,2)
      pdbvydz = dbvyu(irg,itg,ipg,3)
      pdbvzdx = dbvzu(irg,itg,ipg,1)
      pdbvzdy = dbvzu(irg,itg,ipg,2)
      pdbvzdz = dbvzu(irg,itg,ipg,3)
c
      cdbvxd(irg,itg,ipg,1) = pdbvxd(irg,itg,ipg,1)
     &                      - cri(irg,itg,ipg,1,1)*bvxha
     &                      - cri(irg,itg,ipg,2,1)*bvyha
     &                      - cri(irg,itg,ipg,3,1)*bvzha
      cdbvyd(irg,itg,ipg,1) = pdbvyd(irg,itg,ipg,1)
     &                      - cri(irg,itg,ipg,1,2)*bvxha
     &                      - cri(irg,itg,ipg,2,2)*bvyha
     &                      - cri(irg,itg,ipg,3,2)*bvzha
      cdbvzd(irg,itg,ipg,1) = pdbvzd(irg,itg,ipg,1)
     &                      - cri(irg,itg,ipg,1,3)*bvxha
     &                      - cri(irg,itg,ipg,2,3)*bvyha
     &                      - cri(irg,itg,ipg,3,3)*bvzha
c
      cdbvxd(irg,itg,ipg,2) = pdbvxd(irg,itg,ipg,2)
     &                      - cri(irg,itg,ipg,1,2)*bvxha
     &                      - cri(irg,itg,ipg,2,2)*bvyha
     &                      - cri(irg,itg,ipg,3,2)*bvzha
      cdbvyd(irg,itg,ipg,2) = pdbvyd(irg,itg,ipg,2)
     &                      - cri(irg,itg,ipg,1,4)*bvxha
     &                      - cri(irg,itg,ipg,2,4)*bvyha
     &                      - cri(irg,itg,ipg,3,4)*bvzha
      cdbvzd(irg,itg,ipg,2) = pdbvzd(irg,itg,ipg,2)
     &                      - cri(irg,itg,ipg,1,5)*bvxha
     &                      - cri(irg,itg,ipg,2,5)*bvyha
     &                      - cri(irg,itg,ipg,3,5)*bvzha
c
      cdbvxd(irg,itg,ipg,3) = pdbvxd(irg,itg,ipg,3)
     &                      - cri(irg,itg,ipg,1,3)*bvxha
     &                      - cri(irg,itg,ipg,2,3)*bvyha
     &                      - cri(irg,itg,ipg,3,3)*bvzha
      cdbvyd(irg,itg,ipg,3) = pdbvyd(irg,itg,ipg,3)
     &                      - cri(irg,itg,ipg,1,5)*bvxha
     &                      - cri(irg,itg,ipg,2,5)*bvyha
     &                      - cri(irg,itg,ipg,3,5)*bvzha
      cdbvzd(irg,itg,ipg,3) = pdbvzd(irg,itg,ipg,3)
     &                      - cri(irg,itg,ipg,1,6)*bvxha
     &                      - cri(irg,itg,ipg,2,6)*bvyha
     &                      - cri(irg,itg,ipg,3,6)*bvzha
c
      dbvxdx = cdbvxd(irg,itg,ipg,1)
      dbvydx = cdbvyd(irg,itg,ipg,1)
      dbvzdx = cdbvzd(irg,itg,ipg,1)
c
      dbvxdy = cdbvxd(irg,itg,ipg,2)
      dbvydy = cdbvyd(irg,itg,ipg,2)
      dbvzdy = cdbvzd(irg,itg,ipg,2)
c
      dbvxdz = cdbvxd(irg,itg,ipg,3)
      dbvydz = cdbvyd(irg,itg,ipg,3)
      dbvzdz = cdbvzd(irg,itg,ipg,3)
c
      gmxxd = hxxd(irg,itg,ipg) + 1.0d0
      gmxyd = hxyd(irg,itg,ipg)
      gmxzd = hxzd(irg,itg,ipg)
      gmyyd = hyyd(irg,itg,ipg) + 1.0d0
      gmyzd = hyzd(irg,itg,ipg)
      gmzzd = hzzd(irg,itg,ipg) + 1.0d0
      gmyxd = gmxyd
      gmzxd = gmxzd
      gmzyd = gmyzd
      gmxxu = hxxu(irg,itg,ipg) + 1.0d0
      gmxyu = hxyu(irg,itg,ipg)
      gmxzu = hxzu(irg,itg,ipg)
      gmyyu = hyyu(irg,itg,ipg) + 1.0d0
      gmyzu = hyzu(irg,itg,ipg)
      gmzzu = hzzu(irg,itg,ipg) + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
cccp      cdivbv(irg,itg,ipg) = gmxxu*dbvxdx + gmxyu*dbvydx + gmxzu*dbvzdx
cccp     &                    + gmyxu*dbvxdy + gmyyu*dbvydy + gmyzu*dbvzdy
cccp     &                    + gmzxu*dbvxdz + gmzyu*dbvydz + gmzzu*dbvzdz
      cdivbv(irg,itg,ipg) = pdbvxdx + pdbvydy + pdbvzdz
      diver = fa23*cdivbv(irg,itg,ipg)
c
c --  For rotating shift
c      
      oelpxx = 0.0d0
      oelpxy = 0.0d0
      oelpxz = 0.0d0
      oelpyy = 0.0d0
      oelpyz = 0.0d0
      oelpzz = 0.0d0
      if (chgra.eq.'h'.or.chgra.eq.'c'.or.chgra.eq.'C'
     &.or.chgra.eq.'H'.or.chgra.eq.'W') then
      oelpxx = ainvh*ome*elpxx(irg,itg,ipg)*cutoff
      oelpxy = ainvh*ome*elpxy(irg,itg,ipg)*cutoff
      oelpxz = ainvh*ome*elpxz(irg,itg,ipg)*cutoff
      oelpyy = ainvh*ome*elpyy(irg,itg,ipg)*cutoff
      oelpyz = ainvh*ome*elpyz(irg,itg,ipg)*cutoff
      oelpzz = ainvh*ome*elpzz(irg,itg,ipg)*cutoff
      end if
c
      rkij(irg,itg,ipg,1,1) = ainvh*(2.0d0*dbvxdx-gmxxd*diver) +oelpxx
      rkij(irg,itg,ipg,2,2) = ainvh*(2.0d0*dbvydy-gmyyd*diver) +oelpyy
      rkij(irg,itg,ipg,3,3) = ainvh*(2.0d0*dbvzdz-gmzzd*diver) +oelpzz
      rkij(irg,itg,ipg,1,2) = ainvh*(dbvydx+dbvxdy-gmxyd*diver)+oelpxy
      rkij(irg,itg,ipg,1,3) = ainvh*(dbvzdx+dbvxdz-gmxzd*diver)+oelpxz
      rkij(irg,itg,ipg,2,3) = ainvh*(dbvzdy+dbvydz-gmyzd*diver)+oelpyz
      rkij(irg,itg,ipg,2,1) = rkij(irg,itg,ipg,1,2)
      rkij(irg,itg,ipg,3,1) = rkij(irg,itg,ipg,1,3)
      rkij(irg,itg,ipg,3,2) = rkij(irg,itg,ipg,2,3)
c
      gamu(1,1) = gmxxu 
      gamu(1,2) = gmxyu 
      gamu(1,3) = gmxzu 
      gamu(2,1) = gmyxu 
      gamu(2,2) = gmyyu 
      gamu(2,3) = gmyzu 
      gamu(3,1) = gmzxu 
      gamu(3,2) = gmzyu 
      gamu(3,3) = gmzzu
c 
      rkijkij(irg,itg,ipg) = 0.0d0
      do 8 id = 1, 3
      do 8 ic = 1, 3
      do 8 ib = 1, 3
      do 8 ia = 1, 3
      rkijkij(irg,itg,ipg) = rkijkij(irg,itg,ipg)
     &       + gamu(ia,ic)*gamu(ib,id)
     &        *rkij(irg,itg,ipg,ia,ib)*rkij(irg,itg,ipg,ic,id)
    8 continue
c
      if (rkijkij(irg,itg,ipg).ne.0.) info = 1
c
c --  Lie_beta tgamma
c
      rlbxx(irg,itg,ipg) = 2.0d0*dbvxdx
      rlbxy(irg,itg,ipg) = dbvydx + dbvxdy
      rlbxz(irg,itg,ipg) = dbvzdx + dbvxdz
      rlbyy(irg,itg,ipg) = 2.0d0*dbvydy
      rlbyz(irg,itg,ipg) = dbvzdy + dbvydz
      rlbzz(irg,itg,ipg) = 2.0d0*dbvzdz
c
 4    continue
      if (info.ne.1) write(6,*) ' ### Warning K_ij = 0 *** '
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine liegmab
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / cliep / elpxx(0:nnrg,0:nntg,0:nnpg),
     &                 elpxy(0:nnrg,0:nntg,0:nnpg),
     &                 elpxz(0:nnrg,0:nntg,0:nnpg),
     &                 elpyy(0:nnrg,0:nntg,0:nnpg),
     &                 elpyz(0:nnrg,0:nntg,0:nnpg),
     &                 elpzz(0:nnrg,0:nntg,0:nnpg)
      common / lieph / rlpxx(0:nnrg,0:nntg,0:nnpg),
     &                 rlpxy(0:nnrg,0:nntg,0:nnpg),
     &                 rlpxz(0:nnrg,0:nntg,0:nnpg),
     &                 rlpyy(0:nnrg,0:nntg,0:nnpg),
     &                 rlpyz(0:nnrg,0:nntg,0:nnpg),
     &                 rlpzz(0:nnrg,0:nntg,0:nnpg)
      common / dvphi / dphiu(3,3)
c
c --- Compute conformal invariant derivative of tgamma w.r.t. phi. 
c
      fa13 = 1.0d0/3.0d0
c
      do 4 ipg = 0, npg
      do 4 itg = 0, ntg
      do 4 irg = 0, nrtot
c
      gmxxd = hxxd(irg,itg,ipg) + 1.0d0
      gmxyd = hxyd(irg,itg,ipg)
      gmxzd = hxzd(irg,itg,ipg)
      gmyyd = hyyd(irg,itg,ipg) + 1.0d0
      gmyzd = hyzd(irg,itg,ipg)
      gmzzd = hzzd(irg,itg,ipg) + 1.0d0
      gmyxd = gmxyd
      gmzxd = gmxzd
      gmzyd = gmyzd
      gmxxu = hxxu(irg,itg,ipg) + 1.0d0
      gmxyu = hxyu(irg,itg,ipg)
      gmxzu = hxzu(irg,itg,ipg)
      gmyyu = hyyu(irg,itg,ipg) + 1.0d0
      gmyzu = hyzu(irg,itg,ipg)
      gmzzu = hzzu(irg,itg,ipg) + 1.0d0
      gmyxu = gmxyu
      gmzxu = gmxzu
      gmzyu = gmyzu
c
      call grderiv1phi(hxxd,dhxxdp,irg,itg,ipg,1,1,1)
      call grderiv1phi(hxyd,dhxydp,irg,itg,ipg,1,-1,-1)
      call grderiv1phi(hxzd,dhxzdp,irg,itg,ipg,-1,-1,1)
      call grderiv1phi(hyyd,dhyydp,irg,itg,ipg,1,1,1)
      call grderiv1phi(hyzd,dhyzdp,irg,itg,ipg,-1,1,-1)
      call grderiv1phi(hzzd,dhzzdp,irg,itg,ipg,1,1,1)
c
      rlpxx(irg,itg,ipg) = dhxxdp + gmxyd*dphiu(2,1) + gmyxd*dphiu(2,1)
      rlpxy(irg,itg,ipg) = dhxydp + gmxxd*dphiu(1,2) + gmyyd*dphiu(2,1)
      rlpxz(irg,itg,ipg) = dhxzdp
      rlpyy(irg,itg,ipg) = dhyydp + gmyxd*dphiu(1,2) + gmxyd*dphiu(1,2)
      rlpyz(irg,itg,ipg) = dhyzdp
      rlpzz(irg,itg,ipg) = dhzzdp
c
      dhxxdp = rlpxx(irg,itg,ipg)
      dhxydp = rlpxy(irg,itg,ipg)
      dhxzdp = rlpxz(irg,itg,ipg)
      dhyydp = rlpyy(irg,itg,ipg)
      dhyzdp = rlpyz(irg,itg,ipg)
      dhzzdp = rlpzz(irg,itg,ipg)
      dhyxdp = dhxydp
      dhzxdp = dhxzdp
      dhzydp = dhyzdp

      trlie = gmxxu*dhxxdp + gmxyu*dhxydp + gmxzu*dhxzdp
     &      + gmyxu*dhyxdp + gmyyu*dhyydp + gmyzu*dhyzdp
     &      + gmzxu*dhzxdp + gmzyu*dhzydp + gmzzu*dhzzdp
c
      elpxx(irg,itg,ipg) = dhxxdp - fa13*gmxxd*trlie
      elpxy(irg,itg,ipg) = dhxydp - fa13*gmxyd*trlie
      elpxz(irg,itg,ipg) = dhxzdp - fa13*gmxzd*trlie
      elpyy(irg,itg,ipg) = dhyydp - fa13*gmyyd*trlie
      elpyz(irg,itg,ipg) = dhyzdp - fa13*gmyzd*trlie
      elpzz(irg,itg,ipg) = dhzzdp - fa13*gmzzd*trlie
c
    4 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grgrad(fnc,dfdx,dfdy,dfdz,irg,itg,ipg,
     &                  ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg), 
     &          fr5(5), ft5(5), fp5(5), r5(5), th5(5), phi5(5)
c
c --- Compute the gradient of a function.  
c --- The gradient is evaluated on grid points. 
c
      ir0 = min0(irg-2,nrtot-4)
      it0 = itg-2
      ip0 = ipg-2
ctesttest      ir0 = min0(max0(irg-2,0),nrtot-4)
ctesttest      it0 = min0(max0(itg-2,0),ntg-4)
ctesttest      ip0 = min0(max0(ipg-2,0),npg-4)
c
      ir0sym = ixysym*iyzsym*izxsym
      it0sym = iyzsym*izxsym
      itnsym = ixysym
      ip0sym = izxsym
      ipnsym = iyzsym
      r0sym = dble(ir0sym)
      t0sym = dble(it0sym)
      tnsym = dble(itnsym)
      p0sym = dble(ip0sym)
      pnsym = dble(ipnsym)
c
      rv = rg(irg)
      tv = thg(itg)
      pv = phig(ipg)
      rrgginv = rginv(irg)
c
      do 8 ii = 1, 5
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      r5(ii) = rgex(irg0)
      th5(ii) = thgex(itg0)
      phi5(ii) = phigex(ipg0)
      irlsw = (irg0-1)/nrtot
      itlsw = (itg0-1)/ntg
      iplsw = (ipg0-1)/npg
      irssw = (1-isign(1,irg0))/2
      itssw = (1-isign(1,itg0))/2
      ipssw = (1-isign(1,ipg0))/2
      irmsw = 1 - irlsw - irssw
      itmsw = 1 - itlsw - itssw
      ipmsw = 1 - iplsw - ipssw
      iairg0 = (irssw + irmsw)*iabs(irg0) + irlsw*(2*nrtot-irg0)
      iaitg0 = (itssw + itmsw)*iabs(itg0) + itlsw*(2*ntg  -itg0)
      iaipg0 = (ipssw + ipmsw)*iabs(ipg0) + iplsw*(2*npg  -ipg0)
      rlsw = dble(irlsw)
      tlsw = dble(itlsw)
      plsw = dble(iplsw)
      rssw = dble(irssw)
      tssw = dble(itssw)
      pssw = dble(ipssw)
      rmsw = dble(irmsw)
      tmsw = dble(itmsw)
      pmsw = dble(ipmsw)
c
      if (irg.eq.0) then
      facr = rmsw + pnsym*rssw
      fact = rmsw + p0sym*rssw
      facp = rmsw + tnsym*rssw
      fr5(ii) = facr*fnc(iairg0,ntg,npgxz)
      ft5(ii) = fact*fnc(iairg0,ntg,npgyz)
      fp5(ii) = facp*fnc(iairg0,0,0)
      else if (irg.ne.0.and.itg.eq.0) then
      facr = tmsw + pnsym*tssw
      fact = tmsw + p0sym*tssw
      facp = rmsw + tnsym*rssw
      fr5(ii) = facr*fnc(irg,iaitg0,npgxz)
      ft5(ii) = fact*fnc(irg,iaitg0,npgyz)
      fp5(ii) = facp*fnc(iairg0,0,0)
      else
      facr = rmsw + r0sym*rssw
      fact = tmsw + t0sym*tssw + tnsym*tlsw
      facp = pmsw + p0sym*pssw + pnsym*plsw
      fr5(ii) = facr*fnc(iairg0,itg,ipg)
      ft5(ii) = fact*fnc(irg,iaitg0,ipg)
      fp5(ii) = facp*fnc(irg,itg,iaipg0)
      end if
cc      if (irg.eq.1.and.itg.eq.20.and.ipg.eq.20) then
cc      write(6,22) r5(ii),th5(ii),phi5(ii),fr5(ii),ft5(ii),fp5(ii)
cc      write(6,*) iairg0,iaitg0,iaipg0
cc      write(6,*) tssw,tmsw,tlsw,pssw,pmsw,plsw
cc      end if
    8 continue
cc 22   format(1p,6e12.4)
cc      if (irg.eq.1.and.itg.eq.20.and.ipg.eq.20) stop
c
c --- To cartesian component.  
c
      if (irg.eq.0) then
      dfdx = dfncdx(r5,fr5,rv)
      dfdy = dfncdx(r5,ft5,rv) 
      dfdz = dfncdx(r5,fp5,rv)
      else if (irg.ne.0.and.itg.eq.0) then
      dfdx = dfncdx(th5,fr5,tv)*rrgginv
      dfdy = dfncdx(th5,ft5,tv)*rrgginv
      dfdz = dfncdx(r5,fp5,rv)
      else
      gr1 = dfncdx(r5,fr5,rv)
      gr2 = dfncdx(th5,ft5,tv)*rrgginv
      gr3 = dfncdx(phi5,fp5,pv)*rrgginv*cosecg(itg)
      dfdx = gr1*sintheg(itg)*cosphig(ipg)
     &     + gr2*costheg(itg)*cosphig(ipg)  
     &     - gr3*sinphig(ipg) 
      dfdy = gr1*sintheg(itg)*sinphig(ipg)
     &     + gr2*costheg(itg)*sinphig(ipg)
     &     + gr3*cosphig(ipg) 
      dfdz = gr1*costheg(itg)
     &     - gr2*sintheg(itg)
      end if
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grgrad4(fnc,grad,ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg), grad(0:nnrg,0:nntg,0:nnpg,3)
c
      do 10 ipg = 0, npg
      do 10 itg = 0, ntg
      do 10 irg = 0, nrtot
      call grgrad(fnc,dfdx,dfdy,dfdz,irg,itg,ipg,ixysym,iyzsym,izxsym)
      grad(irg,itg,ipg,1) = dfdx
      grad(irg,itg,ipg,2) = dfdy
      grad(irg,itg,ipg,3) = dfdz
   10 continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grgrad1g(fnc,grad1,irg,itg,ipg,ixysym,iyzsym,izxsym)
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      dimension  fnc(0:nnrg,0:nntg,0:nnpg), grad1(3)
c
      call grgrad(fnc,dfdx,dfdy,dfdz,irg,itg,ipg,ixysym,iyzsym,izxsym)
c
      grad1(1) = dfdx
      grad1(2) = dfdy
      grad1(3) = dfdz
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grgrad_2(fnc,dfdx,dfdy,dfdz,irg,itg,ipg,
     &                    ixysym,iyzsym,izxsym)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_cogra.f'
      common / excog/rgex(-4:nnrg+4),thgex(-4:nntg+4),phigex(-4:nnpg+4)
c
      dimension fnc(0:nnrg,0:nntg,0:nnpg), 
     &          fr3(3), ft3(3), fp3(3), r3(3), th3(3), phi3(3)
c
c --- Compute the gradient of a function.  
c --- The gradient is evaluated on grid points. 
c
      ir0 = min0(irg-1,nrtot-2)
      it0 = itg-1
      ip0 = ipg-1
c
      ir0sym = ixysym*iyzsym*izxsym
      it0sym = iyzsym*izxsym
      itnsym = ixysym
      ip0sym = izxsym
      ipnsym = iyzsym
      r0sym = dble(ir0sym)
      t0sym = dble(it0sym)
      tnsym = dble(itnsym)
      p0sym = dble(ip0sym)
      pnsym = dble(ipnsym)
c
      rv = rg(irg)
      tv = thg(itg)
      pv = phig(ipg)
      rrgginv = rginv(irg)
c
      do 8 ii = 1, 3
      irg0 = ir0 + ii - 1
      itg0 = it0 + ii - 1
      ipg0 = ip0 + ii - 1
      r3(ii) = rgex(irg0)
      th3(ii) = thgex(itg0)
      phi3(ii) = phigex(ipg0)
      irlsw = (irg0-1)/nrtot
      itlsw = (itg0-1)/ntg
      iplsw = (ipg0-1)/npg
      irssw = (1-isign(1,irg0))/2
      itssw = (1-isign(1,itg0))/2
      ipssw = (1-isign(1,ipg0))/2
      irmsw = 1 - irlsw - irssw
      itmsw = 1 - itlsw - itssw
      ipmsw = 1 - iplsw - ipssw
      iairg0 = (irssw + irmsw)*iabs(irg0) + irlsw*(2*nrtot-irg0)
      iaitg0 = (itssw + itmsw)*iabs(itg0) + itlsw*(2*ntg  -itg0)
      iaipg0 = (ipssw + ipmsw)*iabs(ipg0) + iplsw*(2*npg  -ipg0)
      rlsw = dble(irlsw)
      tlsw = dble(itlsw)
      plsw = dble(iplsw)
      rssw = dble(irssw)
      tssw = dble(itssw)
      pssw = dble(ipssw)
      rmsw = dble(irmsw)
      tmsw = dble(itmsw)
      pmsw = dble(ipmsw)
c
      if (irg.eq.0) then
      facr = rmsw + pnsym*rssw
      fact = rmsw + p0sym*rssw
      facp = rmsw + tnsym*rssw
      fr3(ii) = facr*fnc(iairg0,ntg,npgxz)
      ft3(ii) = fact*fnc(iairg0,ntg,npgyz)
      fp3(ii) = facp*fnc(iairg0,0,0)
      else if (irg.ne.0.and.itg.eq.0) then
      facr = tmsw + pnsym*tssw
      fact = tmsw + p0sym*tssw
      facp = rmsw + tnsym*rssw
      fr3(ii) = facr*fnc(irg,iaitg0,npgxz)
      ft3(ii) = fact*fnc(irg,iaitg0,npgyz)
      fp3(ii) = facp*fnc(iairg0,0,0)
      else
      facr = rmsw + r0sym*rssw
      fact = tmsw + t0sym*tssw + tnsym*tlsw
      facp = pmsw + p0sym*pssw + pnsym*plsw
      fr3(ii) = facr*fnc(iairg0,itg,ipg)
      ft3(ii) = fact*fnc(irg,iaitg0,ipg)
      fp3(ii) = facp*fnc(irg,itg,iaipg0)
      end if
    8 continue
c
c --- To cartesian component.  
c
      if (irg.eq.0) then
      dfdx = dfncdx2nd(r3,fr3,rv)
      dfdy = dfncdx2nd(r3,ft3,rv) 
      dfdz = dfncdx2nd(r3,fp3,rv)
      else if (irg.ne.0.and.itg.eq.0) then
      dfdx = dfncdx2nd(th3,fr3,tv)*rrgginv
      dfdy = dfncdx2nd(th3,ft3,tv)*rrgginv
      dfdz = dfncdx2nd(r3,fp3,rv)
      else
      gr1 = dfncdx2nd(r3,fr3,rv)
      gr2 = dfncdx2nd(th3,ft3,tv)*rrgginv
      gr3 = dfncdx2nd(phi3,fp3,pv)*rrgginv*cosecg(itg)
      dfdx = gr1*sintheg(itg)*cosphig(ipg)
     &     + gr2*costheg(itg)*cosphig(ipg)  
     &     - gr3*sinphig(ipg) 
      dfdy = gr1*sintheg(itg)*sinphig(ipg)
     &     + gr2*costheg(itg)*sinphig(ipg)
     &     + gr3*cosphig(ipg) 
      dfdz = gr1*costheg(itg)
     &     - gr2*sintheg(itg)
      end if
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grgrad1g_2(fnc,grad1,irg,itg,ipg,ixysym,iyzsym,izxsym)
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      dimension  fnc(0:nnrg,0:nntg,0:nnpg), grad1(3)
c
      call grgrad_2(fnc,dfdx,dfdy,dfdz,irg,itg,ipg,ixysym,iyzsym,izxsym)
c
      grad1(1) = dfdx
      grad1(2) = dfdy
      grad1(3) = dfdz
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine grimpro(back,rnew,fffac,epsmax,irerr,iterr,iperr)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_cogra.f'
c
      dimension rnew(0:nnrg,0:nntg,0:nnpg),
     &          back(0:nnrg,0:nntg,0:nnpg)
c
c --- Set improved values for quantities on GR-coordinate and 
c --- convergence check.  
c
      epsmax = 0.0d0
      do 401 ipg = 0, npg
      do 401 itg = 0, ntg
      do 401 irg = 0, nrtot
      rnew(irg,itg,ipg) = 
     & fffac*rnew(irg,itg,ipg) + (1.d0-fffac)*back(irg,itg,ipg)
      edet  = rnew(irg,itg,ipg)
      edetb = back(irg,itg,ipg)
      devi  = dabs(rnew(irg,itg,ipg)) + dabs(back(irg,itg,ipg))
c      
      if (irg.le.nrin.and.devi.ge.1.0d-8) then
      error = dabs(2.d0*(edet - edetb))/devi
      if(error .gt. epsmax) then
      epsmax = error
      irerr = irg
      iterr = itg
      iperr = ipg
      end if
      end if
 401  continue
c
      end 
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine flimpro(back,rnew,fffac,epsmax,irerr,iterr,iperr,isw)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      dimension rnew(0:nnr,0:nnt,0:nnp),
     &          back(0:nnr,0:nnt,0:nnp)
c
c --- Set improved values for quantities on fluid-coordinate and 
c --- convergence check.  
c
      epsmax = 0.0d0
      do 401 ip = 0, np
      do 401 it = 0, nt
      do 401 ir = 0, nr - isw
      rnew(ir,it,ip) = 
     &   fffac*rnew(ir,it,ip) + (1.d0-fffac)*back(ir,it,ip)
      edet  = rnew(ir,it,ip)
      edetb = back(ir,it,ip)
      devi  = dabs(rnew(ir,it,ip)) + dabs(back(ir,it,ip))
      if (dabs(edet+edetb).ge.1.0d-8) then
      error = dabs(2.d0*(edet - edetb))/devi
      if(error .gt. epsmax) then
      epsmax = error
      irerr = ir
      iterr = it
      iperr = ip
      end if
      end if
 401  continue
c
      end 
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine rsimpro(back,rnew,fffac,epsmax,iterr,iperr)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      dimension rnew(0:nnt,0:nnp),
     &          back(0:nnt,0:nnp)
c
c --- Set improved values for quantities on fluid-coordinate and 
c --- convergence check.  
c
      epsmax = 0.0d0
      do 401 ip = 0, np
      do 401 it = 0, nt
      rnew(it,ip) = 
     &   fffac*rnew(it,ip) + (1.d0-fffac)*back(it,ip)
      edet  = rnew(it,ip)
      edetb = back(it,ip)
      devi  = dabs(rnew(it,ip)) + dabs(back(it,ip))
      if (dabs(edet+edetb).ge.1.0d-8) then
      error = dabs(2.d0*(edet - edetb))/devi
      if(error .gt. epsmax) then
      epsmax = error
      iterr = it
      iperr = ip
      end if
      end if
cz      if (rnew(it,ip).ge.1.0d0) rnew(it,ip) = 1.0d0
 401  continue
c
      end 
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine minv(aa,bb,nn,nnz)
c
c --- linear equations solver.
c
      implicit real*8(a-h,o-z)
c
      dimension aa(nnz,nnz),bb(nnz)
c
c     solution of sm*aa=ss
      nnp1 = nn + 1
      do 100 ii = 1, nn
      aa(ii,nnp1) = bb(ii)
  100 continue
c
      nnm1 = nn - 1
      do 200 k = 1, nnm1
      kp1 = k + 1
c
      fmax = 1.e-10
cccp      fmax = 0.0
      ifmax = 1
c
      do 300 iia = k, nn
      aab = abs(aa(iia,k))
      if(aab.gt.fmax) then
         fmax = aab
         ifmax = iia
      end if
  300 continue
      if(ifmax.ne.k) then
        sig = 1.0d0
        if(aa(k,k)*aa(ifmax,k).lt.0.) sig = -1.0d0
        do 310 ii = 1, nnp1
        aa(k,ii) = aa(k,ii) + sig*aa(ifmax,ii)
  310   continue
      end if
c
      do 210 j = kp1, nnp1
      aa(k,j) = aa(k,j)/aa(k,k)
  210 continue
      do 220 i = kp1, nn
      do 220 j = kp1, nnp1
      aa(i,j) = aa(i,j) - aa(i,k)*aa(k,j)
  220 continue
c
  200 continue
c
      aa(nn,nnp1) = aa(nn,nnp1)/aa(nn,nn)
      do 250 l = 1, nnm1
      k   = nn - l
      kp1 = k + 1
      do 260 j = kp1, nn
      aa(k,nnp1) = aa(k,nnp1) - aa(k,j)*aa(j,nnp1)
  260 continue
  250 continue
c
      do 500 ii = 1, nn
      bb (ii) = aa(ii,nnp1)
  500 continue
c
      return
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine paimpro(ome,ber,radi,convf,iter,fmax0,isw)
c
c --- Improve parameters
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metfl.f'
      include 'GR_IRDR_metgr.f'
c
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      dimension sgg(10), gg(10,10)
      dimension gradv(0:nnr,0:nnt,0:nnp,1:3)
      dimension x(10),y(10),df(2),iopt(2),c(10,3), f(1)
c
c --- for interporation.
c
      df(1) = 0.0d0
      df(2) = 0.0d0
      iopt(1) = 3
      iopt(2) = 3
      nc = 10
      kn = 6
      km = 1
c
c --- parameter eq.
c
      do 2001 ii = 1, 10
      sgg(ii) = 0.0d0
      do 2001 jj = 1, 10
      gg(ii,jj) = 0.0d0
 2001  continue
c
      rgin  = sepato - 1.0d0
      rgmid = sepato
      rgout = sepato + 1.0d0
c
      if (rgin.le.0.0d0) rgin = 0.0d0
      if (rgin.ne.0.0d0) rgininv = 1.0d0/rgin
      if (rgin.le.0.0d0) rgininv = 0.0d0
      rgmidinv = 1.0d0/rgmid
      rgoutinv = 1.0d0/rgout
      delrg = drg(2)
c
      do 595 jj = 1, 3
      if (jj.eq.1) then 
      irgini = idint(rgin/delrg) - kn/2 + 1
      rrrg = rgin
      end if
      if (jj.eq.2) then 
      irgini = idint(rgmid/delrg) - kn/2 + 1
      rrrg = rgmid
      end if
      if (jj.eq.3) then
      irgini = idint(rgout/delrg) - kn/2 + 1
      rrrg = rgout
      end if
      if (irgini.le.0) irgini = 0
c
      do 590 ii = 1, kn
      irg = irgini + ii-1
      x(ii) = rg(irg)
 590  continue
c
      do 7100 ii = 1, kn
      irg = irgini + ii-1
 7100 y(ii) = alph(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      a1 = dlog(f(1)**(1.d0/radi**2))
c
      do 7101 ii = 1, kn
      irg = irgini + ii-1
 7101 y(ii) = psi(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      p1 = f(1)**(-2.d0/radi**2)
c
      do 7102 ii = 1, kn
      irg = irgini + ii-1
 7102 y(ii) = bvyu(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      b1 = f(1)
c
      do 7104 ii = 1, kn
      irg = irgini + ii-1
 7104 y(ii) = hyyu(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      h1 = f(1)
c
      if (jj.eq.1) then 
      ain = a1
      pin = p1
      bin = b1
      gin = h1 + 1.0d0
      end if
      if (jj.eq.2) then 
      amid = a1
      pmid = p1
      bmid = b1
      gmid = h1 + 1.0d0
      end if
      if (jj.eq.3) then
      aout = a1
      pout = p1
      bout = b1
      gout = h1 + 1.0d0
      end if
c
 595  continue
c
      emdmid = emdc
c
      call flgrad4(vep,gradv,rs,1,0)
c      call flgrad4(vep,gradv,rs,1,4)
c      call flgrad(vep,gradv,rs,1,0)
      gradvin = gradv(nr,nt,np,2)
      gradvmid = gradv(0,nt,npfyz,2)
      gradvout = gradv(nr,nt,0,2)
c
      fac1in = gradvin**2*gin
      fac1mid = gradvmid**2*gmid
      fac1out = gradvout**2*gout
      fac2in = gradvin
      fac2mid = gradvmid
      fac2out = gradvout
      facmm = (1.d0+(pinx+1.d0)*emdmid)**2  
c
      vphiyin = vphif(nr,nt,npfxzm,2)
      vphiymid = vphif(0,nt,npfyz,2)
      vphiyout = vphif(nr,nt,npfxz,2)
c
c      write(6,*) ' step  p '
c      write(6,789) ome,ber,radi
c      write(6,789) ain, pin, bin, gin
c      write(6,789) amid, pmid, bmid, gmid
c      write(6,789) aout, pout, bout, gout
c      write(6,789) gradvin, gradvmid, gradvout
c      write(6,789) vphiyin, vphiymid, vphiyout
cc      write(6,789) ramin, rammid, ramout
c 789  format(1p,4e12.4)
c
      omeb = ome
      berb = ber
      radib = radi
c
      numero = 0
c
 99   continue
c
      ramin = ber + (bin + ome*vphiyin)*fac2in
      rammid = ber + (bmid + ome*vphiymid)*fac2mid
      ramout = ber + (bout + ome*vphiyout)*fac2out
c
      sgg(1) = -(  radi**2*ain 
     &           + 0.5d0*dlog(1.0d0 + pin**(2.d0*radi**2)*fac1in)
     &           - dlog(ramin))
      sgg(2) = -(  radi**2*aout
     &           + 0.5d0*dlog(1.0d0 + pout**(2.d0*radi**2)*fac1out)
     &           - dlog(ramout))
      sgg(3) = -(  radi**2*amid
     &           + 0.5d0*dlog(facmm + pmid**(2.d0*radi**2)*fac1mid)
     &           - dlog(rammid))
c
      gg(1,1) = - vphiyin*fac2in/ramin
      gg(1,2) = -       1.0d0/ramin
      gg(1,3) = 2.0d0*radi*ain + 
     &          0.5d0/(1.0d0 + pin**(2.d0*radi**2)*fac1in)* 
     &          dlog(pin)*4.d0*radi*pin**(2.d0*radi**2)*fac1in
      gg(2,1) = - vphiyout*fac2out/ramout
      gg(2,2) = -             1.d0/ramout
      gg(2,3) = 2.0d0*radi*aout + 
     &          0.5d0/(1.0d0 + pout**(2.d0*radi**2)*fac1out)* 
     &          dlog(pout)*4.d0*radi*pout**(2.d0*radi**2)*fac1out
      gg(3,1) = - vphiymid*fac2mid/rammid
      gg(3,2) = -             1.d0/rammid
      gg(3,3) = 2.0d0*radi*amid + 
     &          0.5d0/(facmm + pmid**(2.d0*radi**2)*fac1mid)* 
     &          dlog(pmid)*4.d0*radi*pmid**(2.d0*radi**2)*fac1mid
c
      call minv(gg,sgg,3,10)
      ddome = sgg(1)
      ddber = sgg(2)
      ddradi = sgg(3)
      facfac = dmin1(dble(numero)/5.0d0,1.0d0)
      ome = ome + ddome*facfac
      ber = ber + ddber*facfac
      radi = radi + ddradi*facfac
      error = dmax1(dabs(ddome/ome),dabs(ddber/ber),dabs(ddradi/radi))
      numero = numero + 1
      if (numero.gt.1000)
     &write(6,*)' numero = ', numero, '   error =',error
      if (iter.le.10.and.numero.gt.10) go to 909
      if (numero.gt.1010) go to 909
      if (dabs(error).gt.1.0d-08) go to 99
c
 909  continue
c      write(6,*)' numero = ', numero, '  error = ',error
c
      if (radi.le.0.d0) write(6,*) ' ### radi minus ###'
      if (radi.le.0.d0) radi = - radi
      if (ome.le.0.d0) write(6,*) ' ### ome minus ###'
      if (ome.le.0.d0) ome = - ome
      if (ber.le.0.d0) write(6,*) ' ### ber minus ###'
      if (ber.le.0.d0) ber = - ber
      ome = convf*ome + (1.d0-convf)*omeb
      ber = convf*ber + (1.d0-convf)*berb
      radi = convf*radi + (1.d0-convf)*radib
c
      if (isw.eq.1) then
      write(6,4900)'  -- ome   --, error =', 
     &        2.0d0*dabs((ome - omeb)/(ome + omeb)), ome
      write(6,4900)'  -- ber   --, error =', 
     &        2.0d0*abs((ber - berb)/(ber + berb)), ber
      write(6,4900)'  -- radi  --, error =', 
     &        2.0d0*dabs((radi - radib)/(radi + radib)), radi
      end if
      fmax0 = dmax1(2.0d0*dabs((ome - omeb)/(ome + omeb)),
     &              2.0d0*dabs((ber - berb)/(ber + berb)),
     &              2.0d0*dabs((radi - radib)/(radi + radib)),fmax0)
c
c --  Improving alpha and psi.  
c
      do 470 ipg = 0, npg
      do 470 itg = 0, ntg
      do 470 irg = 0, nrtot
      alph(irg,itg,ipg) = alph(irg,itg,ipg)**((radi/radib)**2)
      psi(irg,itg,ipg) = psi(irg,itg,ipg)**((radi/radib)**2)
 470  continue
c
 4900 format(a22,1p,e12.4,',  value =',e12.4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine paimproco(ome,ber,radi,convf,iter,fmax0,isw)
c
c --- Improve parameters
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metfl.f'
      include 'GR_IRDR_metgr.f'
c
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      dimension sgg(10), gg(10,10)
      dimension gradv(0:nnr,0:nnt,0:nnp,1:3)
      dimension x(10),y(10),df(2),iopt(2),c(10,3), f(1)
c
c --- for interporation.
c
      df(1) = 0.0d0
      df(2) = 0.0d0
      iopt(1) = 3
      iopt(2) = 3
      nc = 10
      kn = 6
      km = 1
c
c --- parameter eq.
c
      do 2001 ii = 1, 10
      sgg(ii) = 0.0d0
      do 2001 jj = 1, 10
      gg(ii,jj) = 0.0d0
 2001  continue
c
      rgin  = sepato - 1.0d0
      rgmid = sepato
      rgout = sepato + 1.0d0
c
      if (rgin.le.0.0d0) rgin = 0.0d0
      delrg = drg(2)
c
      do 595 jj = 1, 3
      if (jj.eq.1) then 
      irgini = idint(rgin/delrg) - kn/2 + 1
      rrrg = rgin
      end if
      if (jj.eq.2) then 
      irgini = idint(rgmid/delrg) - kn/2 + 1
      rrrg = rgmid
      end if
      if (jj.eq.3) then
      irgini = idint(rgout/delrg) - kn/2 + 1
      rrrg = rgout
      end if
      if (irgini.le.0) irgini = 0
c
      do 590 ii = 1, kn
      irg = irgini + ii-1
      x(ii) = rg(irg)
 590  continue
c
      do 7100 ii = 1, kn
      irg = irgini + ii-1
 7100 y(ii) = alph(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      a1 = dlog(f(1)**(1.d0/radi**2))
      a2 = f(1)
c
      do 7101 ii = 1, kn
      irg = irgini + ii-1
 7101 y(ii) = psi(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      pa1 = (f(1)**2/a2)**(1.d0/radi**2)
c
      do 7102 ii = 1, kn
      irg = irgini + ii-1
 7102 y(ii) = bvyu(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      b1 = f(1)
c
      do 7104 ii = 1, kn
      irg = irgini + ii-1
 7104 y(ii) = hyyd(irg,ntg,0)
      call splc(x,kn,y,df,iopt,c,nc,ier)
      call splf(x,kn,y,c,nc,rrrg,km,f,ier)
      h1 = f(1)
c
      if (jj.eq.1) then 
      ain = a1
      pain = pa1
      bin = b1
      gin = h1 + 1.0d0
      end if
      if (jj.eq.2) then 
      amid = a1
      pamid = pa1
      bmid = b1
      gmid = h1 + 1.0d0
      end if
      if (jj.eq.3) then
      aout = a1
      paout = pa1
      bout = b1
      gout = h1 + 1.0d0
      end if
c
 595  continue
c
      emdmid = emdc
c
      dloghh = dlog(1.d0+(pinx+1.d0)*emdmid)
c
      vphiyin = vphif(nr,nt,npfxzm,2)
      vphiymid = vphif(0,nt,npfyz,2)
      vphiyout = vphif(nr,nt,npfxz,2)
c
      omeb = ome
      berb = ber
      radib = radi
c
      numero = 0
c
 99   continue
c
      ovin  = bin  + ome*vphiyin
      ovmid = bmid + ome*vphiymid
      ovout = bout + ome*vphiyout
      ovovin  = gin*ovin**2
      ovovmid = gmid*ovmid**2
      ovovout = gout*ovout**2
c
      termin = 1.0d0 - pain**(2.d0*radi**2)*ovovin
      termmid = 1.0d0 - pamid**(2.d0*radi**2)*ovovmid
      termout = 1.0d0 - paout**(2.d0*radi**2)*ovovout
      dtermdoin = - pain**(2.d0*radi**2)*2.0d0*gin*ovin*vphiyin
      dtermdomid= - pamid**(2.d0*radi**2)*2.0d0*gmid*ovmid*vphiymid
      dtermdoout= - paout**(2.d0*radi**2)*2.0d0*gout*ovout*vphiyout
      dtermdrin =-dlog(pain)*4.d0*radi*pain**(2.d0*radi**2)*ovovin
      dtermdrmid=-dlog(pamid)*4.d0*radi*pamid**(2.d0*radi**2)*ovovmid
      dtermdrout=-dlog(paout)*4.d0*radi*paout**(2.d0*radi**2)*ovovout
c
      sgg(1) = -(radi**2*ain  + 0.5d0*dlog(termin)  - dlog(ber))
      sgg(2) = -(radi**2*aout + 0.5d0*dlog(termout) - dlog(ber))
      sgg(3) = -(radi**2*amid + 0.5d0*dlog(termmid) - dlog(ber)
     &           + dloghh)
c
      gg(1,1) =   0.5d0*dtermdoin/termin
      gg(1,2) = - 1.0d0/ber
      gg(1,3) = 2.0d0*radi*ain + 0.5d0*dtermdrin/termin
c
      gg(2,1) =   0.5d0*dtermdoout/termout
      gg(2,2) = - 1.0d0/ber
      gg(2,3) = 2.0d0*radi*aout + 0.5d0*dtermdrout/termout
c
      gg(3,1) =   0.5d0*dtermdomid/termmid
      gg(3,2) = - 1.0d0/ber
      gg(3,3) = 2.0d0*radi*amid + 0.5d0*dtermdrmid/termmid
c
      call minv(gg,sgg,3,10)
      ddome = sgg(1)
      ddber = sgg(2)
      ddradi = sgg(3)
      facfac = dmin1(dble(numero)/5.0d0,1.0d0)
      ome = ome + ddome*facfac
      ber = ber + ddber*facfac
      radi = radi + ddradi*facfac
      error = dmax1(dabs(ddome/ome),dabs(ddber/ber),dabs(ddradi/radi))
      numero = numero + 1
      if (numero.gt.1000)
     &write(6,*)' numero = ', numero, '   error =',error
      if (iter.le.10.and.numero.gt.10) go to 909
      if (numero.gt.1010) go to 909
      if (dabs(error).gt.1.0d-08) go to 99
c
 909  continue
c      write(6,*)' numero = ', numero, '  error = ',error
c
      if (radi.le.0.d0) write(6,*) ' ### radi minus ###'
      if (radi.le.0.d0) radi = - radi
      if (ome.le.0.d0) write(6,*) ' ### ome minus ###'
      if (ome.le.0.d0) ome = - ome
      if (ber.le.0.d0) write(6,*) ' ### ber minus ###'
      if (ber.le.0.d0) ber = - ber
      ome = convf*ome + (1.d0-convf)*omeb
      ber = convf*ber + (1.d0-convf)*berb
      radi = convf*radi + (1.d0-convf)*radib
c
      if (isw.eq.1) then
      write(6,4900)'  -- ome   --, error =', 
     &        2.0d0*dabs((ome - omeb)/(ome + omeb)), ome
      write(6,4900)'  -- ber   --, error =', 
     &        2.0d0*abs((ber - berb)/(ber + berb)), ber
      write(6,4900)'  -- radi  --, error =', 
     &        2.0d0*dabs((radi - radib)/(radi + radib)), radi
      end if
      fmax0 = dmax1(2.0d0*dabs((ome - omeb)/(ome + omeb)),
     &              2.0d0*dabs((ber - berb)/(ber + berb)),
     &              2.0d0*dabs((radi - radib)/(radi + radib)),fmax0)
c
c --  Improving alpha and psi.  
c
      do 470 ipg = 0, npg
      do 470 itg = 0, ntg
      do 470 irg = 0, nrtot
      alph(irg,itg,ipg) = alph(irg,itg,ipg)**((radi/radib)**2)
      psi(irg,itg,ipg) = psi(irg,itg,ipg)**((radi/radib)**2)
 470  continue
c
 4900 format(a22,1p,e12.4,',  value =',e12.4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine physq(istat,iseq,chgra)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metfl.f'
      include 'GR_IRDR_metgr.f'
c
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      common / weigh / wgdr(0:nnr), wgdt(0:nnt), wgdp(0:nnp),
     &                wgrtp(0:nnr,0:nnt,0:nnp), 
     &                 w4dr(0:nnr), w4dt(0:nnt), w4dp(0:nnp),
     &                w4rtp(0:nnr,0:nnt,0:nnp), wahop(0:nnr,0:nnt,0:nnp)
      common / weigg / wgdrg(nnrg), wgdtg(0:nntg), wgdpg(0:nnpg),
     &                wgrtpg(nnrg,0:nntg,0:nnpg), 
     &               w4drg(0:nnrg), w4dtg(0:nntg), w4dpg(0:nnpg),
     &                w4rtpg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / iomis / fffac, ffvep, eps, convf, itmx, iddd, numseq,
     &                 itype, iwrite
      common / trmpg / sinmpg(0:nnlg,0:nnpg), cosmpg(0:nnlg,0:nnpg),
     &                simpsig(0:nnlg,0:nnpg)
c
      common / extri / rkij(0:nnrg,0:nntg,0:nnpg,1:3,1:3),
     &                 rkijkij(0:nnrg,0:nntg,0:nnpg)
      common / ricci / rab(0:nnrg,0:nntg,0:nnpg,1:6),
     &                 rabnl(0:nnrg,0:nntg,0:nnpg,1:6)
      common / crist / cri(0:nnrg,0:nntg,0:nnpg,1:3,1:6)
c
      common / phint / ahores, ahoang, ahoadm
      common / fitms / fitadm, fitkom
      common / flusw / swflu
      common / cutsw / cutfac
      common / seqmas/ restmass, gravmass
c
      dimension gradv(0:nnr,0:nnt,0:nnp,1:3)
      dimension emdg(0:nnrg,0:nntg,0:nnpg), 
     &          vepg(0:nnrg,0:nntg,0:nnpg), 
     &          ramg(0:nnrg,0:nntg,0:nnpg), 
     &        gradvg(0:nnrg,0:nntg,0:nnpg,1:3)
c
      dimension speangg(0:nnrg,0:nntg,0:nnpg), 
     &          speang(0:nnr,0:nnt,0:nnp), rmsafr(0:100)
c
      dimension souresm(0:nnrg,0:nntg,0:nnpg),
     &          souadmg(0:nnrg,0:nntg,0:nnpg),
     &          soukomg(0:nnrg,0:nntg,0:nnpg),
     &          souangg(0:nnrg,0:nntg,0:nnpg),
     &          souvcgg(0:nnrg,0:nntg,0:nnpg),
     &          souvckg(0:nnrg,0:nntg,0:nnpg)
c
      dimension souadmf(0:nnrg,0:nntg,0:nnpg),
     &          soukomf(0:nnrg,0:nntg,0:nnpg),
     &          souangf(0:nnrg,0:nntg,0:nnpg),
     &          souvccf(0:nnrg,0:nntg,0:nnpg)
c
      dimension gradp(0:nnrg,0:nntg,0:nnpg,1:3),
     &          grada(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension aij(3,3), gamu(3,3), ric(3,3), vphig(3), 
     &          dpsiu(3), dpsid(3), dalpd(3), dhu(3,3,3)
      dimension rna(3), gradpsi(3), gradalp(3), cris(3,3,3)
      dimension snvd(3), snvu(3), grad1(3)
c
      character*1 chgra
c
      if (iseq.eq.1) then
      open(10,file='gnbphy.dat',status='old')
      open(11,file='gnbphydp.dat',status='old')
      open(12,file='gnbangphy.dat',status='old')
      open(17,file='gnbaxis.dat',status='old')
      open(31,file='gnbphyplot.dat',status='old')
      open(34,file='gnbasym.dat',status='old')
      end if
      if (istat.eq.2) write(10,*) ' == Solution does not converge. == '
c
      call fl2grspl(emd,emdg,rs,hrg,rg,1)
      if (chgra.eq.'i') call cleargeometry
      if (chgra.eq.'h'.or.chgra.eq.'c'.or.chgra.eq.'C'
     &.or.chgra.eq.'H'.or.chgra.eq.'W') then 
      call liegmab
      end if
      call excurve(chgra)
      call flgrad4(vep,gradv,rs,1,0)
cx      call flgrad(vep,gradv,rs,1,0)
      call vfl2vgrcap(gradv,gradvg,rs,hrg,rg,1)
      call vgr2vflcap(rs)
c
      bvyfg = bvyu(nrgmid,ntg,0)
      do 77 ip = 0, np
      do 77 it = 0, nt
      ir = 0
      vphiy = vphif(ir,it,ip,2)
      ram(ir,it,ip) = ber + (bvyfg + ome*vphiy)*gradv(0,nt,npfyz,2)
      do 77 ir = 1, nr
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
      ram(ir,it,ip) = ber + (bvxfc + ome*vphix)*gradv(ir,it,ip,1)
     &                    + (bvyfc + ome*vphiy)*gradv(ir,it,ip,2)
     &                    + (bvzfc + ome*vphiz)*gradv(ir,it,ip,3)
 77   continue
c
      call fl2grspl(ram,ramg,rs,hrg,rg,1)
c
      call grgrad4(alph,grada,1,1,1)
      call grgrad4(psi,gradp,1,1,1)
c
c --  Integrand for non-compact source.
c
      do 400 ipg = 0, npg
      do 400 itg = 0, ntg
      do 400 irg = 0, nrtot
c
      emdgc = emdg(irg,itg,ipg)
      ramgc = ramg(irg,itg,ipg)
      psigc =  psi(irg,itg,ipg)
      psigc4=  psigc**4
      psinv = 1.0d0/psigc
      alpgc = alph(irg,itg,ipg)
      alinv = 1.0d0/alpgc
      rhogc = emdgc**pinx
      pregc = rhogc*emdgc
      hhgc  = 1.0d0 + (pinx+1.0d0)*emdgc
c
      utgc  =       swflu *ramg(irg,itg,ipg)/(alpgc**2*hhgc)
     &      +(1.0d0-swflu)*hhgc/ber
c
      zfac = 1.0d0
      if (emdgc.le.0.0d0) zfac = 0.0d0
      rhoHc = hhgc*rhogc*(alpgc*utgc)**2 - pregc
      esseS = - hhgc*rhogc + 4.0d0*pregc +rhoHc
c
      otermx =       swflu *gradvg(irg,itg,ipg,1)
     &       +(1.0d0-swflu)*psigc4*ovxd(irg,itg,ipg)
      otermy =       swflu *gradvg(irg,itg,ipg,2)
     &       +(1.0d0-swflu)*psigc4*ovyd(irg,itg,ipg)
      otermz =       swflu *gradvg(irg,itg,ipg,3)
     &       +(1.0d0-swflu)*psigc4*ovzd(irg,itg,ipg)
c
      rjx =       swflu *rhogc*alpgc*utgc*otermx
     &    +(1.0d0-swflu)*hhgc*rhogc*alpgc*utgc**2*otermx
      rjy =       swflu *rhogc*alpgc*utgc*otermy
     &    +(1.0d0-swflu)*hhgc*rhogc*alpgc*utgc**2*otermy
      rjz =       swflu *rhogc*alpgc*utgc*otermz
     &    +(1.0d0-swflu)*hhgc*rhogc*alpgc*utgc**2*otermz
c
      vphig(1) = - rg(irg)*sintheg(itg)*sinphig(ipg)
      vphig(2) =   rg(irg)*sintheg(itg)*cosphig(ipg)
      vphig(3) = 0.0d0
      dpsid(1) = gradp(irg,itg,ipg,1)
      dpsid(2) = gradp(irg,itg,ipg,2)
      dpsid(3) = gradp(irg,itg,ipg,3)
      dalpd(1) = grada(irg,itg,ipg,1)
      dalpd(2) = grada(irg,itg,ipg,2)
      dalpd(3) = grada(irg,itg,ipg,3)
c
      gamu(1,1) = hxxu(irg,itg,ipg) + 1.0d0
      gamu(1,2) = hxyu(irg,itg,ipg)
      gamu(1,3) = hxzu(irg,itg,ipg)
      gamu(2,2) = hyyu(irg,itg,ipg) + 1.0d0
      gamu(2,3) = hyzu(irg,itg,ipg)
      gamu(3,3) = hzzu(irg,itg,ipg) + 1.0d0
      gamu(2,1) = gamu(1,2)
      gamu(3,1) = gamu(1,3)
      gamu(3,2) = gamu(2,3)
c
      if (chgra.eq.'i') go to 410
      ric(1,1) = rab(irg,itg,ipg,1)
      ric(1,2) = rab(irg,itg,ipg,2)
      ric(1,3) = rab(irg,itg,ipg,3)
      ric(2,2) = rab(irg,itg,ipg,4)
      ric(2,3) = rab(irg,itg,ipg,5)
      ric(3,3) = rab(irg,itg,ipg,6)
      ric(2,1) = ric(1,2)
      ric(3,1) = ric(1,3)
      ric(3,2) = ric(2,3)
      cris(1,1,1) = cri(irg,itg,ipg,1,1)
      cris(1,1,2) = cri(irg,itg,ipg,1,2)
      cris(1,1,3) = cri(irg,itg,ipg,1,3)
      cris(1,2,1) = cri(irg,itg,ipg,1,2)
      cris(1,2,2) = cri(irg,itg,ipg,1,4)
      cris(1,2,3) = cri(irg,itg,ipg,1,5)
      cris(1,3,1) = cri(irg,itg,ipg,1,3)
      cris(1,3,2) = cri(irg,itg,ipg,1,5)
      cris(1,3,3) = cri(irg,itg,ipg,1,6)
      cris(2,1,1) = cri(irg,itg,ipg,2,1)
      cris(2,1,2) = cri(irg,itg,ipg,2,2)
      cris(2,1,3) = cri(irg,itg,ipg,2,3)
      cris(2,2,1) = cri(irg,itg,ipg,2,2)
      cris(2,2,2) = cri(irg,itg,ipg,2,4)
      cris(2,2,3) = cri(irg,itg,ipg,2,5)
      cris(2,3,1) = cri(irg,itg,ipg,2,3)
      cris(2,3,2) = cri(irg,itg,ipg,2,5)
      cris(2,3,3) = cri(irg,itg,ipg,2,6)
      cris(3,1,1) = cri(irg,itg,ipg,3,1)
      cris(3,1,2) = cri(irg,itg,ipg,3,2)
      cris(3,1,3) = cri(irg,itg,ipg,3,3)
      cris(3,2,1) = cri(irg,itg,ipg,3,2)
      cris(3,2,2) = cri(irg,itg,ipg,3,4)
      cris(3,2,3) = cri(irg,itg,ipg,3,5)
      cris(3,3,1) = cri(irg,itg,ipg,3,3)
      cris(3,3,2) = cri(irg,itg,ipg,3,5)
      cris(3,3,3) = cri(irg,itg,ipg,3,6)
  410 continue
c
      do 18 ib = 1, 3
      dpsiu(ib) = 0.0d0
      do 18 ia = 1, 3
      dpsiu(ib) = dpsiu(ib) + gamu(ib,ia)*dpsid(ia)
      aij(ia,ib) = rkij(irg,itg,ipg,ia,ib)
   18 continue
c
c
      if (chgra.eq.'i') go to 420
      call grgrad1g(hxxu,grad1,irg,itg,ipg,1,1,1)
      dhu(1,1,1) = grad1(1)
      dhu(1,1,2) = grad1(2)
      dhu(1,1,3) = grad1(3)
      call grgrad1g(hxyu,grad1,irg,itg,ipg,1,-1,-1)
      dhu(1,2,1) = grad1(1)
      dhu(1,2,2) = grad1(2)
      dhu(1,2,3) = grad1(3)
      dhu(2,1,1) = grad1(1)
      dhu(2,1,2) = grad1(2)
      dhu(2,1,3) = grad1(3)
      call grgrad1g(hxzu,grad1,irg,itg,ipg,-1,-1,1)
      dhu(1,3,1) = grad1(1)
      dhu(1,3,2) = grad1(2)
      dhu(1,3,3) = grad1(3)
      dhu(3,1,1) = grad1(1)
      dhu(3,1,2) = grad1(2)
      dhu(3,1,3) = grad1(3)
      call grgrad1g(hyyu,grad1,irg,itg,ipg,1,1,1)
      dhu(2,2,1) = grad1(1)
      dhu(2,2,2) = grad1(2)
      dhu(2,2,3) = grad1(3)
      call grgrad1g(hyzu,grad1,irg,itg,ipg,-1,1,-1)
      dhu(2,3,1) = grad1(1)
      dhu(2,3,2) = grad1(2)
      dhu(2,3,3) = grad1(3)
      dhu(3,2,1) = grad1(1)
      dhu(3,2,2) = grad1(2)
      dhu(3,2,3) = grad1(3)
      call grgrad1g(hzzu,grad1,irg,itg,ipg,1,1,1)
      dhu(3,3,1) = grad1(1)
      dhu(3,3,2) = grad1(2)
      dhu(3,3,3) = grad1(3)
  420 continue
c
c
      aijvpp = 0.0d0
      dpdp = 0.0d0
      dada = 0.0d0
      rics = 0.0d0
      do 20 ib = 1, 3
      do 20 ia = 1, 3
      rics = rics + gamu(ia,ib)*ric(ia,ib)
      dpdp = dpdp + gamu(ia,ib)*dpsid(ia)*dpsid(ib)
      dada = dada + gamu(ia,ib)*dalpd(ia)*dalpd(ib)
caaa      do 20 id = 1, 3
caaa      do 20 ic = 1, 3
caaa      aijvpp = aijvpp + gamu(ia,id)*aij(ia,ib)*cris(ib,id,ic)*vphig(ic)
      aijvpp = aijvpp - 0.5*(aij(ia,ib)*vphig(1)*dhu(ia,ib,1)
     &                     + aij(ia,ib)*vphig(2)*dhu(ia,ib,2)
     &                     + aij(ia,ib)*vphig(3)*dhu(ia,ib,3))
   20 continue
      rjapa = rjx*vphig(1) + rjy*vphig(2) + rjz*vphig(3)
      aijaij = rkijkij(irg,itg,ipg)
c
      souresm(irg,itg,ipg) = rhogc*alpgc*utgc*psigc**6
      souadmg(irg,itg,ipg) = - 0.125d0*psigc*rics 
     &                       + 0.125d0*psigc**5*aijaij
      soukomg(irg,itg,ipg) = alpgc*psigc**6*aijaij
      souangg(irg,itg,ipg) = aijvpp*psigc**6
c
      souadmf(irg,itg,ipg) = 2.0d0*pi*psigc**5*rhoHc*zfac
      soukomf(irg,itg,ipg) = 4.0d0*pi*psigc**6*alpgc*(rhoHc+esseS)*zfac
      souangf(irg,itg,ipg) = 8.0d0*pi*psigc**6*rjapa*zfac
c
      souvcgg(irg,itg,ipg) = - psigc**2*alinv**2*dada + 2.0d0*dpdp
      souvckg(irg,itg,ipg) = 0.25d0*psigc**2*rics
     &                     + 0.75d0*psigc**6*aijaij
      souvccf(irg,itg,ipg) = 4.0d0*pi*psigc**6*esseS
c
 400  continue
c
      call halfsou(souresm)
      call halfsou(souadmg)
      call halfsou(soukomg)
      call halfsou(souangg)
      call halfsou(souadmf)
      call halfsou(soukomf)
      call halfsou(souangf)
      call halfsou(souvcgg)
      call halfsou(souvckg)
      call halfsou(souvccf)
c
c
      resmas = 0.0d0
      admgra = 0.0d0
      admflu = 0.0d0
      rkogra = 0.0d0
      rkoflu = 0.0d0
      amogra = 0.0d0
      amoflu = 0.0d0
      vcgra  = 0.0d0
      vckgr  = 0.0d0
      vcflu  = 0.0d0
      dgsepa = 0.0d0
c
      do 404 ipg = 0, npg
      do 404 itg = 0, ntg
      do 404 irg = 1, nrtot
c
      resmas = resmas + souresm(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      admgra = admgra + souadmg(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      admflu = admflu + souadmf(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      rkogra = rkogra + soukomg(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      rkoflu = rkoflu + soukomf(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      amogra = amogra + souangg(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      amoflu = amoflu + souangf(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
c
      dgsepa = dgsepa + hrg(irg)*sintheg(itg)*cosphig(ipg)
     &                 *souresm(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
c
      vcgra = vcgra + souvcgg(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      vckgr = vckgr + souvckg(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
      vcflu = vcflu + souvccf(irg,itg,ipg)*wgrtpg(irg,itg,ipg)
c
  404 continue
c
      resmas = radi**3*resmas*8.0d0/2.0d0
      admmas =(radi*admgra + radi**3*admflu)/(2.0d0*pi)*8.0d0/2.0d0
      rkomas =(radi*rkogra + radi**3*rkoflu)/(4.0d0*pi)*8.0d0/2.0d0
      angmom =(radi**2*amogra + radi**4*amoflu)/(8.0d0*pi)*8.0d0/2.0d0
      amomfl = radi**4*amoflu/(8.0d0*pi)*8.0d0/2.0d0
c
      dgsepa = radi**4*dgsepa/resmas*8.0d0/2.0d0
      virial =(((vcgra + vckgr)*radi + vcflu*radi**3)*8.0d0
     &       - 4.0d0*pi*(rkomas*2.0d0)**2/(radi*rg(nrtot))
     &       + 2.0d0*pi*(admmas*2.0d0)**2/(radi*rg(nrtot)))/
     &        (4.0d0*pi*admmas*2.0d0)

c
c computation on the surface fitted coordinate.
c
      call gr2flspl(psi,psif,rs,0,0)
      call gr2flspl(alph,alphf,rs,0,0)
c      call vgr2vflcap(rs)
c
      call flgrad4(vep,gradv,rs,1,0)
c      call flgrad(vep,gradv,rs,1,0)
c
      dis = sepato
      ahores = 0.0d0
      ahoadm = 0.0d0
      ahokom = 0.0d0
      ahokom2 = 0.0d0
      ahoang = 0.0d0
      ahodgs = 0.0d0
      ahovc  = 0.0d0
      do 500 ip = 0, np
      do 500 it = 0, nt
      do 500 ir = 0, nr
      xxxx = dis + r(ir)*rs(it,ip)*sinthe(it)*cosphi(ip)
c
      emd(nr,it,ip) = 1.0d-14
      if (emd(ir,it,ip).le.0.0d0) emd(ir,it,ip) = 1.0d-14
c
      emdfc = emd(ir,it,ip)
      ramfc = ram(ir,it,ip)
      psifc = psif(ir,it,ip)
      psifc4= psifc**4
      psinv = 1.0d0/psifc
      alpfc = alphf(ir,it,ip)
      alinv = 1.0d0/alpfc
      rhofc = emdfc**pinx
      prefc = rhofc*emdfc
      hhfc  = 1.0d0 + (pinx+1.0d0)*emdfc
c
      utfc  =       swflu *ramfc/(alpfc**2*hhfc)
     &      +(1.0d0-swflu)*hhfc/ber
c
      zfac = 1.0d0
      if (emdfc.le.0.0d0) zfac = 0.0d0
      rhoHc = hhfc*rhofc*(alpfc*utfc)**2 - prefc
      esseS = - hhfc*rhofc + 4.0d0*prefc +rhoHc
c
      gmxxdf = 1.0d0 + hxxdf(ir,it,ip)
      gmxydf =         hxydf(ir,it,ip)
      gmxzdf =         hxzdf(ir,it,ip)
      gmyydf = 1.0d0 + hyydf(ir,it,ip)
      gmyzdf =         hyzdf(ir,it,ip)
      gmzzdf = 1.0d0 + hzzdf(ir,it,ip)
      gmyxdf = gmxydf
      gmzxdf = gmxzdf
      gmzydf = gmyzdf
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
c
      ovxfc = bvxfc + ome*vphix
      ovyfc = bvyfc + ome*vphiy
      ovzfc = bvzfc + ome*vphiz
      ovxdf = gmxxdf*ovxfc + gmxydf*ovyfc + gmxzdf*ovzfc
      ovydf = gmyxdf*ovxfc + gmyydf*ovyfc + gmyzdf*ovzfc
      ovzdf = gmzxdf*ovxfc + gmzydf*ovyfc + gmzzdf*ovzfc
c
      otermx =       swflu *gradv(ir,it,ip,1)
     &       +(1.0d0-swflu)*psifc4*ovxdf
      otermy =       swflu *gradv(ir,it,ip,2)
     &       +(1.0d0-swflu)*psifc4*ovydf
      otermz =       swflu *gradv(ir,it,ip,3)
     &       +(1.0d0-swflu)*psifc4*ovzdf
c
      rjx =       swflu *rhofc*alpfc*utfc*otermx
     &    +(1.0d0-swflu)*hhfc*rhofc*alpfc*utfc**2*otermx
      rjy =       swflu *rhofc*alpfc*utfc*otermy
     &    +(1.0d0-swflu)*hhfc*rhofc*alpfc*utfc**2*otermy
      rjz =       swflu *rhofc*alpfc*utfc*otermz
     &    +(1.0d0-swflu)*hhfc*rhofc*alpfc*utfc**2*otermz
c
      dpsid(1) = gradp(irg,itg,ipg,1)
      dpsid(2) = gradp(irg,itg,ipg,2)
      dpsid(3) = gradp(irg,itg,ipg,3)
c
      rjapa = rjx*vphix + rjy*vphiy + rjz*vphiz
      rjbeta= rjx*bvxfc + rjy*bvyfc + rjz*bvzfc
c
      weiflu = rs(it,ip)**3*wahop(ir,it,ip)
c
      ahores = ahores + rhofc*alpfc*utfc*psifc**6*weiflu
      ahodgs = ahodgs + rhofc*alpfc*utfc*psifc**6*weiflu*xxxx
      ahoadm = ahoadm + 2.0d0*pi*psifc**5*rhoHc*weiflu
      ahokom = ahokom + 4.0d0*pi*psifc**6*alpfc*(rhoHc+esseS)*weiflu
     &                - 8.0d0*pi*psifc**6*rjbeta*weiflu
      ahokom2= ahokom2+ 4.0d0*pi*psifc**6*alpfc*(rhoHc+esseS)*weiflu
      ahoang = ahoang + 8.0d0*pi*psifc**6*rjapa*weiflu
      ahovc = ahovc + 4.0d0*pi*psifc**6*esseS*weiflu
c
      rr = rf(ir)*rs(it,ip)
      st = sinthef(it)
      ct = costhef(it)
      sp = sinphif(ip)
      cp = cosphif(ip)
      rstcp = rr*st*cp
      rstsp = rr*st*sp
      xxyy = (dis**2 + (rr*st)**2 + 2.d0*dis*rstcp)**0.5
      phigf = datan2(rstsp,dis+rstcp)
c
      ssp = dsin(phigf)
      ccp = dcos(phigf)
c
      egf13 = - ssp
      egf23 = ccp
      egf33 = 0.0d0
c
      oterm =       swflu *(gradv(ir,it,ip,1)*egf13
     &                    + gradv(ir,it,ip,2)*egf23)
     &      +(1.0d0-swflu)*hhfc*utfc*psifc4*(ovxdf*egf13+ovydf*egf23)
c
      speang(ir,it,ip) = xxyy*oterm
c
 500  continue
      ahores = radi**3*ahores*8.0d0/2.0d0
      ahoadm =(radi*admgra + radi**3*ahoadm )/(2.0d0*pi)*8.0d0/2.0d0
      ahokom =               radi**3*ahokom  /(4.0d0*pi)*8.0d0/2.0d0
      ahokom2=(radi*rkogra + radi**3*ahokom2)/(4.0d0*pi)*8.0d0/2.0d0
      ahoafl = radi**4*ahoang/(8.0d0*pi)*8.0d0/2.0d0
      ahoang =(radi**2*amogra + radi**4*ahoang)/(8.0d0*pi)*8.0d0/2.0d0
      ahodgs = radi**4*ahodgs/ahores*8.0d0/2.0d0
      ahovc  =(((vcgra + vckgr)*radi + ahovc*radi**3)*8.0d0
     &       - 4.0d0*pi*(ahokom*2.0d0)**2/(radi*rg(nrtot))
     &       + 2.0d0*pi*(ahoadm*2.0d0)**2/(radi*rg(nrtot)))/
     &        (4.0d0*pi*ahoadm*2.0d0)
c
      fitvir = dabs((fitadm-fitkom)/fitadm)
c
c --- Check gauge conditions.
c
      detgmx = 1.0d0
      dethijmx = 0.0d0
      irgd = 0
      itgd = 0
      ipgd = 0
      do 100 ipg = 0, npg
      do 100 itg = 0, ntg
cccc      do 100 irg = 0, nrtot
      do 100 irg = 0, nrin
c
      gmxx = 1.0d0 + hxxd(irg,itg,ipg)
      gmxy =         hxyd(irg,itg,ipg)
      gmxz =         hxzd(irg,itg,ipg)
      gmyx = gmxy
      gmyy = 1.0d0 + hyyd(irg,itg,ipg)
      gmyz =         hyzd(irg,itg,ipg)
      gmzx = gmxz
      gmzy = gmyz
      gmzz = 1.0d0 + hzzd(irg,itg,ipg)
c
      detgmi =-gmxz*gmyy*gmzx + gmxy*gmyz*gmzx
     &       + gmxz*gmyx*gmzy - gmxx*gmyz*gmzy
     &       - gmxy*gmyx*gmzz + gmxx*gmyy*gmzz
c
      if (dabs(detgmi-1.0d0).gt.dabs(detgmx-1.0d0)) then
      irgd = irg
      itgd = itg
      ipgd = ipg
      detgmx = detgmi
      end if
c
      gmxx = gmxx - 1.0d0
      gmyy = gmyy - 1.0d0
      gmzz = gmzz - 1.0d0
      dethij =-gmxz*gmyy*gmzx + gmxy*gmyz*gmzx
     &       + gmxz*gmyx*gmzy - gmxx*gmyz*gmzy
     &       - gmxy*gmyx*gmzz + gmxx*gmyy*gmzz
      dethij = dabs(dethij)**(1.0d0/3.0d0)
      dethijmx = dmax1(dethij,dethijmx)
c
 100  continue
c
      dhijmx = 0.0d0
      tramax = 0.0d0
      irgh = 0
      itgh = 0
      ipgh = 0
      do 101 ipg = 0, npg
      do 101 itg = 0, ntg
cccc      do 100 irg = 0, nrtot
      do 101 irg = 0, nrin
c
      call grgrad(hxxu,dhxxdx,dhxxdy,dhxxdz,irg,itg,ipg,1,1,1)
      call grgrad(hxyu,dhxydx,dhxydy,dhxydz,irg,itg,ipg,1,-1,-1)
      call grgrad(hxzu,dhxzdx,dhxzdy,dhxzdz,irg,itg,ipg,-1,-1,1)
      call grgrad(hyyu,dhyydx,dhyydy,dhyydz,irg,itg,ipg,1,1,1)
      call grgrad(hyzu,dhyzdx,dhyzdy,dhyzdz,irg,itg,ipg,-1,1,-1)
      call grgrad(hzzu,dhzzdx,dhzzdy,dhzzdz,irg,itg,ipg,1,1,1)
      hxidiv = dhxxdx + dhxydy + dhxzdz
      hyidiv = dhxydx + dhyydy + dhyzdz
      hzidiv = dhxzdx + dhyzdy + dhzzdz
c
      hijmax = dmax1(dabs(hxidiv),dabs(hyidiv),dabs(hzidiv))
ck      htermax = dmax1(dabs(dhxxdx),dabs(dhxydy),dabs(dhxzdz),
ck     &                dabs(dhxydx),dabs(dhyydy),dabs(dhyzdz),
ck     &                dabs(dhxzdx),dabs(dhyzdy),dabs(dhzzdz))
ctesttest      htermax = dethijmx
      htermax = 1.0d0
      if (htermax.gt.0.0d0) hijmax = dabs(hijmax/htermax)
      if (dabs(dhijmx).lt.hijmax.and.htermax.gt.0.0d0) then
      irgh = irg
      itgh = itg
      ipgh = ipg
      dhijmx = hijmax
      end if
c
      traij = 0.0d0
      aijmx = 0.0d0
      irga = 0
      itga = 0
      ipga = 0
      do 121 ib = 1, 3
      do 121 ia = 1, 3
      aijmx = dmax1(aijmx,dabs(gamu(ia,ib)*aij(ia,ib)))
      traij = traij + gamu(ia,ib)*aij(ia,ib)
 121  continue
      if (aijmx.gt.0.0d0) traij = dabs(traij/aijmx)
      if (dabs(tramax).lt.traij.and.aijmx.gt.0.0d0) then
      irga = irg
      itga = itg
      ipga = ipg
      tramax = traij
      end if
c
 101  continue
c
c #### mass test
      write(34,*) ' '
      write(34,*) ' ngdin and separation ', ngdin, dis
      write(34,*) ' '
      iskip0 = (nrtot-nrin)/20
      do 170 irg = nrin, nrtot, iskip0
      admm = 0.0d0
      rkom = 0.0d0
      angj = 0.0d0
c
      do 171 ipg = 0, npg
      do 171 itg = 0, ntg
c
      gamu(1,1) = hxxu(irg,itg,ipg) + 1.0d0
      gamu(1,2) = hxyu(irg,itg,ipg)
      gamu(1,3) = hxzu(irg,itg,ipg)
      gamu(2,2) = hyyu(irg,itg,ipg) + 1.0d0
      gamu(2,3) = hyzu(irg,itg,ipg)
      gamu(3,3) = hzzu(irg,itg,ipg) + 1.0d0
      gamu(2,1) = gamu(1,2)
      gamu(3,1) = gamu(1,3)
      gamu(3,2) = gamu(2,3)
      do 172 ib = 1, 3
      do 172 ia = 1, 3
      aij(ia,ib) = rkij(irg,itg,ipg,ia,ib)
  172 continue
c
      snvd(1) = sintheg(itg)*cosphig(ipg)
      snvd(2) = sintheg(itg)*sinphig(ipg)
      snvd(3) = costheg(itg)
      snvu(1) = sintheg(itg)*cosphig(ipg)
      snvu(2) = sintheg(itg)*sinphig(ipg)
      snvu(3) = costheg(itg)      
      vphig(1) = - rg(irg)*sintheg(itg)*sinphig(ipg)
      vphig(2) =   rg(irg)*sintheg(itg)*cosphig(ipg)
      vphig(3) = 0.0d0
c
      psipsi = psi(irg,itg,ipg)
      call grderiv1r(psi,grpsi,irg,itg,ipg,1,1,1)
      call grderiv1r(alph,gralp,irg,itg,ipg,1,1,1)
      admm = admm + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*grpsi
      rkom = rkom + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*gralp*psipsi**2
      angj = angj + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*
     &      (aij(1,1)*vphig(1)*snvd(1) + aij(2,1)*vphig(2)*snvd(1)
     &     + aij(1,2)*vphig(1)*snvd(2) + aij(2,2)*vphig(2)*snvd(2)
     &     + aij(1,3)*vphig(1)*snvd(3) + aij(2,3)*vphig(2)*snvd(3))
  171 continue
      admm = - 1.0d0/(2.0d0*pi)*admm*radi*8.0d0/2.0d0
      rkom =   1.0d0/(4.0d0*pi)*rkom*radi*8.0d0/2.0d0
      angj =   1.0d0/(8.0d0*pi)*angj*radi**2*8.0d0/2.0d0
      write(34,820) irg, rg(irg), admm, rkom, angj
  170 continue
c
      adm5 = 0.0d0
      adm4 = 0.0d0
      adm3 = 0.0d0
      adm2 = 0.0d0
      adm1 = 0.0d0
      rko5 = 0.0d0
      rko4 = 0.0d0
      rko3 = 0.0d0
      rko2 = 0.0d0
      rko1 = 0.0d0
      write(34,*) ' '
      do 174 irg = nrin, nrtot, iskip0
      admm = 0.0d0
      rkom = 0.0d0
      angj = 0.0d0
      do 175 ipg = 0, npg
      do 175 itg = 0, ntg
c
      gamu(1,1) = 1.0d0 + hxxu(irg,itg,ipg)
      gamu(1,2) =         hxyu(irg,itg,ipg)
      gamu(1,3) =         hxzu(irg,itg,ipg)
      gamu(2,2) = 1.0d0 + hyyu(irg,itg,ipg)
      gamu(2,3) =         hyzu(irg,itg,ipg)
      gamu(3,3) = 1.0d0 + hzzu(irg,itg,ipg)
      gamu(2,1) = gamu(1,2)
      gamu(3,1) = gamu(1,3)
      gamu(3,2) = gamu(2,3)
c
      rna(1) = sintheg(itg)*cosphig(ipg)
      rna(2) = sintheg(itg)*sinphig(ipg)
      rna(3) = costheg(itg)
      vphig(1) = - rg(irg)*sintheg(itg)*sinphig(ipg)
      vphig(2) =   rg(irg)*sintheg(itg)*cosphig(ipg)
      vphig(3) = 0.0d0
      do 176 ib = 1, 3
      do 176 ia = 1, 3
      aij(ia,ib) = rkij(irg,itg,ipg,ia,ib)
  176 continue
c
      call grgrad1g(psi,gradpsi,irg,itg,ipg,1,1,1)
      call grgrad1g(alph,gradalp,irg,itg,ipg,1,1,1)
      soup = 0.0d0
      soua = 0.0d0
      souj = 0.0d0
      do 177 jj = 1, 3
      do 177 ii = 1, 3
      soup = soup + gamu(ii,jj)*gradpsi(ii)*rna(jj)
      soua = soua + gamu(ii,jj)*gradalp(ii)*rna(jj)
      souj = souj + gamu(ii,jj)*(aij(ii,1)*vphig(1)
     &                         + aij(ii,2)*vphig(2))*rna(jj)
  177 continue
      psipsi = psi(irg,itg,ipg)
      admm = admm + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*soup
cc      admm = admm + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*soup*psipsi**2
      rkom = rkom + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*soua*psipsi**2
      angj = angj + rg(irg)**2*w4dtg(itg)*w4dpg(ipg)*souj*psipsi**6
  175 continue
      admm = - 1.0d0/(2.0d0*pi)*admm*radi*8.0d0/2.0d0
      rkom =   1.0d0/(4.0d0*pi)*rkom*radi*8.0d0/2.0d0
      angj =   1.0d0/(8.0d0*pi)*angj*radi**2*8.0d0/2.0d0
      write(34,820) irg, rg(irg), admm, rkom, angj
      adm5 = adm4
      adm4 = adm3
      adm3 = adm2
      adm2 = adm1
      adm1 = admm
      rko5 = rko4
      rko4 = rko3
      rko3 = rko2
      rko2 = rko1
      rko1 = rkom
  174 continue
      asyadm = (adm1+adm2+adm3+adm4+adm5)/5.0d0
      asykom = (rko1+rko2+rko3+rko4+rko5)/5.0d0
c
  820 format(1i5,1p,7e18.10)
c
c
      nbin = 30
      do 505 jj = 0, nbin
 505  rmsafr(jj) = 0.0d0
c
      do 501 ip = 0, np
      do 501 it = 0, nt
      do 501 ir = 0, nr
      speang(ir,it,ip) = radi*speang(ir,it,ip)/(ahoadm*2.0d0)
c
      emdfc = emd(ir,it,ip)
      ramfc = ram(ir,it,ip)
      psifc = psif(ir,it,ip)
      psinv = 1.0d0/psifc
      alpfc = alphf(ir,it,ip)
      alinv = 1.0d0/alpfc
      rhofc = emdfc**pinx
      prefc = rhofc*emdfc
      hhfc  = 1.0d0 + (pinx+1.0d0)*emdfc
c
      utfc  =       swflu *ramfc/(alpfc**2*hhfc)
     &      +(1.0d0-swflu)*hhfc/ber
c
      weiflu = rs(it,ip)**3*wahop(ir,it,ip)
c
      respart = rhofc*alpfc*utfc*psifc**6*weiflu
c
      do 502 jj = 0, nbin
      if (speang(ir,it,ip).ge.dble(jj)*0.1d0) then
      rmsafr(jj) = rmsafr(jj) +  respart
      end if
 502  continue
 501  continue
c
      nbin = 30
      do 506 jj = 0, nbin
 506  rmsafr(jj) = rmsafr(jj)*radi**3*8.0d0/2.0d0/ahores
c
      aaa1 = 0.0d0
      aaa2 = 0.0d0
      aaa3 = 0.0d0
      san1 = 1.0d0/3.0d0
      san4 = 4.0d0/3.0d0
      san2 = 2.0d0/3.0d0
      do 510 ir = 0, nr
      if (iddd.eq.2) then
      if(ir.eq.0.or .ir.eq.nr) wedr = 0.5d0*dr
      if(ir.ne.0.and.ir.ne.nr) wedr = 1.0d0*dr
      end if
      if (iddd.eq.4) then
      if(ir.eq.0.or .ir.eq.nr                   ) wedr = san1*dr
      if(ir.ne.0.and.ir.ne.nr.and.mod(ir,2).eq.1) wedr = san4*dr
      if(ir.ne.0.and.ir.ne.nr.and.mod(ir,2).eq.0) wedr = san2*dr
      end if
      aaa1 = aaa1 + wedr*psif(ir,nt,   0)**2*rs(nt,   0)
     &            + wedr*psif(ir,nt,np  )**2*rs(nt,np  )
      aaa2 = aaa2 + wedr*psif(ir,nt,np/2)**2*rs(nt,np/2)*2.0d0
      aaa3 = aaa3 + wedr*psif(ir, 0,   0)**2*rs(0    ,0)*2.0d0
 510  continue
c
      emdmx = 0.0d0
      do 44 ir = 0, nr
      emdmx = dmax1(emdmx,emd(ir,nt,0))
      if (emdmx.eq.emd(ir,nt,0)) nrfdmx = ir
 44   continue
c
      emdmx = 0.0d0
      call maxden(emd,emdmx,ddmax)
      ddmax = ddmax + dis
c      
      za = (sepato-1.0d0)/(sepato+1.0d0)
      sepa = sepato
      write(10,4001) nrf, ngdin, za, sepa, pinx, cutfac
      write(10,4000) ome/radi*2.0d0*gravmass, radi, ber, emdc, emdmx
      write(10,4002) irgd, itgd, ipgd, detgmx
      write(10,4002) irgh, itgh, ipgh, dhijmx
      write(10,4002) irga, itga, ipga, tramax
      write(10,4000) resmas, admmas, rkomas, angmom, amomfl
      write(10,4000) ahores, ahoadm, ahokom, ahoang, ahoafl
      write(10,4000) virial, fitadm, fitkom, restmass, gravmass
      write(10,4000) ahovc,  fitvir
c
      write(6,4001) nrf, ngdin, za, sepa, pinx, cutfac
      write(6,4000) ome/radi*2.0d0*gravmass, radi, ber, emdc, emdmx
      write(6,4002) irgd, itgd, ipgd, detgmx
      write(6,4002) irgh, itgh, ipgh, dhijmx
      write(6,4002) irga, itga, ipga, tramax
      write(6,4000) resmas, admmas, rkomas, angmom, amomfl
      write(6,4000) ahores, ahoadm, ahokom, ahoang, ahoafl
      write(6,4000) virial, fitadm, fitkom, restmass, gravmass
      write(6,4000) ahovc,  fitvir
 4000 format(1p,6e14.6)
 4001 format(2i7, 1p,6e14.6)
 4002 format(3i7,7x,1p,e14.6)
c
      write(11,4005) nrf, ngdin, nrfdmx, za, sepa, pinx, cutfac
      write(11,4004) ome/radi, radi, ber
      write(11,4004) emdc, emdmx, ddmax
      write(11,4004) ahores, ahoadm, ahoang
      write(11,4004) ahokom, ahodgs, ahovc 
      write(11,4004) resmas, admmas, angmom
      write(11,4004) rkomas, dgsepa, virial
      write(11,4004) ahoafl, amomfl, ahokom2
      write(11,4004) fitadm, fitkom,  fitvir
      write(11,4004) restmass, gravmass
 4005 format(3i6, 1p,6e12.4)
 4004 format(1p,3e23.15)
c
      write(31,4045) nrf, ngdin, nrfdmx, 2.0d0*sepa, sepa, 
     &               ome/radi, ome/radi*2.0d0*gravmass, 
     &               radi, ber, 
     &               emdc, emdmx, ddmax,
     &               ahores, ahoadm, ahoang,
     &               ahokom, ahodgs, ahovc,
     &               resmas, admmas, angmom,
     &               rkomas, dgsepa, virial,
     &               ahoafl, amomfl, asyadm, asykom, ahokom2, 
     &               fitadm, fitkom, fitvir
 4045 format(3i6, 1p,40e16.8)
c
      do 508 jj = 0, nbin
      write(12,4004) dble(jj)*0.1d0, rmsafr(jj)
 508  continue
      if (iseq.eq.numseq) then
      open(18,file='gnbangphydp.dat',status='old')
      do 507 ip = 0, np
      do 507 it = 0, nt
      write(18,4000) (speang(ir,it,ip), ir = 0, nr)
 507  continue
      close(18)
      end if
c
      write(17,4004) aaa1, aaa2, aaa3
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine mascon(imascond,emxemd,ahores,emdc,restmass,emddiff,
     &                  rmeps,eps,fmax0)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      common / masmas / ahoresm(0:4), ahoemdc(0:4)
c
      write(6,*) ' === emdc and rest mass ===' , emdc, ahores
c
      if (emxemd.lt.rmeps) then
c
      do 10 ii = 0, 3
      ahoresm(ii) = ahoresm(ii+1)
      ahoemdc(ii) = ahoemdc(ii+1)
 10   continue
      ahoresm(4) = ahores
      ahoemdc(4) = emdc
c
      go to (1,2,3) imascond
 1    continue
      if (ahores.le.restmass) emdc = (1.0d0+emddiff)*emdc
      if (ahores.gt.restmass) emdc = (1.0d0-emddiff)*emdc
      imascond = 2
      return
 2    fac1 = (restmass - ahoresm(3))/(ahoresm(4) - ahoresm(3))
      fac2 = 1.0d0 - fac1
      emdc = fac2*ahoemdc(3) + fac1*ahoemdc(4)
      fmax0 = 1.0d0
      if (dabs(restmass - ahoresm(4))/restmass.le.1.0d-4) then
      rmeps = eps
      imascond = 3
      end if
      return
 3    continue
      if (dabs(restmass - ahoresm(4))/restmass.gt.eps) then
      fac1 = (restmass - ahoresm(3))/(ahoresm(4) - ahoresm(3))
      fac2 = 1.0d0 - fac1
      emdc = fac2*ahoemdc(3) + fac1*ahoemdc(4)
      fmax0 = 1.0d0
      end if
      return
ck 2    fac1 = (restmass - ahoresm(3))/(ahoresm(4) - ahoresm(3))
ck      fac2 = 1.0d0 - fac1
ck      emdc = fac2*ahoemdc(3) + fac1*ahoemdc(4)
ckc      imascond = 3
ck      return
ck 3    continue
ck      return
c            
      end if
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine vgr2vflcap(rs)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metfl.f'
      include 'GR_IRDR_metgr.f'
c
      common / cfong / rgf(0:nnr,0:nnt,0:nnp), 
     &                thgf(0:nnr,0:nnt,0:nnp), 
     &               phigf(0:nnr,0:nnt,0:nnp)
      common / cgonf / rfg(0:nnrg,0:nntg,0:nnpg), 
     &                thfg(0:nnrg,0:nntg,0:nnpg), 
     &               phifg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
      common / gmcri / gmcrix(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriy(0:nnrg,0:nntg,0:nnpg),
     &                 gmcriz(0:nnrg,0:nntg,0:nnpg)
      common / gmcrif/ gmcrixf(0:nnr,0:nnt,0:nnp),
     &                 gmcriyf(0:nnr,0:nnt,0:nnp),
     &                 gmcrizf(0:nnr,0:nnt,0:nnp)
      common / cdivb / cdivbv(0:nnrg,0:nntg,0:nnpg)
      common / cdivbf/ cdvbvf(0:nnr,0:nnt,0:nnp)
c
      dimension rs(0:nnt,0:nnp)
c
c
c --- Interporation of the Cartesian component, 
c     from GR to fluid coordinate.  
c
      call gr2flspl(bvxu,bvxuf,rs,1,0)
      call gr2flspl(bvyu,bvyuf,rs,0,0)
      call gr2flspl(bvzu,bvzuf,rs,1,1)
      call gr2flspl(hxxu,hxxuf,rs,0,0)
      call gr2flspl(hxyu,hxyuf,rs,1,0)
      call gr2flspl(hxzu,hxzuf,rs,0,1)
      call gr2flspl(hyyu,hyyuf,rs,0,0)
      call gr2flspl(hyzu,hyzuf,rs,1,1)
      call gr2flspl(hzzu,hzzuf,rs,0,0)
      call gr2flspl(hxxd,hxxdf,rs,0,0)
      call gr2flspl(hxyd,hxydf,rs,1,0)
      call gr2flspl(hxzd,hxzdf,rs,0,1)
      call gr2flspl(hyyd,hyydf,rs,0,0)
      call gr2flspl(hyzd,hyzdf,rs,1,1)
      call gr2flspl(hzzd,hzzdf,rs,0,0)
      call gr2flspl(gmcrix,gmcrixf,rs,0,0)
      call gr2flspl(gmcriy,gmcriyf,rs,1,0)
      call gr2flspl(gmcriz,gmcrizf,rs,0,1)
      call gr2flspl(cdivbv,cdvbvf,rs,0,0)
c
c --- 
c
      dis = sepato
      do 20 ip = 0, npf
      do 20 it = 0, ntf
      do 20 ir = 0, nrf
c
      vphif(ir,it,ip,1) =     - rs(it,ip)*rf(ir)*sinthef(it)*sinphif(ip)
      vphif(ir,it,ip,2) = dis + rs(it,ip)*rf(ir)*sinthef(it)*cosphif(ip)
      vphif(ir,it,ip,3) = 0.0d0
c
 20   continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine vfl2vgrcap(gradf,gradg,rs,hhrg,rrrg,isw)
c
c --- Compute non-variables for inteporation.
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
      common / cfong / rgf(0:nnr,0:nnt,0:nnp), 
     &                thgf(0:nnr,0:nnt,0:nnp), 
     &               phigf(0:nnr,0:nnt,0:nnp)
      common / cgonf / rfg(0:nnrg,0:nntg,0:nnpg), 
     &                thfg(0:nnrg,0:nntg,0:nnpg), 
     &               phifg(0:nnrg,0:nntg,0:nnpg)
c
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      dimension grv(0:nnrg,0:nntg,0:nnpg), flv(0:nnr,0:nnt,0:nnp)
      dimension gradf(0:nnr,0:nnt,0:nnp,1:3),
     &          gradg(0:nnrg,0:nntg,0:nnpg,1:3)
      dimension rs(0:nnt,0:nnp),hhrg(nnrg),rrrg(0:nnrg),rrgg(0:nnrg)
c
      dimension xx(2*nnr+1),yy(2*nnr+1),cc(2*nnr+1,3),
     &          xf(2*nnr+1),ff(2*nnr+1),df(2),iopt(2)
      dimension fr4(4), r4(4)
c --- 
c
      if (isw.eq.0) then
      rrgg(0)   = 0.0d0
      do 9000 irg = 1, nrtot
      rrgg(irg) = hhrg(irg)
 9000 continue
      end if
c
      if (isw.ne.0) then
      do 9001 irg = 0, nrtot
      rrgg(irg) = rrrg(irg)
 9001 continue
      end if
c
c --- Interporation of the Cartesian component, 
c     from fluid to GR coordinate.  
c
      do 8 ii = 1, 3
      do 9 ipg = 0, npg
      do 9 itg = 0, ntg
      do 9 irg = 0, nrtot
      gradg(irg,itg,ipg,ii) = 0.0d0
      grv(irg,itg,ipg) = 0.0d0
 9    continue
      do 7 ipf = 0, npf
      do 7 itf = 0, ntf
      do 7 irf = 0, nrf
      flv(irf,itf,ipf) = gradf(irf,itf,ipf,ii)
 7    continue
      call fl2grspl(flv,grv,rs,hhrg,rrrg,isw)
      do 4 ip = 0, npgmax
      do 4 it = ntgmin, ntg
      do 4 ir = nrgmin, nrgmax
      gradg(ir,it,ip,ii) = grv(ir,it,ip)
 4    continue
 8    continue
c
c --  for phi velocity on x-axis. 
c
      dis = sepato
      do 900 irf = 0, nrf-1
      xx(irf+1) = dis - rf(nrf-irf)*rs(ntf,npf)
 900  yy(irf+1) = gradf(nrf-irf,ntf,npf,2)
      irf = nrf
      xx(irf+1) = dis
cmachigai      yy(irf+1) = gradf(0,ntf,npf/2,1)
      yy(irf+1) = gradf(0,ntf,npfyz,2)
      do 901 irf = nrf+1, 2*nrf
      xx(irf+1) = dis + rf(irf-nrf)*rs(ntf,0)
 901  yy(irf+1) = gradf(irf-nrf,ntf,0,2)
c
      small = 1.0d-8 
      nrgmin1 = max0(0,nrgmin-1)
      do 902 irg = nrgmin1, nrgmax
      ir0 = 1
      if (rrgg(irg).le.xx(1)-small) go to 902
      if (rrgg(irg).ge.xx(2*nrf+1)+small) go to 905
      do 903 irf = 1, 2*nrf + 1
      if (rrgg(irg).ge.xx(irf).and.rrgg(irg).lt.xx(irf+1)+small) then
      ir0 = min0(max0(irf-2,1),2*nrf+1-3)
      go to 904
      end if
 903  continue
 904  continue
      rv = rrgg(irg)
      do 90 ii = 1, 4
      irf0 = ir0 + ii - 1
      r4(ii) = xx(irf0)
      fr4(ii) = yy(irf0)
 90   continue
      gradg(irg,ntg,0,2) = fn_lagint(r4,fr4,rv)
 902  continue
 905  continue
c
c --  for phi=0 plane. 
c
      do 21 it = ntgmin, ntg
      do 21 ir = nrgmin, nrgmax
      gradg(ir,it,0,1) = 0.0d0
c --- y sokudo ha itsumo sei (kidou kaiten ookii).
      gradg(ir,it,0,2) = dabs(gradg(ir,it,0,2))
      gradg(ir,it,0,3) = 0.0d0
c
 21   continue
c
c      if (it.eq.ntg)write(24,*) gradg(ir,it,0,2),yy(ir-nrgmin+1)
cc      write(6,*) gradf(nr,nt,np,2), gradf(0,nt,npfyz,2),
cc     &            gradf(nr,nt,0,2)
cc       stop ' aho '
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine fluid(iter,itmx,convf,cfvep,fmax0,ahores,emxemd,char)
c
      implicit real*8(a-h,o-z), integer(i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_metfl.f'
c
      common / weigh / wgdr(0:nnr), wgdt(0:nnt), wgdp(0:nnp),
     &                wgrtp(0:nnr,0:nnt,0:nnp), 
     &                 w4dr(0:nnr), w4dt(0:nnt), w4dp(0:nnp),
     &                w4rtp(0:nnr,0:nnt,0:nnp), wahop(0:nnr,0:nnt,0:nnp)
      common / intpp / thmx, phimx,
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
      common / legen / spn(0:nnt,0:nnp,0:nnl), 
     &                 fsn(0:nnr,0:nnl,0:nnr)
      common / asleg / pna(0:nnla,0:nnla,0:nnt),
     &               dtpna(0:nnla,0:nnla,0:nnt), 
     &               facnm(0:nnla,0:nnla), epsi(0:nnla)
      common / trimp / sinmp(0:nnla,0:nnp),  cosmp(0:nnla,0:nnp)
      common / asylm / ypna(0:nnla,0:nnla,0:nnt),
     &               dtypna(0:nnla,0:nnla,0:nnt)
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato,
     &                 g, pi, emdc, ipolar
c
      common / diffv / rsinv(0:nnt,0:nnp),
     &              dtrs(0:nnt,0:nnp),dprs(0:nnt,0:nnp)
c
      common / gmcrif/ gmcrixf(0:nnr,0:nnt,0:nnp),
     &                 gmcriyf(0:nnr,0:nnt,0:nnp),
     &                 gmcrizf(0:nnr,0:nnt,0:nnp)
      common / cdivbf/ cdvbvf(0:nnr,0:nnt,0:nnp)
c
      dimension backf(0:nnr,0:nnt,0:nnp), rsb(0:nnt,0:nnp)
      dimension hut(0:nnr,0:nnt,0:nnp), aloh(0:nnr,0:nnt,0:nnp),
     &        hutp6(0:nnr,0:nnt,0:nnp),psif4(0:nnr,0:nnt,0:nnp), 
     &        gradv(0:nnr,0:nnt,0:nnp,1:3),
     &       gradps(0:nnr,0:nnt,0:nnp,1:3),
     &       gradhu(0:nnr,0:nnt,0:nnp,1:3),
     &       gradah(0:nnr,0:nnt,0:nnp,1:3),
     &        grade(0:nnr,0:nnt,0:nnp,1:3)
c
      dimension surp(0:nnt,0:nnp), rs00(0:nnt,0:nnp)
      dimension vpot(0:nnr,0:nnt,0:nnp), souv(0:nnr,0:nnt,0:nnp)
      dimension vpotfc(0:nnr,0:nnt,0:nnp), souvfc(0:nnr,0:nnt,0:nnp)
c      dimension emdfc(0:nnr,0:nnt,0:nnp), potfc(0:nnr,0:nnt,0:nnp)
      dimension flag(0:nnr,0:nnt,0:nnp),   wgsf(0:nnr,0:nnt,0:nnp),
     &        wgrtpv(0:nnr,0:nnt,0:nnp), wgrtpp(0:nnr,0:nnt,0:nnp)
c
      dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),f(1)
      dimension dabvep(3,3)
      dimension ddvpot(0:nnt,0:nnp,1:3)
      dimension sgg(nnbou), gg(nnbou,nnbou)
c
      character*3 char
c
c ----------------------------------------------------------------------
c
      drinv=1.0d0/dr
      dtinv=1.0d0/dth
      dpinv=1.0d0/dphi
      pi = 3.14159265358979d+0
c
c ----------------------------------------------------------------------
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
c     Equations start. 
c
c ======================================================================
c
c     Generalized Bernoulli equation.
c
c ======================================================================
c
c --  Preparation.
cmark
cxx      call flgrad4(vep,gradv,rs,1,-1)
cfouri      call flgrad(vep,gradv,rs,1,np/4)
      call flgrad(vep,gradv,rs,1,0)
c
      do 70 ip = 0, np
      do 70 it = 0, nt
      ir = 0
      bvyfg = bvyuf(0,nt,npfyz)
      vphiy = vphif(ir,it,ip,2)
      dyvp  = gradv(0,nt,npfyz,2)
      ram(ir,it,ip) = ber + (bvyfg + ome*vphiy)*dyvp
      do 70 ir = 1, nr
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
      dxvp  = gradv(ir,it,ip,1)
      dyvp  = gradv(ir,it,ip,2)
      dzvp  = gradv(ir,it,ip,3)
      ram(ir,it,ip) = ber + (bvxfc + ome*vphix)*dxvp
     &                    + (bvyfc + ome*vphiy)*dyvp
     &                    + (bvzfc + ome*vphiz)*dzvp
 70   continue
c
c --  Generalized Bernoulli equation.
c
      do 100 ip = 0, np
      do 100 it = 0, nt
      do 100 ir = 0, nr
c
      backf(ir,it,ip) = emd(ir,it,ip)
      gamxxu = hxxuf(ir,it,ip) + 1.0d0
      gamxyu = hxyuf(ir,it,ip)
      gamxzu = hxzuf(ir,it,ip)
      gamyyu = hyyuf(ir,it,ip) + 1.0d0
      gamyzu = hyzuf(ir,it,ip)
      gamzzu = hzzuf(ir,it,ip) + 1.0d0
      gamyxu = gamxyu
      gamzxu = gamxzu
      gamzyu = gamyzu
      dxvp = gradv(ir,it,ip,1)
      dyvp = gradv(ir,it,ip,2)
      dzvp = gradv(ir,it,ip,3)
c
      ramc  = ram(ir,it,ip)
      alphc = alphf(ir,it,ip)
      psic  = psif(ir,it,ip)
c
      emd(ir,it,ip) = 1.0d0/(pinx+1.0d0)*
     &  (((ramc/alphc)**2 - 1.0d0/psic**4*
     &  (gamxxu*dxvp*dxvp + gamxyu*dxvp*dyvp + gamxzu*dxvp*dzvp
     & + gamyxu*dyvp*dxvp + gamyyu*dyvp*dyvp + gamyzu*dyvp*dzvp
     & + gamzxu*dzvp*dxvp + gamzyu*dzvp*dyvp + gamzzu*dzvp*dzvp))**0.5
     & - 1.0d0)
c
  100 continue
c
      do 42 ip = 0, np
      do 42 it = 0, nt
      emd(0,it,ip) = emd(0,nt,np/2)
 42   continue
c
      emdmx = 0.0d0
      do 44 ir = 0, nr
      emdmx = dmax1(emdmx,emd(ir,nt,0))
      if (emdmx.eq.emd(ir,nt,0)) nrfdmx = ir
 44   continue
c
      nrgdmx = nrfdmx + nrgmid
cz      emd(nrfdmx,nt,0) = emdc
cz      if (nrfdmx.eq.0) then 
      do 45 ip = 0, np
      do 45 it = 0, nt
      emd(0,it,ip) = emdc
 45   continue
cz      end if
c
c --- For axis. 
c
      do 191 ir = 1, nr
      emem = emd(ir,0,np/2)
      do 193 ip = 0, np
      emd(ir,0,ip) = emem
 193  continue
 191  continue
c
c --- For surface. 
c
      do 170 ip = 0, np
      do 170 it = 0, nt
      rsb(it,ip) = rs(it,ip)
      delx = dr*(surr - emd(nr,it,ip))/(emd(nr,it,ip) - emd(nr-1,it,ip))
      rs(it,ip) = rs(it,ip)*(1.0d0 + delx)
  170 continue
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c
c     ### Iteration. ###
c     Set improved values for emden function and surface.
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c
c --- For parameters. 
c
      rs(nt, 0) = 1.0d0
      rs(nt,np) = 1.0d0
c
      do 4000 ip = 0, np
      do 4000 it = 0, nt
      emd(nr,it,ip) = surr
cz      if (emd(nr-1,it,ip).le.0.0d0) emd(nr-1,it,ip) = surr
cz      if (emd(nr-2,it,ip).le.0.0d0) emd(nr-2,it,ip) = surr
cz      if (emd(nr-3,it,ip).le.0.0d0) emd(nr-3,it,ip) = surr
      if (rs(it,ip).ge.1.05d0) rs(it,ip) = 1.05d0
      do 4000 ir = 0, nr-1
      if (emd(ir,it,ip).le.0.0d0) emd(ir,it,ip) = surr
 4000 continue
c
      call flimpro(backf,emd,convf,emxemd,irerr,iterr,iperr,1)
      write(6,4901) '  == emd   ==, error =', emxemd,
     &              emd(irerr,iterr,iperr), irerr,iterr,iperr
      fmax0 = dmax1(emxemd,fmax0)
c
      call rsimpro(rsb,rs,convf,emxrs,iterr,iperr)
      write(6,4901) '  == rs    ==, error =', emxrs,
     &              rs(iterr,iperr),iterr,iperr
      fmax0 = dmax1(emxrs,fmax0)
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c --- Derivatives for variables ---
cmark
cx      call flgrad4(vep,gradv,rs,1,0)
cfouri      call flgrad(vep,gradv,rs,1,np/4)
      call flgrad(vep,gradv,rs,1,0)
c
      do 79 ip = 0, np
      do 79 it = 0, nt
      ir = 0
      psic  = psif(ir,it,ip)
      alphc = alphf(ir,it,ip)
      emden  = emd(ir,it,ip)
      hhh = 1.0d0 + (pinx+1.0d0)*emden
      dyvp  = gradv(0,nt,npfyz,2)
      bvyfc = bvyuf(0,nt,npfyz)
      vphiy = vphif(ir,it,ip,2)
      ram(ir,it,ip) = ber + (bvyfc + ome*vphiy)*dyvp
      ramc  = ram(ir,it,ip)
      hut(ir,it,ip) = ramc/alphc**2
      hutp6(ir,it,ip) = ramc/alphc**2*psic**6
      aloh(ir,it,ip) = dlog(alphc/hhh)
      psif4(ir,it,ip) = psic**4
      do 79 ir = 1, nr
      psic  = psif(ir,it,ip)
      alphc = alphf(ir,it,ip)
      emden  = emd(ir,it,ip)
      hhh = 1.0d0 + (pinx+1.0d0)*emden
      dxvp = gradv(ir,it,ip,1)
      dyvp = gradv(ir,it,ip,2)
      dzvp = gradv(ir,it,ip,3)
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
      ram(ir,it,ip) = ber + (bvxfc + ome*vphix)*dxvp
     &                    + (bvyfc + ome*vphiy)*dyvp
     &                    + (bvzfc + ome*vphiz)*dzvp
      ramc  = ram(ir,it,ip)
      hut(ir,it,ip) = ramc/alphc**2
      hutp6(ir,it,ip) = ramc/alphc**2*psic**6
      aloh(ir,it,ip) = dlog(alphc/hhh)
      psif4(ir,it,ip) = psic**4
 79   continue
c
      call flgrad4(psif,gradps,rs,2,0)
c      call flgrad(psif,gradps,rs,2,0)
cmark --
c      call flgrad4(hutp6,gradhu,rs,2,0)
cfouri      call flgrad(hutp6,gradhu,rs,2,np/4)
      call flgrad(hutp6,gradhu,rs,2,0)
c --
      call flgrad4(aloh,gradah,rs,2,0)
      call flgrad4(emd,grade,rs,2,0)
      call flgrad4(psif,gradps,rs,2,0)
cc      call flgrad(hut,gradhu,rs,2,0)
cc      call flgrad(aloh,gradah,rs,2,0)
cc      call flgrad(emd,grade,rs,2,0)
cc      call flgrad(hhh,gradh,rs,2,0)
c
c ======================================================================
c
c     Equation of continuity.  
c     Homogeneous solution.
c
c ======================================================================
c
c ----
c     Source term.
c ----
      do 1099 ip = 0, np
      do 1099 it = 0, nt
      surp(it,ip) = 0.0d0
      do 1099 ir = 0, nr
      souv(ir,it,ip) = 0.0d0
      vpot(ir,it,ip) = 0.0d0
 1099 continue
c
      do 1100 ip = 0, np
      do 1100 it = 0, nt
      do 1100 ir = 0, nr
c
      hhxxu = hxxuf(ir,it,ip)
      hhxyu = hxyuf(ir,it,ip)
      hhxzu = hxzuf(ir,it,ip)
      hhyyu = hyyuf(ir,it,ip)
      hhyzu = hyzuf(ir,it,ip)
      hhzzu = hzzuf(ir,it,ip)
      hhyxu = hhxyu
      hhzxu = hhxzu
      hhzyu = hhyzu
      gamxxu = hhxxu + 1.0d0
      gamxyu = hhxyu
      gamxzu = hhxzu
      gamyyu = hhyyu + 1.0d0
      gamyzu = hhyzu
      gamzzu = hhzzu + 1.0d0
      gamyxu = gamxyu
      gamzxu = gamxzu
      gamzyu = gamyzu
      rotshx = bvxuf(ir,it,ip) + ome*vphif(ir,it,ip,1)
      rotshy = bvyuf(ir,it,ip) + ome*vphif(ir,it,ip,2)
      rotshz = bvzuf(ir,it,ip) + ome*vphif(ir,it,ip,3)
      gcx = gmcrixf(ir,it,ip)
      gcy = gmcriyf(ir,it,ip)
      gcz = gmcrizf(ir,it,ip)
c
      dxpsi = gradps(ir,it,ip,1)
      dypsi = gradps(ir,it,ip,2)
      dzpsi = gradps(ir,it,ip,3)
      pfinv = 1.0d0/psif(ir,it,ip)
      pf2inv = pfinv**2
      pf4 = psif4(ir,it,ip)
      dxvpd = gradv(ir,it,ip,1)
      dyvpd = gradv(ir,it,ip,2)
      dzvpd = gradv(ir,it,ip,3)
      dxvpu = gamxxu*dxvpd + gamxyu*dyvpd + gamxzu*dzvpd
      dyvpu = gamyxu*dxvpd + gamyyu*dyvpd + gamyzu*dzvpd
      dzvpu = gamzxu*dxvpd + gamzyu*dyvpd + gamzzu*dzvpd
      hhut = hut(ir,it,ip)
      dxhutp6 = gradhu(ir,it,ip,1)
      dyhutp6 = gradhu(ir,it,ip,2)
      dzhutp6 = gradhu(ir,it,ip,3)
      dxlnarh = gradah(ir,it,ip,1)+pinx*grade(ir,it,ip,1)/emd(ir,it,ip)
      dylnarh = gradah(ir,it,ip,2)+pinx*grade(ir,it,ip,2)/emd(ir,it,ip)
      dzlnarh = gradah(ir,it,ip,3)+pinx*grade(ir,it,ip,3)/emd(ir,it,ip)
      divbvf = cdvbvf(ir,it,ip)
c
c      if (it.eq.nt.and.ip.eq.np/2) write(6,*)divbvf,bvyuf(ir,it,ip)
c --- DaDb vep
c
      call dadbscalarf(vep,dabvep,ir,it,ip)
c
      souv(ir,it,ip) = 
     &  -(hhxxu*dabvep(1,1) + hhxyu*dabvep(1,2) + hhxzu*dabvep(1,3)
     &  + hhyxu*dabvep(2,1) + hhyyu*dabvep(2,2) + hhyzu*dabvep(2,3)
     &  + hhzxu*dabvep(3,1) + hhzyu*dabvep(3,2) + hhzzu*dabvep(3,3))
     &  + gcx*dxvpd + gcy*dyvpd + gcz*dzvpd
     &  - 2.0d0*pfinv*(dxvpu*dxpsi + dyvpu*dypsi + dzvpu*dzpsi)
     &  + pf2inv*(rotshx*dxhutp6 + rotshy*dyhutp6 + rotshz*dzhutp6)
     &  + pf4*hhut*divbvf
     &  -(dxvpu - pf4*hhut*rotshx)*dxlnarh
     &  -(dyvpu - pf4*hhut*rotshy)*dylnarh
     &  -(dzvpu - pf4*hhut*rotshz)*dzlnarh
c
 1100 continue
c
ctesttest
c        stop
ctesttest
c
      do 1101 ip = 0, np
      do 1101 it = 0, nt
      b1 = souv(nr-2,it,ip) - souv(nr-3,it,ip)
      b2 = souv(nr-1,it,ip) - souv(nr-2,it,ip)
      b3 = 2.0d0*b2 - b1
      souv(nr,it,ip) = b3 + souv(nr-1,it,ip)
ccc      souv(nr,it,ip) = 2.0d0*souv(nr-1,it,ip) - souv(nr-2,it,ip)
      souv(0,it,ip) = 0.0d0
 1101 continue
      do 1102 it = 0, nt
      do 1102 ir = 0, nr
      souv(ir,it, 0) = 0.0d0
      souv(ir,it,np) = 0.0d0
 1102 continue
c
c === START of fixed coordinate. ===
c
      call sf2fc(souv,souvfc,rs)
c
      do 448 ip = 0, np
      do 448 it = 0, nt
      iflag = 1
      irsf = idint(rs(it,ip)*dble(nr))
      drdr= (rs(it,ip) - r(irsf))/dr
      do 448 ir = 0, nr
c
      wgsf(ir,it,ip) = dble(iflag)
czcz      if (ir.eq.irsf-1.and.ir+1.ne.nr) then
czcz      wgsf(ir,it,ip) = 1.0d0 - 0.5d0*drdr**2
czcz      end if
      if (ir.eq.irsf.and.ir.ne.nr) then
czcz      wgsf(ir,it,ip) = 0.5d0 + drdr + 1.5d0*drdr**2
      wgsf(ir,it,ip) = 0.5d0 + drdr
czcz      wgsf(ir,it,ip) = 0.5d0
      iflag = 0
      end if
      wgrtpv(ir,it,ip) = wgsf(ir,it,ip)*wgdr(ir)*wgdt(it)*wgdp(ip)
ccc      wgrtpv(ir,it,ip) = wgdr(ir)*wgdt(it)*wgdp(ip)
      flag(ir,it,ip) = dble(iflag)
cahotest
c
cp      if(ip.eq.0.or .ip.eq.np) facp = 1.0d0/3.0d0
cp      if(ip.ne.0.and.ip.ne.np.and.mod(ip,2).eq.1) facp = 4.0d0/3.0d0 
cp      if(ip.ne.0.and.ip.ne.np.and.mod(ip,2).eq.0) facp = 2.0d0/3.0d0 
c
cp      if(it.eq.0.or .it.eq.nt) fact = 1.0d0/3.0d0
cp      if(it.ne.0.and.it.ne.nt.and.mod(it,2).eq.1) fact = 4.0d0/3.0d0 
cp      if(it.ne.0.and.it.ne.nt.and.mod(it,2).eq.0) fact = 2.0d0/3.0d0 
c
cp      if(ir.eq.0.or .ir.eq.nr) facr = 1.0d0/3.0d0
cp      if(ir.ne.0.and.ir.ne.nr.and.mod(ir,2).eq.1) facr = 4.0d0/3.0d0
cp      if(ir.ne.0.and.ir.ne.nr.and.mod(ir,2).eq.0) facr = 2.0d0/3.0d0
c
cp      fac = facr*fact*facp
cp      wgrtpv(ir,it,ip) = fac*r(ir)**2*dr*sinthe(it)*dth*dphi
c
 448  continue
c
      call gravep(souvfc,vpotfc,wgrtpv,sinmp)
      call fc2sf(vpotfc,vpot,rs)
c
c === END of fixed coordinate. ===
c
      call gravpot(souvfc,ddvpot,wgrtpv,sinmp,rs)
c
c      call flfcgrad4(vpotfc,gradv,3)
c
      ir = nr
      nc = nnr
      n = nr+1
c
      do 1104 ip = 0, np
      do 1104 it = 0, nt
c
      irsf = idnint(rs(it,ip)*dble(nr))
      if (irsf.eq.nr) irsf = nr - 1
      delr = rs(it,ip) - r(irsf)
      ddvpot(it,ip,1) = 0.5d0*drinv**2*
     &         ((2.0d0*delr - dr)*vpotfc(irsf-1,it,ip) 
     &        + (2.0d0*delr + dr)*vpotfc(irsf+1,it,ip) 
     &        -  4.0d0*delr*      vpotfc(irsf  ,it,ip) )
      if (rs(it,ip).ge.1.0d0) then 
      ddvpot(it,ip,1) = 0.5d0*drinv*(3.0d0*vpotfc(nr  ,it,ip)  
     &                             - 4.0d0*vpotfc(nr-1,it,ip) 
     &                             +       vpotfc(nr-2,it,ip) )
      end if
c
      hhxxu = hxxuf(ir,it,ip)
      hhxyu = hxyuf(ir,it,ip)
      hhxzu = hxzuf(ir,it,ip)
      hhyyu = hyyuf(ir,it,ip)
      hhyzu = hyzuf(ir,it,ip)
      hhzzu = hzzuf(ir,it,ip)
      hhyxu = hhxyu
      hhzxu = hhxzu
      hhzyu = hhyzu
      gamxxu = hhxxu + 1.0d0
      gamxyu = hhxyu
      gamxzu = hhxzu
      gamyyu = hhyyu + 1.0d0
      gamyzu = hhyzu
      gamzzu = hhzzu + 1.0d0
      gamyxu = gamxyu
      gamzxu = gamxzu
      gamzyu = gamyzu
      gr1 = ddvpot(it,ip,1)
      gr2 = ddvpot(it,ip,2)
      gr3 = ddvpot(it,ip,3)
      dxvep = gr1*sinthe(it)*cosphi(ip)
     &      + gr2*costhe(it)*cosphi(ip)  
     &      - gr3*sinphi(ip) 
      dyvep = gr1*sinthe(it)*sinphi(ip)
     &      + gr2*costhe(it)*sinphi(ip)
     &      + gr3*cosphi(ip) 
      dzvep = gr1*costhe(it)
     &      - gr2*sinthe(it)
c
      rnr = 1.0d0
      rnth = - rsinv(it,ip)*dtrs(it,ip)
      rnphi = - rsinv(it,ip)*cosec(it)*dprs(it,ip)
      erx = sinthe(it)*cosphi(ip)
      ery = sinthe(it)*sinphi(ip)
      erz = costhe(it)
      ethx = costhe(it)*cosphi(ip)
      ethy = costhe(it)*sinphi(ip)
      ethz = - sinthe(it)
      ephix = - sinphi(ip)
      ephiy =   cosphi(ip)
      ephiz = 0.0d0
      rnx = rnr*erx + rnth*ethx + rnphi*ephix
      rny = rnr*ery + rnth*ethy + rnphi*ephiy
      rnz = rnr*erz + rnth*ethz + rnphi*ephiz
c
      surp(it,ip) = (gamxxu*dxvep + gamxyu*dyvep + gamxzu*dzvep)*rnx
     &            + (gamyxu*dxvep + gamyyu*dyvep + gamyzu*dzvep)*rny
     &            + (gamzxu*dxvep + gamzyu*dyvep + gamzzu*dzvep)*rnz
c
 1104 continue
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c     Coefficients of harmonic solution is computed. 
c      write(6,*)' surf  '
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
      do 2000 ii = 1, nbou
      sgg(ii) = 0.
      do 2000 jj = 1, nbou
      gg(ii,jj) = 0.0d0
      alm(ii,jj) = 0.0d0
 2000 continue
c
c --- Boundary equations are solved. 
c
      ieqs = 0
      do 85 il = 1, nla
      do 85 im = 2-mod(il,2), il, 2
      ieqs = ieqs + 1
c
      do 80 ip = 0, np
      do 80 it = 1, nt
c
      ir = nr
c
      rnr = 1.0d0
      rnth = - rsinv(it,ip)*dtrs(it,ip)
      rnphi = - rsinv(it,ip)*cosec(it)*dprs(it,ip)
      erx = sinthe(it)*cosphi(ip)
      ery = sinthe(it)*sinphi(ip)
      erz = costhe(it)
      ethx = costhe(it)*cosphi(ip)
      ethy = costhe(it)*sinphi(ip)
      ethz = - sinthe(it)
      ephix = - sinphi(ip)
      ephiy =   cosphi(ip)
      ephiz = 0.0d0
      rnx = rnr*erx + rnth*ethx + rnphi*ephix
      rny = rnr*ery + rnth*ethy + rnphi*ephiy
      rnz = rnr*erz + rnth*ethz + rnphi*ephiz
      rotshx = bvxuf(ir,it,ip) + ome*vphif(ir,it,ip,1)
      rotshy = bvyuf(ir,it,ip) + ome*vphif(ir,it,ip,2)
      rotshz = bvzuf(ir,it,ip) + ome*vphif(ir,it,ip,3)
c
      flm = 
     & dble(il)*rs(it,ip)**(il-1)*ypna(il,im,it)*sinmp(im,ip) - 
     & rs(it,ip)**(il-2)*dtrs(it,ip)*dtypna(il,im,it)*sinmp(im,ip) - 
     & rs(it,ip)**(il-2)*cosec(it)**2*dprs(it,ip)*ypna(il,im,it)*
     & dble(im)*cosmp(im,ip)
c
      sgg(ieqs) = sgg(ieqs) + 
     &  ( - surp(it,ip) + hut(ir,it,ip)*psif4(ir,it,ip)*
     &       (rotshx*rnx + rotshy*rny + rotshz*rnz) )*flm
c
      ivec = 0
      do 87 ill = 1, nla
      do 87 imm = 2-mod(ill,2), ill, 2
      ivec = ivec + 1
c
      fllmm = 
     & dble(ill)*rs(it,ip)**(ill-1)*ypna(ill,imm,it)*sinmp(imm,ip) - 
     & rs(it,ip)**(ill-2)*dtrs(it,ip)*dtypna(ill,imm,it)*sinmp(imm,ip) - 
     & rs(it,ip)**(ill-2)*cosec(it)**2*dprs(it,ip)*ypna(ill,imm,it)*
     & dble(imm)*cosmp(imm,ip)
c
      gg(ieqs,ivec) = gg(ieqs,ivec) + fllmm*flm
c
   87 continue
c
      if(ivec.ne.nbou) write(6,*) ' harmonic ivec wrong ', ivec, nbou
c
   80 continue
c
   85 continue
c
      if(ieqs.ne.nbou) write(6,*) ' harmonic ieqs wrong ', ieqs, nbou
c
ctesttest
c      do ii = 0, ieqs
c      write(24,99)sgg(ii)
c      end do
c      stop
c
      call minv(gg,sgg,nbou,nnbou)
c
      ieqs = 0
      do 88 il = 1, nla
      do 88 im = 2-mod(il,2), il, 2
      ieqs = ieqs + 1
      alm(il,im) = sgg(ieqs)
   88 continue
      if(ieqs.ne.nbou) write(6,*) ' harmonic alm wrong ', ieqs, nbou
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
      do 110 irtp = 1, (nr+1)*(nt+1)*(np+1)
c
      ip = (irtp-1)/((nr+1)*(nt+1))
      it = (irtp-1)/ (nr+1) - ip*(nt+1)
      ir = irtp-1 - it*(nr+1) - ip*(nr+1)*(nt+1)
c
      surf = 0.d0
      do 140 il = 1, nla
ccc      do 140 il = 1, nla-2
      do 140 im = 2-mod(il,2), il, 2
      surf = surf + alm(il,im)*(r(ir)*rs(it,ip))**il*
     &              ypna(il,im,it)*sinmp(im,ip)
  140 continue
c
      backf(ir,it,ip) = vep(ir,it,ip)
      vep(ir,it,ip) = vpot(ir,it,ip) + surf
c
  110 continue
c
ctesttest
c      do ir = 0, nr
c      write(24,99)r(ir),vep(ir,nt-2,2),vpot(ir,nt-2,2),
c     &   vep(ir,nt-2,2)-vpot(ir,nt-2,2)
c       end do
c 99   format(1p,7e14.6)
c        stop
ctesttest
c
      if (iter.eq.itmx) then
      do 141 il = 1, nla
      do 141 im = 2-mod(il,2), il, 2
      write(24,*)il,im,alm(il,im)
 141  continue
      end if
c
c --- For x-z plane. 
c
      do 1197 ip = 0, np
      do 1197 ir = 0, nr
      vep(ir,0,ip) = 0.0d0
 1197 continue
      do 1198 it = 1, nt
      do 1198 ir = 0, nr
      vep(ir,it,0 ) = 0.0d0
      vep(ir,it,np) = 0.0d0
 1198 continue
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c
c     ### Iteration. ###
c     Set improved values for velocity potential.
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c
c --- Set improved variables. 
c
      call flimpro(backf,vep,cfvep,emxvep,irerr,iterr,iperr,0)
      write(6,4901) '  == vep   ==, error =', emxvep,
     &              vep(irerr,iterr,iperr), irerr,iterr,iperr
      fmax0 = dmax1(emxvep,fmax0)
c
c --  Improving parameters and alpha and psi.  
c
      call paimpro(ome,ber,radi,convf,iter,fmax0,1)
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
cmark
      call flgrad4(vep,gradv,rs,1,0)
c      call flgrad(vep,gradv,rs,1,0)
      ahores = 0.0d0
      do 500 ip = 0, np
      do 500 it = 0, nt
      do 500 ir = 0, nr
c
      alpfc = alphf(ir,it,ip)
      psifc = psif(ir,it,ip)
      emdfc = emd(ir,it,ip)
      if (emdfc.le.1.0d-14) emdfc = 1.0d-14
      rhofc = emdfc**pinx
      hhfc  = 1.0d0 + (pinx+1.0d0)*emdfc
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
      ram(ir,it,ip) = ber + (bvxfc + ome*vphix)*gradv(ir,it,ip,1)
     &                    + (bvyfc + ome*vphiy)*gradv(ir,it,ip,2)
     &                    + (bvzfc + ome*vphiz)*gradv(ir,it,ip,3)
      ramfc = ram(ir,it,ip)
c
      utfc  = ramfc/(alpfc**2*hhfc)
c
      weiflu = rs(it,ip)**3*wahop(ir,it,ip)
      ahores = ahores + rhofc*alpfc*utfc*psifc**6*weiflu
c
 500  continue
      ahores = radi**3*ahores*8.0d0/2.0d0
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
 4901 format(a22,1p,e12.4,',  value =',e12.4,2x,3i4)
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine gravep(sou,pot,wgrtp,scmp)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      common / legen / spn(0:nnt,0:nnp,0:nnl), 
     &                 fsn(0:nnr,0:nnl,0:nnr)
      common / asleg / pna(0:nnla,0:nnla,0:nnt),
     &               dtpna(0:nnla,0:nnla,0:nnt), 
     &               facnm(0:nnla,0:nnla), epsi(0:nnla)
c
      dimension  sou(0:nnr,0:nnt,0:nnp), pot(0:nnr,0:nnt,0:nnp)
      dimension  scmp(0:nnla,0:nnp)
      dimension  wgrtp(0:nnr,0:nnt,0:nnp)
      dimension work1(0:nnt,0:nnr,0:nnl), 
     &          work2(0:nnr,0:nnl,0:nnl), 
     &          work3(0:nnl,0:nnl,0:nnr),
     &          work4(0:nnl,0:nnr,0:nnt)
c
c --- Gravitational and Velocity potential is caluculated.
c      write(6,*)' gravep  '
c
c    fsn(irr,nn,id,ir) --> id =  0 for r'< r
c                          id = +1 for r < r'
c
      do 1001 im = 0, nl, msym
      do 1001 irr = 0, nr
      do 1001 itt = 0, nt
      work1(itt,irr,im) = 0.0d0
      do 1001 ipp = 0, np
      work1(itt,irr,im) = work1(itt,irr,im) + 
     &                    wgrtp(irr,itt,ipp)*
     &                    sou(irr,itt,ipp)*scmp(im,ipp)
 1001 continue
c
      do 1002 il = 0, nl
      do 1002 im = 0, nl, msym
      pari = 1.0d0 + (-1.0d0)**(il+im)
      do 1002 irr = 0, nr
      work2(irr,il,im) = 0.0d0
      do 1002 itt = 0, nt
      work2(irr,il,im) = work2(irr,il,im) + 
     &                   pari*epsi(im)*facnm(il,im)*
     &                   work1(itt,irr,im)*pna(il,im,itt)
 1002 continue
c
      do 1003 ir = 0, nr
      do 1003 il = 0, nl
      do 1003 im = 0, nl, msym
      work3(il,im,ir) = 0.0d0
      do 1003 irr = 0, nr
      work3(il,im,ir) = work3(il,im,ir) + 
     &                  work2(irr,il,im)*fsn(irr,il,ir)
 1003 continue
c
      do 1004 it = 0, nt
      do 1004 ir = 0, nr
      do 1004 im = 0, nl, msym
      work4(im,ir,it) = 0.0d0
      do 1004 il = 0, nl
      work4(im,ir,it) = work4(im,ir,it) + 
     &                  work3(il,im,ir)*pna(il,im,it)
 1004 continue
c
      do 1000 ip = 0, np
      do 1000 it = 0, nt
      do 1000 ir = 0, nr
      pot(ir,it,ip) = 0.0d0
      do 1000 im = 0, nl, msym
      pot(ir,it,ip) = pot(ir,it,ip) +
     &                work4(im,ir,it)*scmp(im,ip)
 1000 continue
c
      pi = 3.14159265358979d+0
      pi4inv = 1.0d0/4.0d0/pi
      pi4aho = pi4inv*2.0d0*dble(msym)
      do 100 ip = 0, np
      do 100 it = 0, nt
      do 100 ir = 0, nr
 100  pot(ir,it,ip) = - pi4aho*pot(ir,it,ip)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine gravpot(sou,ddvpot,wgrtp,scmp,rs)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      common / legen / spn(0:nnt,0:nnp,0:nnl), 
     &                 fsn(0:nnr,0:nnl,0:nnr)
      common / trimp / sinmp(0:nnla,0:nnp),  cosmp(0:nnla,0:nnp)
      common / asleg / pna(0:nnla,0:nnla,0:nnt),
     &               dtpna(0:nnla,0:nnla,0:nnt), 
     &               facnm(0:nnla,0:nnla), epsi(0:nnla)
c
      dimension  sou(0:nnr,0:nnt,0:nnp), pot(0:nnr,0:nnt,0:nnp,2:3)
      dimension  scmp(0:nnla,0:nnp)
      dimension  wgrtp(0:nnr,0:nnt,0:nnp)
      dimension work1(0:nnt,0:nnr,0:nnl), 
     &          work2(0:nnr,0:nnl,0:nnl), 
     &          work3(0:nnl,0:nnl,0:nnr),
     &          work42(0:nnl,0:nnr,0:nnt),
     &          work43(0:nnl,0:nnr,0:nnt)
c
      dimension ddvpot(0:nnt,0:nnp,1:3), rs(0:nnt,0:nnp)
      dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),f(1)
c
c --- Gravitational and Velocity potential is caluculated.
c      write(6,*)' gravep  '
c
c    fsn(irr,nn,id,ir) --> id =  0 for r'< r
c                          id = +1 for r < r'
      do 1001 im = 0, nl, msym
      do 1001 irr = 0, nr
      do 1001 itt = 0, nt
      work1(itt,irr,im) = 0.0d0
      do 1001 ipp = 0, np
      work1(itt,irr,im) = work1(itt,irr,im) + 
     &                    wgrtp(irr,itt,ipp)*
     &                    sou(irr,itt,ipp)*scmp(im,ipp)
 1001 continue
c
      do 1002 il = 0, nl
      do 1002 im = 0, nl, msym
      pari = 1.0d0 + (-1.0d0)**(il+im)
      do 1002 irr = 0, nr
      work2(irr,il,im) = 0.0d0
      do 1002 itt = 0, nt
      work2(irr,il,im) = work2(irr,il,im) + 
     &                   pari*epsi(im)*facnm(il,im)*
     &                   work1(itt,irr,im)*pna(il,im,itt)
 1002 continue
c
      do 1003 ir = 0, nr
      do 1003 il = 0, nl
      do 1003 im = 0, nl, msym
      work3(il,im,ir) = 0.0d0
      do 1003 irr = 0, nr
      work3(il,im,ir) = work3(il,im,ir) + 
     &                  work2(irr,il,im)*fsn(irr,il,ir)
 1003 continue
c
      do 1004 it = 0, nt
      do 1004 ir = 0, nr
      do 1004 im = 0, nl, msym
      work42(im,ir,it) = 0.0d0
      work43(im,ir,it) = 0.0d0
      do 1004 il = 0, nl
      work42(im,ir,it) = work42(im,ir,it) + 
     &                    work3(il,im,ir)*dtpna(il,im,it)
      work43(im,ir,it) = work43(im,ir,it) + 
     &                    work3(il,im,ir)*pna(il,im,it)
 1004 continue
c
      do 1000 ip = 0, np
      do 1000 it = 0, nt
      do 1000 ir = 0, nr
      pot(ir,it,ip,2) = 0.0d0
      pot(ir,it,ip,3) = 0.0d0
      do 1000 im = 0, nl, msym
      pot(ir,it,ip,2) = pot(ir,it,ip,2) +
     &                  work42(im,ir,it)*sinmp(im,ip)
      pot(ir,it,ip,3) = pot(ir,it,ip,3) +
     &                  work43(im,ir,it)*dble(im)*cosmp(im,ip)
 1000 continue
c
      pi = 3.14159265358979d+0
      pi4inv = 1.0d0/4.0d0/pi
      pi4aho = pi4inv*2.0d0*dble(msym)
      do 100 ii = 2, 3
      do 100 ip = 0, np
      do 100 it = 0, nt
      do 100 ir = 0, nr
      pot(ir,it,ip,ii) = - pi4aho*pot(ir,it,ip,ii)
 100  continue
c
      nc = nnr
      n = nr+1
c
      do 9 iii = 2, 3 
      do 9 ip = 0, np
      do 9 it = 0, nt
      ddvpot(it,ip,iii) = 0.0d0
      if (iii.eq.1) go to 9
c
      do 10 ir=0,nr
       x(ir+1)=r(ir)
   10  y(ir+1)=pot(ir,it,ip,iii)
      iopt(1)=3
      iopt(2)=3
cccp      iopt(1)=1
cccp      iopt(2)=1
      df(1) = 0.d0
      df(2) = 0.d0
      call splc(x,n,y,df,iopt,c,nc,ier)
      v=rs(it,ip)
      if (rs(it,ip).ge.1.0d0) v = 1.0d0
      call splf(x,n,y,c,nc,v,1,f,ier)
      ddvpot(it,ip,iii) = f(1)
 9    continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine sf2fc(sfv,fcv,rs)
c
c --- cal.non-variables on grids. (s.t. radius sine cosine etc.)
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      dimension rs(0:nnt,0:nnp)
      dimension sfv(0:nnr,0:nnt,0:nnp), fcv(0:nnr,0:nnt,0:nnp)
c
       dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),f(nnr),v(nnr)
c
      nc = nnr
      n = nr+1
      do 4 ip = 0, np
      do 4 it = 0, nt
      do 10 ir=0,nr
       x(ir+1)=r(ir)*rs(it,ip)
   10  y(ir+1)=sfv(ir,it,ip)
      iopt(1)=3
c --- important, iopt(2)=1 is better than iopt(2)=3
      iopt(2)=1
cccp      iopt(1)=1
cccp      iopt(2)=1
      df(1) = 0.d0
      df(2) = 0.d0
      call splc(x,n,y,df,iopt,c,nc,ier)
      irsf = idint(rs(it,ip)*dble(nr))
      do 20 ir=1,irsf
   20  v(ir)=r(ir)
      call splf(x,n,y,c,nc,v,irsf,f,ier)
      fcv(0,it,ip) = sfv(0,it,ip) 
      do 25 ir=1,irsf
   25  fcv(ir,it,ip) = f(ir)
      do 26 ir=irsf+1,nr
   26  fcv(ir,it,ip) = 0.0d0
    4 continue
c
      do 15 ir = 0, nr
      fcv(ir,nt, 0) = sfv(ir,nt, 0)
      fcv(ir,nt,np) = sfv(ir,nt,np)
 15   continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine fc2sf(fcv,sfv,rs)
c
c --- cal.non-variables on grids. (s.t. radius sine cosine etc.)
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      dimension rs(0:nnt,0:nnp)
      dimension sfv(0:nnr,0:nnt,0:nnp), fcv(0:nnr,0:nnt,0:nnp)
c
       dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),f(nnr),v(nnr)
c
      nc = nnr
      nro = nr
      do 4 ip = 0, np
      do 4 it = 0, nt
      if((ip.eq.0.and.it.eq.nt).or.(ip.eq.np.and.it.eq.nt)) go to 4
ckk      nro = idint(rs(it,ip)*dble(nr))
      n = nro+1
ckk      n = nro+2
czz      do 10 ir=0,nro
ckk      do 10 ir=0,nro+1
      do 10 ir=0,nro
       x(ir+1)=r(ir)
   10  y(ir+1)=fcv(ir,it,ip)
      iopt(1)=3
      iopt(2)=3
ccccc      iopt(2)=1
      df(1) = 0.d0
      df(2) = 0.d0
      call splc(x,n,y,df,iopt,c,nc,ier)
czz      do 20 ir=1,nr-1
      do 20 ir=1,nr
   20  v(ir)=r(ir)*rs(it,ip)
      call splf(x,n,y,c,nc,v,nr,f,ier)
      sfv(0,it,ip) = fcv(0,it,ip) 
cccc      do 25 ir=1,nr-1
      do 25 ir=1,nr
   25 sfv(ir,it,ip) = f(ir)
cccc      sfv(nr,it,ip) = 2.0d0*f(nr-1) - f(nr-2)
    4 continue
c
      do 15 ir = 0, nr
      sfv(ir,nt, 0) = fcv(ir,nt, 0)
      sfv(ir,nt,np) = fcv(ir,nt,np)
 15   continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine flgrad(fnc,grad,rs,isw,iswx)
c
      implicit real*8(a-h,o-z), integer(i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      common / diffv / rsinv(0:nnt,0:nnp),
     &              dtrs(0:nnt,0:nnp),dprs(0:nnt,0:nnp)
      common / trimp / sinmp(0:nnla,0:nnp),  cosmp(0:nnla,0:nnp)
c
      dimension  fnc(0:nnr,0:nnt,0:nnp), rs(0:nnt,0:nnp), 
     &          grad(0:nnr,0:nnt,0:nnp,1:3)
      dimension  fp(0:nnp), dfp(0:nnp)
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c     Derivatives for variables.
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      drinv=1.0d0/dr
      dtinv=1.0d0/dth
      dpinv=1.0d0/dphi
      pi = 3.14159265358979d+0
c
c --- Clear.
c
      do 40 ip = 0, np
      do 40 it = 0, nt
      rsinv(it,ip)=1.0d0/rs(it,ip)
      dtrs(it,ip) = 0.0d0
      dprs(it,ip) = 0.0d0
      do 40 ir = 0, nr
      grad(ir,it,ip,1) = 0.0d0
      grad(ir,it,ip,2) = 0.0d0
      grad(ir,it,ip,3) = 0.0d0
 40   continue
c
c --- r-direction.
c
      do 41 ip = 0, np
      do 41 it = 0, nt
      grad( 0,it,ip,1) = 0.5d0*drinv*rsinv(it,ip)*
     & (-3.0d0*fnc( 0,it,ip)+4.0d0*fnc(   1,it,ip)-fnc(   2,it,ip))
      grad(nr,it,ip,1) = 0.5d0*drinv*rsinv(it,ip)*
     & ( 3.0d0*fnc(nr,it,ip)-4.0d0*fnc(nr-1,it,ip)+fnc(nr-2,it,ip))
      do 41 ir = 1, nr-1
      grad(ir,it,ip,1) = (fnc(ir+1,it,ip) - fnc(ir-1,it,ip))*
     &                  0.5d0*drinv*rsinv(it,ip)
 41   continue
c
c --- theta-direction.
c
      do 42 ip = 0, np
      dtrs( 0,ip) = 0.5d0*dtinv*
     & (-3.0d0*rs(0,ip)+4.0d0*rs(1,ip)-rs(2,ip))
      dtrs(nt,ip) = 0.5d0*dtinv*
     & (3.0d0*rs(nt,ip)-4.0d0*rs(nt-1,ip)+rs(nt-2,ip))
      do 43 ir = 1, nr
      grad(ir,0,ip,2) = 0.5d0*dtinv*
     & (-3.0d0*fnc(ir,0,ip)+4.0d0*fnc(ir,1,ip)-fnc(ir,2,ip))
     &                - r(ir)*dtrs(0,ip)*grad(ir,0,ip,1)
      grad(ir,nt,ip,2) = 0.5d0*dtinv*
     & (3.0d0*fnc(ir,nt,ip)-4.0d0*fnc(ir,nt-1,ip)+fnc(ir,nt-2,ip))
     &                 - r(ir)*dtrs(nt,ip)*grad(ir,nt,ip,1)
 43   continue
      do 44 it = 1, nt-1
      dtrs(it,ip) = 0.5d0*dtinv*(rs(it+1,ip) - rs(it-1,ip))
      do 44 ir = 1, nr
      grad(ir,it,ip,2) = (fnc(ir,it+1,ip)-fnc(ir,it-1,ip))*0.5d0*dtinv
     &                 - r(ir)*dtrs(it,ip)*grad(ir,it,ip,1)
 44   continue
 42   continue
c
c --- phi-direction.
c
      do 45 it = 0, nt
      dprs(it,0) = 0.5d0*dpinv*
     & (-3.0d0*rs(it,0)+4.0d0*rs(it,1)-rs(it,2))
caho      if(iswx.eq.-1) dprs(it,0) = dpinv*(rs(it,1)-rs(it,0))
caho      if(iswx.eq.-1) dprs(it,0) = 0.0d0
      dprs(it,np) = 0.5d0*dpinv*
     & (3.0d0*rs(it,np)-4.0d0*rs(it,np-1)+rs(it,np-2))
caho      if(iswx.eq.-1) dprs(it,np) = dpinv*(rs(it,np) - rs(it,np-1))
      do 46 ir = 1, nr
      grad(ir,it, 0,3) = 0.5d0*dpinv*
     & (-3.0d0*fnc(ir,it,0)+4.0d0*fnc(ir,it, 1)-fnc(ir,it,2))
     &                 - r(ir)*dprs(it,0)*grad(ir,it,0,1)
       if (iswx.eq.-1) 
     & grad(ir,it, 0,3) = dpinv*
     & (fnc(ir,it,1) - fnc(ir,it,0))
     &                 - r(ir)*dprs(it,0)*grad(ir,it,0,1)
      grad(ir,it,np,3) = 0.5d0*dpinv*
     & (3.0d0*fnc(ir,it,np)-4.0d0*fnc(ir,it,np-1)+fnc(ir,it,np-2))
     &                 - r(ir)*dprs(it,np)*grad(ir,it,np,1)
caho       if (iswx.eq.-1) 
caho     & grad(ir,it,np,3) = dpinv*
caho     & (fnc(ir,it,np) - fnc(ir,it,np-1))
caho     &                 - r(ir)*dprs(it,np)*grad(ir,it,np,1)
clast
ck       if (isw.eq.1) 
ck     & grad(ir,it,np,3) = dpinv*
ck     & (fnc(ir,it,np) - fnc(ir,it,np-1))
ck     &                 - r(ir)*dprs(it,np)*grad(ir,it,np,1)
clast
 46   continue
      do 47 ip = 1, np-1
      dprs(it,ip) = (rs(it,ip+1) - rs(it,ip-1))*0.5d0*dpinv
      do 47 ir = 1, nr
      grad(ir,it,ip,3) = (fnc(ir,it,ip+1)-fnc(ir,it,ip-1))*0.5d0*dpinv
     &                 - r(ir)*dprs(it,ip)*grad(ir,it,ip,1)
 47   continue
 45   continue
c
      if (iswx.ge.1) then
c
      error = 0.0d0
      do 400 it = nt/2, nt
c
cz      do 4001 ip = 0, np
cz 4001 fp(ip) = rs(it,ip)
cz      call fouri(fp,dfp,cosmp,sinmp,2)
cz      do 4002 ip = 0, 5
czz       ip = 0
cz      oldv = dprs(it,ip)
cz      dprs(it,ip) = 0.0d0
cz      dprs(it,ip) = dfp(ip)
cz 4002 error = 
cz     &  dmax1(error,dabs(dprs(it,ip) - oldv)/
cz     &              dabs(dprs(it,ip) + oldv))
czz      write(6,*) dprs(it,ip) , oldv
c      
      do 401 ir = nr/2, nr
c
      do 4004 ip = 0, np
 4004 fp(ip) = fnc(ir,it,ip)
      if (isw.eq.1) call fouri(fp,dfp,sinmp,cosmp,isw)
      if (isw.eq.2) call fouri(fp,dfp,cosmp,sinmp,isw)
      do 4005 ip = 0, iswx
      oldv = grad(ir,it,ip,3)
      grad(ir,it,ip,3) = 0.0d0
      grad(ir,it,ip,3) = dfp(ip)
     &                 - r(ir)*dprs(it,ip)*grad(ir,it,ip,1)
 4005 error = 
     &  dmax1(error,dabs(grad(ir,it,ip,3) - oldv)/
     &              dabs(grad(ir,it,ip,3) + oldv))
c
 401  continue
 400  continue
      if (error.ge.0.1d0) 
     & write(6,*) ' relative error for derivative ', error
c
      end if
c
      do 49 ip = 0, np
      do 49 it = 0, nt
      do 49 ir = 0, nr
      grad(ir,it,ip,1)=grad(ir,it,ip,1)
      grad(ir,it,ip,2)=grad(ir,it,ip,2)*rinv(ir)*rsinv(it,ip)
      grad(ir,it,ip,3)=grad(ir,it,ip,3)*rinv(ir)*rsinv(it,ip)*cosec(it)
 49   continue
c
c --- On theta=0 axis and the center for velocity.
c
      if (isw.eq.1) then
      do 58 ip = 0, np
      do 58 ir = 0, nr
      grad(ir,0,ip,3)=grad(ir,0,np/2,2)*cosphi(ip)
 58   continue
      do 59 ip = 0, np
      do 59 it = 0, nt
      grad(0,it,ip,2)=grad(0,nt,np/2,1)*costhe(it)*sinphi(ip)
      grad(0,it,ip,3)=grad(0,nt,np/2,1)*cosphi(ip)
 59   continue
      end if
c
      do 141 ip = 0, np
      do 141 it = 0, nt
      do 141 ir = 0, nr
      gr1=grad(ir,it,ip,1)
      gr2=grad(ir,it,ip,2)
      gr3=grad(ir,it,ip,3)
      grad(ir,it,ip,1) = gr1*sinthe(it)*cosphi(ip)
     &                 + gr2*costhe(it)*cosphi(ip)  
     &                 - gr3*sinphi(ip) 
      grad(ir,it,ip,2) = gr1*sinthe(it)*sinphi(ip)
     &                 + gr2*costhe(it)*sinphi(ip)
     &                 + gr3*cosphi(ip) 
      grad(ir,it,ip,3) = gr1*costhe(it)
     &                 - gr2*sinthe(it)
 141  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine flgrad4(fnc,grad,rs,isw,iswx)
c
      implicit real*8(a-h,o-z), integer(i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      common / diffv / rsinv(0:nnt,0:nnp),
     &              dtrs(0:nnt,0:nnp),dprs(0:nnt,0:nnp)
      common / trimp / sinmp(0:nnla,0:nnp),  cosmp(0:nnla,0:nnp)
c
      dimension  fnc(0:nnr,0:nnt,0:nnp), rs(0:nnt,0:nnp), 
     &          grad(0:nnr,0:nnt,0:nnp,1:3)
      dimension  fp(0:nnp), dfp(0:nnp)
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c     Derivatives for variables.
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      drinv=1.0d0/dr
      dtinv=1.0d0/dth
      dpinv=1.0d0/dphi
      drinv12=1.0d0/dr/12.0d0
      dtinv12=1.0d0/dth/12.0d0
      dpinv12=1.0d0/dphi/12.0d0
      pi = 3.14159265358979d+0
c
c --- Clear.
c
      do 40 ip = 0, np
      do 40 it = 0, nt
      rsinv(it,ip)=1.0d0/rs(it,ip)
      dtrs(it,ip) = 0.0d0
      dprs(it,ip) = 0.0d0
      do 40 ir = 0, nr
      grad(ir,it,ip,1) = 0.0d0
      grad(ir,it,ip,2) = 0.0d0
      grad(ir,it,ip,3) = 0.0d0
 40   continue
c
c --- r-direction.
c
      do 41 ip = 0, np
      do 41 it = 0, nt
      grad(   0,it,ip,1) = drinv12*rsinv(it,ip)*
     & ( - 25.0d0*fnc(   0,it,ip) + 48.0d0*fnc(   1,it,ip) 
     &   - 36.0d0*fnc(   2,it,ip) + 16.0d0*fnc(   3,it,ip) 
     &   -  3.0d0*fnc(   4,it,ip) )
      grad(   1,it,ip,1) = drinv12*rsinv(it,ip)*
     & ( -  3.0d0*fnc(   0,it,ip) - 10.0d0*fnc(   1,it,ip) 
     &   + 18.0d0*fnc(   2,it,ip) -  6.0d0*fnc(   3,it,ip) 
     &   +        fnc(   4,it,ip) )
      grad(nr  ,it,ip,1) = drinv12*rsinv(it,ip)*
     & (   25.0d0*fnc(nr  ,it,ip) - 48.0d0*fnc(nr-1,it,ip)
     &   + 36.0d0*fnc(nr-2,it,ip) - 16.0d0*fnc(nr-3,it,ip)
     &   +  3.0d0*fnc(nr-4,it,ip) )
      if (isw.eq.3) then
cc      grad(nr  ,it,ip,1) = drinv*rsinv(it,ip)*
cc     & ( fnc(nr,it,ip) - fnc(nr-1,it,ip) )
      grad(nr  ,it,ip,1) = 0.5d0*drinv*rsinv(it,ip)*
     & (3.0d0*fnc(nr,it,ip)-4.0d0*fnc(nr-1,it,ip)+fnc(nr-2,it,ip))
      end if
      grad(nr-1,it,ip,1) = drinv12*rsinv(it,ip)*
     & (    3.0d0*fnc(nr  ,it,ip) + 10.0d0*fnc(nr-1,it,ip)
     &   - 18.0d0*fnc(nr-2,it,ip) +  6.0d0*fnc(nr-3,it,ip)
     &   -        fnc(nr-4,it,ip) )
      do 41 ir = 2, nr-2
      grad(ir,it,ip,1) = drinv12*rsinv(it,ip)*
     & ( -        fnc(ir+2,it,ip) +  8.0d0*fnc(ir+1,it,ip)
     &   -  8.0d0*fnc(ir-1,it,ip) +        fnc(ir-2,it,ip) )
 41   continue
c
c --- theta-direction.
c
      do 42 ip = 0, np
      dtrs(   0,ip) = dtinv12*
     & ( - 25.0d0*rs(   0,ip) + 48.0d0*rs(   1,ip) 
     &   - 36.0d0*rs(   2,ip) + 16.0d0*rs(   3,ip) 
     &   -  3.0d0*rs(   4,ip) )
      dtrs(   1,ip) = dtinv12*
     & ( -  3.0d0*rs(   0,ip) - 10.0d0*rs(   1,ip) 
     &   + 18.0d0*rs(   2,ip) -  6.0d0*rs(   3,ip) 
     &   +        rs(   4,ip) )
      dtrs(nt  ,ip) = dtinv12*
     & (   25.0d0*rs(nt  ,ip) - 48.0d0*rs(nt-1,ip)
     &   + 36.0d0*rs(nt-2,ip) - 16.0d0*rs(nt-3,ip)
     &   +  3.0d0*rs(nt-4,ip) )
      dtrs(nt-1,ip) = dtinv12*
     & (    3.0d0*rs(nt  ,ip) + 10.0d0*rs(nt-1,ip)
     &   - 18.0d0*rs(nt-2,ip) +  6.0d0*rs(nt-3,ip)
     &   -        rs(nt-4,ip) )
      do 43 ir = 1, nr
      grad(ir,   0,ip,2) = dtinv12*
     & ( - 25.0d0*fnc(ir,   0,ip) + 48.0d0*fnc(ir,   1,ip) 
     &   - 36.0d0*fnc(ir,   2,ip) + 16.0d0*fnc(ir,   3,ip) 
     &   -  3.0d0*fnc(ir,   4,ip) )
     &                - r(ir)*dtrs(0,ip)*grad(ir,0,ip,1)
      grad(ir,   1,ip,2) = dtinv12*
     & ( -  3.0d0*fnc(ir,   0,ip) - 10.0d0*fnc(ir,   1,ip) 
     &   + 18.0d0*fnc(ir,   2,ip) -  6.0d0*fnc(ir,   3,ip) 
     &   +        fnc(ir,   4,ip) )
     &                - r(ir)*dtrs(1,ip)*grad(ir,1,ip,1)
      grad(ir,nt  ,ip,2) = dtinv12*
     & (   25.0d0*fnc(ir,nt  ,ip) - 48.0d0*fnc(ir,nt-1,ip)
     &   + 36.0d0*fnc(ir,nt-2,ip) - 16.0d0*fnc(ir,nt-3,ip)
     &   +  3.0d0*fnc(ir,nt-4,ip) )
     &                 - r(ir)*dtrs(nt,ip)*grad(ir,nt,ip,1)
      grad(ir,nt-1,ip,2) = dtinv12*
     & (    3.0d0*fnc(ir,nt  ,ip) + 10.0d0*fnc(ir,nt-1,ip)
     &   - 18.0d0*fnc(ir,nt-2,ip) +  6.0d0*fnc(ir,nt-3,ip)
     &   -        fnc(ir,nt-4,ip) )
     &                 - r(ir)*dtrs(nt-1,ip)*grad(ir,nt-1,ip,1)
 43   continue
      do 44 it = 2, nt-2
      dtrs(it,ip) = dtinv12*
     & ( -        rs(it+2,ip) +  8.0d0*rs(it+1,ip)
     &   -  8.0d0*rs(it-1,ip) +        rs(it-2,ip) )
      do 44 ir = 1, nr
      grad(ir,it,ip,2) = dtinv12*
     & ( -        fnc(ir,it+2,ip) +  8.0d0*fnc(ir,it+1,ip)
     &   -  8.0d0*fnc(ir,it-1,ip) +        fnc(ir,it-2,ip) )
     &                 - r(ir)*dtrs(it,ip)*grad(ir,it,ip,1)
 44   continue
 42   continue
c
c --- phi-direction.
c
      do 45 it = 0, nt
      dprs(it,   0) = dpinv12*
     & ( - 25.0d0*rs(it,   0) + 48.0d0*rs(it,   1) 
     &   - 36.0d0*rs(it,   2) + 16.0d0*rs(it,   3) 
     &   -  3.0d0*rs(it,   4) )
      dprs(it,   1) = dpinv12*
     & ( -  3.0d0*rs(it,   0) - 10.0d0*rs(it,   1) 
     &   + 18.0d0*rs(it,   2) -  6.0d0*rs(it,   3) 
     &   +        rs(it,   4) )
      dprs(it,np  ) = dpinv12*
     & (   25.0d0*rs(it,np  ) - 48.0d0*rs(it,np-1)
     &   + 36.0d0*rs(it,np-2) - 16.0d0*rs(it,np-3)
     &   +  3.0d0*rs(it,np-4) )
      dprs(it,np-1) = dpinv12*
     & (    3.0d0*rs(it,np  ) + 10.0d0*rs(it,np-1)
     &   - 18.0d0*rs(it,np-2) +  6.0d0*rs(it,np-3)
     &   -        rs(it,np-4) )
caho      if(iswx.eq.-1) 
caho     & dprs(it,0) = 0.5d0*dpinv*
caho     & (-3.0d0*rs(it,0)+4.0d0*rs(it,1)-rs(it,2))
      do 46 ir = 1, nr
      grad(ir,it,   0,3) = dpinv12*
     & ( - 25.0d0*fnc(ir,it,   0) + 48.0d0*fnc(ir,it,   1) 
     &   - 36.0d0*fnc(ir,it,   2) + 16.0d0*fnc(ir,it,   3) 
     &   -  3.0d0*fnc(ir,it,   4) )
     &                - r(ir)*dprs(it,0)*grad(ir,it,0,1)
      grad(ir,it,   1,3) = dpinv12*
     & ( -  3.0d0*fnc(ir,it,   0) - 10.0d0*fnc(ir,it,   1) 
     &   + 18.0d0*fnc(ir,it,   2) -  6.0d0*fnc(ir,it,   3) 
     &   +        fnc(ir,it,   4) )
     &                - r(ir)*dprs(it,1)*grad(ir,it,1,1)
      grad(ir,it,np  ,3) = dpinv12*
     & (   25.0d0*fnc(ir,it,np  ) - 48.0d0*fnc(ir,it,np-1)
     &   + 36.0d0*fnc(ir,it,np-2) - 16.0d0*fnc(ir,it,np-3)
     &   +  3.0d0*fnc(ir,it,np-4) )
     &                 - r(ir)*dprs(it,np)*grad(ir,it,np,1)
      grad(ir,it,np-1,3) = dpinv12*
     & (    3.0d0*fnc(ir,it,np  ) + 10.0d0*fnc(ir,it,np-1)
     &   - 18.0d0*fnc(ir,it,np-2) +  6.0d0*fnc(ir,it,np-3)
     &   -        fnc(ir,it,np-4) )
     &                 - r(ir)*dprs(it,np-1)*grad(ir,it,np-1,1)
caho       if (iswx.eq.-1) 
caho     & grad(ir,it, 0,3) = 0.5d0*dpinv*
caho     & (-3.0d0*fnc(ir,it,0)+4.0d0*fnc(ir,it, 1)-fnc(ir,it,2))
caho     &                 - r(ir)*dprs(it,0)*grad(ir,it,0,1)
 46   continue
      do 47 ip = 2, np-2
      dprs(it,ip) = dpinv12*
     & ( -        rs(it,ip+2) +  8.0d0*rs(it,ip+1)
     &   -  8.0d0*rs(it,ip-1) +        rs(it,ip-2) )
      do 47 ir = 1, nr
      grad(ir,it,ip,3) = dpinv12*
     & ( -        fnc(ir,it,ip+2) +  8.0d0*fnc(ir,it,ip+1)
     &   -  8.0d0*fnc(ir,it,ip-1) +        fnc(ir,it,ip-2) )
     &                 - r(ir)*dprs(it,ip)*grad(ir,it,ip,1)
 47   continue
 45   continue
c
cx      if (isw.eq.1) then
cx      do 490 ip = 0, np, np
cx      do 490 it = 0, nt
cx      do 490 ir = 0, nr
cx      grad(ir,it,ip,3)=0.0d0
cx 490  continue
cx      end if
c
      if (iswx.ge.1) then
c
      error = 0.0d0
      do 400 it = nt/2, nt
c
      do 401 ir = nr/2, nr
c
      do 4004 ip = 0, np
 4004 fp(ip) = fnc(ir,it,ip)
      if (isw.eq.1) call fouri(fp,dfp,sinmp,cosmp,isw)
      if (isw.eq.2) call fouri(fp,dfp,cosmp,sinmp,isw)
c
      do 4005 ip = 0, iswx 
      oldv = grad(ir,it,ip,3)
      grad(ir,it,ip,3) = 0.0d0
      grad(ir,it,ip,3) = dfp(ip)
     &                 - r(ir)*dprs(it,ip)*grad(ir,it,ip,1)
 4005 error = 
     &  dmax1(error,dabs(grad(ir,it,ip,3) - oldv)/
     &              dabs(grad(ir,it,ip,3) + oldv))
c
 401  continue
 400  continue
      if (error.ge.0.1d0) 
     & write(6,*) ' relative error for derivative ', error
c
      end if
c
      do 49 ip = 0, np
      do 49 it = 0, nt
      do 49 ir = 0, nr
      grad(ir,it,ip,1)=grad(ir,it,ip,1)
      grad(ir,it,ip,2)=grad(ir,it,ip,2)*rinv(ir)*rsinv(it,ip)
      grad(ir,it,ip,3)=grad(ir,it,ip,3)*rinv(ir)*rsinv(it,ip)*cosec(it)
 49   continue
c
c --- On theta=0 axis and the center for velocity.
c
      if (isw.eq.1) then
      do 58 ip = 0, np
      do 58 ir = 0, nr
      grad(ir,0,ip,3)=grad(ir,0,np/2,2)*cosphi(ip)
 58   continue
      do 59 ip = 0, np
      do 59 it = 0, nt
      grad(0,it,ip,2)=grad(0,nt,np/2,1)*costhe(it)*sinphi(ip)
      grad(0,it,ip,3)=grad(0,nt,np/2,1)*cosphi(ip)
 59   continue
      end if
c
      do 141 ip = 0, np
      do 141 it = 0, nt
      do 141 ir = 0, nr
      gr1=grad(ir,it,ip,1)
      gr2=grad(ir,it,ip,2)
      gr3=grad(ir,it,ip,3)
      grad(ir,it,ip,1) = gr1*sinthe(it)*cosphi(ip)
     &                 + gr2*costhe(it)*cosphi(ip)  
     &                 - gr3*sinphi(ip) 
      grad(ir,it,ip,2) = gr1*sinthe(it)*sinphi(ip)
     &                 + gr2*costhe(it)*sinphi(ip)
     &                 + gr3*cosphi(ip) 
      grad(ir,it,ip,3) = gr1*costhe(it)
     &                 - gr2*sinthe(it)
 141  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine dadbscalarf(fnc,dabfnc,ir,it,ip)
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      dimension  fnc(0:nnr,0:nnt,0:nnp), dabfnc(1:3,1:3),
     &           r5(5), th5(5), phi5(5), grad1(3),
     &           dfdx_r(5), dfdx_th(5), dfdx_phi(5),
     &           dfdy_r(5), dfdy_th(5), dfdy_phi(5),
     &           dfdz_r(5), dfdz_th(5), dfdz_phi(5)
c
c --- Compute second derivative of a scalar D_b D_a f,   
c     whose value is assigned on the grid points. 
c     Derivative is computed by that of Catesian coordinate for 
c --- r=0 or theta=0, and by that of spherical coordinate for elsewhere.
c
      ir0 = min0(max0(ir-2,0),nr-4)
      it0 = min0(max0(it-2,0),nt-4)
      ip0 = min0(max0(ip-2,0),np-4)
c
      rv = r(ir)
      tv = th(it)
      pv = phi(ip)
      rrinvb = rinv(ir)
      cosecb = cosec(it)
c
      do 27 ii = 1, 5
      irf0 = ir0 + ii - 1
      itf0 = it0 + ii - 1
      ipf0 = ip0 + ii - 1
      r5(ii) = r(irf0)
      th5(ii) = th(itf0)
      phi5(ii) = phi(ipf0)
   27 continue
c
      if (ir.eq.0) then
c
      do 28 ii = 1, 5
c
      irf0 = ir0 + ii - 1
      itf0 = it0 + ii - 1
      ipf0 = ip0 + ii - 1
c
      call flgrad1f(fnc,irf0,nt,npfxz,grad1)
      dfdx_r(ii) = grad1(1)
      dfdy_r(ii) = grad1(2)
      dfdz_r(ii) = grad1(3)
c
      call flgrad1f(fnc,irf0,nt,npfyz,grad1)
      dfdx_th(ii) = grad1(1)
      dfdy_th(ii) = grad1(2)
      dfdz_th(ii) = grad1(3)
c
      call flgrad1f(fnc,irf0,0,0,grad1)
      dfdx_phi(ii) = grad1(1)
      dfdy_phi(ii) = grad1(2)
      dfdz_phi(ii) = grad1(3)
c
   28 continue
c
      dabfnc(1,1) = dfncdx(r5,dfdx_r,rv)
      dabfnc(1,2) = dfncdx(r5,dfdx_th,rv)
      dabfnc(1,3) = dfncdx(r5,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx(r5,dfdy_r,rv)
      dabfnc(2,2) = dfncdx(r5,dfdy_th,rv)
      dabfnc(2,3) = dfncdx(r5,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx(r5,dfdz_r,rv)
      dabfnc(3,2) = dfncdx(r5,dfdz_th,rv)
      dabfnc(3,3) = dfncdx(r5,dfdz_phi,rv)
c
      else if (ir.ne.0.and.it.eq.0) then
c
      do 38 ii = 1, 5
c
      irf0 = ir0 + ii - 1
      itf0 = it0 + ii - 1
      ipf0 = ip0 + ii - 1
c
      call flgrad1f(fnc,ir,itf0,npfxz,grad1)
      dfdx_r(ii) = grad1(1)
      dfdy_r(ii) = grad1(2)
      dfdz_r(ii) = grad1(3)
c
      call flgrad1f(fnc,ir,itf0,npfyz,grad1)
      dfdx_th(ii) = grad1(1)
      dfdy_th(ii) = grad1(2)
      dfdz_th(ii) = grad1(3)
c
      call flgrad1f(fnc,irf0,0,0,grad1)
      dfdx_phi(ii) = grad1(1)
      dfdy_phi(ii) = grad1(2)
      dfdz_phi(ii) = grad1(3)
c
   38 continue
c
      dabfnc(1,1) = dfncdx(th5,dfdx_r,tv)*rrinvb
      dabfnc(1,2) = dfncdx(th5,dfdx_th,tv)*rrinvb
      dabfnc(1,3) = dfncdx(r5,dfdx_phi,rv)
      dabfnc(2,1) = dfncdx(th5,dfdy_r,tv)*rrinvb
      dabfnc(2,2) = dfncdx(th5,dfdy_th,tv)*rrinvb
      dabfnc(2,3) = dfncdx(r5,dfdy_phi,rv)
      dabfnc(3,1) = dfncdx(th5,dfdz_r,tv)*rrinvb
      dabfnc(3,2) = dfncdx(th5,dfdz_th,tv)*rrinvb
      dabfnc(3,3) = dfncdx(r5,dfdz_phi,rv)
c
      else
c
      do 48 ii = 1, 5
c
      irf0 = ir0 + ii - 1
      itf0 = it0 + ii - 1
      ipf0 = ip0 + ii - 1
c
      call flgrad1f(fnc,irf0,it,ip,grad1)
      dfdx_r(ii) = grad1(1)
      dfdy_r(ii) = grad1(2)
      dfdz_r(ii) = grad1(3)
c
      call flgrad1f(fnc,ir,itf0,ip,grad1)
      dfdx_th(ii) = grad1(1)
      dfdy_th(ii) = grad1(2)
      dfdz_th(ii) = grad1(3)
c
      call flgrad1f(fnc,ir,it,ipf0,grad1)
      dfdx_phi(ii) = grad1(1)
      dfdy_phi(ii) = grad1(2)
      dfdz_phi(ii) = grad1(3)
c
   48 continue
c
      ddfdxdr = dfncdx(r5,dfdx_r,rv)
      ddfdxdt = dfncdx(th5,dfdx_th,tv)
      ddfdxdp = dfncdx(phi5,dfdx_phi,pv)
      ddfdydr = dfncdx(r5,dfdy_r,rv)
      ddfdydt = dfncdx(th5,dfdy_th,tv)
      ddfdydp = dfncdx(phi5,dfdy_phi,pv)
      ddfdzdr = dfncdx(r5,dfdz_r,rv)
      ddfdzdt = dfncdx(th5,dfdz_th,tv)
      ddfdzdp = dfncdx(phi5,dfdz_phi,pv)
c
      dabfnc(1,1) = ddfdxdr*sinthe(it)*cosphi(ip)
     &            + ddfdxdt*costhe(it)*cosphi(ip)  
     &            - ddfdxdp*sinphi(ip)
      dabfnc(1,2) = ddfdxdr*sinthe(it)*sinphi(ip)
     &            + ddfdxdt*costhe(it)*sinphi(ip)
     &            + ddfdxdp*cosphi(ip)
      dabfnc(1,3) = ddfdxdr*costhe(it)
     &            - ddfdxdt*sinthe(it)
      dabfnc(2,1) = ddfdydr*sinthe(it)*cosphi(ip)
     &            + ddfdydt*costhe(it)*cosphi(ip)  
     &            - ddfdydp*sinphi(ip)
      dabfnc(2,2) = ddfdydr*sinthe(it)*sinphi(ip)
     &            + ddfdydt*costhe(it)*sinphi(ip)
     &            + ddfdydp*cosphi(ip)
      dabfnc(2,3) = ddfdydr*costhe(it)
     &            - ddfdydt*sinthe(it)
      dabfnc(3,1) = ddfdzdr*sinthe(it)*cosphi(ip)
     &            + ddfdzdt*costhe(it)*cosphi(ip)  
     &            - ddfdzdp*sinphi(ip)
      dabfnc(3,2) = ddfdzdr*sinthe(it)*sinphi(ip)
     &            + ddfdzdt*costhe(it)*sinphi(ip)
     &            + ddfdzdp*cosphi(ip)
      dabfnc(3,3) = ddfdzdr*costhe(it)
     &            - ddfdzdt*sinthe(it)
c
      end if
c
ctesttest 
c      dabfnc(2,1) = dabfnc(1,2)
c      dabfnc(3,1) = dabfnc(1,3)
c      dabfnc(3,2) = dabfnc(2,3)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine flgrad1f(fnc,ir,it,ip,grad1)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_coflu.f'
c
      dimension fnc(0:nnr,0:nnt,0:nnp), fr5(5), ft5(5), fp5(5),
     &          grad1(3), r5(5), th5(5), phi5(5)
c
c --- Compute the gradient of a function.  
c --- The gradient is evaluated on grid points. 
c
      ir0 = min0(max0(ir-2,0),nr-4)
      it0 = min0(max0(it-2,0),nt-4)
      ip0 = min0(max0(ip-2,0),np-4)
c
      do 8 ii = 1, 5
      irf0 = ir0 + ii - 1
      itf0 = it0 + ii - 1
      ipf0 = ip0 + ii - 1
      r5(ii) = r(irf0)
      th5(ii) = th(itf0)
      phi5(ii) = phi(ipf0)
      if (ir.eq.0) then
      fr5(ii) = fnc(irf0,nt,npfxz)
      ft5(ii) = fnc(irf0,nt,npfyz)
      fp5(ii) = fnc(irf0,0,0)
      else if (ir.ne.0.and.it.eq.0) then
      fr5(ii) = fnc(ir,itf0,npfxz)
      ft5(ii) = fnc(ir,itf0,npfyz)
      fp5(ii) = fnc(irf0,0,0)
      else
      fr5(ii) = fnc(irf0,it,ip)
      ft5(ii) = fnc(ir,itf0,ip)
      fp5(ii) = fnc(ir,it,ipf0)
      end if
    8 continue
c
      rv = r(ir)
      tv = th(it)
      pv = phi(ip)
      rrinv = rinv(ir)
c
c --- To cartesian component.  
c
      if (ir.eq.0) then
      grad1(1) = dfncdx(r5,fr5,rv)
      grad1(2) = dfncdx(r5,ft5,rv) 
      grad1(3) = dfncdx(r5,fp5,rv)
      else if (ir.ne.0.and.it.eq.0) then
      grad1(1) = dfncdx(th5,fr5,tv)*rrinv
      grad1(2) = dfncdx(th5,ft5,tv)*rrinv
      grad1(3) = dfncdx(r5,fp5,rv)
      else
      gr1 = dfncdx(r5,fr5,rv)
      gr2 = dfncdx(th5,ft5,tv)*rrinv
      gr3 = dfncdx(phi5,fp5,pv)*rrinv*cosec(it)
      grad1(1) = gr1*sinthe(it)*cosphi(ip)
     &         + gr2*costhe(it)*cosphi(ip)  
     &         - gr3*sinphi(ip) 
      grad1(2) = gr1*sinthe(it)*sinphi(ip)
     &         + gr2*costhe(it)*sinphi(ip)
     &         + gr3*cosphi(ip) 
      grad1(3) = gr1*costhe(it)
     &         - gr2*sinthe(it)
c
      end if
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine flfcgrad4(fnc,grad,isw)
c
      implicit real*8(a-h,o-z), integer(i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      dimension  fnc(0:nnr,0:nnt,0:nnp), 
     &          grad(0:nnr,0:nnt,0:nnp,1:3)
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c     Derivatives for variables.
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      drinv=1.0d0/dr
      dtinv=1.0d0/dth
      dpinv=1.0d0/dphi
      drinv12=1.0d0/dr/12.0d0
      dtinv12=1.0d0/dth/12.0d0
      dpinv12=1.0d0/dphi/12.0d0
      pi = 3.14159265358979d+0
c
c --- Clear.
c
      do 40 ip = 0, np
      do 40 it = 0, nt
      do 40 ir = 0, nr
      grad(ir,it,ip,1) = 0.0d0
      grad(ir,it,ip,2) = 0.0d0
      grad(ir,it,ip,3) = 0.0d0
 40   continue
c
c --- r-direction.
c
      do 41 ip = 0, np
      do 41 it = 0, nt
      grad(   0,it,ip,1) = drinv12*
     & ( - 25.0d0*fnc(   0,it,ip) + 48.0d0*fnc(   1,it,ip) 
     &   - 36.0d0*fnc(   2,it,ip) + 16.0d0*fnc(   3,it,ip) 
     &   -  3.0d0*fnc(   4,it,ip) )
      grad(   1,it,ip,1) = drinv12*
     & ( -  3.0d0*fnc(   0,it,ip) - 10.0d0*fnc(   1,it,ip) 
     &   + 18.0d0*fnc(   2,it,ip) -  6.0d0*fnc(   3,it,ip) 
     &   +        fnc(   4,it,ip) )
      grad(nr  ,it,ip,1) = drinv12*
     & (   25.0d0*fnc(nr  ,it,ip) - 48.0d0*fnc(nr-1,it,ip)
     &   + 36.0d0*fnc(nr-2,it,ip) - 16.0d0*fnc(nr-3,it,ip)
     &   +  3.0d0*fnc(nr-4,it,ip) )
      if (isw.eq.3) then
cc      grad(nr  ,it,ip,1) = drinv*
cc     & ( fnc(nr,it,ip) - fnc(nr-1,it,ip) )
      grad(nr  ,it,ip,1) = 0.5d0*drinv*
     & (3.0d0*fnc(nr,it,ip)-4.0d0*fnc(nr-1,it,ip)+fnc(nr-2,it,ip))
      end if
      grad(nr-1,it,ip,1) = drinv12*
     & (    3.0d0*fnc(nr  ,it,ip) + 10.0d0*fnc(nr-1,it,ip)
     &   - 18.0d0*fnc(nr-2,it,ip) +  6.0d0*fnc(nr-3,it,ip)
     &   -        fnc(nr-4,it,ip) )
      do 41 ir = 2, nr-2
      grad(ir,it,ip,1) = drinv12*
     & ( -        fnc(ir+2,it,ip) +  8.0d0*fnc(ir+1,it,ip)
     &   -  8.0d0*fnc(ir-1,it,ip) +        fnc(ir-2,it,ip) )
 41   continue
c
c --- theta-direction.
c
      do 42 ip = 0, np
      do 43 ir = 1, nr
      grad(ir,   0,ip,2) = dtinv12*
     & ( - 25.0d0*fnc(ir,   0,ip) + 48.0d0*fnc(ir,   1,ip) 
     &   - 36.0d0*fnc(ir,   2,ip) + 16.0d0*fnc(ir,   3,ip) 
     &   -  3.0d0*fnc(ir,   4,ip) )
      grad(ir,   1,ip,2) = dtinv12*
     & ( -  3.0d0*fnc(ir,   0,ip) - 10.0d0*fnc(ir,   1,ip) 
     &   + 18.0d0*fnc(ir,   2,ip) -  6.0d0*fnc(ir,   3,ip) 
     &   +        fnc(ir,   4,ip) )
      grad(ir,nt  ,ip,2) = dtinv12*
     & (   25.0d0*fnc(ir,nt  ,ip) - 48.0d0*fnc(ir,nt-1,ip)
     &   + 36.0d0*fnc(ir,nt-2,ip) - 16.0d0*fnc(ir,nt-3,ip)
     &   +  3.0d0*fnc(ir,nt-4,ip) )
      grad(ir,nt-1,ip,2) = dtinv12*
     & (    3.0d0*fnc(ir,nt  ,ip) + 10.0d0*fnc(ir,nt-1,ip)
     &   - 18.0d0*fnc(ir,nt-2,ip) +  6.0d0*fnc(ir,nt-3,ip)
     &   -        fnc(ir,nt-4,ip) )
 43   continue
      do 44 it = 2, nt-2
      do 44 ir = 1, nr
      grad(ir,it,ip,2) = dtinv12*
     & ( -        fnc(ir,it+2,ip) +  8.0d0*fnc(ir,it+1,ip)
     &   -  8.0d0*fnc(ir,it-1,ip) +        fnc(ir,it-2,ip) )
 44   continue
 42   continue
c
c --- phi-direction.
c
      do 45 it = 0, nt
      do 46 ir = 1, nr
      grad(ir,it,   0,3) = dpinv12*
     & ( - 25.0d0*fnc(ir,it,   0) + 48.0d0*fnc(ir,it,   1) 
     &   - 36.0d0*fnc(ir,it,   2) + 16.0d0*fnc(ir,it,   3) 
     &   -  3.0d0*fnc(ir,it,   4) )
      grad(ir,it,   1,3) = dpinv12*
     & ( -  3.0d0*fnc(ir,it,   0) - 10.0d0*fnc(ir,it,   1) 
     &   + 18.0d0*fnc(ir,it,   2) -  6.0d0*fnc(ir,it,   3) 
     &   +        fnc(ir,it,   4) )
      grad(ir,it,np  ,3) = dpinv12*
     & (   25.0d0*fnc(ir,it,np  ) - 48.0d0*fnc(ir,it,np-1)
     &   + 36.0d0*fnc(ir,it,np-2) - 16.0d0*fnc(ir,it,np-3)
     &   +  3.0d0*fnc(ir,it,np-4) )
      grad(ir,it,np-1,3) = dpinv12*
     & (    3.0d0*fnc(ir,it,np  ) + 10.0d0*fnc(ir,it,np-1)
     &   - 18.0d0*fnc(ir,it,np-2) +  6.0d0*fnc(ir,it,np-3)
     &   -        fnc(ir,it,np-4) )
 46   continue
      do 47 ip = 2, np-2
      do 47 ir = 1, nr
      grad(ir,it,ip,3) = dpinv12*
     & ( -        fnc(ir,it,ip+2) +  8.0d0*fnc(ir,it,ip+1)
     &   -  8.0d0*fnc(ir,it,ip-1) +        fnc(ir,it,ip-2) )
 47   continue
 45   continue
c
      if (isw.eq.1) then
      do 490 ip = 0, np, np
      do 490 it = 0, nt
      do 490 ir = 0, nr
      grad(ir,it,ip,3)=0.0d0
 490  continue
      end if
c
      do 49 ip = 0, np
      do 49 it = 0, nt
      do 49 ir = 0, nr
      grad(ir,it,ip,1)=grad(ir,it,ip,1)
      grad(ir,it,ip,2)=grad(ir,it,ip,2)*rinv(ir)
      grad(ir,it,ip,3)=grad(ir,it,ip,3)*rinv(ir)*cosec(it)
 49   continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine fouri(fp,dfp,scfn,scdf,isw)
c
      implicit real*8(a-h,o-z), integer(i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
c
      common / weigh / wgdr(0:nnr), wgdt(0:nnt), wgdp(0:nnp),
     &                wgrtp(0:nnr,0:nnt,0:nnp), 
     &                 w4dr(0:nnr), w4dt(0:nnt), w4dp(0:nnp),
     &                w4rtp(0:nnr,0:nnt,0:nnp), wahop(0:nnr,0:nnt,0:nnp)
c
      dimension fp(0:nnp), dfp(0:nnp), al(0:nnla)
      dimension scfn(0:nnla,0:nnp),  scdf(0:nnla,0:nnp)
c
      pi = 3.14159265358979d+0
      do 100 il = 0, nla
      aaa = 0.0d0
      do 200 ip = 0, np
      aaa = aaa + fp(ip)*scfn(il,ip)*wgdp(ip)
 200  continue
      fac = 2.0d0
      if (isw.eq.2.and.il.eq.0) fac = 1.0d0
      al(il) = aaa*fac/pi
 100  continue
c
      fac = (- 1.0d0)**(isw+1)
      do 110 ip = 0, np
      dfp(ip) = 0.0d0
cxxx      do 120 il = 0, nla
      do 120 il = 0, 4
      dfp(ip) = dfp(ip) + fac*dble(il)*al(il)*scdf(il,ip)
 120  continue
 110  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine fluidco(iter,itmx,convf,cfvep,fmax0,ahores,emxemd,char)
c
      implicit real*8(a-h,o-z), integer(i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_metfl.f'
c
      common / weigh / wgdr(0:nnr), wgdt(0:nnt), wgdp(0:nnp),
     &                wgrtp(0:nnr,0:nnt,0:nnp), 
     &                 w4dr(0:nnr), w4dt(0:nnt), w4dp(0:nnp),
     &                w4rtp(0:nnr,0:nnt,0:nnp), wahop(0:nnr,0:nnt,0:nnp)
      common / intpp / thmx, phimx,
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato,
     &                 g, pi, emdc, ipolar
c
      common / diffv / rsinv(0:nnt,0:nnp),
     &              dtrs(0:nnt,0:nnp),dprs(0:nnt,0:nnp)
c
      common / gmcrif/ gmcrixf(0:nnr,0:nnt,0:nnp),
     &                 gmcriyf(0:nnr,0:nnt,0:nnp),
     &                 gmcrizf(0:nnr,0:nnt,0:nnp)
      common / cdivbf/ cdvbvf(0:nnr,0:nnt,0:nnp)
c
      dimension backf(0:nnr,0:nnt,0:nnp), rsb(0:nnt,0:nnp)
      dimension hut(0:nnr,0:nnt,0:nnp), aloh(0:nnr,0:nnt,0:nnp),
     &        hutp6(0:nnr,0:nnt,0:nnp),psif4(0:nnr,0:nnt,0:nnp), 
     &        gradv(0:nnr,0:nnt,0:nnp,1:3),
     &       gradps(0:nnr,0:nnt,0:nnp,1:3),
     &       gradhu(0:nnr,0:nnt,0:nnp,1:3),
     &       gradah(0:nnr,0:nnt,0:nnp,1:3),
     &        grade(0:nnr,0:nnt,0:nnp,1:3)
c
      dimension flag(0:nnr,0:nnt,0:nnp),   wgsf(0:nnr,0:nnt,0:nnp),
     &        wgrtpv(0:nnr,0:nnt,0:nnp), wgrtpp(0:nnr,0:nnt,0:nnp)
c
      dimension x(nnr),y(nnr),df(2),iopt(2),c(nnr,3),f(1)
      dimension dabvep(3,3)
      dimension ddvpot(0:nnt,0:nnp,1:3)
      dimension sgg(nnbou), gg(nnbou,nnbou)
c
      character*3 char
c
c ----------------------------------------------------------------------
c
      drinv=1.0d0/dr
      dtinv=1.0d0/dth
      dpinv=1.0d0/dphi
      pi = 3.14159265358979d+0
c
c ----------------------------------------------------------------------
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
c     Equations start. 
c
c ======================================================================
c
c     First integral of Euler equation.
c
c ======================================================================
c
c --  First integral of Euler equation.
c
      do 100 ip = 0, np
      do 100 it = 0, nt
      do 100 ir = 0, nr
c
      backf(ir,it,ip) = emd(ir,it,ip)
c
      alphc = alphf(ir,it,ip)
      psic  = psif(ir,it,ip)
      gmxxdf = 1.0d0 + hxxdf(ir,it,ip)
      gmxydf =         hxydf(ir,it,ip)
      gmxzdf =         hxzdf(ir,it,ip)
      gmyydf = 1.0d0 + hyydf(ir,it,ip)
      gmyzdf =         hyzdf(ir,it,ip)
      gmzzdf = 1.0d0 + hzzdf(ir,it,ip)
      gmyxdf = gmxydf
      gmzxdf = gmxzdf
      gmzydf = gmyzdf
      bvxfc = bvxuf(ir,it,ip)
      bvyfc = bvyuf(ir,it,ip)
      bvzfc = bvzuf(ir,it,ip)
      vphix = vphif(ir,it,ip,1)
      vphiy = vphif(ir,it,ip,2)
      vphiz = vphif(ir,it,ip,3)
c
      ovxfc = bvxfc + ome*vphix
      ovyfc = bvyfc + ome*vphiy
      ovzfc = bvzfc + ome*vphiz
      ovxdf = gmxxdf*ovxfc + gmxydf*ovyfc + gmxzdf*ovzfc
      ovydf = gmyxdf*ovxfc + gmyydf*ovyfc + gmyzdf*ovzfc
      ovzdf = gmzxdf*ovxfc + gmzydf*ovyfc + gmzzdf*ovzfc
c
      ovovf = ovxfc*ovxdf + ovyfc*ovydf + ovzfc*ovzdf
c
      emd(ir,it,ip) = 1.0d0/(pinx+1.0d0)
     &              * (ber/dsqrt(alphc**2 - psic**4*ovovf) - 1.0d0)
c
  100 continue
c
      do 42 ip = 0, np
      do 42 it = 0, nt
      emd(0,it,ip) = emd(0,nt,np/2)
 42   continue
c
      emdmx = 0.0d0
      do 44 ir = 0, nr
      emdmx = dmax1(emdmx,emd(ir,nt,0))
      if (emdmx.eq.emd(ir,nt,0)) nrfdmx = ir
 44   continue
c
      nrgdmx = nrfdmx + nrgmid
cz      emd(nrfdmx,nt,0) = emdc
cz      if (nrfdmx.eq.0) then 
      do 45 ip = 0, np
      do 45 it = 0, nt
      emd(0,it,ip) = emdc
 45   continue
cz      end if
c
c --- For axis. 
c
      do 191 ir = 1, nr
      emem = emd(ir,0,np/2)
      do 193 ip = 0, np
      emd(ir,0,ip) = emem
 193  continue
 191  continue
c
c --- For surface. 
c
      do 170 ip = 0, np
      do 170 it = 0, nt
      rsb(it,ip) = rs(it,ip)
      delx = dr*(surr - emd(nr,it,ip))/(emd(nr,it,ip) - emd(nr-1,it,ip))
      rs(it,ip) = rs(it,ip)*(1.0d0 + delx)
  170 continue
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c
c     ### Iteration. ###
c     Set improved values for emden function and surface.
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c
c --- For parameters. 
c
      rs(nt, 0) = 1.0d0
      rs(nt,np) = 1.0d0
c
      do 4000 ip = 0, np
      do 4000 it = 0, nt
      emd(nr,it,ip) = surr
cz      if (emd(nr-1,it,ip).le.0.0d0) emd(nr-1,it,ip) = surr
cz      if (emd(nr-2,it,ip).le.0.0d0) emd(nr-2,it,ip) = surr
cz      if (emd(nr-3,it,ip).le.0.0d0) emd(nr-3,it,ip) = surr
      if (rs(it,ip).ge.1.05d0) rs(it,ip) = 1.05d0
      do 4000 ir = 0, nr-1
      if (emd(ir,it,ip).le.0.0d0) emd(ir,it,ip) = surr
 4000 continue
c
      call flimpro(backf,emd,convf,emxemd,irerr,iterr,iperr,1)
      write(6,4901) '  == emd   ==, error =', emxemd,
     &              emd(irerr,iterr,iperr), irerr,iterr,iperr
      fmax0 = dmax1(emxemd,fmax0)
c
      call rsimpro(rsb,rs,convf,emxrs,iterr,iperr)
      write(6,4901) '  == rs    ==, error =', emxrs,
     &              rs(iterr,iperr),iterr,iperr
      fmax0 = dmax1(emxrs,fmax0)
c
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c --  Improving parameters and alpha and psi.  
c
      call paimproco(ome,ber,radi,convf,iter,fmax0,1)
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
cmark
      ahores = 0.0d0
      do 500 ip = 0, np
      do 500 it = 0, nt
      do 500 ir = 0, nr
c
      emd(nr,it,ip) = 1.0d-14
      if (emd(ir,it,ip).le.0.0d0) emd(ir,it,ip) = 1.0d-14
      emdfc = emd(ir,it,ip)
      rhofc = emd(ir,it,ip)**pinx
      alpfc = alphf(ir,it,ip)
      psifc = psif(ir,it,ip)
      hhfc  = 1.0d0 + (pinx+1.0d0)*emdfc
      utfc  = hhfc/ber
c
      weiflu = rs(it,ip)**3*wahop(ir,it,ip)
      ahores = ahores + rhofc*alpfc*utfc*psifc**6*weiflu
c
 500  continue
      ahores = radi**3*ahores*8.0d0/2.0d0
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
 4901 format(a22,1p,e12.4,',  value =',e12.4,2x,3i4)
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
      end
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      subroutine maxden(emd,emdmx,ddmax)
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f'
c
      include 'GR_IRDR_coflu.f'
c
      dimension emd(0:nnr,0:nnt,0:nnp), re(0:nnr+4)
      dimension x(nnr*2),y(nnr*2),df(2),iopt(2),c(nnr*2,3),f(1)
c
      pi = 3.14159265358979d+0
c
      nc = nnr*2
      n = nr+4
      iopt(1)=3
      iopt(2)=3
c
      re(1) = emd(3,nt,np)
      re(2) = emd(2,nt,np)
      re(3) = emd(1,nt,np)
      do 19 ir = 0, nr
      re(ir+4) = emd(ir,nt,0)
 19   continue
c
      do 20 ir = 3, n-1
      if (re(ir).gt.re(ir+1)) then
      ini = ir - 2
      if (ir.eq.3) then
      write(6,*) ' WARNING maximum density '
      ini = ini+1
      end if
      go to 21
      end if
 20   continue
 21   continue
c
      do 16 ii = 1, n
      x(ii)=dble(ii)
 16   y(ii)=re(ii)
      call splc(x,n,y,df,iopt,c,nc,ier)
c
      dini = dble(ini)
      delta = 1.0d0
c
 41   continue
c     write(6,*) dini,delta*0.2d0
      v = dini
      call splf(x,n,y,c,nc,v,1,f,ier)
      fb = f(1)
c
 40   continue
      v = v + 0.2d0*delta
      call splf(x,n,y,c,nc,v,1,f,ier)
      fn = f(1)
      if (dabs((fn-fb)/fn).le.1.0d-10) then
      emdmx = fn
      ddmax = (v - 4.0d0)/dble(nr)
      go to 100
      end if
      if (fb.gt.fn) then
      dini = v - 0.2d0*delta*2.0d0
      delta = 0.2d0*delta
      go to 41
      end if
      if (fb.le.fn) then
      fb = fn
      go to 40
      end if
c
 100  continue
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine lagint(x,n,y,v,f)
      implicit real*8 (a-h,o-z), integer (i-n)
      include 'grparm.f'
      dimension x(nnr),y(nnr),f(1)
c
      dx12 = x(1) - x(2)
      dx13 = x(1) - x(3)
      dx14 = x(1) - x(4)
      dx23 = x(2) - x(3)
      dx24 = x(2) - x(4)
      dx34 = x(3) - x(4)
      dx21 = - dx12
      dx31 = - dx13
      dx32 = - dx23
      dx41 = - dx14
      dx42 = - dx24
      dx43 = - dx34
      xv1 = v - x(1)
      xv2 = v - x(2)
      xv3 = v - x(3)
      xv4 = v - x(4)
      wex1 = xv2*xv3*xv4/(dx12*dx13*dx14) 
      wex2 = xv1*xv3*xv4/(dx21*dx23*dx24) 
      wex3 = xv1*xv2*xv4/(dx31*dx32*dx34) 
      wex4 = xv1*xv2*xv3/(dx41*dx42*dx43) 
c
      f(1) = wex1*y(1) + wex2*y(2) + wex3*y(3) + wex4*y(4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function fn_lagint(x,y,v)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension x(4),y(4)
c
      dx12 = x(1) - x(2)
      dx13 = x(1) - x(3)
      dx14 = x(1) - x(4)
      dx23 = x(2) - x(3)
      dx24 = x(2) - x(4)
      dx34 = x(3) - x(4)
      dx21 = - dx12
      dx31 = - dx13
      dx32 = - dx23
      dx41 = - dx14
      dx42 = - dx24
      dx43 = - dx34
      xv1 = v - x(1)
      xv2 = v - x(2)
      xv3 = v - x(3)
      xv4 = v - x(4)
      wex1 = xv2*xv3*xv4/(dx12*dx13*dx14) 
      wex2 = xv1*xv3*xv4/(dx21*dx23*dx24) 
      wex3 = xv1*xv2*xv4/(dx31*dx32*dx34) 
      wex4 = xv1*xv2*xv3/(dx41*dx42*dx43) 
c
      fn_lagint = wex1*y(1) + wex2*y(2) + wex3*y(3) + wex4*y(4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function dfncdx(xg,fnc,rv)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension xg(5),fnc(5)
c
      ir0 = 1
      ir1 = 2
      ir2 = 3
      ir3 = 4
      ir4 = 5
      dr01 = xg(ir0) - xg(ir1)
      dr02 = xg(ir0) - xg(ir2)
      dr03 = xg(ir0) - xg(ir3)
      dr04 = xg(ir0) - xg(ir4)
      dr12 = xg(ir1) - xg(ir2)
      dr13 = xg(ir1) - xg(ir3)
      dr14 = xg(ir1) - xg(ir4)
      dr23 = xg(ir2) - xg(ir3)
      dr24 = xg(ir2) - xg(ir4)
      dr34 = xg(ir3) - xg(ir4)
      dr10 = - dr01
      dr20 = - dr02
      dr21 = - dr12
      dr30 = - dr03
      dr31 = - dr13
      dr32 = - dr23
      dr40 = - dr04
      dr41 = - dr14
      dr42 = - dr24
      dr43 = - dr34
      rrv0 = rv - xg(ir0)
      rrv1 = rv - xg(ir1)
      rrv2 = rv - xg(ir2)
      rrv3 = rv - xg(ir3)
      rrv4 = rv - xg(ir4)
      wer0 = (rrv2*rrv3*rrv4 + rrv1*rrv3*rrv4 + 
     &        rrv1*rrv2*rrv4 + rrv1*rrv2*rrv3)/(dr01*dr02*dr03*dr04) 
      wer1 = (rrv2*rrv3*rrv4 + rrv0*rrv3*rrv4 + 
     &        rrv0*rrv2*rrv4 + rrv0*rrv2*rrv3)/(dr10*dr12*dr13*dr14) 
      wer2 = (rrv1*rrv3*rrv4 + rrv0*rrv3*rrv4 + 
     &        rrv0*rrv1*rrv4 + rrv0*rrv1*rrv3)/(dr20*dr21*dr23*dr24) 
      wer3 = (rrv1*rrv2*rrv4 + rrv0*rrv2*rrv4 + 
     &        rrv0*rrv1*rrv4 + rrv0*rrv1*rrv2)/(dr30*dr31*dr32*dr34) 
      wer4 = (rrv1*rrv2*rrv3 + rrv0*rrv2*rrv3 + 
     &        rrv0*rrv1*rrv3 + rrv0*rrv1*rrv2)/(dr40*dr41*dr42*dr43) 
      dfncdx = wer0*fnc(ir0) + wer1*fnc(ir1) +
     &         wer2*fnc(ir2) + wer3*fnc(ir3) +
     &         wer4*fnc(ir4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function dfncdx1st(xg,fnc,rv)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension xg(5),fnc(5)
c
      ir0 = 1
      ir1 = 2
      dr01 = xg(ir0) - xg(ir1)
      dr10 = - dr01
      rrv0 = rv - xg(ir0)
      rrv1 = rv - xg(ir1)
      wer0 = 1.0d0/dr01
      wer1 = 1.0d0/dr10
      dfncdx1st = wer0*fnc(ir0) + wer1*fnc(ir1)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function dfncdx2nd(xg,fnc,rv)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension xg(5),fnc(5)
c
      ir0 = 1
      ir1 = 2
      ir2 = 3
      dr01 = xg(ir0) - xg(ir1)
      dr02 = xg(ir0) - xg(ir2)
      dr12 = xg(ir1) - xg(ir2)
      dr10 = - dr01
      dr20 = - dr02
      dr21 = - dr12
      rrv0 = rv - xg(ir0)
      rrv1 = rv - xg(ir1)
      rrv2 = rv - xg(ir2)
      wer0 = (rrv2 + rrv1)/(dr01*dr02)
      wer1 = (rrv2 + rrv0)/(dr10*dr12)
      wer2 = (rrv1 + rrv0)/(dr20*dr21)
      dfncdx2nd = wer0*fnc(ir0) + wer1*fnc(ir1) + wer2*fnc(ir2)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function dfncdx3rd(xg,fnc,rv)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension xg(5),fnc(5)
c
      ir0 = 1
      ir1 = 2
      ir2 = 3
      ir3 = 4
      dr01 = xg(ir0) - xg(ir1)
      dr02 = xg(ir0) - xg(ir2)
      dr03 = xg(ir0) - xg(ir3)
      dr12 = xg(ir1) - xg(ir2)
      dr13 = xg(ir1) - xg(ir3)
      dr23 = xg(ir2) - xg(ir3)
      dr10 = - dr01
      dr20 = - dr02
      dr21 = - dr12
      dr30 = - dr03
      dr31 = - dr13
      dr32 = - dr23
      rrv0 = rv - xg(ir0)
      rrv1 = rv - xg(ir1)
      rrv2 = rv - xg(ir2)
      rrv3 = rv - xg(ir3)
      wer0 = (rrv2*rrv3 + rrv1*rrv3 + rrv1*rrv2)/(dr01*dr02*dr03)
      wer1 = (rrv2*rrv3 + rrv0*rrv3 + rrv0*rrv2)/(dr10*dr12*dr13) 
      wer2 = (rrv1*rrv3 + rrv0*rrv3 + rrv0*rrv1)/(dr20*dr21*dr23) 
      wer3 = (rrv1*rrv2 + rrv0*rrv2 + rrv0*rrv1)/(dr30*dr31*dr32) 
      dfncdx3rd = wer0*fnc(ir0) + wer1*fnc(ir1)
     &          + wer2*fnc(ir2) + wer3*fnc(ir3)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      function d2fdx2_3rd(xg,fnc,rv)
      implicit real*8 (a-h,o-z), integer (i-n)
      dimension xg(5),fnc(5)
c
      ir0 = 1
      ir1 = 2
      ir2 = 3
      ir3 = 4
      ir4 = 5
      dr01 = xg(ir0) - xg(ir1)
      dr02 = xg(ir0) - xg(ir2)
      dr03 = xg(ir0) - xg(ir3)
      dr04 = xg(ir0) - xg(ir4)
      dr12 = xg(ir1) - xg(ir2)
      dr13 = xg(ir1) - xg(ir3)
      dr14 = xg(ir1) - xg(ir4)
      dr23 = xg(ir2) - xg(ir3)
      dr24 = xg(ir2) - xg(ir4)
      dr34 = xg(ir3) - xg(ir4)
      dr10 = - dr01
      dr20 = - dr02
      dr21 = - dr12
      dr30 = - dr03
      dr31 = - dr13
      dr32 = - dr23
      dr40 = - dr04
      dr41 = - dr14
      dr42 = - dr24
      dr43 = - dr34
      rrv0 = rv - xg(ir0)
      rrv1 = rv - xg(ir1)
      rrv2 = rv - xg(ir2)
      rrv3 = rv - xg(ir3)
      rrv4 = rv - xg(ir4)
      wer0 = 2.0d0*(rrv3*rrv4 + rrv2*rrv4 + rrv2*rrv3
     &            + rrv1*rrv4 + rrv1*rrv3 + rrv1*rrv2)
     &            /(dr01*dr02*dr03*dr04) 
      wer1 = 2.0d0*(rrv3*rrv4 + rrv2*rrv4 + rrv2*rrv3
     &            + rrv0*rrv4 + rrv0*rrv3 + rrv0*rrv2)
     &            /(dr10*dr12*dr13*dr14) 
      wer2 = 2.0d0*(rrv3*rrv4 + rrv1*rrv4 + rrv1*rrv3
     &            + rrv0*rrv4 + rrv0*rrv3 + rrv0*rrv1)
     &            /(dr20*dr21*dr23*dr24) 
      wer3 = 2.0d0*(rrv2*rrv4 + rrv1*rrv4 + rrv1*rrv2
     &            + rrv0*rrv4 + rrv0*rrv2 + rrv0*rrv1)
     &            /(dr30*dr31*dr32*dr34) 
      wer4 = 2.0d0*(rrv2*rrv3 + rrv1*rrv3 + rrv1*rrv2
     &            + rrv0*rrv3 + rrv0*rrv2 + rrv0*rrv1)
     &            /(dr40*dr41*dr42*dr43) 
c
      d2fdx2_3rd = wer0*fnc(ir0) + wer1*fnc(ir1) +
     &             wer2*fnc(ir2) + wer3*fnc(ir3) +
     &             wer4*fnc(ir4)
c
      end
c
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine hrhafn(omega)
c
c --- cal.non-variables on grids. (s.t. radius sine cosine etc.)
c
      implicit real*8 (a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
c
c      common omega
      common / grbs / bsjy(0:nnrg,0:nnlg,0:nnlg,0:nnrg),
     &         sbsjy(0:nnlg,0:nnlg,0:nnrg),sbsjyp(0:nnlg,0:nnlg,0:nnrg)
c
c- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- Set up of meshes  ---  ( r(1) = dr ( not the center ) )
c --- The constatnt msym means the symmetry of the configuration.
c
      pi = 3.14159265358979d+0
c
c
c -------------------------------------
c --- Computation of function bsjy ---
c -------------------------------------
c
c     bsjy(irr,nn,im,ir) computes, for l=nn, m nonzero 
c     -(2l+1)*m*omega*j_l(m*omega r_<)*y_l(m*omega r_>)
c    The omega -> 0 limit of this is r_<^l/r_>^(l+1),
c    and bsjy replaces the function hfsn in grins
c    For m=0, bsjy is still r_<^l/r_>^(l+1) 
c                        
c
      do 418 nn  = 0, nlg
      do 418 im  = 0, nlg
      do 418 ir  = 0, nrtot
      do 418 irr = 0, nrtot
        bsjy(irr,nn,im,ir) = 0.d0
  418 continue
c
      do 419 ir  = 1, nrtot
      do 4190 irr = 1, nrtot
      if (hrg(irr).lt.rg(ir)) then
      do 4191 nn  = 0, nlg
      do 4191 im  = 0, nn
         if(im.eq.0)then
            bsjy(irr,nn,im,ir) = hrg(irr)**nn/rg(ir)**(nn+1)
         else
          omegam = dble(im)*omega
          call sphbess(omegam*hrg(irr),nn,sj,sy)
          sbj=sj
          call sphbess(omegam*rg(ir),nn,sj,sy)
          sby=sy
          bsjy(irr,nn,im,ir) = -omegam*(2.d0*dble(nn)+1.d0)*sbj*sby
         endif
 4191 continue
      end if
      if (hrg(irr).ge.rg(ir)) then
      do 4192 nn  = 0, nlg
      do 4192 im  = 0, nn
         if(im.eq.0)then
            bsjy(irr,nn,im,ir) = rg(ir)**nn/hrg(irr)**(nn+1)
         else
          omegam = dble(im)*omega
          call sphbess(omegam*rg(ir),nn,sj,sy)
          sbj=sj
          call sphbess(omegam*hrg(irr),nn,sj,sy)
          sby=sy
          bsjy(irr,nn,im,ir) = -omegam*(2.d0*dble(nn)+1.d0)*sbj*sby
         endif
 4192 continue
      end if
 4190 continue
 419  continue
c
      ir  = 0
      nn  = 0
      do 4200 irr = 1, nrtot
        bsjy(irr,nn,0,ir) = 1.d0/hrg(irr)
 4200 continue
c
*  
*  For the surface integral, construct, for m nonzero
*   sbsjy(l,m,ir) :=  j_l(m omega r) y_l(m omega R) (m omega)(2l+1)
*   sbsjyp(l,m,ir) =  j_l(m omega r) y_l'(m omega R)(m omega)^2(2l+1)
*
* For m = 0, use 
*   sbsjy(l,0,ir)  = r^l/R^(l+1)
*   sbsjyp(l,0,ir) = - (l+1) r^l/R^(l+2)
*
       rtpi2 = 1.253314154753822d0
       do nn = 0,nlg
       do im = 1,nn
        omegam=dble(im)*omega
        x = omegam*rg(nrtot)
        xnu = dble(nn)+0.5d0
        om2np1=omegam*(2.d0*dble(nn)+1.d0)
        call bessjy(x,xnu,xrj,xry,xrjp,xryp)
        sy = xry*rtpi2/sqrt(x)
        syp = rtpi2/sqrt(x)*(xryp - xry*0.5d0/x)
        do ir = 1,nrtot
         if(im.eq.0)then
            sbsjy(nn,im,ir) = rg(ir)**nn/rg(nrtot)**(nn+1)
            sbsjyp(nn,im,ir) = 
     &                   -(dble(nn)+1.d0)*rg(ir)**nn/rg(nrtot)**(nn+2)
          else
          xx=omegam*rg(ir)
          call bessjy(xx,xnu,xrj,xry,xrjp,xryp)
          sj = xrj*rtpi2/sqrt(xx)
          sbsjy(nn,im,ir) =  om2np1*sj*sy
          sbsjyp(nn,im,ir) =  omega*om2np1*sj*syp
         endif
        enddo !ir
*       ir = 0 case: nonzero contribution only when l=m=0
*       
        sbsjy(0,0,0) = 1./rg(nrtot)
        sbsjyp(0,0,0)= -1.d0/( rg(nrtot)*rg(nrtot) )
       enddo ! im 
       enddo ! nn
*
      end
*
*************************************************************************
* sphbess computes the spherical bessel functions j_l(x), y_l(x),
* with y_l = n_l the spherical Neumann function 
* The routine uses the Numerical Recipes routine bessjy 
* input: x, l
* output: sj = j_l(x), sy=y_l(x)
*************************************************************************
      subroutine sphbess(x,l,sj,sy)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        rtpi2 = 1.253314154753822d0
	xnu = l+0.5
         call bessjy(x,xnu,xrj,xry,xrjp,xryp)
      sj=xrj*rtpi2/sqrt(x)
      sy=xry*rtpi2/sqrt(x)
      END
*************************************************************************
      SUBROUTINE bessjy(x,xnu,rj,ry,rjp,ryp)
      INTEGER MAXIT
      double precision rj,rjp,ry,ryp,x,xnu,XMIN
      DOUBLE PRECISION EPS,FPMIN,PI
      PARAMETER (EPS=1.e-16,FPMIN=1.e-30,MAXIT=10000,XMIN=2.,
     *PI=3.141592653589793d0)
CU    USES beschb
      INTEGER i,isign,l,nl
      DOUBLE PRECISION a,b,br,bi,c,cr,ci,d,del,del1,den,di,dlr,dli,dr,e,
     *f,fact,fact2,fact3,ff,gam,gam1,gam2,gammi,gampl,h,p,pimu,pimu2,q,
     *r,rjl,rjl1,rjmu,rjp1,rjpl,rjtemp,ry1,rymu,rymup,rytemp,sum,sum1,
     *temp,w,x2,xi,xi2,xmu,xmu2
      if(x.le.0..or.xnu.lt.0.) pause 'bad arguments in bessjy'
      if(x.lt.XMIN)then
        nl=int(xnu+.5d0)
      else
        nl=max(0,int(xnu-x+1.5d0))
      endif
      xmu=xnu-nl
      xmu2=xmu*xmu
      xi=1.d0/x
      xi2=2.d0*xi
      w=xi2/PI
      isign=1
      h=xnu*xi
      if(h.lt.FPMIN)h=FPMIN
      b=xi2*xnu
      d=0.d0
      c=h
      do 11 i=1,MAXIT
        b=b+xi2
        d=b-d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b-1.d0/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1.d0/d
        del=c*d
        h=del*h
        if(d.lt.0.d0)isign=-isign
        if(abs(del-1.d0).lt.EPS)goto 1
11    continue
      pause 'x too large in bessjy; try asymptotic expansion'
1     continue
      rjl=isign*FPMIN
      rjpl=h*rjl
      rjl1=rjl
      rjp1=rjpl
      fact=xnu*xi
      do 12 l=nl,1,-1
        rjtemp=fact*rjl+rjpl
        fact=fact-xi
        rjpl=fact*rjtemp-rjl
        rjl=rjtemp
12    continue
      if(rjl.eq.0.d0)rjl=EPS
      f=rjpl/rjl
      if(x.lt.XMIN) then
        x2=.5d0*x
        pimu=PI*xmu
        if(abs(pimu).lt.EPS)then
          fact=1.d0
        else
          fact=pimu/sin(pimu)
        endif
        d=-log(x2)
        e=xmu*d
        if(abs(e).lt.EPS)then
          fact2=1.d0
        else
          fact2=sinh(e)/e
        endif
        call beschb(xmu,gam1,gam2,gampl,gammi)
        ff=2.d0/PI*fact*(gam1*cosh(e)+gam2*fact2*d)
        e=exp(e)
        p=e/(gampl*PI)
        q=1.d0/(e*PI*gammi)
        pimu2=0.5d0*pimu
        if(abs(pimu2).lt.EPS)then
          fact3=1.d0
        else
          fact3=sin(pimu2)/pimu2
        endif
        r=PI*pimu2*fact3*fact3
        c=1.d0
        d=-x2*x2
        sum=ff+r*q
        sum1=p
        do 13 i=1,MAXIT
          ff=(i*ff+p+q)/(i*i-xmu2)
          c=c*d/i
          p=p/(i-xmu)
          q=q/(i+xmu)
          del=c*(ff+r*q)
          sum=sum+del
          del1=c*p-i*del
          sum1=sum1+del1
          if(abs(del).lt.(1.d0+abs(sum))*EPS)goto 2
13      continue
        pause 'bessy series failed to converge'
2       continue
        rymu=-sum
        ry1=-sum1*xi2
        rymup=xmu*xi*rymu-ry1
        rjmu=w/(rymup-f*rymu)
      else
        a=.25d0-xmu2
        p=-.5d0*xi
        q=1.d0
        br=2.d0*x
        bi=2.d0
        fact=a*xi/(p*p+q*q)
        cr=br+q*fact
        ci=bi+p*fact
        den=br*br+bi*bi
        dr=br/den
        di=-bi/den
        dlr=cr*dr-ci*di
        dli=cr*di+ci*dr
        temp=p*dlr-q*dli
        q=p*dli+q*dlr
        p=temp
        do 14 i=2,MAXIT
          a=a+2*(i-1)
          bi=bi+2.d0
          dr=a*dr+br
          di=a*di+bi
          if(abs(dr)+abs(di).lt.FPMIN)dr=FPMIN
          fact=a/(cr*cr+ci*ci)
          cr=br+cr*fact
          ci=bi-ci*fact
          if(abs(cr)+abs(ci).lt.FPMIN)cr=FPMIN
          den=dr*dr+di*di
          dr=dr/den
          di=-di/den
          dlr=cr*dr-ci*di
          dli=cr*di+ci*dr
          temp=p*dlr-q*dli
          q=p*dli+q*dlr
          p=temp
          if(abs(dlr-1.d0)+abs(dli).lt.EPS)goto 3
14      continue
        pause 'cf2 failed in bessjy'
3       continue
        gam=(p-f)/q
        rjmu=sqrt(w/((p-f)*gam+q))
        rjmu=sign(rjmu,rjl)
        rymu=rjmu*gam
        rymup=rymu*(p+q/gam)
        ry1=xmu*xi*rymu-rymup
      endif
      fact=rjmu/rjl
      rj=rjl1*fact
      rjp=rjp1*fact
      do 15 i=1,nl
        rytemp=(xmu+i)*xi2*ry1-rymu
        rymu=ry1
        ry1=rytemp
15    continue
      ry=rymu
      ryp=xnu*xi*rymu-ry1
      return
      END  
**************************************************************************     
      SUBROUTINE beschb(x,gam1,gam2,gampl,gammi)
      INTEGER NUSE1,NUSE2
      DOUBLE PRECISION gam1,gam2,gammi,gampl,x
      PARAMETER (NUSE1=5,NUSE2=5)
CU    USES chebev
      double precision xx,c1(7),c2(8),chebev
      SAVE c1,c2
      DATA c1/-1.142022680371168d0,6.5165112670737d-3,3.087090173086d-4,
     *-3.4706269649d-6,6.9437664d-9,3.67795d-11,-1.356d-13/
      DATA c2/1.843740587300905d0,-7.68528408447867d-2,
     *1.2719271366546d-3,-4.9717367042d-6,-3.31261198d-8,2.423096d-10,
     *-1.702d-13,-1.49d-15/
      xx=8.d0*x*x-1.d0
      gam1=chebev(-1.d0,1.d0,c1,NUSE1,xx)
      gam2=chebev(-1.d0,1.d0,c2,NUSE2,xx)
      gampl=gam2-x*gam1
      gammi=gam2+x*gam1
      return
      END
***************************************************************************      
      FUNCTION chebev(a,b,c,m,x)
      INTEGER m
      DOUBLE PRECISION chebev,a,b,x,c(m)
      INTEGER j
      DOUBLE PRECISION d,dd,sv,y,y2
      if ((x-a)*(x-b).gt.0.) pause 'x not in range in chebev'
      d=0.
      dd=0.
      y=(2.*x-a-b)/(b-a)
      y2=2.*y
      do 11 j=m,2,-1
        sv=d
        d=y2*d-dd+c(j)
        dd=sv
11    continue
      chebev=y*d-dd+0.5*c(1)
      return
      END
c
c -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
c ______________________________________________________________________
c ______________________________________________________________________
c
c  Usage for subroutine of spline interporation 
c
c  for x_1, IOPT(1) = 1 => DF(1) = d^2 f(x_1)/ dx^2
c           IOPT(1) = 2 => DF(1) = d f(x_1)/ dx
c           IOPT(1) = 3 => DF(1) is not needed, but the same as  
c                          IOPT(1) = 2. (d f(x_1)/ dx is automatically
c                          calculated, using the Lagrange interpolation.)     
c
c   for x_N, similar to x_1, but IOPT(2) and DF(2) are used.
c
************************************************************************
      SUBROUTINE SPLC(X, N, Y, DF, IOPT, C, NC, IER)
************************************************************************
*  COMPUTE THE COEFFICIENTS OF THE CUBIC SPLINE.                       *
*  PARAMETERS                                                          *
*    (1) X: 1-DIM. ARRAY FOR KNOWN POINTS                              *
*    (2) N: NUMBER OF KNOWN POINTS                                     *
*    (3) Y: 1-DIM. ARRAY FOR FUNCTION'S VALUES ON KNOWN POINTS         *
*    (4) DF: 1-DIM. ARRAY FOR DIFFERENTIALS AT END POINTS              *
*    (5) IOPT: 1-DIM. ARRAY SPECIFYING THE CONTENT OF DF               *
*    (6) C: 2-DIM. WORKING ARRAY                                       *
*    (7) NC: ROW SIZE OF THE ARRAY (C)                                 *
*    (8) IER: ERROR CODE                                               *
*  COPYRIGHT   T. OGUNI   JUNE 30 1989    VERSION 1.0                  *
************************************************************************
       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION X(N), Y(N), DF(2), IOPT(2), C(NC,3), EC(4), D(2)
C
      IF (N.LT.2 .OR. NC.LT.N-1 .OR. IOPT(1).LT.1 .OR. IOPT(1).GT.3
     *    .OR. IOPT(2).LT.1 .OR. IOPT(2).GT.3) THEN
       IER = 2
       WRITE(*,*) '(SUBR. SPLC) INVALID ARGUMENT.',N,NC,IOPT(1),IOPT(2)
       RETURN
      ENDIF
      DO 5 I=1,N-1
       IF (X(I) .GE. X(I+1)) THEN
        IER = 1
        WRITE(*,*) '(SUBR. SPLC) X SHOULD SATISFY UPWARD ORDER.'
        RETURN
       ENDIF
    5 CONTINUE
      IER = 0
C  SET THE END CONDITIONS.
      II = 2
      KS = 1
      KE = MIN0(4,N)
      IDER = 1
      DO 70 I=1,2
       I1 = 2 * I - 1
       I2 = 2 * I
       IB = IOPT(I)
       GO TO (10, 20, 30), IB
   10  EC(I1) = 0.0D0
       EC(I2) = 2.0D0 * DF(I)
       GO TO 70
   20  D(I) = DF(I)
   25  IF (I .EQ. 2) II = N
       H = X(II) - X(II-1)
       EC(I1) = 1.0D0
       HY = Y(II) - Y(II-1)
       EC(I2) = 6.0D0 * (HY / H - D(I)) / H
       IF (I .EQ. 2) EC(I2) = - EC(I2)
       GO TO 70
   30  IF (I .NE. 1) THEN
        KS = MAX0(1,N-3)
        KE = N
        IDER = N
       ENDIF
       A2 = 0.0D0
       D(I) = 0.0D0
       DO 60 K=KS,KE
        IF (IDER .NE. K) THEN
         A1 = 1.0D0
         DO 50 J=KS,KE
          IF (J .NE. IDER .AND. J .NE. K) THEN
           X1 = X(IDER) - X(J)
           X2 = X(K) - X(J)
           A1 = A1 * X1 / X2
          ENDIF
   50    CONTINUE
         X3 = X(K) - X(IDER)
         D(I) = D(I) + A1 * Y(K) / X3
         A2 = A2 - 1.0D0 / X3
        ENDIF
   60  CONTINUE
       D(I) = D(I) + Y(IDER) * A2
       GO TO 25
   70 CONTINUE
C  SET THE ELEMENTS FOR THE SYMMETRIC TRIDIAGONAL EQUATION.
      IF (N .NE. 2) THEN
       H1 = X(2) - X(1)
       Y1 = Y(2) - Y(1)
       DO 80 I=2,N-1
        H2 = X(I+1) - X(I)
        Y2 = Y(I+1) - Y(I)
        HH = H1 + H2
        C(I,1) = H2 / HH
        C(I,2) = 1.0D0 - C(I,1)
        C(I,3) = 6.0D0 * (Y2 / H2 - Y1 / H1) / HH
        H1 = H2
   80   Y1 = Y2
      ENDIF
C  SOLVE THE EQUATION
      C(1,1) = - EC(1) * 0.5D0
      C(1,2) =   EC(2) * 0.5D0
      IF (N .NE. 2) THEN
       DO 100 K=2,N-1
        PIV = 2.0D0 + C(K,2) * C(K-1,1)
        C(K,1) = - C(K,1) / PIV
  100   C(K,2) = (C(K,3) - C(K,2) * C(K-1,2)) / PIV
      ENDIF
      DY1 = (EC(4) - EC(3) * C(N-1,2)) / (2.0D0 + EC(3) * C(N-1,1))
      DO 120 I=1,N-1
       K = N - I
       DY2 = C(K,1) * DY1 + C(K,2)
       H = X(K+1) - X(K)
       C(K,3) = (DY1 - DY2) / (6.0D0 * H)
       C(K,2) = 0.5D0 * DY2
       C(K,1) = (Y(K+1) - Y(K)) / H - (C(K,2) + C(K,3) * H) * H
  120  DY1 = DY2
C
      RETURN
      END
c
************************************************************************
      SUBROUTINE SPLF(X, N, Y, C, NC, V, M, F, IER)
************************************************************************
*  INTERPOLATION BY THE CUBIC SPLINE.                                  *
*  PARAMETERS                                                          *
*    (1) X: 1-DIM. ARRAY FOR KNOWN POINTS                              *
*    (2) N: NUMBER OF KNOWN POINTS                                     *
*    (3) Y: 1-DIM. ARRAY FOR FUNCTION'S VALUES ON KNOWN POINTS         *
*    (4) C: 2-DIM. WORKING ARRAY                                       *
*    (5) NC: ROW SIZE OF THE ARRAY (C)                                 *
*    (6) V: 1-DIM. ARRAY FOR POINTS WHICH INTERPOLATION MUST BE MADE   *
*    (7) M: NUMBER OF POINTS FOR WHICH INTERPOLATION MUST BE MADE      *
*    (8) F: 1-DIM. WORKING ARRAY                                       *
*    (9) IER: ERROR CODE                                               *
*  COPYRIGHT   T. OGUNI   JUNE 30 1989   VERSION 1.0                   *
************************************************************************
       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION X(N), Y(N), C(NC,3), V(M), F(M)
C
      IF (N .LT. 2 .OR. M .LT. 1 .OR. NC .LT. N-1) THEN
       IER = 2
       WRITE(*,*) '(SUBR. SPLF) INVALID ARGUMENT. ', N, NC, M
       RETURN
      ENDIF
      IER = 0
      I = 1
      DO 90 K=1,M
       V1 = V(K) - X(I)
       IF (V1) 10, 30, 40
   10  IF (I .GT. 1) GO TO 20
       IER = 1
       GO TO 80
   20  I = I - 1
       V1 = V(K) - X(I)
       IF (V1) 10, 30, 80
   30  F(K) = Y(I)
       GO TO 90
   40  IF (I .LT. N) GO TO 50
       IER = 1
       I = N - 1
       GO TO 80
   50  V2 = V(K) - X(I+1)
       IF (V2) 80, 60, 70
   60  I = I + 1
       GO TO 30
   70  I = I + 1
       V1 = V2
       GO TO 40
   80  F(K) = Y(I) + V1 * (C(I,1) + V1 * (C(I,2) + V1 * C(I,3)))
   90 CONTINUE
C
      RETURN
      END
c ______________________________________________________________________
c ______________________________________________________________________
c
      subroutine subioca
c
      implicit real*8(a-h,o-z), integer (i-n)
c
      include 'grparm.f' 
c
      include 'GR_IRDR_coflu.f'
      include 'GR_IRDR_cogra.f'
      include 'GR_IRDR_metgr.f'
c
      common / intpp / thmx, phimx, 
     &         ndis, nrgmin, nrgmax, nrgmid, ntgmin, npgmax, nrgdmx
c
      common / phisv / emd(0:nnr,0:nnt,0:nnp), vep(0:nnr,0:nnt,0:nnp),
     &                 rs(0:nnt,0:nnp), rho(0:nnr,0:nnt,0:nnp),
     &                 alm(nnbou,nnbou), ram(0:nnr,0:nnt,0:nnp)
      common / calcp /  ome, ber, radi, dis
      common / phisp / pinx, surr, ratio, ratmas, sepato, 
     &                 g, pi, emdc, ipolar
      common / iomis / fffac, ffvep, eps, convf, itmx, iddd, numseq,
     &                 itype, iwrite
      common / trmpg / sinmpg(0:nnlg,0:nnpg), cosmpg(0:nnlg,0:nnpg),
     &                simpsig(0:nnlg,0:nnpg)
c
      common / phint / ahores, ahoang, ahoadm
      common / cutsw / cutfac
c
      dimension gradv(0:nnr,0:nnt,0:nnp,1:3),
     &         emdg(0:nnrg,0:nntg,0:nnpg), 
     &        grada(0:nnrg,0:nntg,0:nnpg,1:3)
c
      character*3 chpr
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
c
c      open(21,file='gnbcart.dat',status='old')
c
c --  Interpolation to Cartesian coordinate.
c
c      read(21,2400) nx, ny, nz, nstar
c      read(21,2401) chpr
      ifl = 2
c      close(21)
c 2400 format(4i5)
c 2401 format(2x,a3)
c
c ---- nstar = grid points per a radius (half diameter) of a star. 
c ---- edge of computational domain would be nxout = nx/nstar.  
c
      call flgrad4(vep,gradv,rs,1,0)
cx      call flgrad(vep,gradv,rs,1,0)
c
      call fl2grspl(emd,emdg,rs,hrg,rg,1)
      call vfl2vgrcap(gradv,grada,rs,hrg,rg,1)
c
c --------------
c --- Write. ---
c --------------
c
cshibata      rkappa = 200.d0/pi
      rkappa = 1.d0
      rkapmn = rkappa**(-pinx)
      rkapn2 = rkappa**(pinx/2.0d0)
      romega = ome/rkapn2/radi
      rradi = radi*rkapn2
c
c
c --- OUTPUT Shibata spheircal data.
c
      if (ifl.eq.2.or.ifl.eq.4.or.ifl.eq.5) then
      open(20,file='gnb_shi_sph.dat',status='unknown')
c
      write(20,5000) nrf, ntf, npf
      write(20,5000) nl, nla, nbou, msym
      write(20,5005) nnn, nrout, rvout
      write(20,5000) ntg, npg, nlg, msymg
      write(20,5002) ngdin, pinx, cutfac
c
      write(20,4000) ahores, ahoang, ahoadm
      write(20,4000) ome, ber, radi
      write(20,4000) (rg(irg), irg = 0, nrtot)
c
      do 400 ip = 0, np
      do 400 it = 0, nt
      write(20,4000) (emd(ir,it,ip), ir = 0, nr)
      write(20,4000) (vep(ir,it,ip), ir = 0, nr)
 400  continue
      do 410 ip = 0, np
      write(20,4000) (rs(it,ip), it = 0, nt)
 410  continue
c
      do 500 ipg = 0, npg
      do 500 itg = 0, ntg
c
      write(20,4000) (rkapmn*emdg(irg,itg,ipg)**pinx, irg = 0, nrtot)
      write(20,4000)
     & (grada(irg,itg,ipg,1)/(1.0d0 + (pinx+1.0d0)*emdg(irg,itg,ipg)),
     &  irg = 0, nrtot)
      write(20,4000)
     & (grada(irg,itg,ipg,2)/(1.0d0 + (pinx+1.0d0)*emdg(irg,itg,ipg)),
     &  irg = 0, nrtot)
      write(20,4000)
     & (grada(irg,itg,ipg,3)/(1.0d0 + (pinx+1.0d0)*emdg(irg,itg,ipg)),
     &  irg = 0, nrtot)
c
      write(20,4000) (psi(irg,itg,ipg)-1.0d0, irg = 0, nrtot)
      write(20,4000) (alph(irg,itg,ipg)-1.0d0, irg = 0, nrtot)
      write(20,4000) (bvxu(irg,itg,ipg), irg = 0, nrtot)
      write(20,4000) (bvyu(irg,itg,ipg), irg = 0, nrtot)
      write(20,4000) (bvzu(irg,itg,ipg), irg = 0, nrtot)
c
 500  continue
c
      close(20)
      end if
c
c --- END
c
 100  format(4i5)
 200  format(1p,5e21.13)
 4000 format(1p,4e19.11)
 5000 format( 5i5)
 5001 format( 1p,2e10.3)
 5002 format( 1i5, 1p,2e10.3)
 5003 format( 1p,1e10.3, 1i4)
 5004 format( 2i5, 3x, a3)
 5005 format( 2i5, 1p,1e10.3)
c
      end
